<?php
/**
 * Category Table
 * 
 * Developed For Ads Manager October 2009
 * 	
 * 
 * @version 1.0.2 (JTheFactory version)
 * @modified:12/12/09
 * 
 * @package:JTheFactory Framework
 * @subpackage:Category Management
 * 
**/
class JTheFactoryCategoryTable extends JFactorySystemTable {
	var $id                = null;
	var $catname           = null;
	var $description       = null;
	var $parent            = null;
	var $hash              = null;
	var $ordering          = null;

	function __construct( $table=APP_CATEGORY_TABLE,$key="id", $db=null )
	{
		if(!isset($db)){
			$db = & FactoryLayer::getDB();
		}
		parent::__construct($table,$key,$db);
	}
	
	function hashCategory(){
		
        $this->hash = JTheFactoryLangHelper::transliterate($this->catname);
    	$this->hash = md5(strtolower(JFilterOutput::stringURLSafe($this->hash)));
    	
	}
	
	
}

class JTheFactoryCategorySefTable extends JFactorySystemTable {
	var $id                = null;
	var $categories        = null;
	var $catid		       = null;

	function __construct( $table=APP_CATEGORY_TABLE_SEF,$key="id", $db=null )
	{
		if(!isset($db)){
			$db = & FactoryLayer::getDB();
		}
		parent::__construct($table,$key,$db);
	}
}

?>