<?php 
/**
 * Comments Controller
 * 
 * 
 * @version 1.0.0 (JTheFactory version)
 * 
 * @package:JTheFactory Framework
 * @subpackage:Comments Management
 * 
**/


class FactoryCommentsController{
	
	var $_db 	= null;
	var $_model = null;
	
	
	function checkTask( &$act )
	{
		$this->_db = &FactoryLayer::getDB();
		if(!$act)
			$act="list_comments";
			
		$method_name = $act;
		if ( method_exists($this,$method_name) ){
			$this->$method_name();
			return true;
		}

		return false;
	}
	
	function del_comment(){
		
		$id = FactoryLayer::getRequest($_REQUEST,"id");
		$this->_db->setQuery("DELETE FROM #__bid_messages WHERE id = $id");
		$this->_db->query();
		$refferer = $_SERVER['HTTP_REFERER'];
		if(!$refferer) $refferer="index.php?option=".F_COMPONENT_NAME."&task=comments_administrator";
		FactoryLayer::redirect($refferer,"Comment removed!");
	}
	
	function toggle_comment(){
		
		$id = FactoryLayer::getRequest($_REQUEST,"id");
		$this->_db->setQuery("UPDATE #__bid_messages SET published=1-published WHERE id = $id");
		$this->_db->query();
		$refferer = $_SERVER['HTTP_REFERER'];
		if(!$refferer) $refferer="index.php?option=".F_COMPONENT_NAME."&task=comments_administrator";
		FactoryLayer::redirect($refferer,"Comment status toggled!");
	}
	
	function list_comments(){
		
		$app	= JFactory::getApplication();

		$context = APP_EXTENSION."comments";
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		$limitstart = ( $limit != 0 ? (floor($limitstart / $limit) * $limit) : 0 );

		$this->_db->setQuery("SELECT COUNT(*) FROM #__bid_messages");
		$total = $this->_db->loadResult();
		
		$page = FactoryLayer::initPagination($total, $limitstart, $limit);
		$rows =$this->_model->getList($limitstart,$limit);
		
		require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."comments_list.php");
		return true;
	}
	
	function do_write(){
		
		$db = & JFactory::getDBO();

		$modal = JRequest::getVar('modal',"");
		
		$id = JRequest::getVar('adid',0);
		$id_reported = JRequest::getVar('id_reported',0);

		if ($id){
			$obj=new JAuctions($db);
			if (!$obj->load($id)) return;
		}elseif($id_reported){
			$obj = new JAuctions($db);
			if (!$obj->load($id_reported)) return;
		}else{
			return;
		}
		$usr=JTable::getInstance("user");
		$usr->load($obj->userid);
		$obj->username=$usr->username;

		if($modal=="yes")
			ob_end_clean();
			
		require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."comment_send.php");
		
		if($modal=="yes")
			jexit();
			
		return true;
		
	}

	function send(){
		
		$app	= JFactory::getApplication();

		$database = & JFactory::getDBO();
		$my = & JFactory::getUser();

		$id=JRequest::getVar('adid',0);
		$message=JRequest::getVar('message','');

		if (!$message){
			echo JText::_("ADS_ERR_MESSAGE_EMPTY");
			return;
		}

		$add = new JAuctions($database);
		if (!$add->load($id)) return;

		$add->newmessages =1;
		$add->store();
		$add->sendNewMessage($id,$id_msg,$message);

		$owner_user=JTable::getInstance("user");
		$owner_user->load($add->userid);

		//$add->SendMails(array($owner_user),'ads_admin_message');

		$app->redirect('index.php?option=com_bids&task=editoffer&id='.$id,JText::_("Message sent!"));
	}
	
	
}
