<?php
/**
 * TheFactory Standard Auto Loaded Controller
 * 
 *
 */
class JTheFactoryCountries_controller{
	
    /**
     * Added INIT Method to load all dependencies both on front & backend
     *
     * @since 13/01/2010 (dd/mm/YYYY)
     */
	function init(&$application){
		
		if($application){
			$app=$application;
		}
		else	
			$app=&JTheFactoryApp::getInstance(null,null);

		
	}

	/**
	 * Backend Application Router
	 *
	 * @param $task
	 * @param $act
	 * @return bool
	 */
	function route(){
		
		$task = & JRequest::getVar("task","");
		$act = & JRequest::getVar("act","");
		
		if (method_exists($this,$task)){
			return $this->$task($act);
		}
        
	}
    
	/**
	 * Backend Main Controller task
	 *
	 * @param $act
	 * @return bool
	*/
    function countries(&$act)
    {

    	
		JLoader::register('FCountriesController', dirname(__FILE__).DS.'controllers'.DS.'countries.php');
		$FCountriesController = new FCountriesController();
		return $FCountriesController->checkTask($act);
	}
	
}

?>