<?php
class JFactoryPositions{
	
	
	function checkTask( &$act )
	{
		if(!$act)
			$act="list";
		
		$method_name = "fposition_".$act;
		if (method_exists($this,$method_name)){
			return $this->$method_name();
		}
			
		return false;
	}
	
	
	function fposition_list()
	{
		
		$PO = &PositionsLib::getInstance();
		$positions = $PO->_loadPositions();
		require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."positions.php");
		return true;
		
	}

	function fposition_new(){
		
		return $this->fposition_edit(1);
		
	}
	
	function fposition_edit($isNew=0)
	{
		if(!$isNew){
			$id = FactoryLayer::getRequest($_REQUEST,"id",null);
			$PO = &PositionsLib::getInstance();
			$position = $PO->_loadPosition($id);
		}
		require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."position_edit.php");
		return true;
	}
	

	function fposition_save(){
		$db = FactoryLayer::getDB();
		$id = FactoryLayer::getRequest($_REQUEST,"id",null);
		$jtable = new JTable("#__".APP_CFIELDS_PREFIX."_positions", "id", $db);
		$jtable->id =$id;
		$jtable->load();
		$jtable->html = JArrayHelper::getValue($_REQUEST,"html",null);
		
		$jtable->store();
		FactoryLayer::redirect("index.php?option=".APP_EXTENSION."&task=fposition_panel&act=edit&id=".$jtable->id,"Position Saved");
	}
	
	
	function fposition_add(){
		$db = FactoryLayer::getDB();
		$jtable = new JTable("#__".APP_CFIELDS_PREFIX."_positions", "id", $db);
		$jtable->id =null;
		$jtable->title =null;
		$jtable->name =null;
		$jtable->name = str_replace(array(" ","-","/",":","."), "_", $jtable->name);
		$jtable->description =null;
		$jtable->html = null;
		$jtable->tpl  = "";
		$jtable->bind($_POST);
		
		if($jtable->title!="" && $jtable->name!="")
			$jtable->store();
		else
			FactoryLayer::redirect("index.php?option=".APP_EXTENSION."&task=fposition_panel&act=new","Title and name fields are compulsory");
				
		FactoryLayer::redirect("index.php?option=".APP_EXTENSION."&task=fposition_panel&act=edit&id=".$jtable->id,"Position Saved");
	}
	
	
	function fposition_remove(){
		
		$db = FactoryLayer::getDB();
		$id = FactoryLayer::getRequest($_REQUEST,"id",null);
		$jtable = new JTable("#__".APP_CFIELDS_PREFIX."_positions", "id", $db);
		$jtable->name =null;
		$jtable->load($id);
		$position = "<strong>{include file='elements/display_fields.tpl' position='$jtable->name'}</strong>";
		$jtable->delete($id);
		
		FactoryLayer::redirect("index.php?option=".APP_EXTENSION."&task=fposition_panel","Position deleted! Pls delete the specific position code from your template (just to keep it clean).<br > You should search for $position ");
	}
	
	
	function fposition_help(){
		echo JTHEF_POSITIONS_TITLE;
		echo "<hr />";
		echo JTHEF_NEW_POSITION_HELP;
		echo "<hr />";
		exit;
	}

	
	
}
