<?php
/**
 * 
 *
 */
class JTheFactoryReviews_model extends JObject{
	
	var $_tblname = null;
	
	var $_item_rated = null;
	
	var $_db = null;
	
	function JTheFactoryReviews_model( &$params ){
		
		$this->_db = & JFactory::getDBO();
		
		$this->_tblname = $params["tblname"];
		$this->_item_rated->tblname = $params["item_rated"]["tblname"];
		$this->_item_rated->field = $params["item_rated"]["field"];
		$this->_item_rated->visit_link = $params["item_rated"]["visit_link"];
		
	}
	
	function &getInstance(&$params)
	{
		static $thefactory;
		if (!isset( $thefactory["reviews"] )){
			$thefactory["reviews"] = new JTheFactoryReviews_model($params);
		}

		return $thefactory["reviews"];
	}
	
	function getList(){
		
	
		//$colList = "CONCAT( ifnull(".$this->_item_rated->tblname.".".$this->_item_rated->field.",'') ) as rated_object ";
		$colList = "{$this->_item_rated->tblname}.{$this->_item_rated->field}  as rated_object ";
		$joinList = "LEFT JOIN {$this->_item_rated->tblname} ON {$this->_item_rated->tblname}.id = r.auction_id ";
		
		$this->_db->setQuery(
		" SELECT r.* , u.username as rauthor, ur.username as user_rated, $colList
		FROM $this->_tblname as r
		LEFT JOIN #__users AS u ON r.voter = u.id 
		LEFT JOIN #__users AS ur ON r.user_rated = ur.id 
		$joinList
		ORDER BY modified DESC "
		);
		
		return $this->_db->loadObjectList();
		
	}
	
}

?>