<fieldset class="adminform">
	<legend><?php echo JText::_( 'Image settings' ); ?></legend>
	<table class="paramlist admintable" width="100%">
    <tr class="hasTip" title="<?php echo JText::_('GD must be installed in order to proccess images');?>">
    	<td width="40%" class="paramlist_key">
    		<strong><?php echo JText::_("GD Version");?>:</strong>
    	</td>
    	<td class="paramlist_value">
    		<?php 
    		$gdVersion = JTHEF_get_gd_version();
    		if($gdVersion!=false) echo $gdVersion; else echo JText::_("GD not installed!");
    		?>
    	</td>
    </tr>
    <tr>
    	<th colspan="2" align="left"><?php echo JText::_("Image thumb settings"); echo JHTML::_('tooltip', JText::_("HELP_RESIZE_THUMB")); ?></th>
    </tr>
    <tr>
		<td class="paramlist_key">
			<span style="margin-left:10px">&nbsp;</span><?php echo JText::_("Image thumb width resize"); ?>:&nbsp;
		</td>
		<td class="paramlist_value">
			<input name="thumb_resize_width" value="<?php if(defined("bid_opt_thumb_width")) echo bid_opt_thumb_width; else echo "100";?>" size="5"/> (px)
		</td>
    </tr>
    <tr>
    	<td class="paramlist_key">
			<span style="margin-left:10px">&nbsp;</span><?php echo JText::_("Image thumb height resize"); ?>:&nbsp;
    	</td>
    	<td class="paramlist_value">
    		<input name="thumb_resize_height" value="<?php if(defined("bid_opt_thumb_height")) echo bid_opt_thumb_height; else echo "100";?>"  size="5"/> (px)
    	</td>
    </tr>
    <tr>
		<th colspan="2"  align="left">
			<?php  echo JText::_("Image medium settings"); echo JHTML::_('tooltip',JText::_("HELP_RESIZE_MEDIUM")); ?>
		</th>
	</tr>
	<tr>
		<td class="paramlist_key">
			<span style="margin-left:10px">&nbsp;</span><?php echo JText::_("Image medium width resize"); ?>:&nbsp;
		</td>
		<td class="parmlist_value">
			<input name="medium_resize_width" value="<?php if(defined("bid_opt_medium_width")) echo bid_opt_medium_width; else echo "200";?>" size="5" /> (px)
		</td>
	</tr>
	<tr>
		<td class="paramlist_key">
			<span style="margin-left:10px">&nbsp;</span><?php echo JText::_("Image medium height resize"); ?>:&nbsp;
		</td>
		<td class="parmlist_value">
			<input name="medium_resize_height" value="<?php if(defined("bid_opt_medium_height")) echo bid_opt_medium_height; else echo "200";?>" size="5" /> (px)
		</td>
	</tr>
	<tr>
		<td class="paramlist_key">
			<?php echo JText::_("Max picture size"); ?>:&nbsp;
		</td>
		<td class="paramlist_value">
			<input name="bid_opt_max_picture_size" value="<?php if(defined("bid_opt_max_picture_size")) echo bid_opt_max_picture_size; else echo "1024";?>" size="12" onkeyup="document.getElementById('tf_mega_size').innerHTML=this.value/1024;"> (Kb)
			 - <span id="tf_mega_size"><?php if(defined("bid_opt_max_picture_size")) echo bid_opt_max_picture_size/1024; else echo 1024/1024;?></span> (MB)<br />
		</td>
	</tr>
    <tr>
		<th colspan="2"  align="left">
			<?php  echo JText::_("Other image settings"); ?>
		</th>
	</tr>
    <tr class="hasTip" title="<?php echo JText::_('The allowed number of an images uploaded in an item');?>">
    	<td class="paramlist_key">
        	<?php echo JText::_("Max nr images");?>:&nbsp;
        </td>	
        <td class="paramlist_value">
        	<input name="max_nr_img" value="<?php if(defined("bid_opt_maxnr_images")) echo bid_opt_maxnr_images; else echo "3"; ?>" size="3">
    	</td>
    </tr>
    <tr>
		<td class="paramlist_key">
			<?php echo JText::_("Require image"); ?>:&nbsp;
		</td>
		<td class="paramlist_value">
			<input name="require_image" <?php if(defined("bid_opt_require_picture") && bid_opt_require_picture!=0) echo "checked"; ?> type="checkbox" value="1">
		</td>
     </tr>
	</table>
</fieldset>	
<?php 

/**
 * Returns the Installed version of GD
 *  or false if not installed
 * 
 *
 * @return string / bool if not installed
 */
function JTHEF_get_gd_version(){
	$gd = array();
	ob_start();
	@phpinfo(INFO_MODULES);
	$output=ob_get_contents();
	ob_end_clean();
	
	if(preg_match("/GD Version[ \t]*(<[^>]+>[ \t]*)+([^<>]+)/s",$output,$matches)){
		return $matches[2];
	}
	
	return false;
}

?>