<?php
// no direct access
/**
 * @package     AuctionsFactory
 * @version     2.0.0
 * @copyright   www.thefactory.ro
 * @license     commercial
 * @modified    30-07-2010 (dd-mm-YYYY)
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class TOOLBAR_userss  {
	function _DEFAULT() {
      JToolBarHelper::title(JText::_( 'Auctions Factory - <small>User Management</small>'),"user.png");
		JToolBarHelper::custom('detailuser','edit','edit','Edit',true);
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::custom('blockuser','cancel','cancel','Block',true);
		JToolBarHelper::spacer();
		JToolBarHelper::custom('unblockuser','apply','apply','Unblock',true);
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		if (bid_opt_enable_acl && bid_opt_acl_type=='profile'){
    		JToolBarHelper::custom('toggleseller','apply','apply','Toggle Seller',false);
	       	JToolBarHelper::custom('togglebidder','apply','apply','Toggle Bidder',false);
			JToolBarHelper::spacer();
			JToolBarHelper::divider();
			JToolBarHelper::spacer();
		}
       	JToolBarHelper::custom('togglepowerseller','apply','apply','Toggle Powerseller',false);
       	JToolBarHelper::custom('toggleverify','apply','apply','Toggle Verify',true);
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		//JToolBarHelper::custom( 'aboutComponent','help','help', 'About Component', false );
	}

	function _NEW() {
        JToolBarHelper::title(JText::_( 'Auctions Factory - <small>New User</small>'));
		JToolBarHelper::custom('offers','back','back','Back',false);
	}

	function _EDIT() {
        JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Edit User</small>'),"user.png");
		JToolBarHelper::custom('offers','back','back','Back to Auctions',false);
		JToolBarHelper::custom('users','back','back','Back to Users',false);
	}
}

class TOOLBAR_settings  {
	function _DEFAULT() {
      JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Settings</small>'));
		JToolBarHelper::custom('savesettings','save','save','Save',false);
		JToolBarHelper::spacer();
		JToolBarHelper::custom('offers','back','back','Cancel',false);
	}
	
	function _SETTINGS($title,$savetask){
		
		$task = &JRequest::getCmd("task");
		
		if ($title) {
			$title = ': <small><small>[ '. $title.' ]</small></small>';
			$title =  'Auctions Factory Settings'.$title;
		}
		
		JToolBarHelper::title( JText::_($title), 'cpanel.png' );
		JToolBarHelper::custom($savetask,'save','save','Save',false);
		JToolBarHelper::divider();
		if( $task!="" && $task!="settingsmanager" )
			TOOLBidsHelper::_SETTINGS_SUBMENU();
	}
	
	function _NONE($title){
		
		$task = &JRequest::getCmd("task");
		if ($title) {
			$title = ': <small><small>[ '. $title.' ]</small></small>';
			$title =  'Auctions Factory Settings'.$title;
		}
		
		JToolBarHelper::title( JText::_($title), 'cpanel.png' );
		JToolBarHelper::divider();
		if( $task!="" && $task!="settingsmanager" )
			TOOLBidsHelper::_SETTINGS_SUBMENU();
	}
	
	function _TOOLS($title){
		
		$task = &JRequest::getCmd("task");
		if ($title) {
			$title = ': <small><small>[ '. $title.' ]</small></small>';
			$title =  'Auctions Factory Tools'.$title;
		}
		
		JToolBarHelper::title( JText::_($title), 'cpanel.png' );
		JToolBarHelper::divider();
		if( $task!="" && $task!="settingsmanager" )
			TOOLBidsHelper::_TOOLS_SUBMENU();
	}
	
	function _CBINTEGRATION(){
       JToolBarHelper::title(JText::_( 'Auctions Factory - <small>CB Integration</small>'));
	   JToolBarHelper::custom('savecbsettings','save','f_save','Save',false);
	}
	
   function _INCREMENTLIST(){
       JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Price Increment Configuration</small>'));
    }
}

class TOOLBAR_offers  {
	
	function _DEFAULT() {
		
		JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Manage Listings</small>'), "article");
		JToolBarHelper::custom('closed','cancel','cancel','Close',true);
		JToolBarHelper::custom('opened','apply','apply','Open',true);
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::custom('editoffer','edit','edit','Edit',false);
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		//JToolBarHelper::custom( 'aboutComponent','help','help', 'About Component', false );

	}

	function _EDIT() {
		JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Edit Listing</small>'), "article");
		JToolBarHelper::custom('offers','back','back','Back to Auctions',false);
		JToolBarHelper::custom('users','back','back','Back to Users',false);
	}
	
	function _REPORTMESSAGE(){
		JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Reported Listings</small>'));
		JToolBarHelper::custom('send_message_auction','apply','apply','Send Message',false);
		JToolBarHelper::custom('offers','back','back','Back',false);
	}
}

class TOOLBAR_categories {
	
	function _DEFAULT() {
       JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Category Management</small>'));
		JToolBarHelper::custom( 'showMoveCategories', 'move', 'move_f2', 'Move categories', true );
		JToolBarHelper::addNew('newcat');
		JToolBarHelper::editList('editcat');
		JToolBarHelper::deleteList('','deletecats','Delete');
		JToolBarHelper::custom( 'purgecategories', 'delete', 'delete_f2', 'Purge Categories' , false );
		JToolBarHelper::custom('offers','back','back','Back',false);
	}

	function _EDIT() {
		
		JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Edit Category</small>'));
		JToolBarHelper::custom('savecat','save','save','Save',false);
		JToolBarHelper::back("Back");

	}
}


class TOOLBAR_reports  {
	function _DEFAULT() {
       JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Reported Listings</small>'));
		JToolBarHelper::custom('solved','apply','apply','Set Solved',false);
		JToolBarHelper::custom('unsolved','cancel','cancel','Unset Solved',false);
		JToolBarHelper::spacer();
		JToolBarHelper::custom('processing','apply','apply','Set in Processing',false);
		JToolBarHelper::custom('unprocessing','cancel','cancel','Unset in Processing',false);
		//JToolBarHelper::custom( 'aboutComponent','help','help', 'About Component',false );
	}
}
class TOOLBAR_installm  {
	function _DEFAULT(){
       JToolBarHelper::title(JText::_( 'Auctions Factory'));
	   JToolBarHelper::custom( 'aboutComponent','help','help', 'About Component', false );
	}

}
class TOOLBAR_statistics  {
	function _DEFAULT(){
       JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Statistics</small>'));
	   JToolBarHelper::custom( 'aboutComponent','help','help', 'About Component', false );
	}
}
class TOOLBAR_aboutComponent  {
	function _DEFAULT(){
       JToolBarHelper::title(JText::_( 'Auctions Factory - <small>About Extension</small>'));
	   JToolBarHelper::custom('offers','back','back','Back',false);
	}

}
class TOOLBAR_import {
	function _DEFAULT(){
      JToolBarHelper::title(JText::_( 'Auctions Factory Tools: [ <small>Import Listings</small> ]'));
		JToolBarHelper::custom('importcsv','save','save','Save',false);
		JToolBarHelper::custom('offers','back','back','Back',false);
		TOOLBidsHelper::_TOOLSSUBMENUHelper();
	}
}
class TOOLBAR_bkp {
	function _DEFAULT(){
      JToolBarHelper::title(JText::_( 'Auctions Factory Tools: [ <small>Backup/Restore</small> ]'));
		JToolBarHelper::custom('restorebackup','save','save','Save',false);
		JToolBarHelper::custom('offers','back','back','Back',false);
		TOOLBidsHelper::_TOOLSSUBMENUHelper();
	}
}
class TOOLBAR_payment {
    function _DEFAULT()
    {
		JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Payment Manager</small>'), 'cpanel');
		JToolBarHelper::custom('enablepayment','apply','apply','Enable/ Disable',true);
		JToolBarHelper::custom('setdefaultpayment','default','default','Set as default',true);
		JToolBarHelper::custom('paymentmanager','back','back','Back',false);
    }
    function _SAVE()
    {
       JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Save Payment Config</small>'));
		JToolBarHelper::custom('savepaymentconfig','save','save','Save',false);
		JToolBarHelper::custom('paymentconfig','back','back','Back',false);
    }
    function _PAYMENTITEMS()
    {
		JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Payment Items</small>'),'module');
		JToolBarHelper::custom('enablepaymentitem','apply','apply','Enable/ Disable',false);
		JToolBarHelper::custom('paymentmanager','back','back','Back',false);
    }
    function _SAVE_ITEM()
    {
       JToolBarHelper::title(JText::_( 'Auctions Factory'));
		$action = JRequest::getVar('action', "");
		if($action!="add_payment"){
			JToolBarHelper::custom('savepaymentitemsconfig','save','save','Save',false);
			JToolBarHelper::custom('paymentitems','back','back','Back',false);
		}		

    }
    function _PAYMENTLIST()
    {
		JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Received Payments</small>'), "impressions");
		JToolBarHelper::custom('approve_payment','apply','apply','Approve Payment',true);
		JToolBarHelper::custom('new_payment','new','new','New Payment',false);
		JToolBarHelper::custom('deletePaylog','delete','delete','Delete Paylog',true);
		JToolBarHelper::custom('paymentitems','back','back','Back',false);
    }
    
    function _NEWPAYMENT()
    {
		JToolBarHelper::title(JText::_( 'Auctions Factory - <small>New Payment</small>'));
		JToolBarHelper::custom('save_payment','save','save','Save Payment',false);
		JToolBarHelper::custom('paymentitems','back','back','Back',false);
    }
}

class TOOLBidsHelper{
	
	function _SETTINGS_SUBMENU(){
		
		$bar = & JToolBar::getInstance('toolbar');
		// Add an apply button
		$bar->appendButton( 'link', 'config', "Settings", "index.php?option=com_bids&task=settingsmanager", false, false );
		
		TOOLBidsHelper::_SUBMENUHelper();
		
	}
	
	function _SUBMENUHelper(){
		$task = &JRequest::getCmd("task");
		$menu = &JToolBar::getInstance('submenu');
		$menu->appendButton("General Settings", "index.php?option=com_bids&amp;task=settings",($task=="settings")?1:0);
		$menu->appendButton("Mail Settings", "index.php?option=com_bids&amp;task=mailsettings",($task=="mailsettings")?1:0);
		$menu->appendButton("Custom Fields", "index.php?option=com_bids&amp;task=field_administrator",(($task=="field_administrator")||($task=="fposition_panel") || ($task=="fposition_fields")|| ($task=="fposition_templates"))?1:0);
		$menu->appendButton("Plugins", "index.php?option=com_bids&amp;task=plugins_administrator",(($task=="plugins_administrator" || $task=="themes_administrator" || $task=="gallery_administrator" || $task=="gateway_administrator" ))?1:0);
		$menu->appendButton("Payment Items", "index.php?option=com_bids&amp;task=paymentitems",($task=="paymentitems" || $task=="paymentitemsconfig")?1:0);
		$menu->appendButton("Payment Gateways", "index.php?option=com_bids&amp;task=paymentconfig",($task=="paymentconfig")?1:0);
		$menu->appendButton("Shipping", "index.php?option=com_bids&amp;task=shipping_administrator",($task=="shipping_administrator")?1:0);
		//$menu->appendButton("Shipping", "index.php?option=com_bids&amp;task=shipping_administrator",($task=="shipping_administrator")?1:0);
		$menu->appendButton("Country Manager", "index.php?option=com_bids&amp;task=countries",($task=="countries")?1:0);
		$menu->appendButton("Profile Integration", "index.php?option=com_bids&amp;task=integration",($task=="integration")?1:0);
		
	}
	
	function _TOOLS_SUBMENU(){
		
		$bar = & JToolBar::getInstance('toolbar');
		// Add an apply button
		$bar->appendButton( 'link', 'config', "Tools", "index.php?option=com_bids&task=auctionmanager", false, false );
		
		TOOLBidsHelper::_TOOLSSUBMENUHelper();
		
	}
	
	function _TOOLSSUBMENUHelper(){
		$task = &JRequest::getCmd("task");
		$menu = &JToolBar::getInstance('submenu');
		$menu->appendButton("Messages", "index.php?option=com_bids&amp;task=comments_administrator",($task=="comments_administrator")?1:0);
		$menu->appendButton("Ratings", "index.php?option=com_bids&amp;task=reviews_administrator",($task=="reviews_administrator")?1:0);
		$menu->appendButton("Bid History", "index.php?option=com_bids&amp;task=bid_stats",($task=="bid_stats")?1:0);
		$menu->appendButton("Auction Statistics", "index.php?option=com_bids&amp;task=statistics",($task=="statistics")?1:0);
		
		$menu->appendButton("Export Auctions to XLS", "index.php?option=com_bids&amp;task=exportToXls",($task=="exportToXls")?1:0);
		$menu->appendButton("Import Auctions from CSV", "index.php?option=com_bids&amp;task=showadmimportform",($task=="showadmimportform")?1:0);
		$menu->appendButton("Backup Auctions", "index.php?option=com_bids&amp;task=backup",($task=="backup")?1:0);
		$menu->appendButton("Restore Auctions", "index.php?option=com_bids&amp;task=showrestoreform",($task=="showrestoreform")?1:0);
		$menu->appendButton("Purge Expired Auctions", "index.php?option=com_bids&amp;task=purgeauctions",($task=="purgeauctions")?1:0);
	}
	
}
?>