<?php
/**
 * @package AuctionsFactory
 * @version 1.6.0
 * @copyright www.thefactory.ro
 * @license: commercial
 * @modified: 28-05-2009 (dd-mm-YYYY)
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$page_titles = array(
	"settings" => "General Settings",
	"mailsettings" => "Mail Settings",
	"showadsconfig" => "Import / Export",
	"integration" => "User Profiler Integration",
	"countries" => "",
	"paymentconfig" => "Payment Gateways Config",
	"showpaymentconfig" => "Payment Gateways Config",
	"paymentitems" => "Payment Pricing Items",
	"paymentitemsconfig" => "Payment Pricing Items",
	"plugins_administrator" => "Plugins Management",
	"field_administrator" => "Custom Fields & Page Positions",
	"fposition_panel" => "Custom Fields & Page Positions",
	"fposition_fields" => "Custom Fields & Page Positions",
	"fposition_templates" => "Custom Fields & Page Positions",
	"countries" => "Country Manager",
	"themes_administrator" => "Themes Administrator",
	"gallery_administrator" => "Gallery Plugins",
	"gateway_administrator" => "Payment Gateway Plugins",
	"shipping_administrator" => "Shipping Zones Configuration",
	"comments_administrator" => "Messages",
	"reviews_administrator" => "Ratings",
	"bid_stats" => "Bid History",
	"statistics" => "Statistics"
);



require_once( JApplicationHelper::getPath( 'toolbar_html' ) );
switch ($task) {
	case 'settings':
		TOOLBAR_settings::_SETTINGS($page_titles[$task],'savesettings');
		break;
	case 'mailsettings':
		TOOLBAR_settings::_SETTINGS($page_titles[$task],'savemailsettings');
      break;

	case 'integration'  :
	case 'countries'  :
	case 'paymentconfig'  :
	case 'showpaymentconfig' :
	case 'paymentitems' :
	case 'plugins_administrator'  :
	case 'field_administrator'  :
	case 'fposition_panel' :
	case 'fposition_fields' :
	case 'fposition_templates' :
	case 'paymentitemsconfig'  :
	case 'countries'  :
	case 'themes_administrator'  :
	case 'gallery_administrator':
	case 'gateway_administrator':
	case 'shipping_administrator':
		TOOLBAR_settings::_NONE($page_titles[$task]);
		break;

	case 'comments_administrator':
	case 'reviews_administrator':	
	case 'bid_stats':	
	case 'statistics':
		TOOLBAR_settings::_TOOLS($page_titles[$task]);
		break;
		
	
	case 'detailuser':
		TOOLBAR_userss::_EDIT();
		break;

	case 'editoffer':
	case 'editofferA':
		TOOLBAR_offers::_EDIT();
		break;
	case 'write_admin_message':
	    TOOLBAR_offers::_REPORTMESSAGE();
	    break;
	//default:
	case 'offers':
		TOOLBAR_offers::_DEFAULT();
		break;
	case'categories':
		TOOLBAR_categories::_DEFAULT();
		break;
	case'editcat':
	case'newcat':
		TOOLBAR_categories::_EDIT();
		break;
	case 'users':
		TOOLBAR_userss::_DEFAULT();
		break;
	case 'cb_integration':
		TOOLBAR_settings::_CBINTEGRATION();
		break;
	case 'reported_offers':
		TOOLBAR_reports::_DEFAULT();
		break;
	case 'installOpt':
		TOOLBAR_installm::_DEFAULT();
		break;
	case'statistics':
		TOOLBAR_statistics::_DEFAULT();
		break;
	case'aboutComponent':
		TOOLBAR_aboutComponent::_DEFAULT();
		break;
	case 'showadmimportform':
	case 'importcsv':
		TOOLBAR_import::_DEFAULT();
	break;
	case'showrestoreform':
		TOOLBAR_bkp::_DEFAULT();
	break;
	case 'paymentitemsconfig':
	    TOOLBAR_payment::_SAVE_ITEM();
	break;
	case 'payments':
	    TOOLBAR_payment::_PAYMENTLIST();
	break;
	case 'new_payment':
	    TOOLBAR_payment::_NEWPAYMENT();
	break;
	case 'auctionmanager':
        JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Data Management</small>'));    
	break;
	case 'paymentmanager':
        JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Payments</small>'));    
	break;
	case 'settingsmanager':
        JToolBarHelper::title(JText::_( 'Auctions Factory - <small>Settings</small>'));    
	break;
    case 'increment_list':
        TOOLBAR_settings::_INCREMENTLIST();      
    break;
    case 'increment_edit':
        TOOLBAR_settings::_INCREMENTLISTEDIT();      
    break;
    default:
    case 'dashbord':
		
    break;
}
?>