<?php


// fucking remove
if(!function_exists("mosStripslashes")){
	function mosStripslashes( &$value )
	{
		$ret = '';
		if (is_string( $value )) {
			$ret = stripslashes( $value );
		} else {
			if (is_array( $value )) {
				$ret = array();
				foreach ($value as $key => $val) {
					$ret[$key] = mosStripslashes( $val );
				}
			} else {
				$ret = $value;
			}
		}
		return $ret;
	}
}

/**
 * @package AuctionsFactory
 * @version 1.7.0
 * @copyright www.thefactory.ro
 * @license: commercial
 * @modified: 29-07-2010 (dd-mm-YYYY)
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class JAuctions extends FactoryFieldsTbl {
	var $id					= null;
	var $userid				= null;
	var $title				= null;
	var $shortdescription	= null;
	var $description		= null;
	var $picture			= null;
	var $link_extern		= null;
	var $initial_price		= null;
	var $currency			= null;
	var $BIN_price			= null;
	var $auction_type		= null;
	var $automatic          = null;
	var $payment			= null;
	var $shipment_info		= null;
	var $shipment_price		= null;
	var $start_date			= null;
	var $end_date			= null;
	var $closed_date		= null;
	var $params 			= null;
	var $published			= null;
	var $close_offer		= null;
	var $close_by_admin		= null;
	var $hits				= null;
	var $modified			= null;
	var $newmessages        = null;
	var $winner_id          = null;
	var $cat				= null;
	var $auction_nr         = null;
	var $nr_items           = null;
	var $nr_items_left      = null;
	var $featured           = null;
	var $reserve_price      = null;
	var $min_increase		= null;
	var $extended_counter	= null;
	var $payment_info		= null;
	//  [+] 1.6.7
	var $quantity			= null;

    var $_allowed_picture_ext = array('JPEG','JPG','GIF','PNG');
    //Parameters and default values
    var $_parameters=array("picture"=>1,
                           "add_picture"=>1,
                           "auto_accept_bin"=>1,
                           "bid_counts"=>1,
                           "max_price"=>1,
                           "show_reserve"=>0,
                           "price_suggest"=>0,
                           "price_suggest_min"=>''
                           );

/**
* @param database A database connector object
*/
	function JAuctions( &$db ) {
		$this->__construct( '#__bid_auctions', 'id', $db );
	}
	
	function load($id){
		$f = parent::load($id);
		$this->title = mosStripslashes($this->title);
		return $f;
	}
	
	function hit(){
		$this->_db->setQuery("update ".$this->_tbl." set hits=hits+1 ".
		"\n where id='$this->id'");
		return $this->_db->query();

	}
	
    function isMyAuction()
    {
        $my = &JFactory::getUser();
        if ($my->id && $my->id==$this->userid) return true;
        else return false;
    }
    function validAuctionType($auction_type)
    {
    	return in_array($this->auction_type,array(AUCTION_TYPE_BIN_ONLY,AUCTION_TYPE_PRIVATE,AUCTION_TYPE_PUBLIC));
    }
	function check(){
		
		//require_once(JPATH_ROOT."/components/com_bids/options.php");
		//echo $this->userid;exit;
		$error = array();
    	$this->_db->setQuery("select count(id) from #__users where id=$this->userid");
		$uid_exists = $this->_db->loadResult();
	
		if($uid_exists==0){
			$error['userid'] = bid_import_check_userid;
		}
		if($this->auction_type){
			switch ($this->auction_type){
				case 'public':
					$auction_type = 1;
				break;
				case 'private':
					$auction_type = 2;
				break;
				default:
				break;
			}
		}
		if ($this->title==''){
			$error['title'] = bid_import_check_title;
		}

		if ($this->BIN_price>0 && $this->BIN_price<$this->initial_price && $this->initial_price>0){
			$error['BIN'] = bid_import_check_BIN;
		}
    	if(floatval($this->initial_price)<=0 && ($this->auction_type!=AUCTION_TYPE_BIN_ONLY)){
    		$error['Initialprice'] =bid_err_initial_price;
    	}

		if(!is_numeric($this->currency)){
			if (!$this->currency){
				$error[] = bid_import_check_currency;
			}else {

				$this->_db->setQuery("select id from #__bid_currency where name like '$this->currency%'");

				$currency = $this->_db->loadResult();
				if(!$currency){
					$error['currency'] = bid_import_check_currency;
				}
			}
		}else {

			$this->_db->setQuery("select count(id) from #__bid_currency where id=$this->currency");
			$curexists = $this->_db->loadResult();
			if($curexists==0){
				$error['currency'] = bid_import_check_currency;
			}
		}

		if(!$this->validAuctionType($this->auction_type)){
			$error['auction_type'] = bid_import_check_auction_type;
		}

		if(bid_opt_enable_date && strtotime($this->start_date)>=strtotime($this->end_date)){
			$error['end_date'] = bid_import_check_end_date;
		}
		
		return $error;
	}
	
	function acl_check($user){
		if ($this->id==null) return true;//new offer
		if ($user->gid==25) return true;//superadmin
		return ($user->id==$this->userid);

	}
	function delete( $oid=null ) {
	    if ($oid){
	        $this->load($oid);
	    }

	    $this->_db->setQuery("select * from #__bid_pictures where id_offer='$this->id'");
	    $images=$this->_db->loadObjectList();
	    if (count($images)){
	        foreach ($images as $image){
	            if (file_exists(AUCTION_PICTURES_PATH.$image->picture)){
        	        @unlink(AUCTION_PICTURES_PATH.$image->picture);
        	        @unlink(AUCTION_PICTURES_PATH."middle_".$image->picture);
        	        @unlink(AUCTION_PICTURES_PATH."resize_".$image->picture);
	            }
	        }
	    }

	    if (file_exists(AUCTION_PICTURES_PATH.$this->picture)){
	        @unlink(AUCTION_PICTURES_PATH.$this->picture);
	        @unlink(AUCTION_PICTURES_PATH."middle_".$this->picture);
	        @unlink(AUCTION_PICTURES_PATH."resize_".$this->picture);

	    }

		$this->_db->setQuery("delete from #__bid_tags where auction_id='$this->id'"); //remove pictures
		$this->_db->query();
		JAuctionImages::delImages($id);
		$this->_db->setQuery("delete from #__bids where id_offer='$this->id'"); //remove bids
		$this->_db->query();
		$this->_db->setQuery("delete from #__bid_proxy where auction_id='$this->id'"); //remove pictures
		$this->_db->query();
		$this->_db->setQuery("delete from #__bid_report_auctions where id_offer='$this->id'"); //remove pictures
		$this->_db->query();
		$this->_db->setQuery("delete from #__bid_watchlist where auctionid='$this->id'"); //remove watches
		$this->_db->query();
		$this->_db->setQuery("delete from #__bid_messages where id_offer='$this->id'"); //remove watches
		$this->_db->query();
		$this->_db->setQuery("delete from #__bid_auctions where id='$this->id'"); //remove the auction
		$this->_db->query();


	}
	function cron_close_offers(){
//TO DO!!
		$this->_db->setQuery("update ".$this->_tbl." set closed_date=end_date, close_offer='1' ".
		"\n where end_date<now() and close_offer<>'1' ");

		$q = "select id, closed_date, end_date from #__bid_auctions where end_date<now() and closed_date='0000-00-00'";
		$this->_db->setQuery($q);
		$rs = $this->_db->loadObjectList();
		for($i=0;$i<count($rs);$i++){
			$r = $rs[$i];
			$q = "update #__bid_auctions set closed_date=end_date, close_offer='1' where end_date<now() and id='$r->id' and (closed_date='0000-00-00' or closed_date='')";
			$this->_db->setQuery($q);
			$this->_db->query();

			$sql = "select title from #__bid_auctions where id=$r->id";
			$this->_db->setQuery($sql);
			$title = $this->_db->loadResult();

			$q = "SELECT u.email, bu.name, bu.surname
				  FROM #__users u, #__bid_users bu, #__bid_auctions bo
				  WHERE bo.id = $r->id
				  AND u.id = bo.userid
				  AND bu.userid = u.id";
			$this->_db->setQuery($q);
			$this->_db->loadObject($off);

			$name 		= $off->name;
			$surname	= $off->surname;
			$email		= $off->email;

			//notice mail about the canceling of the offer
			$mess = "Dear $name ".$surname.",<br><br>We announce you that your offer <b>$title</b> will expire in 24 hours.<br>Please visit our site to see details!<br><br>Echipa blabla.";

			$headers  = 'MIME-Version: 1.0' . "\r\n";
			$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";

			$subject = "The offer $title was modified!";
			mail($email, $subject, $mess, $headers);
		}

		return $this->_db->query();
	}

	function SendMails($userlist,$mailtype){

		$app = & JFactory::getApplication();
		set_time_limit(0);
		ignore_user_abort();
		$mail_body=new JAuctionMails($this->_db);
		if (!$mail_body->load($mailtype) ) return;
		if (!$mail_body->enabled) return;
		if (count($userlist)<=0) return;
		$bid = $this->getBestBid();
		$database = &JFactory::getDBO();
		$database->setQuery("SELECT id FROM #__menu WHERE link LIKE '%task=listauctions%' ");
		$itemId = $database->loadResult();
		
		$database->setQuery("SELECT email FROM #__users WHERE id = '{$this->userid}' ");
		$auctioneerEMAIL = $database->loadResult();
		
		$winnerEMAIL = null;
		if($this->winner_id>0){
			
			$database->setQuery("SELECT email FROM #__users WHERE id = '{$this->winner_id}' ");
			$winnerEMAIL = $database->loadResult();

		}else{
			$database->setQuery("SELECT email FROM #__bids b LEFT JOIN #__users u ON u.id = b.userid WHERE id_offer = '{$this->id}' AND accept = 1  ORDER BY b.modified DESC");
			$winnerEMAIL = $database->loadResult();
		}
		foreach($userlist as $can){
			//notice mail about the canceling of the offer

			$mess =str_replace("%NAME%",$can->name,$mail_body->content);
			$mess =str_replace("%SURNAME%",@$can->surname,$mess);
			$mess =str_replace("%AUCTIONTITLE%",mosStripslashes($this->title),$mess);
			$mess =str_replace("%AUCTIONDESCR%",mosStripslashes($this->description),$mess);
			$mess =str_replace("%AUCTIONSTART%",$this->start_date,$mess);
			$mess =str_replace("%AUCTIONEND%",$this->end_date,$mess);
			$mess = str_replace("%AUCTIONLINK%", JURI::root().'/index.php?option=com_bids&task=viewbids&Itemid='.$itemId.'&id='.$this->id  ,$mess);
			
			$mess =str_replace("%AUCTIONDESCR%",mosStripslashes($this->description),$mess);
			$mess =str_replace("%AUCTIONSTART%",$this->start_date,$mess);
			$mess =str_replace("%AUCTIONEND%",$this->end_date,$mess);
			if(isset($bid->bid_price))
				$mess =str_replace("%BIDPRICE%",$bid->bid_price,$mess);

			$mess =str_replace("%AUCTIONEEREMAIL%",$auctioneerEMAIL,$mess);
			$mess =str_replace("%WINNEREMAIL%",$winnerEMAIL,$mess);
			
			$subj =str_replace("%NAME%",$can->name,$mail_body->subject);
			$subj =str_replace("%SURNAME%",@$can->surname,$subj);
			$subj =str_replace("%AUCTIONTITLE%",mosStripslashes($this->title),$subj);
			$subj =str_replace("%AUCTIONEEREMAIL%",$auctioneerEMAIL,$subj);
			$subj =str_replace("%WINNEREMAIL%",$winnerEMAIL,$subj);
			
			$subj =str_replace("%AUCTIONLINK%",JURI::root().'/index.php?option=com_bids&task=viewbids&Itemid='.$itemId.'&id='.$this->id,$subj);
			/*
			if($mailtype=="suggest_accepted"){
				echo $can->email;
				echo "<hr />";
				echo $subj;
				echo "<hr />";
				echo $mess;
				exit;
			}
			*/
			$mail_from = $app->getCfg('mailfrom');
			$site_name = $app->getCfg('sitename');
			if($can->email)
			     JUtility::sendMail($mail_from,$site_name,$can->email, $subj, $mess, true);
		}

   }

	function sendNewMessage($id,$id_msg,$message,$id_bidder=null){
       
		$my = &JFactory::getUser();

		$m = new JAuctionMessages( $this->_db );

		if( !$id_msg ){
			
			$m->id_offer		= $this->id;
			$m->parent_message	= 0;
			$m->message			= $message;
			$m->modified		= date('Y-m-d H:i:s',time());
			$m->userid1			= $my->id;
			if ($id_bidder)
			    $m->userid2=$id_bidder;
			else
			    $m->userid2=$this->userid;
			
			$usr = JTable::getInstance("user");
			$usr->load($this->userid);
			
			$this->SendMails(array($usr),"new_message");

        } else {
        	
			$replytom = new JAuctionMessages($this->_db);
			$replytom->load($id_msg);
			$m->id_offer 		= $this->id;
			$m->parent_message 	= $id_msg;
			$m->userid1 		= $my->id;
			$m->userid2 		= $replytom->userid1;
			$m->modified 		= date('Y-m-d H:i:s',time());
			$m->message 		= $message;
			$replytom->wasread 	= 1;
			$replytom->store();
			
			$usr = JTable::getInstance("user");
			$usr->load($replytom->userid1);
			
			$this->SendMails(array($usr),"new_message");
        }

		$m->store();

	}
    
    function isAllowedImage($ext)
    {

        return in_array(strtoupper($ext),$this->_allowed_picture_ext);
    }
    
    function ChooseWinner(){
    	//Chooses the Winner in the current auction

    	if (!$this->id) return; // must be loaded

    	$usr = new JTableUser($this->_db);

    	$query = "SELECT b.* FROM #__bids b
        	where b.id_offer = $this->id order by bid_price+0 desc limit 1
    	";

    	$this->_db->setQuery($query);

    	$winner =null;
    	$this->_db->LoadObject($winner);

		if($winner){
        	$query = "SELECT *  from #__bids where id_offer=$this->id and bid_price='$winner->bid_price'";
        	$this->_db->setQuery($query);
        	$isduplicate = $this->_db->loadObjectList();

        	if (count($isduplicate)>1){
	        	$query = "UPDATE #__bid_auctions SET automatic = '0' WHERE id=$this->id";
	        	$this->_db->setQuery($query);
	        	$this->_db->query($query);
    			$usr->load($this->userid);
    			$this->SendMails(array($usr),'bid_choose_winner');//alert owner that 2 or more bids are the same
        	}else{

        	    if ($this->reserve_price>0 && $this->reserve_price>$winner->bid_price){
        	        //reserve price not met!
        			$usr->load($this->userid);
        			$this->SendMails(array($usr),'bid_reserve_not_met');//reserve price not met


        	    }else{
        			$usr->load($winner->userid);
        			$this->winner_id = $winner->userid;
        			$this->store();

					$this->_db->setQuery("update #__bids set accept=1 where id='".$isduplicate[0]->id."'");
					$this->_db->query();

        			$this->SendMails(array($usr),'bid_accepted');

        	    	$usr->load($this->userid);
        	    	$this->SendMails(array($usr),'bid_offer_winner_to_owner');
        	    }
        	}

	    } else {
	    	$usr->load($this->userid);
	    	$this->SendMails(array($usr),'bid_offer_no_winner_to_owner');
		}

    }
    
    function SetPaymentMethod($payment_method_name)
    {
        $this->_db->setQuery("select id from #__bid_payment where name='$payment_method_name'");
        $this->payment=$this->_db->LoadResult();
        return $this->payment;
    }
    
    function SetCategory($category_name)
    {
        $this->_db->setQuery("select id from #__bid_categories where catname='".$category_name."'");
        $this->cat=$this->_db->LoadResult();
        return $this->cat;
    }
    
    function SetCurrency($currency_name)
    {
        $this->_db->setQuery("select id from #__bid_currency where name='".$currency_name."'");
        $this->currency=$this->_db->LoadResult();
        return $this->currency;
    }
    /**
     * Fixed in 1.6.9
     *  issue: Returned only the single payment option
     *
     * @return mixed
     * @since 1.6.9
     */
    function GetPaymentMethod()
    {
		if(bid_opt_payment_select_mode==0){
			
			$payment = "";
			$auction_Payments = new JAuctionPayments($this->_db);
			$auction_Payments->auct = $this->id;
			$paymentList = $auction_Payments->getAuctionPaymentNames();
			$payment = implode(",",$paymentList);
			
		}else{
			
			$this->_db->setQuery("select name from #__bid_payment where id=$this->payment");
			$payment=$this->_db->loadResult();
			
		}
		
        return $payment;
    }
    
    /**
     * Tests if param user is winner
     * ( directly winner_id if the auction has only one item, or tests if has winner bid type: regular bid, bin, suggestion )
     * 
     * @since 1.6.9
     */
    function testIfWinner( &$user_id ){
        
    	
    	// nr_items (initial) no quantity (left)
    	if( (int) $this->nr_items >= 0 ){
        	
        	// AM I bid or bin winner?
			$this->_db->setQuery("SELECT count(*) from #__bids b where id_offer='{$this->id}' and userid='{$user_id}'  and accept = 1");
			$this->i_am_winner = $this->_db->loadResult();
        	// AM I a suggestion?
			if(bin_opt_price_suggestion && $this->_parameters["price_suggest"]){
				$bidSuggest = new JAuctionBidSuggestions($this->_db);
				$bidSuggest->auctionid = $this->id;
				$bidSuggest->userid = $user_id;
				$bidSuggest->status = 1;
				$won_bids = $bidSuggest->getSuggestions();
				if ( count($won_bids)>=1 ){
					// to move in renderAuctionData
					$this->winning_bid=$won_bids[0];
					$this->i_am_winner=1;
				}
			}
        	
        }else{

			if($this->winner_id == $my->id )
				$this->i_am_winner 		 = 1;

        }
    }
    
    function testIfBidder( &$user_id ){
        
    	
    		$this->has_placed_bids = 0;
        	// AM I bid or bin holder?
        	if(!$this->id)
        		return;
        		
			$this->_db->setQuery("SELECT b.bid_price,b.userid from #__bids as b where id_offer='$this->id' ");
			$won_bids = $this->_db->loadObjectList();
			if($won_bids){
				$this->has_placed_bids = 1;
				foreach($won_bids as $wu ){ if($wu->userid == $user_id) { $this->i_am_bidder = 1; break;} }
			}
    	
        	// AM I a suggestion?
			if(bin_opt_price_suggestion && $this->_parameters["price_suggest"]){
				$bidSuggest = new JAuctionBidSuggestions($this->_db);
				$bidSuggest->auctionid = $this->id;
				$bidSuggest->userid = $user_id;
				$won_bids = $bidSuggest->getSuggestions();
				if ( count($won_bids)>=1 ){
					$this->has_placed_bids = 1;
					// to move in renderAuctionData
					$this->winning_bid=$won_bids[0];
					$this->i_am_bidder=1;
				}
			}

    }
    
    /**
     * Gets the amount of price to pay for the param user
     * 
     * total price = 0
     * 
     * total price += The total price is the winning bid price of the param user * winning bid quantity of the param user (a bin is considered a bid )
     * total price += If auction has suggestions then winning suggestion price of the param user * winning suggestion quantity of the param user 
     *
     * @param int $user_id
     * @since 1.6.9
     * @return array
     */
    function getTotalPrice( &$user_id ){
    	
    	
    	$total_price = array();
    	
    	if($this->i_am_winner){
    		
			$this->_db->setQuery("SELECT b.bid_price,b.userid, b.quantity FROM #__bids b where id_offer='$this->id'  and accept = 1");
			$won_bids = $this->_db->loadObjectList();
			if($won_bids)
			foreach($won_bids as $wu ){ 
				if($wu->userid == $user_id) 
				{ 
					$pay = array("price" => $wu->bid_price , "quantity" => $wu->quantity, "total" => $wu->bid_price * $wu->quantity , "type" => "bid");
					$total_price[] = $pay;
				}
			}
   	
			
        	// AM I a suggestion?
			if(bin_opt_price_suggestion && $this->_parameters["price_suggest"]){
				$bidSuggest = new JAuctionBidSuggestions($this->_db);
				$bidSuggest->auctionid = $this->id;
				$bidSuggest->userid = $user_id;
				$bidSuggest->status = 1;
				$won_bids = $bidSuggest->getSuggestions();
				if ( count($won_bids)>=1 ){
					foreach($won_bids as $wu){
						// to move in renderAuctionData
						$this->winning_bid=$wu->price;
						$pay = array("price" => $wu->price , "quantity" => $wu->quantity, "total" => $wu->price * $wu->quantity ,"type" => "suggestion");
						$total_price[] = $pay;
						
					}
				}
			}
    		
    	}
    	
		return $total_price;
    }
    
    function GetCategory()
    {
        $this->_db->setQuery("select catname,id from #__bid_categories where id='$this->cat'");
        return $this->_db->LoadResult();
    }
    function GetCurrency()
    {
        $this->_db->setQuery("select name from #__bid_currency where id='$this->currency'");
        return $this->_db->LoadResult();
    }
    /**
     * Nu e folosit
     * 
     * TO DO
     * sa intoarca si lista cu winning bids a lu useru dat ca parametru
     * ( poate avea un bid castigat si un suggestion )
     *
     * @param int $user_id
     * @return varchar(255)
     * @modified 1.6.9
     */
    function GetWinningBid( &$user_id )
    {
    	
		$query = "SELECT * from #__bids b where id_offer='$this->id'  and accept = 1";
		$this->_db->setQuery($query);
		$b = null;
		$this->_db->LoadObject($b);
		return $b;

    }
    
    /**
     * Get Highest Bid
     * 	used in saveBid method
     *
     * @return object
     */
    function GetBestBid()
    {
		$query = "SELECT * from #__bids b where id_offer='$this->id'  order by bid_price+0 desc";
		$this->_db->setQuery($query,0,1);
		$b=null;
		$this->_db->LoadObject($b);
		return $b;

    }
    function GetParam($paramname,$def_value=null)
    {
        $param=new JParameter($this->params);
        if ($def_value===null){
            $def_value=$this->_parameters[$paramname];
        }
        return $param->get($paramname,$def_value);
    }
    function SetParam($paramname,$value)
    {
        $param=new JParameter($this->params);
        $param->set($paramname,$value);
        $this->params="";
        foreach ($this->_parameters as $key=>$def_val){
            $this->params.="$key=".$param->get($key,$def_val)."\n";
        }
    }
    function SetAllParams($request_array)
    {
        if (!is_array($request_array)) return ;


        foreach ($this->_parameters as $key=>$def_val){
            if (isset($request_array[$key])){
                $this->SetParam($key,$request_array[$key]);
            }else{
                $this->SetParam($key,$def_val);
            }
        }

    }
    function ParamsToArray()
    {
        $param=new JParameter($this->params);
        foreach ($this->_parameters as $key=>$def_val){
            if ($param->get($key,'')==''){
                $param->set($key,$def_val);
            }
        }

        return $param->toArray();
    }
    function getFieldOrderArray()
    {
        return array(
        	'a.start_date'	=> bid_sort_start_date,
        	'a.title'			=> bid_sort_title,
        	'b.username'			=> bid_sort_username,
        	'a.end_date'		=> bid_sort_end_date,
        	'a.initial_price+0'	=> bid_sort_initialprice,
        	'a.hits'			=> bid_sort_hits,
        	'a.BIN_price+0' 	=> bid_sort_binprice,
        	'a.id' 			=> bid_sort_newest
        );

    }
    
    function hasBids(){
    	
		$this->_db->setQuery("SELECT b.bid_price,b.userid from #__bids b where id_offer='$this->id' ");
		$won_bids = $this->_db->loadObjectList();
		if(count($won_bids)) return true;
		else return false;
			
    }
}

class JBids extends FactoryFieldsTbl {
	var $id					= null;
	var $id_offer			= null;
	var $userid				= null;
	var $initial_bid        = null;
	var $bid_price			= null;
	var $payment			= null;
	var $cancel				= null;
	var $accept				= null;
	var $modified			= null;
    var $id_proxy           = null;
    var $quantity           = null;
    
/**
* @param database A database connector object
*/
	function JBids( &$db ) {
		$this->__construct( '#__bids', 'id', $db );
	}

	function LoadBidForUser($auctionid,$userid){
	    $this->_db->setQuery("SELECT * FROM ".$this->_tbl." WHERE cancel=0 and id_offer='$auctionid' and userid='$userid' ");
	    $this->_db->LoadObject($this);
	    return $this;
	}



    function getAuction()
    {
        $a=new JAuctions($this->_db);
        $a->load($this->id_offer);
        return $a;
    }
}


class JAuctionMessages extends FactoryFieldsTbl {
	var $id					= null;
	var $id_offer			= null;
	var $userid1			= null;
	var $userid2			= null;
	var $parent_message		= null;
	var $message			= null;
	var $modified			= null;
	var $wasread            = null;

/**
* @param database A database connector object
*/
	function JAuctionMessages( &$db ) {
		$this->__construct( '#__bid_messages', 'id', $db );
	}
	
	function sendNewMessage(){
		
	}
	
}


class JAuctionMails extends FactoryFieldsTbl {
	var $id 				= null;
	var $mail_type			= null;
	var $content			= null;
	var $subject			= null;
	var $enabled            = null;

	function JAuctionMails( &$db ) {
		$this->__construct( '#__bid_mails', 'mail_type', $db );
	}
	function store( $updateNulls=false ) {
		$k = $this->_tbl_key;

		if ($this->$k) {
			$ret = $this->_db->updateObject($this->_tbl, $this, $this->_tbl_key, $updateNulls);
		} else {
			$ret = $this->_db->insertObject($this->_tbl, $this, $this->_tbl_key);
		}

		if (!$ret) {
			$this->_error = strtolower(get_class($this))."::store failed <br />" . $this->_db->getErrorMsg();
			return false;
		} else {
			return true;
		}
	}
	
	function sendMails(){
		
	}

}

class JAuctionUsers extends FactoryFieldsTbl {
	var $userid				= null;
	var $name				= null;
	var $surname			= null;
	var $address			= null;
	var $city				= null;
	var $country			= null;
	var $phone				= null;
	var $verified			= null;
	var $isBidder			= null;
	var $isSeller			= null;
	var $powerseller		= null;
	var $modified			= null;
    var $paypalemail        = null;
	function JAuctionUsers( &$db ) {
		$this->__construct( '#__bid_users', 'userid', $db );
	}
	
	function getUserDetails($uid=null)
	{
		if ($uid) $this->userid=$uid;
		$u = JTheFactoryUserProfile::getInstance();
		$this->userid = $uid;
		if ( defined("bid_opt_profile_mode") && bid_opt_profile_mode!= "")
			$profile_mode = bid_opt_profile_mode;
		else
			$profile_mode = 'component';
		$u->getUserProfile($this,$profile_mode);
		
	    return $this;
	}
	

    function getRatingsList($uid=null)
    {
	    if (!$uid) $uid=$this->userid;
        $database=$this->_db;
        $database->setQuery("select rating,count(*) as nr  from #__bid_rate where user_rated='$uid' group by rating order by rating");
        return $database->loadAssocList("rating");
    }
}

class JAuctionCountry extends FactoryFieldsTbl {
	var $id 				= null;
	var $name				= null;
	var $simbol				= null;
	var $active				= null;

	function JAuctionCountry( &$db ) {
		$this->__construct( '#__bid_country', 'id', $db );
	}
}

class JAuctionImages extends FactoryFieldsTbl {
	var $id 				= null;
	var $id_offer			= null;
	var $userid				= null;
	var $picture			= null;
	var $modified			= null;

	function JAuctionImages ( &$db ) {
		$this->__construct( '#__bid_pictures', 'id', $db );
	}
	
	function AddImage( $auction , $ext ){
		
		$db = &JFactory::getDBO();
		
		$pic = new JAuctionImages( $db );

        $pic->id_offer 	= $auction->id;
        $pic->userid 	= $auction->userid;
        $pic->modified 	= date('Y-m-d');
        $pic->store();

		$pic->picture 	= $auction->id . "_img_$pic->id.$ext";
		$pic->store();
		return $pic;
	}
	
	function delImage($id){
		
		$db = &JFactory::getDBO();
		$pic = new JAuctionImages( $db );
		$pic->delete($id);
	}
	
	function delImages( $id ){
		
		$db = &JFactory::getDBO();
		$db->setQuery("delete from #__bid_pictures where id_offer='{$id}'");
		$db->query();
		
	}
	
	
}

class JAuctionWatchlist extends FactoryFieldsTbl {

	var $id 				= null;
	var $userid            = null;
	var $auctionid         = null;

	function JAuctionWatchlist( &$db ){
		$this->__construct( '#__bid_watchlist', 'id', $db);
	}
	
	function addWatchlist($userid, $auctionid){
		$db = & JFactory::getDBO();
		
	    $watchList = new JAuctionWatchlist($db);
	    
	    $watchList->userid = $userid;
	    $watchList->auctionid = $auctionid;
	
	    $watchList->store(true);
	}
	
	function delWatchlist($userid, $auctionid){
		
		$db = & JFactory::getDBO();
		
		$where = array("1=1 ");
		
		if($userid)
			$where[] = "  userid=".(int)$userid;
			
		if($auctionid)
			$where[] = "  auctionid=".(int)$auctionid;
			
	    $db->setQuery("delete from  #__bid_watchlist  where ".implode(" AND ",$where));
	    $db->query();
	}
	
	function getUserWatches($userid){
		$db = & JFactory::getDBO();
		
	}
	function getAuctionWatches($auctionid){
		$db = & JFactory::getDBO();
		
	}
	
}

class JAuctionsProxyBid extends FactoryFieldsTbl {
	var $id				   = null;
	var $auction_id        = null;
	var $user_id            = null;
	var $max_proxy_price   = null;
	var $active            = null;
	var $latest_bid        = null;

	function JAuctionsProxyBid(&$db){
		$this->__construct('#__bid_proxy','id',$db);
	}
}

class JAuctionTags extends FactoryFieldsTbl {
    var $id=null;
    var $auction_id=null;
    var $tagname=null;
    function JAuctionTags(&$db){
        $this->__construct('#__bid_tags','id',$db);
    }
    function setAuctionTags($auction_id,$tags){
        /*@var $tags string*/
        //first delete old tags
        $this->_db->setQuery("delete from ".$this->_tbl." where auction_id='$auction_id'");
        $this->_db->query();

        $tag_arr=explode(',',$tags);

        for ($i=0;$i<min(count($tag_arr),bid_opt_max_nr_tags);$i++){
            $this->id=null;
            $this->auction_id=$auction_id;
            $this->tagname=$tag_arr[$i];
            $this->tagname=trim($tag_arr[$i]);
            $this->store();
        }
	}
	
    /** to be deprecated */
    function getAuctionTags($auction_id) {
        $this->_db->setQuery("select tagname,id from ".$this->_tbl." where auction_id='$auction_id' order by id");
        return  $this->_db->loadResultArray();
    }
    
    function getAllTags(){
        $this->_db->setQuery("SELECT tagname,id,auction_id FROM ".$this->_tbl." order by id ");
        $cur = $this->_db->loadRowList();
        $curFinal = array();
        for($i=0; $i<count($cur);$i++){
        	$curFinal[$cur[$i][2]][]=$cur[$i][0];
        }
        return $curFinal;
    }
}

class JAuctionPayments extends JTable{
    var $id		 = null;
    var $auct	 = null;
    var $payment = null;

    function JAuctionPayments(&$db)
    {
        $this->__construct('#__bid_auct_payments','id',$db);
    }
    
	function getAuctionPayments(){
		
		if($this->auct){
			$this->_db->setQuery("SELECT * FROM $this->_tbl WHERE auct = '{$this->auct}'");
			return  $this->_db->loadObjectList();
		}else
			return null;
		
    }

	function getAuctionPaymentIds(){
		
		if($this->auct){
			$this->_db->setQuery("SELECT bp.id FROM $this->_tbl as t LEFT JOIN #__bid_payment as bp ON t.payment = bp.id  WHERE auct = '{$this->auct}'");
			return  $this->_db->loadResultArray();
		}else
			return null;
		
    }
    
	function getAuctionPaymentNames(){
		
		if($this->auct){
			$this->_db->setQuery("SELECT bp.name FROM $this->_tbl as t LEFT JOIN #__bid_payment as bp ON t.payment = bp.id  WHERE auct = '{$this->auct}'");
			return  $this->_db->loadResultArray();
		}else
			return null;
		
    }

    function saveAuctionPayments($PaymentType_Ids){
    	
		if($this->auct){
			// delete existing ones
			$this->_db->setQuery("DELETE FROM $this->_tbl WHERE auct = '{$this->auct}'");
			$this->_db->query();
			 
			if(count($PaymentType_Ids)){
	    		foreach ( $PaymentType_Ids as $i => $paym ){
	    			$this->id = null;
	  				$this->payment = $paym;
	  				$this->store();
	    		}
	    	}
		}	
    }
	
}

class JAuctionShipZones extends FactoryFieldsTbl {
	
    var $id		 = null;
    var $name	 = null;
    var $state	 = null;

    function JAuctionShipZones(&$db)
    {
        $this->__construct('#__bid_shipment_zones','id',$db);
	}
	
	function getList(){
		$this->_db->setQuery("SELECT * FROM $this->_tbl order by `name`");
		return $this->_db->loadObjectList();
	}
	
	function getPriceList($auctionID, $all = false){
		
		$all_filter = "";
		if($all)
			$all_filter = "OR auction IS NULL";
		$this->_db->setQuery("SELECT DISTINCT z.*, a.price FROM `#__bid_shipment_zones` z LEFT JOIN #__bid_shipment_prices a ON z.id = a.zone WHERE auction = '{$auctionID}' $all_filter ");
		return $this->_db->loadObjectList();
		
	}
	
	/**
	 * Save Price List
	 *  @param   auctionID owner of prices to zones association
	 *  @param   $prices array of key - zone => value = price
	 *
	*/
	function savePriceList($auctionID, $prices){
		
		// Delete old prices
		$this->_db->setQuery("DELETE FROM `#__bid_shipment_prices` WHERE auction = '{$auctionID}' ");
		$this->_db->query();
		
		$inserts = array();
		
		if($prices){
			foreach($prices as $zid => $priceVal){
				$inserts[] = " ( '{$zid}', '{$priceVal}', '{$auctionID}' ) "; 
			}
			
			$this->_db->setQuery("INSERT INTO #__bid_shipment_prices (zone, price ,auction ) VALUES ".implode(",", $inserts));
			$this->_db->query();
			
		}
		
	}
}

class JAuctionUserDefaults extends FactoryFieldsTbl {
    var $id		 = null;
    var $userid	 = null;
    var $name	 = null;
    var $value	 = null;

    function JAuctionUserDefaults(&$db)
    {
        $this->__construct('#__bid_user_settings','id',$db);
	}
	
	
	function getUserSettings(){
		
		$this->_db->setQuery(" SELECT * FROM `#__bid_user_settings` WHERE userid = '{$this->userid}' ");
		return $this->_db->loadObjectList("name");
		
	}
	
	/**
	 * Save Settings List
	 *  @param   $settings array of key - name => value = setting value
	 *
	*/
	function saveUserSettings($settings){
		
		// Delete old settings
		$this->_db->setQuery("DELETE FROM `#__bid_user_settings` WHERE userid = '{$this->userid}' ");
		$this->_db->query();
		
		$inserts = array();
		
		if($settings){
			foreach($settings as $name => $settingVal){
				$inserts[] = " ( '{$name}', '{$settingVal}', '{$this->userid}' ) "; 
			}
			
			$this->_db->setQuery("INSERT INTO #__bid_user_settings (name, value ,userid ) VALUES ".implode(",", $inserts));
			$this->_db->query();
			
		}
		
	}
	
}

class JAuctionBidIncrement extends FactoryFieldsTbl {
    var $id			 = null;
    var $min_bid	 = null;
    var $max_bid	 = null;
    var $value	 	 = null;

    function JAuctionBidIncrement(&$db)
    {
        $this->__construct('#__bid_increment','id',$db);
	}

	function getIncrementOfValue($val){
		
		$this->_db->setQuery(" SELECT value FROM `#__bid_increment` WHERE {$val} BETWEEN min_bid AND max_bid ORDER BY min_bid DESC ");
		return $this->_db->loadResult();
		
	}
	
	function getIncrement($value){

		$this->_db->setQuery(" SELECT * FROM `#__bid_increment` WHERE {$value} BETWEEN min_bid AND max_bid  ORDER BY min_bid DESC ");
		//echo $this->_db->_sql;
		$this->_db->loadObject($this);
		return $this;

	}
	
	function getList($min = null){
		$filter = "";
		if($min)
			$filter = " WHERE  $min < max_bid";

		$this->_db->setQuery(" SELECT * FROM `#__bid_increment` $filter order by `min_bid`");
		return $this->_db->loadObjectList();
	}
	
	function getBidChoises( $bid ){
		
		$this->getIncrement($bid);
		
		$band = array();
		
		for( $i=$this->min_bid; $i<=$this->max_bid; $i=$i+$this->value ){
			$band[]=$i;
		}
		return $band;
		
	}
	
}

class sefbids_helper {
    function GetTaskMap()
    {
        $task_map=array(
            "viewbids"=>"auction",
            "ViewDetails"=>"auctioneer"

        );
        return $task_map;
    }
    function Task2Map($task){
        $map=sefbids_helper::GetTaskMap();

        if (isset($map[$task]))
            return $map[$task];
        else
            return $task;
    }
    function Map2Task($url_part){
        $map=array_flip(sefbids_helper::GetTaskMap());
        if (isset($map[$url_part]))
            return $map[$url_part];
        else
            return $url_part;
    }

	function str_clean( $string ) {
		$aToReplace = array(" ","/","&","","","","!","$","%","@","?","#","(",")","+","*",":",";","'","\"");
		$aReplacements = array("-","-","and","");

		$str_buff = str_replace($aToReplace,$aReplacements,strtolower($string)	);
		return $str_buff;
	}

	function getCatString(&$id){
		
		/*
		TO DO: load just once categories in static var
		static $Bids_category_static_list;
		if(!$Bids_category_static_list){
			
			
			global $database;
			$database->setQuery("SELECT * FROM #__bid_categories");
			$Bids_category_static_list = $database->loadObjectList("id");
		}
		*/
		
		$database = &JFactory::getDBO();
		$database->setQuery("select * from #__bid_categories where id='$id'");
		$res='';
		do{
			$row = $database->loadAssocList();
			if(isset($row[0]))
				$row = $row[0];
			if ($row) $res=$row['catname'].'/'.$res;
			$parent_id=$row['parent'];
			$database->setQuery("select * from #__bid_categories where id='$parent_id'");
			
		}while($parent_id>0);
		
		return $res;
	}

	function getCat(&$cat,&$subcat){
		$database = &JFactory::getDBO();
		if (!$cat) return false;
		$database->setQuery("select id from #__bid_categories where hash like '".md5(strtolower(sefbids_helper::str_clean($cat)))."'");
		$id = $database->loadResult();
		

		if ($subcat){
    		$database->setQuery("select id from #__bid_categories where hash like '".md5(strtolower(sefbids_helper::str_clean($subcat)))."' and parent='$id'");
		    $id = $database->loadResult();

		}
		return $id;
	}

	function getTitleBid(&$id){
		$database = &JFactory::getDBO();
		$database->setQuery("select title from #__bid_auctions where id=$id");
		$result = $database->loadResult();
		$result = sefbids_helper::str_clean($result);
		return $result;
	}

	function getUsername(&$id){
		$database = &JFactory::getDBO();
		$database->setQuery("select a.username from #__users a where a.id = $id ");
		$result = $database->loadResult();
		$result = sefbids_helper::str_clean($result);
		return $result;
	}

    function getAuctionNr($url_array)
    {
        $ret="";
        if (in_array("auction_nr",$url_array)){
            $i=array_search("auction_nr",$url_array);
            sefbids_helper::setVar("auction_nr",$url_array[$i+1]);
            $ret.="&auction_nr=".$url_array[$i+1];
        }
        return $ret;

    }
	function getVal (&$string, $varname, $default) {

	     $string = str_replace("&amp;","&",$string);    // replace "&amp;" with "&" for explore routine...
	     $vars = explode("&", $string);

	     $temp = array();
	     $i=0;

	     foreach ($vars as $var) {
	        $temp = explode("=", $var);

	        if ($temp[0] == $varname) {  // Found the variable
	         	break;
	        }
	        $i++;
	     }
	     if ($temp[0] != $varname) { // Not found => Set Default values
	        $temp[0] = $varname;
	        $temp[1] = $default;
	     }

     return $temp[1];
	}

	function  setVar($varname,$value) {

	 global $_GET, $_REQUEST,$_POST;       // Mandatory : Need to access to gobal Link (Request) and Posted (GET) Mambo data


     $_POST[$varname] = $value;
     $_GET[$varname] = $value;
     $_REQUEST[$varname] = $value;
     $v = "&" .$varname. "=$value";

     return $v;
  	}

}

class JAuctionBidSuggestions extends FactoryFieldsTbl {
	
	var $id 		= null;
	var $userid 	= null;
	var $auctionid 	= null;
	var $modified 	= null;
	var $status	 	= null;
	var $price	 	= null;
	var $replyto 	= null;
// [+] 1.6.7
	var $quantity 	= null;
	
	function JAuctionBidSuggestions ( &$db ) {
		$this->__construct( '#__bid_suggest', 'id', $db );
	}
	
	function getSuggestions(){
		
		$filters = array();
		if($this->userid){
			$filters[] = " ( s.userid = '{$this->userid}' || ss.userid = '{$this->userid}')";
		}
		if($this->auctionid){
			$filters[] = " s.auctionid = '{$this->auctionid}' ";
		}
		if($this->status){
			$filters[] = " s.status = '{$this->status}' ";
		}
		
		$filterSql = "";
		if(count($filters))
			$filterSql = " WHERE ".implode(" AND ", $filters );
			
		$this->_db->setQuery("SELECT s.*, ss.userid as repliedto, u.username, u.email FROM #__bid_suggest s LEFT JOIN #__bid_suggest as ss ON s.replyto=ss.id LEFT JOIN #__users u ON s.userid = u.id $filterSql ORDER BY status DESC ");
		$this->_db->loadObjectList();
		return $this->_db->loadObjectList();
	}
	
}

class JBidWatchlistCats extends JTable {
	var $id 			   = null;
	var $catid			   = null;
	var $userid  		   = null;

	function JBidWatchlistCats(&$db){
		$this->__construct( '#__bid_watchlist_cats', 'id', $db);
	}
}

/**
 * Integration Startup
 *
 * Model Methods for Auction Item
 * 
 * @since 1.6.9
 */
class JAuctionHelper{
	
    function setAuctionStatus(&$auction)
    {
		if ($auction->close_offer)
            $auction->auction_status=bid_closed;
        else
            $auction->auction_status=bid_open;
        if (!$auction->published)
            $auction->auction_status=bid_unpublished;
		if(strtotime($auction->end_date) <= $now )
        {
			$auction->expired=true;
            $auction->auction_status=bid_expired;
		}
		
		//2.0.0
        if( substr($auction->closed_date,0,4)!=="0000" && $auction->end_date > $auction->closed_date && !$auction->winner_id)
            $auction->auction_status=bid_canceled;
    }
	
	function getAuctionStatuses( &$auction ){
		
		$my = &JFactory::getUser();
		$database = &JFactory::getDBO();

		$auction->is_my_auction 	 = 0;
		$auction->i_am_winner 		 = 0;
		$auction->i_am_bidder 		 = 0;
		$auction->must_rate 		 = 0;
		$auction->nr_new_messages 	 = 0;
		$auction->bid_list_tab 	 = 0; // Flag for displaying bid_list tab
		$auction->active 			 = 1; // Flag for generic active auction (not closed, banned & unexpired)
		//$auction->must_choose_winner= 1; // Flag for manual chosing a winner when over
		$auction->has_placed_bids	 = 0; // Flag for permitting editing an existing auction
		
        JAuctionHelper::setAuctionStatus($auction);
           
		if( $my->id ){
			
			// is_my_auction
			if ($auction->userid==$my->id) 
				$auction->is_my_auction=1;
			
			// watchlisted or not
			if (!$auction->is_my_auction && !$auction->close_offer) {
					$database->setQuery("SELECT count(*) from #__bid_watchlist WHERE userid='$my->id' AND auctionid='$auction->id' ");
					if($database->loadResult())
						$auction->del_from_watchlist=1;
					else
	 					$auction->add_to_watchlist=1;
			}
			
			// nr messages I (logged user) received
			$database->setQuery("select count(*) from #__bid_messages where userid2='$my->id' and id_offer='$auction->id' and wasread!=1");
			$auction->nr_new_messages = $database->loadResult();
			
	        $auction->testIfWinner( $my->id );
	        $auction->testIfBidder( $my->id );
	        
			$database->setQuery("SELECT count(*) from #__bids b where id_offer='{$auction->id}' and accept = 1");
			$has_winner = $database->loadResult();
			// Must rate; depends on is_my_auction and i_am_winner
            if ($my->id )
    	        if ( ($auction->i_am_winner)|| ($has_winner && $auction->is_my_auction  ) )
    
    	        {
    
    				$database->setQuery("select count(id) from #__bid_rate where (voter = '$my->id' and auction_id = '$auction->id')");
    
    				if ($database->loadResult()==0)  $auction->must_rate=1;
    
    	        }
	        
	        if ( $my->id && $auction->auction_type!=AUCTION_TYPE_BIN_ONLY || ( $auction->nr_items>1 && ( $auction->is_my_auction || $auction->i_am_bidder ) ) || ($auction->close_ofer=1) )
				$auction->bid_list_tab = 1;

	        if ( $auction->auction_type == AUCTION_TYPE_BIN_ONLY && bin_opt_price_suggestion && $auction->_parameters["price_suggest"] )
				$auction->suggestion_tab = 1;
		}
	}
	
	function renderAuctionData( &$auction ){
		
		$database = &JFactory::getDBO();
		$my = &JFactory::getUser();
		
		// [+] Rates
		$database->setQuery("
		SELECT 
 			sum(rating)/count(*) as all_rates,
 			if(rate_type='auctioneer',sum(rating)/count(*),0) as auctioneer_rates, 
 			if(rate_type='bidder',sum(rating)/count(*),0) as bidder_rates 
		FROM #__bid_rate 
		WHERE user_rated='$auction->userid'"); 

		$rates = $database->loadAssocList();
		if(isset($rates[0]))
			$rates = $rates[0];
		$auction->rating_auctioneer = $rates["auctioneer_rates"];
		$auction->rating_bidder = $rates["bidder_rates"];
		$auction->rating_overall = $rates["all_rates"];
		$auction->winning_bid 		 = 0;
        
		// [-] Rates

		// [+] Nr Bidders
		if ($auction->is_my_auction || ($auction->auction_type==AUCTION_TYPE_PUBLIC && $auction->GetParam('bid_counts')))
		{
			$database->setQuery("SELECT count(distinct userid) from #__bids where id_offer=$auction->id");
			$auction->nr_bidders = $database->loadResult();
		}
		// [-] Nr Bidders		
		// [+] Winner Bid or Highest Bid
        if(!$auction->GetParam('max_price') || $auction->auction_type==AUCTION_TYPE_PRIVATE)
        {
		    $auction->highest_bid=bid_private;
		    $auction->highest_bidder=bid_private;   
        }
		if ($auction->is_my_auction || ($auction->auction_type==AUCTION_TYPE_PUBLIC && $auction->GetParam('max_price'))){
			
			$database->setQuery("SELECT b.bid_price,b.userid from #__bids b where id_offer='$auction->id'  and accept = 1");
			$winbid = $database->loadRow();

			if (!$winbid){
				$database->setQuery("SELECT bid_price, username FROM #__bids LEFT JOIN #__users AS u ON userid = u.id WHERE id_offer =$auction->id ORDER BY bid_price+0 DESC LIMIT 0 , 1");
				$max_bid = $database->loadRow();
				if ($max_bid){
				    $auction->highest_bid=$max_bid[0];
				    $auction->highest_bidder=$max_bid[1];   
				}
			}else
                $auction->winning_bid=$winbid[0];


		}elseif ($auction->close_offer){
			
			if($auction->auction_type == AUCTION_TYPE_BIN_ONLY && bin_opt_price_suggestion && $auction->_parameters["price_suggest"]){
				
				if($my->id == $auction->winner_id){
					$bidSuggest = new JAuctionBidSuggestions($database);
					$bidSuggest->auctionid = $auction->id;
					$bidSuggest->userid = $auction->winner_id;
					$bidSuggest->status = 1;
					$winbid = $bidSuggest->getSuggestions();
					if ($winbid){
					    $auction->winning_bid=$winbid[0];
					}
				}
			}else{
				$database->setQuery("SELECT b.bid_price from #__bids b where id_offer='$auction->id'  and accept = 1 and userid='$my->id'");
				$winbid = $database->loadRow();
				if ($winbid){
				    $auction->winning_bid=$winbid[0];
				}
			}
		}
		
        $auction->total_price = $auction->getTotalPrice($my->id);
		// [-] Winner Bid or Highest Bid
		
		// [+] Auction Payment Method
        $auction->payment_name = $auction->GetPaymentMethod();
		// [-] Auction Payment Method
	}
	
	function renderAuctionTiming( &$auction ){
		$now = BidTimeUtilities::getNow();
		
		if ( bid_opt_enable_countdown ){
			
            $expiredate = BidTimeUtilities::getTimeStamp( $auction->end_date );
            $diff=$expiredate-$now;
            if ($diff>0){
                $s=sprintf("%02d",$diff%60);
                $diff=intval($diff/60);
                $m=sprintf("%02d",$diff%60);
                $diff=intval($diff/60);
                $h=sprintf("%02d",$diff%24);
                $d=intval($diff/24);

                if ($d>0) $auction->countdown="$d ".bid_days.", $h:$m:$s";
                else $auction->countdown="$h:$m:$s";

            }else{
                $auction->countdown = bid_expired;
            }
		}
		if(BidTimeUtilities::getTimeStamp($auction->end_date) <= BidTimeUtilities::getNow() ){$auction->expired=true;}else $auction->expired=false;
		
	    $auction->start_date_text = date(bid_opt_date_format,strtotime($auction->start_date));
	    //$auction->start_date_text = print_formatedDate($auction->start_date,0);
		
	    if($auction->end_date && $auction->end_date!='0000-00-00 00:00:00' ) {
			if(bid_opt_enable_hour){
				$dateformat=bid_opt_date_format." H:i";
			}else $dateformat=bid_opt_date_format;

			$auction->end_date_text=date($dateformat,strtotime($auction->end_date));
		    //$auction->end_date_text = print_formatedDate($auction->end_date,1);
		}
		
	}
	
	/**
	 * @added:15/02/10 
	 **/
	function AuctionGetMenuItem($task_name='task=listauctions'){

		$database = &JFactory::getDBO();
		$database->setQuery("SELECT id 
		FROM #__menu WHERE link LIKE '%$task_name%'  
		ORDER BY id DESC LIMIT 0 , 1 ");
		return $database->loadResult();

	}
	
	/**
	 * Fills Auction With Post variables
	 *
	 */
	function processPOST( &$auction ){

		$end_hour 				= JRequest::getWord('end_hour','00','POST');
		$end_minutes 			= JRequest::getWord('end_minutes','00','POST');
		$auction->start_date	= BidsUtilities::auctionDatetoIso($auction->start_date);
		$auction->end_date		= BidsUtilities::auctionDatetoIso($auction->end_date);
		
		$start_date 			= $auction->start_date;
		$end_date 				= $auction->end_date;
		
		$auction->shortdescription = JRequest::getVar('shortdescription','','POST');
		$auction->description      = JRequest::getVar('description','','POST','none',JREQUEST_ALLOWHTML);
		$auction->link_extern      = JRequest::getVar('link_extern','','POST');
		$auction->shipment_info    = JRequest::getVar('shipment_info','','POST');

	}
	
}

?>