<?php
/**
 * @package AuctionsFactory
 * @version 1.7.0
 * @copyright www.thefactory.ro
 * @license: commercial
 * @modified: 15-10-2009 (dd-mm-YYYY)
 */
// no direct access
defined('_JEXEC') or die('Restricted access');
@error_reporting(E_ALL & ~ E_NOTICE & ~ E_DEPRECATED);



//Global Auction Definitions
require_once (JPATH_COMPONENT_SITE.DS.'bids.globals.php');

loadLanguageFile();
require_once (JPATH_COMPONENT_SITE.DS.'thefactory'.DS.'application.php');

$Tapp = &JTheFactoryApp::getInstance(null, true);

require_once (JPATH_COMPONENT_SITE . DS . "bids.class.php");
require_once (JPATH_COMPONENT_SITE . DS . 'bids.functions.php');
require_once (JPATH_COMPONENT_SITE . DS . 'options.php');
require_once (JPATH_COMPONENT_SITE . DS . 'helpers/helper.php');
require_once (JPATH_COMPONENT_SITE . DS . 'bids.acl.php');
require_once (JPATH_COMPONENT_SITE . DS . 'controller.php');
$controller = new BidsController();

// load the html drawing class
require_once (JPATH_COMPONENT_SITE . DS . "bids.html.php");

$app = & JFactory::getApplication();
$app->set('joomlaJavascript', 1);

$view	= JRequest::getCmd( 'view','' );

$task	= JRequest::getCmd( 'task','' );


if ( !$task )
	$task	= JRequest::getCmd( 'layout','' );




if(!$task){
	if (!$task && !$view )
		$task = 'listauctions';
	else	
		$task = 'display';
}
	
if ($Tapp->checktask($task))
    return;

    
$id = JRequest::getInt('id', 0); //bid id



$bid_acl = new JBidsACL();
if (!$bid_acl->acl_check($view,$task))
    return;

/*
$Itemid = JAuctionHelper::AuctionGetMenuItem("task=$task");
if (!$Itemid)
	$Itemid = JAuctionHelper::AuctionGetMenuItem();
*/

if(in_array(strtolower($task),$controller->_methods)){
	// Perform the Request task
	$controller->execute( $task );
	
	// Redirect if set by the controller
	$controller->redirect();
	return;
}


switch ($task)
{
    case "suggest":
        suggestPrice($id, $task);
        break;
    case 'bin':
    case 'sendbid':
        $redirect_link = saveBid($id, $task); // partial verif
        FactoryLayer::redirect($redirect_link);
        break;
    case 'rate':
        userRate($id);
        break;

        //=========================== Auctions ==========================================
    case 'saveauction':
        {
	        $tmp_id = BidsUtilities::getMenuItemId(array("task"=>"listauctions"));
	        if( !$tmp_id )
		        $tmp_id = BidsUtilities::getMenuItemId(array("view"=>"auctions", "layout"=>""));
		      $ItemIdList->listauctions = $tmp_id;
            $msg = saveAuction($id);
            if (!$msg) $msg = bid_succes;
				FactoryLayer::redirect(JURI::root() . "/index.php?option=com_bids&task=viewbids&id=$id&Itemid={$ItemIdList->listauctions}",$msg);
            break;
        }
    case 'accept':
        acceptBid();
        break;
    case 'acceptsuggestion':
        acceptSuggestion();
        break;
    case 'rejectsuggestion':
        rejectSuggestion();
        break;
    case 'publish':
        publishAuction($id);
        break;

    default:
    case 'rss':
        AuctionsRss();
        break;

        //============================= USER DETAILS ===============================

    case 'canceluser':
		FactoryLayer::redirect(JURI::root() . "/index.php?option=com_bids&Itemid=$Itemid");
		break;

    case 'myratings':
		viewUserRatings($id);
		break;

        //=========================== SEARCH =========================================

    case 'search':
		search();
		break;

        //============================================================================

    case 'bulkimport':
        showimportform();
        break;
    case 'importcsv':
        import();
        break;

}

//================================= BIDS =================================

function searchForProxies($id)
{
	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();

    $database->setQuery("select count(*) from #__bids where id_offer=$id");
    $bids = $database->loadResult();

    if ($bids > 0)
    {
        $database->setQuery("select count(*) from #__bids a
							left join #__bid_proxy b on a.id_proxy=b.id
							where id_offer=$id and user_id!=" . $my->id . " and active<>0 ");
        $std_bids = $database->loadResult();
        if ($std_bids > 0)
        {
            return 3;
        }
        else
        {
            return 2;
        }
    }
    else
    {
        return 1;
    }
}

function updateProxies($amount, &$auction)
{
	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();
    /*
    $auction = new JAuctions($database);
    $auction->load($auctionid);
    */
    $auctionid = $auction->id;

    $database->setQuery("select * from #__bid_proxy where (user_id != '{$my->id}') and (auction_id=$auctionid) and active=1");
    $proxies = $database->loadObjectList();

    for ($i = 0; $i < count($proxies); $i++)
    {
        $pr = $proxies[$i];
        if ($pr->max_proxy_price < $amount)
        {
            $database->setQuery("update #__bid_proxy set latest_bid=$pr->max_proxy_price,active=0 where id = $pr->id");
            $database->query();

            $database->setQuery("update #__bids set bid_price=$pr->max_proxy_price, id_proxy=$pr->id where userid=$pr->user_id and id_offer = $auctionid");
            $database->query();

            $database->setQuery("select u.* from #__users u where id=$pr->user_id");
            $users = $database->loadObjectList();
            $auction->SendMails($users, 'proxy_ended');

        } elseif ($pr->max_proxy_price == $amount)
        {

            $bid = $pr->max_proxy_price - $auction->min_increase;

            $database->setQuery("update #__bid_proxy set latest_bid=$bid,active=0 where id = $pr->id");
            $database->query();

            $database->setQuery("update #__bids set bid_price=$bid, id_proxy=$pr->id where userid=$pr->user_id and id_offer = $auctionid");
            $database->query();

            $database->setQuery("select u.* from #__users u where id=$pr->user_id");
            $users = $database->loadObjectList();
            $auction->SendMails($users, 'proxy_ended');

        }
        else
        {
            $bid = $amount + $auction->min_increase;

            if ($bid > $pr->max_proxy_price)
                $bid = $pr->max_proxy_price;

            $database->setQuery("update #__bid_proxy set latest_bid=$bid where id=$pr->id");
            $database->query();
            $database->setQuery("update #__bids set bid_price=$bid, id_proxy=$pr->id where userid=$pr->user_id and id_offer = $auctionid");
            $database->query();

        }
    }

}

function Proxy($amount = null, &$auction, $proxy = null)
{
	global $Itemid;
	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();
	$task = JRequest::getCmd('task');

    $database->setQuery("select * from #__bid_proxy where auction_id = $auction->id and user_id=$my->id ");
    $prx = new JAuctionsProxyBid($database);
    if ($proxy && $auction->auction_type == AUCTION_TYPE_PUBLIC)
    {
		$database->loadObject($prx);
		if(!$prx || !$prx->id){
            $prx->auction_id = $auction->id;
            $prx->user_id = $my->id;
            $prx->max_proxy_price = $amount;
            $prx->active = 1;
            $prx->store();
        }
        else
        {
            $prx->max_proxy_price = $amount;
            $prx->store($prx->id);
        }
    }else{
        $database->setQuery("delete from #__bid_proxy where auction_id=$auction->id and user_id=$my->id");
        $database->query();
    }
    $prx->active = 1;
    $proxies = searchForProxies($auction->id);

    // wtf that was it: $prx->id (doar daca proxy)
    if ($proxy || $proxies > 2)
    {
        /*
        1 -> no bids at all
        2 -> bids, but no other Proxies
        3 -> bids and proxies
        */
        switch ($proxies)
        {
            case 1:
                $proxy_price = $auction->initial_price;
                break;
            case 2:
                $database->setQuery("select bid_price from #__bids where id_offer=$auction->id and userid=$my->id");
                $mybid = $database->loadResult();
                $database->setQuery("select max(bid_price+0) from #__bids where id_offer=$auction->id");
                $max_bid = $database->loadResult();
                if ($mybid < $max_bid)
                {
                    $proxy_price = $max_bid + $auction->min_increase;
                }
                else
                {
                    $proxy_price = $mybid;
                }
                if ($proxy_price >= $amount)
                {
                    $proxy_price = $amount;
                }
                break;
            case 3:
                $database->setQuery("select count(*) from #__bid_proxy where auction_id=$auction->id and max_proxy_price>$amount and user_id != $my->id");
                $result = $database->loadResult();
                if ($result > 0)
                {
                    //other bidders have higher Proxy prices then me
                    $proxy_price = $amount;
                    $prx->latest_bid = $amount;
                    $prx->active = 0;
                    $prx->store();
                    /*
                    Added 1.7.2 and does not work in Joomla 1.5.x
	                    $database->setQuery("select * from #__users where id=$prx->user_id");
	                    $prxu = $database->loadObjectList();
	                    $auction->SendMails($prxu, 'proxy_ended');
                    */
                }
                else
                {

                    $database->setQuery("select max(max_proxy_price+0) from #__bid_proxy where auction_id=$auction->id and user_id != " .$my->id);
                    $max_proxy = $database->loadResult(); //Other Users proxy

                    if ($max_proxy + $auction->min_increase > $amount)
                    {
                        if ($max_proxy == $amount)
                        {
                            $proxy_price = $amount - $auction->min_increase;
                            if ($proxy_price < 0)
                                $proxy_price = 0;
                        }
                        else
                            $proxy_price = $amount;
                    }
                    else
                    {
                        if ($proxy)
                            $proxy_price = $max_proxy + $auction->min_increase; // <== Im gonna regret commenting this
                        else
                            $proxy_price = $amount;
                    }
                }
                break;
            default:
                break;
        }

        $database->setQuery("select max(b.bid_price+0) from #__bids b where id_offer = $auction->id and userid != $my->id");
        $max_bid = $database->loadResult();

        if ($auction->auction_type == AUCTION_TYPE_PUBLIC)
        {
            if ($max_bid != null && $max_bid + $auction->min_increase > $proxy_price && $task !=
                'bin')
            {
                $min_accepted = $max_bid + $auction->min_increase;
            } elseif (!$max_bid && $auction->initial_price > $proxy_price)
            {
                $min_accepted = $auction->initial_price + $auction->min_increase;
            }
            if ($min_accepted)
            {
                FactoryLayer::redirect(JURI::root() . "/index.php?option=com_bids&task=viewbids&id=$auction->id&Itemid=$Itemid" , bid_err_increase . " " . $min_accepted);
                return;
            }
        }

        if ($proxy || $prx->id)
        {

            $prx->latest_bid = $proxy_price;
            $prx->store();
        }

        return array($proxy_price, $prx->id, $prx->max_proxy_price);
    } elseif ($amount)
    {

        return array($amount, 0, 0);
    }

}

function rejectSuggestion()
{
	global $Itemid;
	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();
	$id = (int)JRequest::getVar("id");
    // suggestion id
    $bid_id = $id;
    $auction = new JAuctions($database);

    $bid = new JAuctionBidSuggestions($database);

    if (!$bid->load($bid_id))
    {
        echo bid_does_not_exist;
        return;
    }
    if ($bid->price <= 0)
    {
        echo bid_does_not_exist;
        return;
    }
    if (!$auction->load($bid->auctionid))
    {
        echo bid_does_not_exist;
        return;
    }

    if ($auction->close_offer && $auction->winner_id)
    {
        echo bid_auction_is_closed;
        return;
    }
    if ($auction->published != 1)
    {
        echo bid_does_not_exist;
        return;
    }
    if ($auction->automatic == 1)
    {
        echo bid_err_is_automatic;
        return;
    }

    // Check if I am the Suggestee
    if ($bid->replyto > 0)
    {

        $bid_reply = new JAuctionBidSuggestions($database);

        if (!$bid_reply->load($bid->replyto))
        {
            JError::raiseWarning( 0,bid_you_have_to_login);
            return;
        }
        else
        {
            if ($bid_reply->userid != $my->id)
            {
                JError::raiseWarning( 0,bid_you_have_to_login);
                return;
            }
        }

    }
    else
    {

        if ($auction->userid != $my->id)
        {
            JError::raiseWarning( 0,bid_you_have_to_login);
            return;
        }
    }

    $user1 = &JTable::getInstance("user");
    if (!$user1->load($bid->userid) || $user1->block)
    {
        echo bid_err_user_does_not_exist;
        return;
    }

    $bid->status = 0;
    $bid->store();

    $auction->SendMails(array($user1), 'suggest_rejected');
    $redirect_link = JRoute::_('index.php?option=com_bids&task=viewbids&id=' . $auction->id . '&Itemid=' . $Itemid);
    FactoryLayer::redirect($redirect_link);
}

function acceptSuggestion()
{
	global $Itemid;
	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();
	$id = (int)JRequest::getVar("id");

    // suggestion id
    $bid_id = $id;
    $auction = new JAuctions($database);

    $bid = new JAuctionBidSuggestions($database);

    if (!$bid->load($bid_id))
    {
        echo bid_does_not_exist;
        return;
    }
    if ($bid->price <= 0)
    {
        echo bid_does_not_exist;
        return;
    }
    if (!$auction->load($bid->auctionid))
    {
        echo bid_does_not_exist;
        return;
    }

    // Check if I am the Suggestee
    if ($bid->replyto > 0)
    {
        $bid_reply = new JAuctionBidSuggestions($database);

        if (!$bid_reply->load($bid->replyto))
        {
            JError::raiseWarning( 0,bid_you_have_to_login);
            return;
        }
        else
        {
            if ($bid_reply->userid != $my->id)
            {
                JError::raiseWarning( 0,bid_you_have_to_login);
                return;
            }
        }

    }
    else
    {
        if ($auction->userid != $my->id)
        {
            JError::raiseWarning( 0,bid_you_have_to_login);
            return;
        }
    }

    if ($auction->close_offer && $auction->winner_id)
    {
        echo bid_auction_is_closed;
        return;
    }
    if ($auction->published != 1)
    {
        echo bid_does_not_exist;
        return;
    }
    if ($auction->automatic == 1)
    {
        echo bid_err_is_automatic;
        return;
    }

    $user1 = &JTable::getInstance("user");
    if (!$user1->load($bid->userid) || $user1->block)
    {
        echo bid_err_user_does_not_exist;
        return;
    }

    @ignore_user_abort(true);

    //Watches
    $database->setQuery("select a.userid from #__bid_watchlist a where a.auctionid=$auction->id");
    $ids = $database->loadResultArray();
    $id_string = implode(',', $ids);

    if (count($ids) > 0)
    {
        $query = "select u.* from #__users u
				  where u.id in ($id_string) and u.id<>'$bid->userid'";
        $database->setQuery($query);
        $mails = $database->loadObjectList();
        $auction->SendMails($mails, 'bid_watchlist_closed'); //Notify Watchlist
    }
    //End Watches

    JAuctionWatchlist::delWatchlist(null,$auction->id);

    $auction->published = 1;
    $auction->winner_id = $bid->userid;
    $auction->quantity = $auction->quantity - $bid->quantity;

    if ($auction->quantity == 0)
    {
        $auction->close_offer = 1;
        $auction->closed_date = date('Y-m-d H:i:s', time());
    }
    if ($auction->quantity >= 0)
    {

        $auction->store();

    }
    else
    {
        echo bid_err_price_suggested;
        return;
    }

    $auction->sendNewMessage($auction->id, '', bid_accepted);
    $bid->status = 1;
    $bid->store();

    $auction->SendMails(array($user1), 'suggest_accepted');

    $database->setQuery("UPDATE #__bid_suggest SET status = 0 WHERE auctionid = '{$bid->auctionid}' AND userid <> '{$bid->userid}' ");
    $database->query();

    $database->setQuery("SELECT u.* FROM #__bid_suggest s LEFT JOIN #__users u ON userid = u.id WHERE auctionid = '{$bid->auctionid}' AND userid <> '{$bid->userid}' ORDER BY status DESC ");
    $loser = $database->loadObjectList();

    $auction->SendMails($loser, 'suggest_rejected');

    if ((int)bid_opt_buyers_premium > 0)
    {

        require_once (JPATH_ROOT ."/components/com_bids/plugins/pricing/price_comission.php");
        $com = new price_comission($database);

        $bid_comission = $bid->bid_price * bid_opt_buyers_premium / 100;
        $database->setQuery("INSERT INTO #__bid_comissions SET userid='$auction->userid', bid_id='$bid_id', auction_id='$auction->id', amount = '$bid_comission', comission_date = NOW(), currency = '$auction->currency'");
        $database->query();

        $com->updateBalance($my->id, $bid_comission, $auction->currency);

    }

    $redirect_link = JURI::root() .'/index.php?option=com_bids&task=viewbids&id=' . $auction->id . '&Itemid=' . $Itemid;
    FactoryLayer::redirect($redirect_link);

}

/**
 * Price Suggest for BIN only auction types 
 * 
 * 
 **/
function suggestPrice($id_offer, $task)
{

	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();
	$task = JRequest::getCmd('task');
    $redirect_link = JURI::root() ."/index.php?option=com_bids&task=viewbids&id=$id_offer&Itemid=$Itemid";

    @session_start();
    // token checking
    /*
    if(isset($_SESSION["auction_token"]) && $_SESSION["auction_token"]!=""){
    unset( $_SESSION["auction_token"]);$_SESSION["auction_token"] = null;
    }else{
    FactoryLayer::redirect( $redirect_link );
    }
    */

    $suggest_id = JRequest::getInt('s_id', 0);
    $suggest = JRequest::getFloat('bid_suggest', 0);
    $q = JRequest::getFloat('quantity', 1);

    $bidsSuggest = new JAuctionBidSuggestions($database);

    $auction = new JAuctions($database);
    if (!$auction->load($id_offer))
    {
        FactoryLayer::redirect($redirect_link, bid_does_not_exist);
        return;
    }

    if (!$suggest_id && $auction->userid == $my->id)
    {
        FactoryLayer::redirect($redirect_link, bid_err_no_self_bidding);
        return;
    }
    $auction->_parameters = $auction->ParamsToArray();

    $database->setQuery("SELECT * FROM #__users WHERE id = '{$auction->userid}'");
    $owner = $database->loadObjectList();

    $database->setQuery("SELECT count(*) FROM #__bid_suggest WHERE userid = '{$my->id}' AND auctionid='{$id_offer}' ");
    $nrSuggestions = $database->loadResult();

    $msg = "";

    if (bin_opt_price_suggestion && $auction->auction_type == AUCTION_TYPE_BIN_ONLY &&
        $auction->_parameters["price_suggest"])
    {
        $bidsSuggest->auctionid = $id_offer;
        $bidsSuggest->userid = $my->id;
        $bidsSuggest->modified = date("Y-m-d H:i");
        $bidsSuggest->price = $suggest;
        $bidsSuggest->replyto = $suggest_id;
        $bidsSuggest->quantity = $q;

        if ($suggest != 0 && bin_opt_limit_suggestions <= $nrSuggestions)
        {
            // too many suggestions? yes :reject
            $auction->SendMails(array($my), 'suggest_rejected');
            $msg = bid_err_price_suggested;
            FactoryLayer::redirect($redirect_link, $msg);
        }

        if ($suggest == 0)
        {

            // No valid Number
            $msg = bid_err_valid_suggest;

        } elseif ($auction->_parameters["price_suggest_min"] <= $suggest)
        {

            $bidsSuggest->status = "2";
            $bidsSuggest->store();

            if ($bidsSuggest->replyto)
            {

                $database->setQuery("SELECT userid FROM #__bid_suggest WHERE id = '{$bidsSuggest->replyto}'");
                $user_id = $database->loadResult();
                $database->setQuery("SELECT * FROM #__users WHERE id = '{$user_id}'");
                $user = $database->loadObjectList();
                $auction->SendMails($user, 'replysuggest_success');
            }
            $auction->SendMails($owner, 'suggest_success');
            $msg = bid_msg_price_suggested;

        }
        else
        {

            // suggested price must be higher than the lowest suggestion allowed
            $bidsSuggest->status = "0";
            $bidsSuggest->store();
            $msg = bid_err_low_price_suggested;
        }
    }
    else
    {
        // no support for BIN suggestions
        $msg = bid_err_no_price_suggest;
    }

    FactoryLayer::redirect($redirect_link, $msg);

}

function saveBid($id_offer, $task)
{

	$app = & JFactory::getApplication();
	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();
	$task = JRequest::getCmd('task');
	
   global $_bid_obj;

   $proxy = JRequest::getInt( 'proxy', 0);
   $amount = JRequest::getFloat('amount', 0);
   $quantity_param = JRequest::getInt( "quantity", 1);

   $database->setQuery("SELECT max(bid_price+0) FROM #__bids WHERE id_offer={$id_offer} AND userid = {$my->id}");
   $mylastbid = $database->loadResult();

    $database->setQuery("SELECT max(bid_price+0) FROM #__bids WHERE id_offer={$id_offer}");
    $maxbid = $database->loadResult();

    $msg = "";
    $redirect_link = JRoute::_("index.php?option=com_bids&task=viewbids&id=$id_offer&Itemid=$Itemid");
    $auction = new JAuctions($database);
    if (!$auction->ancLoad($id_offer))
    {
        FactoryLayer::redirect($redirect_link, bid_does_not_exist);
        return;
    }
    if ($auction->userid == $my->id)
    {
        FactoryLayer::redirect($redirect_link, bid_err_no_self_bidding);
        return;
    }
    if ($auction->close_offer)
    {
        FactoryLayer::redirect($redirect_link, bid_auction_is_closed);
        return;
    }
    if ($auction->published != 1)
    {
        FactoryLayer::redirect($redirect_link, bid_does_not_exist);
        return;
    }
    if ($auction->auction_type == AUCTION_TYPE_BIN_ONLY && $task != 'bin')
    {
        FactoryLayer::redirect($redirect_link, bid_err_bin_only);
        return;
    }

    //security check :)
    if (!$my->id)
    {
        JError::raiseWarning( 0,bid_you_have_to_login);
        return;
    }

    if ($task == 'bin')
    {
        $amount = $auction->BIN_price;
        if ($amount <= 0)
        {
            echo bid_no_bin;
            return;
        }
    }
    else
    {
        if (bid_opt_range_increment)
        {
            //$database->setQuery("SELECT MAX(bid_price) FROM #__bids WHERE cancel=0 and id_offer='$auction->id' ");
            //$tmp = $database->LoadResult();

            $tmp = $amount;
            if (!$tmp)
                $tmp = 0;

            $inc = new JAuctionBidIncrement($database);
            $min_increase = $inc->getIncrementOfValue($tmp);
            if (!$min_increase)
                $min_increase = $auction->min_increase;

            $auction->min_increase = $min_increase;

        }

        if (bid_opt_allow_proxy && $auction->auction_type != AUCTION_TYPE_PRIVATE)
        {
            $prxid = Proxy($amount, $auction, $proxy);

            $amount = $prxid[0];
        }
        if ($amount < $auction->initial_price || $amount <= 0)
        {
            FactoryLayer::redirect($redirect_link, bid_err_price);
            return;
        }
    }

    $query = "SELECT u.* FROM #__users u
			  LEFT JOIN #__bid_watchlist w ON u.id=w.userid
			  WHERE not(w.userid is null) AND w.auctionid='$id_offer'
			  and (w.userid<>'$my->id')
			  ";
    $database->setQuery($query);
    $watches = $database->loadObjectList();

    $comment = JRequest::getString('message', '');
    //if the auction it's not private test if bid is right

    //  1.6.9 fix:
    //  was	if($auction->auction_type != AUCTION_TYPE_PRIVATE && !$prxid[0] && $task != 'bin'){
    //!proxy because i can add a new proxy bid while my bid is the best
    if ($auction->auction_type != AUCTION_TYPE_PRIVATE && $task != 'bin'&& !$proxy)
    {

        $my_acceptedpr = $mylastbid + $auction->min_increase; // my bid must be greater than my last bid + minincrease
        $acceptedpr = $maxbid + $auction->min_increase; // my bid must be greater than max bid + minincrease
        
        if ($mylastbid && ($amount < $my_acceptedpr))
        {
            FactoryLayer::redirect($redirect_link, bid_err_price_mybid);
            return;
        }
        if ($maxbid && ($amount < $acceptedpr))
        {
            FactoryLayer::redirect($redirect_link, bid_err_price_maxbid);
            return;
        }
    }

    $bestBid = null;
    if ($auction->auction_type != AUCTION_TYPE_PRIVATE)
        $bestBid = $auction->GetBestBid();
    $database->setQuery("select * from #__bids where cancel=0 and userid='$my->id' and id_offer='$id_offer' ");
    $head_message = new JBids($database); //new head message
    
    // Joomla 1.5.x JDatabaseMySql loadObject method
    $tmp_bid = $database->loadObject();
    if($tmp_bid->id)
    	$head_message->bind($tmp_bid);
    	
    $head_message->userid = $my->id;
    $head_message->id_offer = $id_offer;
    
    if (!($head_message->id))
    {
        $head_message->id_proxy = $prxid[1];
        $head_message->bid_price = $amount;
        $head_message->initial_bid = $amount;
        $head_message->modified = date("Y-m-d H:i:s", time());
        $head_message->accept = 0;
        $head_message->cancel = 0;
        $head_message->ancStore();

    }
    else
    {
        if ($head_message->cancel)
        {
            echo bid_err_was_canceled;
            return;
        }
        if ($amount >= $head_message->bid_price)
        {
            $head_message->id_proxy = $prxid[1];
            $head_message->bid_price = $amount;
            $head_message->modified = date("Y-m-d H:i:s", time());
            $head_message->store();
        }
        else
        {
            //must be bigger
            FactoryLayer::redirect($redirect_link, bid_err_must_be_greater_mybid);
            return;
        }
    }
    // BID SAVED -> pass it on
    $_bid_obj = $head_message;

    $bid_id = $head_message->id;
    $bid_tbl = $head_message->_tbl;
    $head_message->id = null;
    $head_message->_tbl = "#__bid_log";
    $head_message->store();
    $head_message->_tbl = $bid_tbl;
    $head_message->id = $bid_id;

    updateProxies($amount, $auction);
    $bestBid2 = null;
    if ($auction->auction_type != AUCTION_TYPE_PRIVATE)
        $bestBid2 = $auction->GetBestBid();
    /*@var $bestBid JBids*/
    /*@var $bestBid2 JBids*/
    if ($bestBid && $bestBid2 && $bestBid->userid != $bestBid2->userid && $auction->
        auction_type != AUCTION_TYPE_PRIVATE)
    {
        $outbidded = &JTable::getInstance("user");
        $outbidded->load($bestBid->userid);
        $auction->SendMails(array($outbidded), 'bid_outbid'); //Outbidded
    }

    $owner_user = &JTable::getInstance("user");
    $owner_user->load($auction->userid);

    if ($amount >= $auction->BIN_price && $auction->BIN_price > 0)
    {
        if ($auction->GetParam('auto_accept_bin') == '1' || $auction->automatic)
        {
            //accept and close and send emails
            $head_message->accept = 1;
            // [+] 1.6.7

            $head_message->quantity = (int)$head_message->quantity + $quantity_param;

            $head_message->store();

            $auction->quantity = $auction->quantity - $quantity_param;
            /* [+] -> 1.6.7 */
            if ($auction->quantity <= 0)
            {
                $auction->winner_id = $my->id;
                $auction->published = 1;
                $auction->close_offer = 1;
                $auction->closed_date = date('Y-m-d H:i:s', time());
                JAuctionWatchlist::delWatchlist(null,$auction->id);

                $auction->SendMails($watches, 'alert_bin_accepted');
            }
            $auction->ancStore();
            /* [+] <- 1.6.7 */

			JAuctionWatchlist::delWatchlist(null,$auction->id);

            $auction->SendMails($watches, 'alert_bin_accepted');

            $auction->SendMails(array($owner_user), 'new_bid_auto_bin');
            $auction->SendMails(array($my), 'bin_accepted');
        }
        else
        {
            $auction->SendMails($watches, 'alert_new_bid_bin');
            //just notify
            $auction->SendMails(array($owner_user), 'new_bid_bin');
            $auction->SendMails(array($my), 'bin_wait_approval');
        }
    }
    else
    {
        if ($amount > 0)
        {
            $auction->SendMails($watches, 'new_bid_watchlist');
            $auction->SendMails(array($owner_user), 'new_bid');
            $auction->SendMails(array($my), 'bid_new_mybid');

        }
        else
        {
            $auction->SendMails(array($owner_user), 'new_message');
        }
    }

    // ==> auction extending if enabled
    if (bid_opt_auto_extent)
    {

        $time = BidTimeUtilities::getTimeStamp($auction->end_date) - BidTimeUtilities::getNow();
        $time_a = null;

        switch (bid_opt_auto_extent_limit_type)
        {
            case "s":
                $time_a = 1;
                break;
            case "m":
                $time_a = 60;
                break;
            case "h":
                $time_a = 3600;
                break;
            default:
                $time_a = 1;
                break;
        }

        $time = $time / $time_a;

        if ( 0 < $time && $time < bid_opt_auto_extent_limit)
        {
            $time_o = null;

            switch (bid_opt_auto_extent_offset_type)
            {
                case "s":
                    $time_o = 1;
                    break;
                case "m":
                    $time_o = 60;
                    break;
                case "h":
                    $time_o = 3600;
                    break;
                default:
                    $time_o = 1;
                    break;
            }

            
            $auction->end_date = BidTimeUtilities::getTimeStamp($auction->end_date) + bid_opt_auto_extent_offset * $time_o;
            $auction->end_date = gmdate('Y-m-d H:i:s',$auction->end_date);
            //$auction->end_date = auctionDatetoIso($auction->end_date);
            $auction->extended_counter += 1;
            $auction->ancStore();

        }
    }

    // <== auction extending if enabled
    $AuctionParameters = $auction->ParamsToArray();
    $msg = bid_succes;
    if ($auction->reserve_price > 0 && bid_opt_global_enable_reserve_price && $AuctionParameters['show_reserve'])
    {
        if ($amount < $auction->reserve_price)
            $msg = bid_reserve_not_met;
        else
            $msg = bid_reserve_met;
    }
    
    $app->enqueueMessage($msg);
    $redirect_link = JURI::root()."/index.php?option=com_bids&task=viewbids&id=$id_offer&Itemid={$Itemid}#bid_list";
    return $redirect_link;
}


function publishAuction( $id)
{
    global $Itemid;
    $my = &JFactory::getUser();
    $database = &JFactory::getDBO();

    $filter_archive =JRequest::getInt('filter_archive', 0);

    $auction = new JAuctions($database);
    $auction->load($id);

    if ($my->id != $auction->userid)
    {
        JError::raiseWarning( 0,bid_you_have_to_login);
        return;
    }

    $auction->published = 1;

    $auction->store($id);
    $redirect_link = JRoute::_("index.php?option=com_bids&task=myauctions&Itemid=$Itemid&filter_archive=$filter_archive");
    FactoryLayer::redirect($redirect_link);
}


//===================================Auctions ===============================

function ValidateSaveAuction()
{
	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();
	$task = JRequest::getCmd('task');

    $error_msg = "";
    $auction = new JAuctions($database);

    $auction->bind($_POST, '_allowed_picture_ext');
    $oldid = JRequest::getInt( 'oldid', 0);
    if ($oldid && !$auction->id)
        $isRepost = true;
    else
        $isRepost = false;

    if (!$auction->id)
    {
        $end_hour = JRequest::getString('end_hour', '00');
        $end_minutes = JRequest::getString('end_minutes', '00');
        if ($end_hour > 24) {
            $error_msg .= bid_err_end_date_valid;
        }
        
        if ($end_minutes > 60) {
            $error_msg .= bid_err_end_date_valid;
        }
        
        $auction->start_date = BidsUtilities::auctionDatetoIso($auction->start_date);
        $auction->end_date = BidsUtilities::auctionDatetoIso($auction->end_date);
        $start_date = $auction->start_date;
        $end_date = $auction->end_date;

        if (!$start_date){
            $error_msg .= bid_err_start_date_valid;
        }
        if (!$end_date && bid_opt_enable_date){
            $error_msg .= bid_err_end_date_valid;
        }

        if ($start_date && $end_date && !JRequest::getInt('id', 0))//trebuie luat ID din request, functia e apelata si din alte parti
        {
            if (strlen($start_date) < 10 || strlen($start_date) > 10){
                $error_msg .= bid_not_allowed_start_date_format . "\n";
            }
            if (bid_opt_enable_date && strlen($end_date) < 10 || strlen($end_date) > 10){
                $error_msg .= bid_not_allowed_end_date_format . "\n";
            }

            $year = date("Y", strtotime($start_date));
            $month = date("m", strtotime($start_date));
            $day = date("d", strtotime($start_date));
            if (bid_opt_enable_date)
            {
                $year_end = date("Y", strtotime($end_date));
                $month_end = date("m", strtotime($end_date));
                $day_end = date("d", strtotime($end_date));
            }

            if ($year < 1900 && $year > 2200)
            {
                $error_msg .= bid_not_valid_start_date_year . "\n";
            }
            if ($month < 1 && $month > 12)
            {
                $error_msg .= bid_not_valid_start_date_month . "\n";
            }
            if ($day < 1 && $day > 31)
            {
                $error_msg .= bid_not_valid_start_date_day . "\n";
            }

            if (bid_opt_enable_date)
            {
                if ($year_end < 1900 && $year_end > 2200)
                {
                    $error_msg .= bid_not_valid_start_date_year . "\n";
                }
                if ($month_end < 1 && $month_end > 12){
                    $error_msg .= bid_not_valid_start_date_month . "\n";
                }
                if ($day_end < 1 && $day_end > 31){
                    $error_msg .= bid_not_valid_start_date_day . "\n";
                }

                $datedif = mktime(0, 0, 0, $month_end, $day_end, $year_end) - mktime(0, 0, 0, $month, $day, $year);
                if (bid_opt_availability > 0)
                    if (floor($datedif / 60 / 60 / 24) >= bid_opt_availability * 31)
                    {
                        $error_msg .= bid_not_valid_date_interval . ": " . bid_opt_availability . "\n";
                    }
            }
        }

    }

    if ($auction->id)
    {
        // was  Edit Auction
        $auction->load($auction->id);
        if ($my->id != $auction->userid)
        {
            $error_msg .= bid_err_invalid_offerid . "\n";
        }
        $auction->shortdescription =JRequest::getString('shortdescription', '');
        $auction->description = JRequest::getVar('description','','default','none',JREQUEST_ALLOWHTML);
        $auction->link_extern = JRequest::getString('link_extern', '');
        $auction->shipment_info = JRequest::getString( 'shipment_info', '');
        if (!$auction->published)
            $auction->published = JRequest::getInt('published', '0');
        $query = "select name from #__bid_currency where id = $auction->currency";
        $database->setQuery($query);
        if (!$database->loadResult())
        {
            //if currencies got modified inbetween
            $query = "select id from #__bid_currency limit 1";
            $database->setQuery($query);
            $auction->currency = $database->loadResult();
        }
    }
    else
    {
        $auction->auction_nr = time() . rand(100, 999);
    }

    $auction->modified = date("Y-m-d H:i:s", time());
    $auction->userid = $my->id;
    $auction->SetAllParams($_POST);

    if (is_array($errors = $auction->check()))
    {
        $error_msg .= htmlentities(implode('\n', $errors), ENT_QUOTES);
    }

    if ($auction->close_offer)
    {
        $error_msg .= bid_auction_is_closed . "\n";
    }
    //Required Image
    $nrfiles = 0;
    if (count($_FILES))
        foreach ($_FILES as $k => $file)
        {
            if (substr($k, 0, 7) != "picture")
                continue;
            if (!is_uploaded_file(@$file['tmp_name']))
                continue;
            if (!bid_opt_resize_if_larger && filesize($file['tmp_name']) >
                bid_opt_max_picture_size * 1024)
            {
                continue;
            }

            $fname = $file['name'];
            $ext = JFile::getExt($fname);

            if (!$auction->isAllowedImage($ext))
            {
                continue;
            }
            $nrfiles++;
        }
    if (!$auction->id && !$isRepost && !$nrfiles && bid_opt_require_picture)
    {
        $error_msg .= bid_err_picture_is_required . "\n";
    }
    return $error_msg;
}

function saveAuction(&$id)
{
	jimport('joomla.filesystem.file');
   global $Itemid;
	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();
	$task = JRequest::getCmd('task');
   $id = JRequest::getInt( 'id', 0);
	

    @session_start();
    // simple spoof check security

    if (bid_debug == 1)
    {
        //josSpoofCheck();
        // token checking
        if (isset($_SESSION["auction_token"]) && $_SESSION["auction_token"] != "")
        {

            unset($_SESSION["auction_token"]);
            $_SESSION["auction_token"] = null;

        }
        else
        {
        	// this Itemid allways sucked
            FactoryLayer::redirect(JURI::root() . "/index.php?option=com_bids&Itemid=$Itemid");
        }
    }

    $errors = ValidateSaveAuction();

    if ($errors)
    {

        if (!$id)
        {
            $auction = new JAuctions($database);
            $auction->bind($_POST, 'allowed_picture_ext');
            $auction->tags = JRequest::getString( 'tags', '');
            $auction->payment_options = JRequest::getString('payment', '');
            $_SESSION['auction_temp'] = serialize($auction);

        }
        $errors = str_replace(array("\n", "\r"), " ", $errors);
        echo "<script>alert('" . htmlentities($errors) . "');history.go(-1);</script>";
        exit;
    }
    

    
    $_SESSION['auction_temp'] = null;
    // ce mama d*@!
    if (isset($_SESSION['auction_temp']))
        unset($_SESSION['auction_temp']);
    $auction = new JAuctions($database);

    $auction->bind($_POST, 'allowed_picture_ext');
    $auction->picture = null;
    $oldid =JRequest::getInt( 'oldid', 0);
    $delete_pictures = JRequest::getVar( 'delete_pictures', array());
    $delete_main_picture = JRequest::getInt('delete_main_picture', 0);

    $end_hour = JRequest::getString( 'end_hour', '00');
    $end_minutes = JRequest::getString('end_minutes', '00');
    $auction->start_date = BidsUtilities::auctionDatetoIso($auction->start_date);

    if (!bid_opt_enable_date)
    {

        $mins = array();
        if (bid_opt_allow_proxy && intval(bid_opt_proxy_default_period) > 0)
        {
            $mins[] = bid_opt_proxy_default_period;
        }

        if (bid_opt_global_enable_bin && intval(bid_opt_bin_default_period) > 0 && $auction->
            BIN_price > 0)
        {
            $mins[] = bid_opt_bin_default_period;
        }

        if (bid_opt_global_enable_reserve_price && intval(bid_opt_reserve_price_default_period) > 0 && $auction->reserve_price > 0)
        {
            $mins[] = bid_opt_reserve_price_default_period;
        }
        if (intval(bid_opt_default_period) > 0){
            $mins[] = bid_opt_default_period;
        }

        $min = min($mins);

        if ($min)
            $auction->end_date = date(bid_opt_date_format, strtotime($auction->start_date) + 86400 * $min);
        else
            $auction->end_date = date(bid_opt_date_format, strtotime($auction->start_date) + 86400);

        $auction->end_date = BidsUtilities::auctionDatetoIso($auction->end_date);

    }
    else
    {
        $auction->end_date = BidsUtilities::auctionDatetoIso($auction->end_date);
    }

    $auction->nr_items = $auction->quantity;

    if ($oldid && !$auction->id)
        $isRepost = true;
    else
        $isRepost = false;
        
    $auction->end_date .= " $end_hour:$end_minutes";
    $end_date = $auction->end_date;

    if (!isset($_POST['automatic']))
        $auction->automatic = 0;

    if ($auction->id)
    {
        // was  Edit Auction
        $auction->load($auction->id);

        if ($my->id != $auction->userid)
        {
            JError::raiseWarning( 0,bid_you_have_to_login);
            exit();
        }

        $auction->shortdescription = JRequest::getString( 'shortdescription', '');
        $auction->description = JRequest::getVar('description','','POST','none',JREQUEST_ALLOWHTML);
        $auction->link_extern = JRequest::getString( 'link_extern', '');
        $auction->shipment_info = JRequest::getString( 'shipment_info', '');

        /** @since 2.0.4 */
        $auction->end_date = $end_date;

        $bidSuggest = new JAuctionBidSuggestions($database);
        $bidSuggest->auctionid = $auction->id;
        $suggests = $bidSuggest->getSuggestions();
        $exist_suggests = 0;
        if (count($suggests) > 0)
            $exist_suggests = 1;

        if (!$auction->hasBids() && !$exist_suggests)
        {

            $auction->auction_type =JRequest::getInt('auction_type', 0);
            $auction->shipment_price = JRequest::getFloat('shipment_price', 0);
            $auction->initial_price = JRequest::getFloat('initial_price', 0);
            $auction->min_increase = JRequest::getFloat('min_increase', 0);
            $auction->quantity = JRequest::getInt('quantity', 0);

            if (JRequest::getFloat("bin_OPTION",0) == 1 || ($auction->auction_type == AUCTION_TYPE_BIN_ONLY))
                $auction->BIN_price = JRequest::getFloat( 'BIN_price', 0);
            else
                $auction->BIN_price = 0;

            $auction->reserve_price = JRequest::getFloat(  'reserve_price', 0);
        }

        if (!$auction->published)
            $auction->published = JRequest::getInt('published', 0);
        $query = "select name from #__bid_currency where id = $auction->currency";
        $database->setQuery($query);
        if (!$database->loadResult())
        {
            //if currencies got modified inbetween
            $query = "select id from #__bid_currency limit 1";
            $database->setQuery($query);
            $auction->currency = $database->loadResult();
        }

    }
    else
    {
        $auction->auction_nr = time() . rand(100, 999);
    }

    $auction->min_increase = JRequest::getFloat("min_increase",0);

    if ($auction->min_increase == 0)
    {
        $auction->min_increase = bid_opt_min_increase;
    }

    $auction->modified = date("Y-m-d H:i:s", time());
    $auction->userid = $my->id;
    $auction->SetAllParams($_POST);
    
    $auction->cat =JRequest::getInt('cat', $auction->cat);

    unset($auction->tags);
    unset($auction->payment_options);
    $error = $auction->store();
    if ($error !== true)
    {

        $auction->bind($_POST, 'allowed_picture_ext');
        $auction->tags =JRequest::getString( 'tags', '');
        $auction->payment_options = JRequest::getString( 'payment', '');
        $_SESSION['auction_temp'] = serialize($auction);

        $errors = str_replace(array("\n", "\r"), " ", $error);
        echo "<script>alert('" . htmlentities($errors) . "');history.go(-1);</script>";
        exit;
    }
    else
    {
        unset($_SESSION['auction_temp']);
    }

    //Set Auction Tags
    $tags = JRequest::getString('tags', '');
    $tag_obj = new JAuctionTags($database);
    $tag_obj->setAuctionTags($auction->id, $tags);
    
    
    if ($isRepost)
    {

        $database->setQuery("select count(*) from #__bid_auctions where id='$oldid' and userid='$my->id'");
        if (!$database->loadResult())
        {
            JError::raiseWarning( 0,bid_you_have_to_login);
            exit;
        }

        $database->setQuery("select picture from #__bid_auctions where id=$oldid");
        $oldpic = $database->loadResult();

        $new_id = $auction->id;

        if (!empty($oldpic) && !$delete_main_picture)
        {
            if (file_exists(AUCTION_PICTURES_PATH . $oldpic))
            {

                if (strpos($oldpic, $oldid . "_") === 0)
                    $buf = substr($oldpic, strlen($oldid), strlen($oldpic));
                else
                    $buf = $oldpic;

                $new_pic_name = $new_id . "_" . $buf;
                copy(AUCTION_PICTURES_PATH . $oldpic, AUCTION_PICTURES_PATH . $new_pic_name);
                copy(AUCTION_PICTURES_PATH . "middle_$oldpic", AUCTION_PICTURES_PATH . "middle_$new_pic_name");
                copy(AUCTION_PICTURES_PATH . "resize_$oldpic", AUCTION_PICTURES_PATH . "resize_$new_pic_name");
                $auction->picture = $new_pic_name;
                $auction->ancStore();
            }
        }
        if ($delete_main_picture)
        {
            $auction->picture = '';
            $auction->ancStore();
        }

        $database->setQuery("select * from #__bid_pictures where id_offer=$oldid");
        $pictures = $database->loadObjectList();
        for ($i = 0; $i < count($pictures); $i++)
        {
            $ext = substr($pictures[$i]->picture, strpos($pictures[$i]->picture, '.') + 1,strlen($pictures[$i]->picture));
            if ($auction->isAllowedImage($ext) && !in_array($pictures[$i]->id, $delete_pictures))
            {
                if (file_exists(AUCTION_PICTURES_PATH . $pictures[$i]->picture))
                {
					$pic = JAuctionImages::AddImage($auction, $ext);
					
					copy(AUCTION_PICTURES_PATH . $pictures[$i]->picture, AUCTION_PICTURES_PATH . $pic->picture);
					copy(AUCTION_PICTURES_PATH . "middle_" . $pictures[$i]->picture,AUCTION_PICTURES_PATH . "middle_" . $pic->picture);
					copy(AUCTION_PICTURES_PATH . "resize_" . $pictures[$i]->picture,AUCTION_PICTURES_PATH . "resize_" . $pic->picture);
                }
            }
        }
    }
    $msg = "";
    $nrfiles = 0;
    foreach ($_FILES as $k => $file)
    {
        if (substr($k, 0, 7) != "picture")
            continue;
        if (!is_uploaded_file(@$file['tmp_name']))
            continue;
        if (!bid_opt_resize_if_larger && filesize($file['tmp_name']) > bid_opt_max_picture_size * 1024)
        {
            $msg .= $file['name'] . "- " . bid_err_imagesize_too_big . "<br><br>";
            continue;
        }

        if (!file_exists(AUCTION_PICTURES_PATH))
            @mkdir(AUCTION_PICTURES_PATH, 0755);
        $fname = $file['name'];
        $ext = JFile::getExt($fname);

        if (!$auction->isAllowedImage($ext))
        {
            $msg .= bid_err_not_allowed_ext . ': ' . $file['name'];
            continue;
        }
        if ($k == "picture_main")
        {
            $file_name = $auction->id . "_" . $fname . '.' . $ext;
            $auction->picture = $file_name;
            $auction->ancStore();
        }
        else
        {
            if ($nrfiles >= bid_opt_maxnr_images)
                continue;
                
            $file_name = $fname . '.' . $ext;
            
            $pic = JAuctionImages::AddImage($auction, $ext);
            
            $file_name = $auction->id . "_img_$pic->id.$ext";
            $nrfiles++;
        }

        $path = AUCTION_PICTURES_PATH . "/$file_name";
        if (bid_opt_resize_if_larger && filesize($file['tmp_name']) > bid_opt_max_picture_size * 1024)
            $res = resize_to_filesize($file['tmp_name'], $path, bid_opt_max_picture_size * 1024);
        else
            $res = move_uploaded_file($file['tmp_name'], $path);
            
        if ($res)
        {
            @chmod($path, 0755);
            resize_image($file_name, bid_opt_thumb_width, bid_opt_thumb_height, 'resize');
            resize_image($file_name, bid_opt_medium_width, bid_opt_medium_height, 'middle');
        }
        else
        {
            $msg .= $file['name'] . "- " . bid_err_upload_failed . "<br><br>";
        }
    }
    

    if (!$isRepost)
    {
        if ($delete_main_picture)
        {
            $query = "select picture from #__bid_auctions where id=$id";
            $database->setQuery($query);
            $main_pic = $database->loadResult();

            $query = "update #__bid_auctions set picture = '' where id = $id";
            $database->setQuery($query);
            $database->query();

            @unlink(AUCTION_PICTURES_PATH . $main_pic);
            @unlink(AUCTION_PICTURES_PATH . "small_" . $main_pic);
            @unlink(AUCTION_PICTURES_PATH . "middle_" . $main_pic);
            @unlink(AUCTION_PICTURES_PATH . "resize_" . $main_pic);
        }

        foreach ($delete_pictures as $dele_id)
        {
            $query = "select picture from #__bid_pictures where id=$dele_id and userid=$my->id";
            $database->setQuery($query);
            $pic = $database->loadResult();

			JAuctionImages::delImage($dele_id);

            @unlink(AUCTION_PICTURES_PATH . $pic);
            @unlink(AUCTION_PICTURES_PATH . "small_" . $pic);
            @unlink(AUCTION_PICTURES_PATH . "middle_" . $pic);
            @unlink(AUCTION_PICTURES_PATH . "resize_" . $pic);

        }
    }

    
    if (bid_opt_payment_select_mode == 0)
    {
        $auction_Payments = new JAuctionPayments($database);
        $auction_Payments->auct = $auction->id;

        $payment_list = JRequest::getVar('payment');
        if ($payment_list)
        {
            $auction_Payments->saveAuctionPayments($payment_list);
        }
    }

    // shipping
    if (bid_opt_multiple_shipping)
    {

        $p = new JAuctionShipZones($database);

        $prices = array();
        foreach ($_POST as $key => $value)
        {
            $priceValue = (float)$value;
            if (substr($key, 0, 6) == "zprice" && $priceValue > 0)
            {

                $prices[$_POST["zzone_" . substr($key, 7)]] = $priceValue;
            }
        }
        $p->savePriceList($auction->id, $prices);
    }

    if (bid_opt_allow_user_settings)
    {

        $save_settings = JRequest::getInt('save_user_settings', 0);

        if ($save_settings)
        {
            $us = new JAuctionUserDefaults($database);
            $us->userid = $auction->userid;
            $settings = array();

            $param_list = $auction->ParamsToArray();
            foreach ($param_list as $pk => $pv)
            {
                $settings[$pk] = $pv;
            }

            $settings["end_hour"] = date("H", strtotime($auction->end_date));
            $settings["end_minute"] = date("i", strtotime($auction->end_date));

            $settings["auction_type"] = $auction->auction_type;
            $settings["payment_info"] = $auction->payment_info;
            $settings["currency"] = $auction->currency;
            $settings["shipment_info"] = $auction->shipment_info;
            $settings["shipment_price"] = $auction->shipment_price;
            $settings["payment_info"] = $auction->payment_info;

            if (bid_opt_payment_select_mode == 0)
            {

                $auction_Payments = new JAuctionPayments($database);
                $auction_Payments->auct = $auction->id;
                $o = $auction_Payments->getAuctionPaymentIds();
                $settings["payment_options"] = implode(",", $o);

            }
            else
                $settings["payment"] = $auction->payment;

            if (bid_opt_multiple_shipping)
            {
                $p = new JAuctionShipZones($database);
                $o = $p->getPriceList($auction->id);
                foreach ($o as $ko => $io)
                {
                    $settings["shipping_$io->id"] = $io->price;
                }
            }

            $us->saveUserSettings($settings);
        }
    }
    
	if(!$id || $isRepost ){
		$auction->SendMails(array($my),"new_auction");
	}
    if ($auction->id)
        $id = $auction->id;
    return $msg;
}

function acceptBid()
{
    global $Itemid;
    
    $database = & JFactory::getDBO();
    $my = & JFactory::getUser();

    $bid_id = JRequest::getInt( 'bid', 0);
    $auction = new JAuctions($database);
    $bid = new JBids($database);

    if (!$bid->load($bid_id))
    {
        echo bid_does_not_exist;
        return;
    }
    if ($bid->cancel)
    {
        echo bid_does_not_exist;
        return;
    }
    if ($bid->bid_price <= 0)
    {
        echo bid_does_not_exist;
        return;
    }
    if (!$auction->load($bid->id_offer))
    {
        echo bid_does_not_exist;
        return;
    }
    if (!$auction->acl_check($my))
    {
        JError::raiseWarning( 0,bid_you_have_to_login);
        return;
    }
    if ($auction->close_offer && $auction->winner_id)
    {
        echo bid_auction_is_closed;
        return;
    }
    if ($auction->published != 1)
    {
        echo bid_does_not_exist;
        return;
    }
    if ($auction->automatic == 1)
    {
        echo bid_err_is_automatic;
        return;
    }

    $user1 = &JTable::getInstance("user");
    if (!$user1->load($bid->userid) || $user1->block)
    {
        echo bid_err_user_does_not_exist;
        return;
    }

    @ignore_user_abort(true);

    //Watches
    $database->setQuery("select a.userid from #__bid_watchlist a where a.auctionid=$auction->id");
    $ids = $database->loadResultArray();
    $id_string = implode(',', $ids);

    if (count($ids) > 0)
    {
        $query = "select u.* from #__users u
				  where u.id in ($id_string) and u.id<>'$bid->userid'";
        $database->setQuery($query);
        $mails = $database->loadObjectList();
        $auction->SendMails($mails, 'bid_watchlist_closed'); //Notify Watchlist
    }
    //End Watches

    $database->setQuery("delete from #__bid_watchlist where auctionid = $auction->id");
    $database->query();

    $auction->published = 1;
    $auction->close_offer = 1;
    $auction->winner_id = $bid->userid;
    $auction->closed_date = date('Y-m-d H:i:s', time());
    $auction->ancStore();

    $auction->sendNewMessage($auction->id, '', bid_accepted);
    $bid->accept = 1;
    $bid->store();

    $auction->SendMails(array($user1), 'bid_accepted');

    $query = "select u.* from #__users u
	   left join #__bids b on u.id=b.userid
	   where b.cancel=0 and b.accept=0 and u.block=0 and b.id_offer='$auction->id'
	";
    $database->setQuery($query);
    $loser = $database->loadObjectList();
    $auction->SendMails($loser, 'bid_lost');

    if ((int)bid_opt_buyers_premium > 0)
    {
        require_once (JPATH_ROOT ."/components/com_bids/plugins/pricing/price_comission.php");
        $com = new price_comission($database);

        $bid_comission = $bid->bid_price * bid_opt_buyers_premium / 100;
        $database->setQuery("INSERT INTO #__bid_comissions SET userid='$auction->userid', bid_id='$bid_id', auction_id='$auction->id', amount = '$bid_comission', comission_date = NOW(), currency = '$auction->currency'");
        $database->query();
        $com->updateBalance($my->id, $bid_comission, $auction->currency);
    }
    
    $redirect_link = JRoute::_('index.php?option=com_bids&task=viewbids&id=' . $auction->id . '&Itemid=' . $Itemid);
    FactoryLayer::redirect($redirect_link);
}

// ====================================== USER DETAILS ==============================


function userRate($id )
{
    global $Itemid;
	$database = &JFactory::getDBO();
	$my = &JFactory::getUser();
    $auction_id = $id;
    $note = JRequest::getString('comment', '');
    $rate = JRequest::getInt( 'rate', 0);
    $user_rated = JRequest::getInt( 'user_rated', 0);
    $modified_date = date("Y-m-d H:i:s");
    $auction = new JAuctions($database);
    $auction->load($auction_id);
	/**
	 * 
	 * 1.7.0 return after filling profile feature
	 * 
	 */
	$return = JRequest::getVar( "return","");
	if($return!=""){
		FactoryLayer::redirect( base64_decode($return), _USER_DETAILS_SAVE );
	}
    if (!$rate)
    { //must have a rating
        FactoryLayer::redirect(JURI::root() . '/' . "index.php?option=com_bids&task=viewbids&id=$id&Itemid={$Itemid}#bid_list",bid_must_rate);
        return;
    }
	if( $auction->winner_id == $user_rated || $auction->userid == $user_rated || (is_array($weeners) && isset($weeners[$user_rated]) ) )
    {
        $database->setQuery("select count(id) from #__bid_rate where auction_id = $id and voter = $my->id");
        $result = $database->loadResult();
        if(!$result || ($result <= count($weeners) ))
        {
            $rate_type = ($auction->winner_id == $user_rated) ? "bidder" : "auctioneer";
            $database->setQuery("insert into #__bid_rate (voter,user_rated,rating,modified,message,auction_id,rate_type) values ($my->id,$user_rated,$rate,'$modified_date','$note',$id,'$rate_type')");
            $database->query();
            $database->setQuery("select * from #__users where id = $user_rated");
            $result = $database->loadObjectList();
            $auction->SendMails($result, 'bid_rate');
        }
    }
    else{
        die(bid_err_does_not_exist);
    }
    FactoryLayer::redirect("index.php?option=com_bids&task=viewbids&id=$id&Itemid={$Itemid}#bid_list" , bid_rate_succes );
}

function showimportform()
{
    global $Itemid;
    $my  = &JFactory::getUser();

    if (!$my->id || bid_opt_allow_import != 1)
    {
        JError::raiseWarning( 0,bid_you_have_to_login);
        return;
    }
    HTML_Auction_helper::bulkimport($Itemid, null);
}

function import()
{
    $my = &JFactory::getUser();
    if (!$my->id || bid_opt_allow_import != 1){
        JError::raiseWarning( 0,bid_you_have_to_login);
        return;
    }
    $err = ImportFromCSV("com_bids", 0);
    if (count($err) <= 0)
        FactoryLayer::redirect("index.php?option=com_bids&task=myauctions&Itemid=$Itemid",bid_auctions_imported);
    else{
        HTML_Auction_helper::bulkimport("com_bids", $Itemid, $err);
    }
}

function AuctionsRss()
{

    $database = &JFactory::getDBO();

    ob_end_clean();
    $feed = bid_opt_RSS_feedtype;
    $cat = JRequest::getInt('cat', '');
    $user = JRequest::getInt('user', '');

    $limit = (defined("bid_opt_RSS_description")) ? intval(bid_opt_RSS_nritems) :
        intval(bid_opt_nr_items_per_page);
    if (!$limit)
        $limit = 10;

    require_once (JPATH_ROOT . '/includes/feedcreator.class.php');

    $rss = new UniversalFeedCreator();
    // load image creator class
    $iso = split('=', _ISO);

    $rss->title = bid_opt_RSS_title;
    $rss->description = bid_opt_RSS_description;
    $rss->link = htmlspecialchars(JURI::root());
    $rss->syndicationURL = htmlspecialchars(JURI::root());
    $rss->cssStyleSheet = null;
    $rss->encoding = $iso[1];

    $where = " where published=1 and close_offer=0 and close_by_admin=0 ";

    if ($cat)
    {
         if (!bid_opt_inner_categories)
             $where .= " and a.cat = '" . $cat . "' ";
         else{
         	$catOb = new JTheFactoryCategoryObj();
         	
         	$cTree = $catOb->build_child($cat,true);
         	$cat_ids = array();
         	if($cTree){
         		foreach ($cTree as $cc){
         			if(isset($cc["id"]) && $cc["id"]!="")
         				$cat_ids[] = $cc["id"];
         		}
         	}
         	if( count($cat_ids) )
         		$cat_ids = implode(",", $cat_ids);
             $where .= " and ( a.cat  IN (" . $cat_ids . ") )";
         }
    }

    if ($user)
        $where .= " and userid='$user' ";
    $database->setQuery("select a.* from #__bid_auctions a left join #__bid_categories c on c.id=a.cat $where order by id desc",
        0, $limit);
    $rows = $database->loadObjectList();
    //echo $database->_sql;exit;

    for ($i = 0; $i < count($rows); $i++)
    {

        $auction = $rows[$i];

        $item_link = 'index.php?option=com_bids&task=viewbids&id=' . $auction->id;
        $item_link = JRoute::_($item_link);

        // removes all formating from the intro text for the description text
        $item_description = $auction->description;
        $item_description = JFilterOutput::cleanText($item_description);
        $item_description = html_entity_decode($item_description);

        // load individual item creator class
        $item = new FeedItem();
        // item info
        $item->title = $auction->title;
        $item->link = $item_link;
        $item->description = $item_description;
        $item->source = $rss->link;
        $item->date = date('r', strtotime($auction->start_date));
        $database->setQuery("select catname from #__bid_categories where id='$auction->cat' ");
        $item->category = $database->loadResult();

        $rss->addItem($item);

    }
    $rss->saveFeed($feed);
}

function loadLanguageFile()
{
    $lang = &JFactory::getLanguage();
    if (JOOMFISH_DETECT)
    {
        $lng = substr($lang->_lang, 0, 2);
    }
    else
    {
        $lng = bid_opt_language;
    }
    if (file_exists(JPATH_COMPONENT_SITE . '/lang/' . $lng . ".php"))
        require_once (JPATH_COMPONENT_SITE . '/lang/' . $lng . ".php");
    else
        require_once (JPATH_COMPONENT_SITE . '/lang/default.php');

}
?>