<?php
/**
 * @package AuctionsFactory
 * @version 1.7.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }



if(!defined('ITEMS_PER_PAGE'))	define("ITEMS_PER_PAGE", '5');

class getmyauctionsTab extends cbTabHandler {

	function getmyauctionsTab() {
		$this->cbTabHandler();
	}

	function getDisplayTab($tab,$user,$ui){
		global $Itemid;
		$database = &JFactory::getDBO();
		$my = & JFactory::getUser();


		define("BIDS_COMPONENT_PATH",JPATH_ROOT."/components/com_bids/");
		
		if(!file_exists(JPATH_ROOT."/components/com_bids/bids.php")){
			  return "<div>You must First install <a href='http://www.thefactory.ro/shop/joomla-components/auction-factory.html'> Auction Factory </a></div>";
		}
		require_once(JPATH_ROOT."/components/com_bids/options.php");

        if (file_exists(BIDS_COMPONENT_PATH.'/lang/'.bid_opt_language))
            require_once(BIDS_COMPONENT_PATH.'/lang/'.bid_opt_language);
        else
            require_once(BIDS_COMPONENT_PATH.'/lang/default.php');

        $params = $this->params;
        
		$query = "SELECT u.username,b.*, m.name as payment_name,c.name as currency_name
			FROM #__bid_auctions b
			left join #__bid_payment m on b.payment=m.id
			left join #__bid_currency c on b.currency=c.id
			left join #__users u on b.userid=u.id

			where userid = '$user->user_id' order by id desc";

		$database->setQuery($query);
		$nrauctions = $database->loadObjectList();

		$total = count($nrauctions);

		$limitstart=0;
		$pagingParams = $this->_getPaging( array(), array( "myauctions_" ) );
		if (isset($pagingParams["myauctions_limitstart"])) {
			$limitstart=$pagingParams["myauctions_limitstart"];
		}
		
		$database->setQuery($query,$limitstart, ITEMS_PER_PAGE);
		$myauctions = $database->loadObjectList();
		
		$pagingParams["limitstart"] = $limitstart;
		$pagingParams["limit"] = ITEMS_PER_PAGE;


		$return = "\t\t<div>\n";
		$return .="<table width='100%'>";
		$return .='<form name="topForm'.$tab->tabid.'" action="index.php" method="post">';
		$return .="<input type='hidden' name='option' value='com_comprofiler' />";
		$return .="<input type='hidden' name='task' value='userProfile' />";
		$return .="<input type='hidden' name='user' value='".$user->user_id."' />";
		$return .="<input type='hidden' name='tab' value='".$tab->tabid."' />";
		$return .="<input type='hidden' name='act' value='' />";


		if($myauctions) {


			$return	.= '<tr>';
			$return .= '<th class="list_ratings_header" width="15%">'.bid_bid_status.'</th>';
			$return .= '<th class="list_ratings_header" width="*%">'.bid_bid_title.'</th>';
			$return .= '<th class="list_ratings_header" width="15%">'.bid_start_date.'</th>';
			$return .= '<th class="list_ratings_header" width="15%">'.bid_end_date.'</th>';
			$return .= '<th class="list_ratings_header" width="10%">'.bid_initial_price.'</th>';

			if($my->id==$user->user_id){
				$return .= '<th class="list_ratings_header" width="10%">'.bid_last_bid.'</th>';
			}

			$return .= '</tr>';
			$k=0;
			foreach ($myauctions as $ma){
			    /*@var $ma JAuctions*/
    			if($my->id == $user->user_id){
    				$query = "SELECT bid_price from #__bids where id_offer='$ma->id' order by id desc limit 1";
    				$database->setQuery($query);
    				$last_bid = $database->loadResult();
    			}else{
    			    if (!$ma->published || $ma->close_by_admin) continue; //hide unpublished or Banned auctions
    			}
    	       	$link_view_details = JRoute::_("index.php?option=com_comprofiler&task=userprofile&user=$ma->userid&Itemid=$Itemid");
    			$link_view_auction = JRoute::_("index.php?option=com_bids&task=viewbids&id=$ma->id&Itemid=$Itemid");

    			$status="";
    			if ($ma->close_offer){
    			    $status=bid_closed;

    			}elseif(!$ma->published){
    			    $status=bid_unpublished;
    			}elseif(strtotime($ma->end_date) <= strtotime(date("Y-m-d",time()))){
                    $status=bid_expired;
                }else{
                    $status=bid_published;
                }

    			 $return .='<tr class="mywatch'.$k.'">';
    			 $return .='<td>';
    			 $return .= $status;
    			 $return .='</td>';

    			 $return .='<td>';
    			 $return .= '<a href="'.$link_view_auction.'">'.$ma->title.'</a>';
    			 $return .='</td>';

    			 $return .='<td>';
    			 $return .= date(bid_opt_date_format,strtotime($ma->start_date));
    			 $return .='</td>';
    			 $return .='<td>';
    			 $return .= date(bid_opt_date_format,strtotime($ma->end_date));
    			 $return .='</td>';
    			 $return .='<td>';
    			 $return .= $ma->initial_price." ".$ma->currency_name;
    			 $return .='</td>';
    			 if($my->id==$user->user_id){
    			     if ($last_bid) $last_bid.=' '.$ma->currency_name;
    			  	 $return .= '<td>'.$last_bid.'</td>';
    			 }
    			 $return .= "</tr>";
    			 $k=1-$k;

			 }
		} else {

			$return .=	"".bid_no_items."";

		}

		

		$return .= "<tr height='20px'>";
		$return .= "<td colspan='3' align='center'>";
		$return .= "</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td colspan='2' align='center'>";
		$return .= $this->_writePaging($pagingParams,"myauctions_", ITEMS_PER_PAGE, $total);
		$return .= "</td>";
		$return .= "</tr>";
		$return .= "</form>";
		$return .= "</table>";
		$return .= "</div>";


		return $return;
	}
}
?>