<?php
/**
 * @package AuctionsFactory
 * @version 1.7.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }


define('AUCTION_TYPE_PUBLIC', 1 );
define('AUCTION_TYPE_PRIVATE', 2 );
define('AUCTION_TYPE_BIN_ONLY', 3 );


class getmysettingsTab extends cbTabHandler {

	function getmysettingsTab() {
		$this->cbTabHandler();
	}

	function getDisplayTab($tab,$user,$ui){
		global $Itemid;
		$database = &JFactory::getDBO();
		$my = & JFactory::getUser();

		if($my->id!=$user->user_id){
			return null;
		}

		if(!file_exists(JPATH_ROOT."/components/com_bids/bids.php")){
			return "<div>You must First install <a href='http://www.thefactory.ro/shop/joomla-components/auction-factory.html'> Auction Factory </a></div>";
		}
		require_once(JPATH_ROOT."/components/com_bids/options.php");
		if(bid_opt_allow_user_settings==0)
			return false;
		
        if (file_exists(JPATH_ROOT.'/components/com_bids/lang/'.bid_opt_language))
            require_once(JPATH_ROOT.'/components/com_bids/lang/'.bid_opt_language);
        else
            require_once(JPATH_ROOT.'/components/com_bids/lang/default.php');

            
		$p = new mosCBBidUserSettings($database);
		$p->userid = $my->id;
	
	$act = JRequest::getVar($_POST,"com_act");
	if($act =="save_u_settings"){
		
		//save user settings requested
		$settings = array();
		
		$settings["show_reserve"] = JRequest::getVar( "show_reserve");
		$settings["picture"] = JRequest::getVar( "picture");
		$settings["add_picture"] = JRequest::getVar( "add_picture");
		$settings["auto_accept_bin"] = JRequest::getVar( "auto_accept_bin");
		$settings["bid_counts"] = JRequest::getVar( "bid_counts");
		$settings["max_price"] = JRequest::getVar( "max_price");
		
		$settings["end_hour"] = JRequest::getVar( "end_hour");
		$settings["end_minute"] = JRequest::getVar( "end_minute");
		 
		$settings["auction_type"] = JRequest::getVar( "auction_type"); 
		$settings["currency"] = JRequest::getVar( "currency");
		$settings["shipment_info"] = JRequest::getVar( "shipment_info");
		$settings["shipment_price"] = JRequest::getVar( "shipment_price");
		$settings["payment_info"] = JRequest::getVar( "payment_info");
		
		if( bid_opt_payment_select_mode==0 )
		{
			
			$o = JRequest::getVar( "payment_options");
			
			$settings["payment_options"] = implode(",", $o);
			
		}

		$p->saveUserSettings($settings);
	}
		
		
	// settting processing
	$lists["user_settings"] = $p->getUserSettings();
	
	if($lists["user_settings"]['payment_options']){
		$po = $lists["user_settings"]['payment_options']->value;
	}
	$query = "SELECT id as payment, name"
	. "\n FROM #__bid_payment"
	. "\n ORDER BY id"
	;
	$database->setQuery( $query );
	$pays = $database->loadObjectList();
		
	if(bid_opt_payment_select_mode == 0)
	{
		if($po){
			$database->setQuery("SELECT id as payment, name FROM #__bid_payment WHERE id IN ($po)");
			$plist = $database->loadObjectList();
		}
		$lists["user_settings"]['payment_options']->html = JHTML::_('select.genericlist', $pays, 'payment_options[]', 'class="inputbox" multiple="multiple" alt="payment"', 'payment', 'name', $plist);
	}

	
	if( isset($lists["user_settings"]['auction_type']->value) )
		$fi = $lists["user_settings"]['auction_type']->value;
	else
		$fi = null;
		
	$opts=null;
	$opts[] = JHTML::_('select.option','',bid_pick_type_of_auction);
	$opts[] = JHTML::_('select.option',AUCTION_TYPE_PUBLIC,bid_public_label);
	if( bid_opt_global_enable_private )
		$opts[] = JHTML::_('select.option',AUCTION_TYPE_PRIVATE,bid_private_label);
	if( bid_opt_global_enable_bin && bid_opt_enable_bin_only )
		$opts[] =JHTML::_('select.option',AUCTION_TYPE_BIN_ONLY,bid_bin_only_label);
		
	$lists["user_settings"]['auction_type']->html=	JHTML::_('select.genericlist', $opts, 'auction_type', 'class="inputbox" alt="auction_type"',  'value', 'text',$fi);

	if( isset($lists["user_settings"]['currency']->value) )
		$fi = $lists["user_settings"]['currency']->value;
	else
		$fi = null;
		
	$query = "SELECT id as value, name as text "
	. "\n FROM #__bid_currency"
	. "\n ORDER BY id"
	;
	$opts = null;
	$database->setQuery( $query );
	$opts = $database->loadObjectList();
	$lists["user_settings"]['currency']->html =	JHTML::_('select.genericlist', $opts, 'currency', 'class="inputbox" size="1"',  'value', 'text',$fi);


		$return .= "\t\t<div>\n";
		$return .="<table width='100%'>";
		$return .='<form name="topForm'.$tab->tabid.'" action="index.php?option=com_comprofiler&task=userProfile" method="post">';
		$return .="<input type='submit' name='save' value='Save settings' />";
		$return .="<input type='hidden' name='option' value='com_comprofiler' />";
		$return .="<input type='hidden' name='com_act' value='save_u_settings' />";
		$return .="<input type='hidden' name='task' value='userProfile' />";
		$return .="<input type='hidden' name='user' value='".$user->user_id."' />";
		$return .="<input type='hidden' name='tab' value='".$tab->tabid."' />";
		$return .="<input type='hidden' name='Itemid' value='".$Itemid."' />";
		$return .="<input type='hidden' name='act' value='' />";
		
$return .= "<tr>
		<td>".bid_setting_payment_options."</td>
		<td>
			".$lists["user_settings"]["payment_options"]->html."
		</td>
	</tr>";
$return .= "<tr>
		<td>".bid_setting_currency."</td>
		<td>
			".$lists["user_settings"]["currency"]->html."
		</td>
	</tr>";
$return .= "<tr>
		<td>".bid_type_of_auction."</td>
		<td>
			".$lists["user_settings"]["auction_type"]->html."
		</td>
	</tr>";
$return .= "<tr>
		<td>".bid_setting_end_time."</td>
		<td>
			H: <input type=\"text\" name=\"end_hour\" value=\"".$lists["user_settings"]["end_hour"]->value."\" style=\"width:20px;\" />
			m: <input type=\"text\" name=\"end_minute\" value=\"".$lists["user_settings"]["end_minute"]->value."\"  style=\"width:20px;\" />
		</td>
	</tr>";
$return .= "<tr>
		<td>".bid_payment_info."</td>
		<td>
			<input type=\"text\" name=\"payment_info\" value=\"".$lists["user_settings"]["payment_info"]->value."\" />
		</td>
	</tr>";
$return .= "<tr>
		<td>".bid_shipment."</td>
		<td>
			<input type=\"text\" name=\"shipment_info\" value=\"".$lists["user_settings"]["shipment_info"]->value."\" />
		</td>
	</tr>";
$return .= "<tr>
		<td>".bid_shipment_price."</td>
		<td>
			<input type=\"text\" name=\"shipment_price\" value=\"".$lists["user_settings"]["shipment_price"]->value."\" />
		</td>
	</tr>";

if (bid_opt_global_enable_reserve_price) {
$return .= "<tr>
        <td>".bid_param_reserve_price_text.":</td>
        <td>
            <input type=\"radio\" name=\"show_reserve\" value=\"1\" ";
				if($lists["user_settings"]["show_reserve"]->value=='1') $return .= "checked";
		 	$return .= ">".bid_show;
            $return .= "<input type=\"radio\" name=\"show_reserve\" value=\"0\" ";
				if ($lists["user_settings"]["show_reserve"]->value!='1') $return .= "checked";
			$return .= " >".bid_hide;
        $return .= "</td>
	</tr>";
}
$return .= "<tr>
        <td>".bid_param_picture_text.JHTML::_('tooltip',bid_param_picture_help).":</td>
        <td>
            <input type=\"radio\" name=\"picture\" value=\"1\" "; 
				if  ($lists["user_settings"]["picture"]->value=='1') $return .= "checked";
			$return .= ">".bid_show;
            $return .= "<input type=\"radio\" name=\"picture\" value=\"0\" ";
			if ($lists["user_settings"]["picture"]->value!='1')  $return .= "checked";
			$return .= ">".bid_hide;
        $return .= "</td>
    </tr>";
$return .= "<tr>
        <td>".bid_param_add_picture_text.JHTML::_('tooltip',bid_param_add_picture_help).":</td>
        <td>
            <input type=\"radio\" name=\"add_picture\" value=\"1\" ";
			if ($lists["user_settings"]["add_picture"]->value=='1') $return .= "checked";
			$return .= ">".bid_show;
            $return .= "<input type=\"radio\" name=\"add_picture\" value=\"0\" ";
			if ($lists["user_settings"]["add_picture"]->value!='1') $return .= "checked";
			$return .= ">".bid_hide;
        $return .= "</td>
    </tr>";
if (bid_opt_global_enable_bin) {
    $return .= "<tr>
        <td>".bid_param_accept_bin_text.JHTML::_('tooltip',bid_param_accept_bin_help).":</td>
        <td>
            <input type=\"radio\" name=\"auto_accept_bin\" value=\"1\" ";
			if ($lists["user_settings"]["auto_accept_bin"]->value=='1') $return .= "checked";
				$return .= ">".bid_yes;
    $return .= "<input type=\"radio\" name=\"auto_accept_bin\" value=\"0\" ";
			if ($lists["user_settings"]["auto_accept_bin"]->value!='1') $return .= "checked";
				$return .= ">".bid_no;
        $return .= "</td>
    </tr>";
}
    $return .= "<tr>
        <td>".bid_param_counts_text.JHTML::_('tooltip',bid_param_counts_help).":</td>
        <td>
            <input type=\"radio\" name=\"bid_counts\" value=\"1\" ";
			if ($lists["user_settings"]["bid_counts"]->value=='1') $return .= "checked";
				$return .= ">".bid_show;
    $return .= "<input type=\"radio\" name=\"bid_counts\" value=\"0\" ";
			if ($lists["user_settings"]["bid_counts"]->value!='1') $return .= "checked";
				$return .= ">".bid_hide;
        $return .= "</td>
    </tr>";

    $return .= "<tr>
        <td>".bid_param_max_price_text.JHTML::_('tooltip',bid_param_max_price_help).":</td>
        <td>
            <input type=\"radio\" name=\"max_price\" value=\"1\" ";
			if ($lists["user_settings"]["max_price"]->value=='1') $return .= "checked";
				$return .= ">".bid_show;
    $return .= "<input type=\"radio\" name=\"max_price\" value=\"0\" ";
			if ($lists["user_settings"]["max_price"]->value!='1') $return .= "checked";
				$return .= ">".bid_hide;
        $return .= "</td>
    </tr>";

		$return .= "</form>";
		$return .= "</table>";
		$return .= "</div>";

		//$return ="";
		return $return;
	}
}

class mosCBBidUserSettings extends JTable {
    var $id		 = null;
    var $userid	 = null;
    var $name	 = null;
    var $value	 = null;

    function mosCBBidUserSettings(&$db)
    {
        $this->__construct('#__bid_user_settings','id',$db);
	}
	
	
	function getUserSettings(){
		
		$this->_db->setQuery(" SELECT * FROM `#__bid_user_settings` WHERE userid = '{$this->userid}' ");
		return $this->_db->loadObjectList("name");
		
	}
	
	/**
	 * Save Settings List
	 *  @param   $settings array of key - name => value = setting value
	 *
	*/
	function saveUserSettings($settings){
		
		// Delete old settings
		$this->_db->setQuery("DELETE FROM `#__bid_user_settings` WHERE userid = '{$this->userid}' ");
		$this->_db->query();
		
		$inserts = array();
		
		if($settings){
			foreach($settings as $name => $settingVal){
				$inserts[] = " ( '{$name}', '{$settingVal}', '{$this->userid}' ) "; 
			}
			
			$this->_db->setQuery("INSERT INTO #__bid_user_settings (name, value ,userid ) VALUES ".implode(",", $inserts));
			$this->_db->query();
			
		}
		
	}
	
}

?>