<?php
/**
 * @package		Auctions Factory
 * @license		comercial
 * @modified	12/07/2010
 */
// Check to ensure this file is included in Joomla!
jimport('joomla.application.component.controller');

/**
 * Controller Auctions Factory
 *
 * @package		Auctions Factory
 * @version 	2.0.0
 */
class BidsController extends JController
{
	var $_name='bids';
	
	function newauction(){
		$this->form();
	}
	
	function editauction(){
		$this->form();
	}
	
	function republish(){
		$this->form();
	}
	
	function tags(){
		$this->showsearchresults();
	}
	
	function form(){

	   $id=(int)JRequest::getVar('id','');
	    
		$db = & JFactory::getDBO();
		$view = $this->setViewParams("auction");
		$view->edit();
	}

	function listcats(){
		$view = $this->setViewParams(JRequest::getVar('view', 'category', 'listcats', 'cmd'));
		$view->display();
	}
	
	function listauctions(){
		$view = $this->setViewParams(JRequest::getVar('view', 'auctions', 'listauctions', 'cmd'));
		$view->listauctions();
	}
	
	function mybids(){
		$view = $this->setViewParams(JRequest::getVar('view', 'auctions', 'mybids', 'cmd'));
		$view->listmybids();
	}
	
	function mywonbids(){
		$view = $this->setViewParams(JRequest::getVar('view', 'auctions', 'mybids', 'cmd'));
		$view->listmywonbids();
	}
	
	function mywatchlist(){
		$view = $this->setViewParams(JRequest::getVar('view', 'auctions', 'mywatchlist', 'cmd'));
		$view->listwatchlist();
	}
	
	function myauctions(){
		$view = $this->setViewParams(JRequest::getVar('view', 'auctions', 'listmyauctions', 'cmd'));
		$view->listmyauctions();
	}

	function suggestions(){
		$view = $this->setViewParams(JRequest::getVar('view', 'auctions', 'listsuggestions', 'cmd'));
		$view->listsuggestions();
	}
	
	function listsuggestions(){
		$view = $this->setViewParams(JRequest::getVar('view', 'auctions', 'listsuggestions', 'cmd'));
		$view->listsuggestions();
	}
	
	function mysuggestions(){
		$view = $this->setViewParams(JRequest::getVar('view', 'auctions', 'mysuggestions', 'cmd'));
		$view->mysuggestions();
	}
	
	function showsearchresults(){
		$view = $this->setViewParams("auctions");
		$view->listauctions();
	}
	
	function search(){
		$view = $this->setViewParams("auction");
		$view->search();
	}
	
	function tree(){
		$view = $this->setViewParams(JRequest::getVar('view', 'category', 'listcats', 'cmd'));
		$view->tree_cats();
	}

	function selectcat()
	{
		$id=(int)JRequest::getVar('id','');
		$view = $this->setViewParams("category");
		$view->catselect();
	}
	
	function addwatchcat(){
		
		$database =& JFactory::getDBO();
		$my =& JFactory::getUser();
	
		if (!$my->id) {
			echo "<br />" . JText::_( 'You need to login.' );
			return;
		}
		
		$cid = (int)JRequest::getVar('cat',0);
	
		$query = "select count(id) from #__bid_watchlist_cats where userid = $my->id and catid = '$cid'";
		/* @var database database */
		$database->setQuery($query);
		$result = $database->loadResult();
	
		if(!$result)
		{
			$watchList = new JBidWatchlistCats($database);
			$watchList->userid = $my->id;
			$watchList->catid = $cid;
			$watchList->store();
		}
		
		$refferer = $_SERVER['HTTP_REFERER'];
		if(!$refferer) $refferer="index.php?option=com_bids";
		FactoryLayer::redirect($refferer,JText::_("Added to wachlist!"));
		
	}
	
	function delwatchcat(){
		$database =& JFactory::getDBO();
		$my =& JFactory::getUser();
	
		if (!$my->id) {
			echo "<br />" . JText::_( 'You need to login.' );
			return;
		}
		
		$cid = (int)JRequest::getVar('cat',0);
		$database->setQuery("delete from  #__bid_watchlist_cats  where userid=$my->id and catid=$cid");
	
		$database->query();
		$refferer = $_SERVER['HTTP_REFERER'];
		if(!$refferer) $refferer=JURI::root().'/'."index.php?option=com_bids";
		FactoryLayer::redirect($refferer,JText::_("Remove from wachlist!"));
	}
	
	function viewdetails(){
		$id = (int)JRequest::getVar('id',null);
		if(!$id)
			FactoryLayer::redirect( JURI::root()."index.php?option=com_bids", "Select an user!" );
		
		$r = BidsUtilities::redirectToProfile( $id );
		if($r)
			$this->setRedirect( $r );

		$view = $this->setViewParams(JRequest::getVar('view', 'user', 'userdetails', 'cmd'));
		$view->userdetails();
	}

	function userdetails(){
		$r = BidsUtilities::redirectToProfile();
		if($r)
			$this->setRedirect( $r );
		$view = $this->setViewParams(JRequest::getVar('view', 'user', 'myuserdetails', 'cmd'));
		$view->myuserdetails();
	}
	
	function saveUserDetails(){
		
		global $Itemid;
		
		$my = & JFactory::getUser();
		
		if ( !$my->id ) {
			echo JText::_('ALERTNOTAUTH');
			echo "<br />" . JText::_( 'You need to login.' );
			return;
		}
		
		$model = &$this->getModel( 'User' ,'bidsModel');
		$err = $model->saveUserDetails();
		$msg = null;
		if($err!==true)
			$msg = $err;
		else 
			$msg = JText::_("Details saved!");
			
		/**
		 * 
		 * 1.7.0 return after filling profile feature
		 * 
		 */
		$return = JRequest::getVar( "return","");
		if($return!=""){
			FactoryLayer::redirect( base64_decode($return),$msg );
		}
			
		FactoryLayer::redirect( JURI::root()."index.php?option=com_bids&task=UserDetails&Itemid=$Itemid", $msg );
	}
	
	function myratings(){
		$view = $this->setViewParams(JRequest::getVar('view', 'user', 'myratings', 'cmd'));
		$view->myratings();
	}
	
	function userratings(){
		$view = $this->setViewParams(JRequest::getVar('view', 'user', 'userratings', 'cmd'));
		$view->userratings();
	}
	
	function watchlist()
	{
	    global $Itemid;
	    
		$auctionid = (int)JRequest::getVar('id',null);
	    $database = & JFactory::getDBO();
	    $my = & JFactory::getUser();
	    
	    if (!$my->id)
	    {
	        JError::raiseWarning( 0,bid_you_have_to_login);
	        return;
	    }
	
	    $query = "select count(id) from #__bid_watchlist where userid = $my->id and auctionid = '$auctionid'";
	    $database->setQuery($query);
	    $result = $database->loadResult();
	    if ($result)
	        return;
	
		JAuctionWatchlist::addWatchlist($my->id,$auctionid);
		
	    $refferer = $_SERVER['HTTP_REFERER'];
	    if (!$refferer)
	        $refferer = JURI::root() . "index.php?option=com_bids";
	    FactoryLayer::redirect($refferer, bid_added_to_watchlist);
	}
	
	function searchUsers(){
		$view = $this->setViewParams(JRequest::getVar('view', 'user', 'searchusers', 'cmd'));
		$view->searchUsers();
	}

	function showUsers(){
		$view = $this->setViewParams(JRequest::getVar('view', 'user', 'showusers', 'cmd'));
		$view->showusers();
	}

	function delwatch()
	{
	    global $Itemid;
	    
		$auctionid = (int)JRequest::getVar('id',null);
	    $database = & JFactory::getDBO();
	    $my = & JFactory::getUser();
	    
	    if (!$my->id)
	    {
	        JError::raiseWarning( 0,bid_you_have_to_login);
	        return;
	    }
	
		JAuctionWatchlist::delWatchlist($my->id,$auctionid);
	    
	    $refferer = $_SERVER['HTTP_REFERER'];
	    if (!$refferer)
	        $refferer = JURI::root() .  "index.php?option=com_bids";
	    FactoryLayer::redirect($refferer, bid_del_from_watchlist);
	}

	function cancelauction()
	{
	    global $Itemid;
	    
		$database = &JFactory::getDBO();
		$my = &JFactory::getUser();
		$task = JRequest::getCmd('task');
		$id = JRequest::getInt('id');
	
	    @ignore_user_abort(true);
	    $auction = new JAuctions($database);
	    // load the row from the db table
	    $auction->load($id);
	    if (!$auction->acl_check($my))
	    {
	        JError::raiseWarning( 0,bid_you_have_to_login);
	        return;
	    }
	    
	    
	    $auction->close_offer = 1;
	    $auction->closed_date = date("Y-m-d H:i:s", time());
	
	    if ($auction->ancStore())
	    {
	        //Get Bidders
	        $q = "SELECT distinct u.*
	    		  FROM #__users u
	              left join  #__bids b on b.userid=u.id
	    		  WHERE b.id_offer = $id AND b.cancel=0";
	        $database->setQuery($q);
	        $usermails = $database->loadObjectList();
	        $query = "SELECT u.* from #__users u
					left join #__bid_watchlist w on u.id = w.userid
					where w.auctionid = $id";
	        $database->setQuery($query);
	        $watchlist_mails = $database->loadObjectList();
	
	        $auction->SendMails($watchlist_mails, 'bid_watchlist_canceled');
	        $auction->SendMails($usermails, 'bid_canceled');
	
	        $msg = bid_auction_was_canceled;
	    }
	    else
	    {
	        $msg = bid_err_auction_was_canceled_failed;
	    }
	    FactoryLayer::redirect(JURI::root()."index.php?option=com_bids&task=myauctions&Itemid=$Itemid",$msg);
	}
	
	function terms_and_conditions()
	{
	    $database = & JFactory::getDBO();
	    $terms = new JAuctionMails($database);
	    if (!$terms->load('terms_and_conditions'))
	        return;
	    ob_clean();
	    echo $terms->content;
	    exit;
	}
	
	function report_auction()
	{
	    global $Itemid;
	    
		$id = JRequest::getInt('id');
		
		$database = &JFactory::getDBO();
		$my = &JFactory::getUser();
		$task = JRequest::getCmd('task');
		
	    $app = &JFactory::getApplication();
	    
		$mail_from = $app->getCfg('mailfrom');
		$site_name = $app->getCfg('sitename');
	    
	
	    $message = JRequest::getString('message', '');
	
	    $database->setQuery("select title from #__bid_auctions where id=$id");
	    $title = $database->loadResult();
	
	    if ($message)
	    {
	        $database->setQuery("insert into #__bid_report_auctions (id_offer,userid,message,modified) values ('$id','$my->id','$message',now() )");
	        $database->query();
	        // TO DO: send mail to ADMIN
	        $can->name = $site_name;
	        $can->surname = "";
	        $can->email = $mail_from;
	        $auction = new JAuctions($database);
	        $auction->load($id);
	        $auction->SendMails(array($can), "report_notify");
	
	        FactoryLayer::redirect(JURI::root() . "/index.php?option=com_bids&task=viewbids&id=$id&Itemid=$Itemid",bid_auction_reported);
	        exit;
	    }
	
	$view = $this->setViewParams(JRequest::getVar('view', 'auction', 'report_auction', 'cmd'));
	$view->reportAuction($id, $title, $Itemid);
	}
	
	function viewbids()
	{
	
		$database = &JFactory::getDBO();
		$my = &JFactory::getUser();
		$task = JRequest::getCmd('task');
		$id = JRequest::getInt('id');
	   $auction = new JAuctions($database);
	   $TOOL_auction = new JAuctions($database);
	    
	    if (!$auction->load($id))
	    {
	        echo bid_err_does_not_exist;
	        return;
	    }
	
	    if( $my->id ){
	    	
		    if (!$auction->published && $my->id != $auction->userid)
		    {
				echo bid_err_does_not_exist;
				return;
		    }
		    
		    if( $my->id==$auction->userid && $auction->newmessages==1 )
		    {
			    	$TOOL_auction->ancLoad($id);
					$TOOL_auction->newmessages = 0 ;
					$TOOL_auction->ancStore();
		    }
		
		    $database->setQuery("UPDATE #__bid_messages set wasread=1 where userid2='$my->id' and id_offer={$auction->id}");
		    $database->query();
	    	
	    }
	
	    if ($my->id != $auction->userid && (!isset($_COOKIE['washit']) || $_COOKIE['washit'] < time()))
	    {
	        //protection against jumping hits through reload through
	        // reloads related to templates or other javascript
	        $auction->hit();
	        setcookie("washit", time() + 4);
	    }
	
	    $bid_user = &JTable::getInstance("user");
	    $bid_user->load($auction->userid);
	
	    $u = new JAuctionUsers($database);
	    $bid_user_details = $u->getUserDetails($bid_user->id);
	    $list["auctioneer_ratings"] = array();
	    $res = $u->getRatingsList($bid_user->id);
	    for ($i = 1; $i <= 5; $i++)
	    {
	        $list["auctioneer_ratings"][$i] = $res[$i * 2]['nr'] + $res[$i * 2 - 1]['nr'];
	        $list["auctioneer_ratings"][0] += $list["auctioneer_ratings"][$i];
	    }
	
	    $query = "
		SELECT m.*,u1.username as fromuser, u2.username as touser
		FROM #__bid_messages as m
		LEFT JOIN #__users u1 ON u1.id = m.userid1";
	    $query .= " LEFT JOIN #__users u2 ON u2.id = m.userid2
			WHERE m.id_offer=$id and (m.userid1 = $my->id or m.userid2 = $my->id) AND published=1 
		";
	    $database->setQuery($query);
	
	    $messages = $database->loadObjectList();
	
	    if ($auction->auction_type == AUCTION_TYPE_PRIVATE && $my->id != $auction->userid)
	    {
	        //Closed Auction
	        $where = " where id_offer='$id' and userid='$my->id'";
	    }
	    else
	    {
	        //Open Auction
	        $where = " where id_offer='$id'";
	    }
	
	    $bin_sql = "";
	    if ($auction->BIN_price > 0)
	    {
	        $bin_sql = " , IF(a.bid_price='$auction->BIN_price',1,0) AS is_bin ";
	    }
	    $query = "select a.*,u.name,u.username $bin_sql from #__bids a 
			left join #__users u on a.userid=u.id
	
			$where ";
	    $database->setQuery($query);
	    $bids_placed = $database->loadObjectList();
		// 1.6.9 FIX
		$statement = "SELECT COUNT(user_rated) as no FROM #__bid_rate WHERE auction_id = '{$id}' AND voter = '{$my->id}' ";
		$database->setQuery($statement);
		$number_rates = $database->loadObject();
		
		$weeners_statement = "SELECT user_rated FROM #__bid_rate WHERE auction_id = '{$id}'";
		$database->setQuery($weeners_statement);
		$weeners = $database->loadObjectList("user_rated");
		
		$mustRate = 1;
		if(!$auction->isMyAuction() ){
			if($number_rates>=1)
				$mustRate = 0;
		}else{
			if($number_rates >= count($weeners))
				$mustRate = 0;
		}
		
		for ($ij = 0 ; $ij < count($bids_placed); $ij++ )
		{
			$bidD = $bids_placed[$ij];
			$bidD->must_rate = $mustRate;
			if(is_array($weeners) && isset($weeners[$bidD->userid]) ){
				$bidD->must_rate = 0;
			}
		}
		
	
	    $database->setQuery("select name from #__bid_currency where id=$auction->currency");
	    $currency = $database->loadResult();
	    //Other items by this user:
	    $query = "
	    	SELECT
	    	a.*, b.name,b.username,m.name as payment_name, c.name as currency_name ,cats.catname, cats.id as cid
	    	FROM #__bid_auctions as a
	    	LEFT JOIN #__users as b ON b.id=a.userid
	    	LEFT JOIN #__bid_payment as m ON m.id=a.payment
	    	LEFT JOIN #__bid_currency as c ON c.id=a.currency
	    	LEFT JOIN #__bid_categories as cats ON a.cat=cats.id
		    where a.userid='{$auction->userid}' and a.id<>'{$auction->id}' 
	        order by RAND()";
	
	    $database->setQuery($query, 0, 5);
	    $other_items = $database->loadObjectList();
	    if (bid_opt_enable_countdown && count($other_items))
	    {
	        foreach ($other_items as $row)
	        {
	            $now = BidTimeUtilities::getNow();
	            $expiredate = strtotime($row->end_date);
	            $diff = $expiredate - $now;
	            if ($diff > 0)
	            {
	                $s = sprintf("%02d", $diff % 60);
	                $diff = intval($diff / 60);
	                $m = sprintf("%02d", $diff % 60);
	                $diff = intval($diff / 60);
	                $h = sprintf("%02d", $diff % 24);
	                $d = intval($diff / 24);
	                if ($d > 0)
	                    $row->countdown = "$d " . bid_days . ", $h:$m:$s";
	                else
	                    $row->countdown = "$h:$m:$s";
	            }
	            else
	            {
	                $row->countdown = bid_expired;
	            }
	        }
	    }
	    $list['other_items'] = $other_items;
	
	    $arr[] = JHTML::_('select.option',1, '1');
	    $arr[] = JHTML::_('select.option',2, '2');
	    $arr[] = JHTML::_('select.option',3, '3');
	    $arr[] = JHTML::_('select.option',4, '4');
	    $arr[] = JHTML::_('select.option',5, '5');
	    $arr[] = JHTML::_('select.option',6, '6');
	    $arr[] = JHTML::_('select.option',7, '7');
	    $arr[] = JHTML::_('select.option',8, '8');
	    $arr[] = JHTML::_('select.option',9, '9');
	    $arr[] = JHTML::_('select.option',10, '10');
	
	    $list['ratings'] = JHTML::_('select.radiolist',$arr, 'rate', null);
	    
		$view = $this->setViewParams(JRequest::getVar('view', 'auction', 'viewbids', 'cmd'));
	    $view->AuctionDetails($auction, $list, $bid_user, $bid_user_details, $bids_placed,$currency, $messages);
	}
	
	function savemessage()
	{
	    global $Itemid;
	    $database = &JFactory::getDBO();
	    $my = &JFactory::getUser();
		$id_offer = JRequest::getInt("id");
	
	    if (!$my->id && bid_opt_enable_captcha)
	    {
	        // if code not good halt
			if( !BidsHTML::verify_captcha() )
	        {
	            $redirect_link = 'index.php?option=com_bids&task=viewbids&id=' . $id_offer .'&Itemid=' . $Itemid  . "#messages";
	            FactoryLayer::redirect($redirect_link, bid_message_error_captcha );
	        }
	    }
	
	    $id_msg = JRequest::getInt("idmsg", 0);
	    $bidder_id = JRequest::getInt("bidder_id", 0);
	
	    $auction = new JAuctions($database);
	
	    if (!$auction->load($id_offer))
	    {
	        echo bid_does_not_exist;
	        return;
	    }
	
	    if ($auction->close_offer)
	    {
	        if (!$auction->isMyAuction() && (!$auction->winner_id == $my->id))
	        {
	            echo bid_auction_is_closed;
	            return;
	        }
	    }
	    if ($auction->published != 1)
	    {
	        echo bid_does_not_exist;
	        return;
	    }
	
	    if (bid_opt_allow_messages)
	    {
	        $comment = JRequest::getString('message', '');
	        $comment = str_replace("\n", '<br>', $comment);
	
	        $auction->sendNewMessage($id, $id_msg, $comment, $bidder_id);
	    }
	
	    if (UDDEIM_DETECT && bid_opt_uddeim)
	    {
	        $reply = $id_msg;
	        $author = $my->id;
	        $to = $auction->userid;
	        if (file_exists(JPATH_ROOT .
	            "/components/com_uddeim/uddeimlib15.php"))
	            require_once (JPATH_ROOT ."/components/com_uddeim/uddeimlib15.php");
	
	        require_once (JPATH_ROOT ."/administrator/components/com_uddeim/admin.shared.php");
	        require (JPATH_ROOT ."/administrator/components/com_uddeim/config.class.php");
	        $config = new uddeimconfigclass();
	        uddeIMcheckConfig($config);
	        uddeIMloadLanguage($pathtoadmin, $config);
	        if ($bidder_id)
	            $to = $bidder_id;
	        if ($id_msg)
	        {
	            $replytom = new JAuctionMessages($database);
	            $replytom->load($id_msg);
	            $to = $replytom->userid1;
	        }
	        if ($to != $author)
	        {
	            $comment = str_replace('<br>', "\n", $comment);
	            $comment = sprintf(bid_subject_format, $auction->auction_nr) . $comment;
	            $q = "INSERT INTO #__uddeim SET fromid = '{$author}', toid = '{$to}', message = '{$comment}', datum = UNIX_TIMESTAMP(); ";
	            $database->setQuery($q);
	            $database->query();
	        }
	    }
	
		$redirect_link = 'index.php?option=com_bids&task=viewbids&id=' . $id_offer .'&Itemid=' . $Itemid . "#messages";
	
		FactoryLayer::redirect($redirect_link,bid_message_success);
	}
	
	function setViewParams($_viewName){
		
		$document 	=& JFactory::getDocument();
		$viewType	= $document->getType();
		$view 	= &$this->getView($_viewName, $viewType);

		$model	= &$this->getModel( "category" );
		if (!JError::isError( $model )) { $view->setModel( $model, true ); }
		
		$model	= &$this->getModel( "auctions" );
		if (!JError::isError( $model )) { $view->setModel( $model, true ); }
		
		$model	= &$this->getModel( "user" );
		if (!JError::isError( $model )) { $view->setModel( $model, true ); }
		
		$model	= &$this->getModel( "bid" );
		if (!JError::isError( $model )) { $view->setModel( $model, true ); }
		
		return $view;
	}
	
}