<?php
/**
 * @package Factory
 * @version 1.0.1
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

include_once(JPATH_ROOT . DS . "components". DS ."com_bids" . DS . "gallery" . DS . "gallery.php");

class gl_simple_gallery extends auct_gallery{
	var $_pathToJS;
	var $_pathToImages;

	function gl_simple_gallery(&$db,$pathToImages)
	{
		$this->_db=$db;
		$this->_pathToJS=JURI::root() . "/components/com_bids/gallery/simple_gallery/";
		$this->_pathToImages=$pathToImages."/";
	}
	
	function getJS()
	{
      $jdoc = & JFactory::getDocument();
      
      $width = intval(bid_opt_medium_width);
      $height = intval(bid_opt_medium_height);
		
      $box_width = $width+20;
      $box_height = $height+20;
      
      $gal_width = $width + 100;
      
		$css = "
			.gallery_wrap{
				width:{$gal_width}px !important;
				height:{$box_height}px !important;
			}
			
			#gallery_preview{
				width:{$box_width}px !important;
				height:{$box_height}px !important;
				float:left;
				background:#FFF;
			}
			
			#preview_pic{
				margin:6px;
				
				max-width:{$width}px !important;
				max-height:{$height}px !important;
				width:{$width}px;
			}
			
			#gallery_thumblist{
				background:#FFF;
				float:left;
				width:80px;
				height:{$box_height}px !important;
				overflow:auto;
			}
			
			.img_thumb{
				margin:0px;
				background:url('".$this->_pathToJS."/photo_bg.jpg') no-repeat;
				width:60px !important;
				height:60px !important;
				text-align:center !important;
				
			}
			.img_thumb img{
				margin-top:5px !important;
				width:45px !important;
				max-width:45px !important;
				max-height:45px !important;
				cursor:pointer;
			}
		";
		$jdoc->addStyleDeclaration($css);
		$js = "
			function showPic(src){
				
				document.getElementById('id_waid').style.display='none';
				document.getElementById('preview_pic').style.display='block';
				document.getElementById('preview_pic').src = src;
				document.getElementById('preview_pic_big').href = src.replace('middle_','');
			}
		
			function picSelect(imgO){
				
				document.getElementById('id_waid').style.display='block';
				document.getElementById('preview_pic').style.display='none';
				//imgO.style.width='70px';
				setTimeout(\"showPic('\"+imgO.src+\"')\", 300);
				
			}
		";
		$jdoc->addScriptDeclaration($js);
	}
	function writeJS(){
		$this->getJS();
		JHTML::_('behavior.modal');
	}
	
	function getThumb($thumbnr=0,$overlib=1,$medium=0)
	{
		$img = "";
		if($this->imagelist[$thumbnr]){
		   $img_small=$this->_pathToImages.'/resize_'.$this->imagelist[$thumbnr];
   	   $img_full=$this->_pathToImages.$this->imagelist[$thumbnr];
   	   $img_middle=$this->_pathToImages.'/middle_'.$this->imagelist[$thumbnr];
	      $img_small_html="<img src='$img_small' border=0>";
	      $img_middle_html="<img src='$img_middle' border=0>";
	      $img_full_html="<img src='$img_full' border=0>";
		   if ($overlib){{
				JHTML::_("behavior.tooltip",".hasTip");
			
			$img = "$img_middle_html";
			echo '<style type="text/css">.tool-tip{max-width:100% !important;}</style>';
			$img='<img src="'.$img_small.'" border="0" class="editlinktip hasTip" title="'.$img.'" >';
		   }

		   }else{
    	       $img='<a href="'.$img_full.'" class="modal">';
		       $img.='<img src="'.$img_small.'" border="0" />';
		       $img.='</a>';
		   }
		}else{
 	       if ($medium)
	           $width= intval(bid_opt_medium_width);
	       else
	           $width= intval(bid_opt_thumb_width);
           $img.='<img src="'.$this->_pathToImages.'/no_image.png" border="0" width="'.$width.'"/>';

		}
        return $img;
	}
	function writeThumb($thumbnr=0,$overlib=1,$medium=0)
	{
		//JHTMLBehavior::mootools();
	    echo $this->getThumb($thumbnr,$overlib,$medium);
	}
	
	function getGallery()
	{
		
		$img = "";
        $width= intval(bid_opt_medium_width);
	    if (count($this->imagelist)>0){

	    	$nr=0;
	        for($i=0;$i<count($this->imagelist);$i++){
	        	if ($this->imagelist[$i]=='') continue;
	        	$nr++;
	        }
	        
	       $img.='<div class="gallery_wrap">';
	        
	        if($this->imagelist[0]){
		        $main_img = $this->imagelist[0];
	        }
	        
	        $img.='<div id="gallery_preview">
							<img id="id_waid" src="'.$this->_pathToJS.'ajax-loader.gif" style="display:none; margin-top:50px; margin-left:50px;" />
							<a class="modal" id="preview_pic_big" href="'.$this->_pathToImages.$main_img.'"><img id="preview_pic" src="'.$this->_pathToImages.'middle_'.$main_img.'" /></a>
						</div>
						<div id="gallery_thumblist">';
	        
			        for($i=0;$i<count($this->imagelist);$i++){
			            if ($this->imagelist[$i]=='') continue;
			            $img.='<div class="img_thumb">';
			            
			            $img.= '<img src="'.$this->_pathToImages.'middle_'.$this->imagelist[$i].'" onclick="picSelect(this);" alt="" border=0 width="'.$width.'" >';
				            	 
				         $img.='</div>';
			        }
	            $img.='</div>
							 <div style="clear:both;">&nbsp;</div>
					 </div>';
	    } else {
	        $img='<img src="'.$this->_pathToImages.'/no_image.png" border="0" alt="No image" >';
	    }
	    
	    return $img;
	}
	function writeGallery(){
	    echo $this->getGallery();

	}
	

}

?>