<?php

class BidsUtilities{

	function cloack_email($mail_address){

		if(defined("bid_opt_enable_antispam_bot") && bid_opt_enable_antispam_bot==1 && defined("bid_opt_choose_antispam_bot")){
			if (bid_opt_choose_antispam_bot == "recaptcha" ){
				require(JPATH_COMPONENT_SITE.DS.'helpers'.DS.'recaptcha'.DS.'recaptchalib.php');
				$mail = recaptcha_mailhide_url("01WxCXdKklKdG2JpOlMY15jw==","2198178B23BFFB00CBAEA6370CE7A0B2", $mail_address);
				return "<a href=\"$mail.\" onclick=\"window.open('$mail', '', 'toolbar=0,scrollbars=0,location=0,statusbar=0, menubar=0,resizable=0,width=500,height=300');	return false;\" title=\"Reveal this e-mail address\">".JText::_("Show email")."</a>";
			}elseif (bid_opt_choose_antispam_bot  == "joomla" ){
				
				// Discutable if use Content Mail Plugin or ... just JHTML_('email.cloac' it does the same .. just global configuration is in question
				global $mainframe;
			    $plugin =& JPluginHelper::getPlugin('content', 'emailcloak');
			    $pluginParams = new JParameter( $plugin->params );
			    require_once (JPATH_SITE.DS.'plugins'.DS.'content'.DS.'emailcloak.php');
			    plgContentEmailCloak($mail_address, $pluginParams);
				return $mail_address;
				
			}elseif (bid_opt_choose_antispam_bot =="smarty"){
				$smarty = BidsUtilities::SmartyLoaderHelper();
				require_once(SMARTY_DIR."plugins/function.mailto.php");
				return smarty_bids_print_encoded(array("address"=>$mail_address, "encode"=>"hex"), $smarty);
			}
		}
		else
			return $mail_address;
	}	
	
	/**
	 * Finds The Menu Item Of the Component 
	 *  by the needles as params
	 *
	 * needle example: 'view' => 'category'
	 * 
	 * 
	 * @param array $needle
	 * @since 1.5.0
	 */
	function getMenuItemId( $needles, $external_link = 0 ){
		$component =& JComponentHelper::getComponent('com_bids');

		$menus	= &JApplication::getMenu('site', array());
		if($external_link){
			$items	= $menus->getItems('type', "url");
		}else{
			$items	= $menus->getItems('componentid', $component->id);
		}
		
		$match = null;
		
		if($items)
		foreach($items as $item)
		{
			
			$ok = true;
			foreach($needles as $needle => $id)
			{
				if ( @$item->query[$needle] != $id ) {
					
					$ok = false;
					break;
				}
			}
			if($ok==true){
				$match=$item;
				break;
			}
		}
		
		if (isset($match)) {
			
			return $match->id;
			
		}else 
			return null;
	}

	function redirectToProfile($id=null){
		
		if(defined("bid_opt_profile_mode"))
			return JTheFactoryUserProfile::setRedirectToProfile(bid_opt_profile_mode, $id);
			
		return null;	
	}
	
	function auctionDatetoIso($date)
	{
	    if (bid_opt_date_format=='Y-m-d'){
	        return $date;
	    }
	    if (bid_opt_date_format=='Y-d-m'){
	        preg_match("/([0-9]+)-([0-9]+)-([0-9]+)/",$date,$matches);
	        return $matches[1]."-".$matches[3]."-".$matches[2];
	    }
	    if (bid_opt_date_format=='m/d/Y') {
	        preg_match("/([0-9]+)\/([0-9]+)\/([0-9]+)/",$date,$matches);
	        return $matches[3]."-".$matches[1]."-".$matches[2];
	    }
	    if (bid_opt_date_format=='d/m/Y') {
	        preg_match("/([0-9]+)\/([0-9]+)\/([0-9]+)/",$date,$matches);
	        return $matches[3]."-".$matches[2]."-".$matches[1];
	    }
	    return $date;
	}

    function SmartyLoaderHelper($debug=false)
    {
    	global $Itemid;
        $option = "com_bids";
        $my = & JFactory::getUser();
        $database = & JFactory::getDbo();
        
		$task	= JRequest::getCmd( 'task','' );
		if ( !$task )
			$task	= JRequest::getCmd( 'layout','' );
		if (!$task)
			$task = 'display';
        

        require_once (JPATH_COMPONENT_SITE . '/helpers/bids.smarty.plugins.php');

        $act = JRequest::getWord( 'act', '');
        $smarty = new JTheFactorySmarty();
        $smarty->template_dir = JPATH_COMPONENT_SITE . '/templates/'.BID_TPL_THEME.DS;
        $smarty->compile_dir = JPATH_COMPONENT_SITE . '/templates/cache'.DS;
        $smarty->config_dir = JPATH_COMPONENT_SITE . '/templates/configs'.DS;
        $smarty->debugging= $debug;

        $smarty->register_function('set_css', 'smarty_set_css');
        $smarty->register_function('infobullet', 'smarty_infobullet');
        $smarty->register_function('printdate', 'smarty_printdate');
        $smarty->register_function('createtab', 'smarty_createtab');
        $smarty->register_function('startpane', 'smarty_startpane');
        $smarty->register_function('endpane', 'smarty_endpane');
        $smarty->register_function('starttab', 'smarty_starttab');
        $smarty->register_function('endtab', 'smarty_endtab');
        $smarty->register_function('get_now', 'smarty_get_now');
        $smarty->register_modifier('stripslashes', 'stripslashes');
        $smarty->register_modifier('add_days', 'smarty_add_day');
        $smarty->register_modifier('jroute', 'smarty_jroute');
        $smarty->register_function('init_behavior', 'smarty_init_behavior');
        $smarty->register_function('show_editor', 'smarty_show_editor');
        $smarty->register_function('import_js_file', 'smarty_import_js_file');
        $smarty->register_block('import_js_block', 'smarty_import_js_block');
        $smarty->register_block('import_css_block', 'smarty_import_css_block');
        $smarty->register_function('print_price', 'smarty_print_price');
        $smarty->register_function('import_css_file', 'smarty_import_css_file');
        $smarty->register_block('txt', 'smarty_translate_txt_block');

        $now = BidTimeUtilities::getNow();
        $nowFormated = date(bid_opt_date_format . " " . bid_opt_date_time_format, $now);
        $smarty->assign('nowTime', $nowFormated);

        
        $ItemIdList = new stdClass();
        $tmp_id = BidsUtilities::getMenuItemId(array("task"=>"listauctions"));
        if( !$tmp_id )
	        $tmp_id = BidsUtilities::getMenuItemId(array("view"=>"auctions", "layout"=>""));
        $ItemIdList->listauctions = $tmp_id;
        
        $tmp_id = BidsUtilities::getMenuItemId(array("task"=>"newauction"));
        if( !$tmp_id )
	        $tmp_id = BidsUtilities::getMenuItemId(array("view"=>"auction", "layout"=>"form"));
        
		$ItemIdList->newauction = $tmp_id;
        $smarty->assign('newAuction_link', JRoute::_('index.php?option=com_bids&amp;task=newauction&amp;Itemid=' .$ItemIdList->newauction));
        
        $smarty->assign('ItemIdList', $ItemIdList);
        
		$has_profile = JTheFactoryUserProfile::hasProfile();
        
        $smarty->assign('has_profile', $has_profile);
        $smarty->assign('mosConfig_live_site', JURI::root() );
        $smarty->assign('ROOT_HOST', JURI::root() );
        $smarty->assign('Itemid', $Itemid);
        $smarty->assign('task', $task);
        $smarty->assign('act', $act);
        $smarty->assign('option', $option);
        $smarty->assign('is_logged_in', ($my->id) ? "1" : "0");
        $smarty->assign('userid', $my->id);

        $jdoc = &JFactory::getDocument();
        $smarty->assign('document_type', $jdoc->getType()); // from 1.7.0

        /* Is user Auction profiled? */
        $profile = 0;
        if ($my) {
            $bid_user = new JAuctionUsers($database);
            if (CB_DETECT || ($bid_user->load($my->id)))
                $profile = 1;
        }

        $smarty->assign('has_profile', $profile);

        $arr_dateformat = array('Y-m-d' => '%Y-%m-%d', 'Y-d-m' => '%Y-%d-%m', 'm/d/Y' =>
            '%m/%d/%Y', 'd/m/Y' => '%d/%m/%Y', 'D, F d Y' => '%Y-%m-%d');
        $smarty->assign('opt_date_format', $arr_dateformat[bid_opt_date_format]);

        return $smarty;
    }
	
}

class BidTimeUtilities{
	
	function getNow(){
		
		$config = & JFactory::getConfig();
		$offset = $config->getValue("offset");
		
		if (defined("bid_opt_component_offset") && bid_opt_component_offset!="")
			$offset = bid_opt_component_offset;
			
		return time() + 3600*$offset;	 
	}
	
	function getNowSql(){
		$offset = $config->getValue("offset");
		
		if (defined("bid_opt_component_offset") && bid_opt_component_offset!="")
			$offset = bid_opt_component_offset;
			
		$jnow		=& JFactory::getDate('now',$offset);
		
		return  $jnow->toMySQL();
	}
	
	function apendDays($time, $nrOfdays){
		
		return $time + 86400*$nrOfdays;
		
	}
	
	function corelate($datetime){

		$config = & JFactory::getConfig();
		$offset = $config->getValue("offset");
		
		if (defined("bid_opt_component_offset") && bid_opt_component_offset!="")
			$offset = bid_opt_component_offset;

		return $datetime + 3600 * $offset;
	}
	
	/**
	 * Returns a MySql Database Formated timestamp
	 *
	 * @param $time timestamp
	 * @return date
	 */
	function getDateSql($time){
		$jdate		=& JFactory::getDate($time);
		return  $jdate->toMySQL();
	}

	function getTimeStamp($date,$corelate=0){
	
		
		$result = null;
		
		if (preg_match('~(\\d{4})-(\\d{2})-(\\d{2})[T\s](\\d{2}):(\\d{2}):(\\d{2})(.*)~', $date, $matches))
		{
			
			$result = gmmktime(
				$matches[4], $matches[5], $matches[6],
				$matches[2], $matches[3], $matches[1]
			);
		}
		if($corelate==1)
			return 	BidTimeUtilities::corelate($result);
		else 
			return 	$result;
	}
	
	function process_countdown( & $add , $params = array() ){
    	
		$params["set_date_format"] = bid_opt_date_format;
		$params["set_time_format"] = bid_opt_date_time_format;
		$params["word_expired"] =JText::_("Expires in");
		$params["word_days"] = JText::_("Days");
		
		$time = BidTimeUtilities::corelate(JTheFactoryHelperTime::getNow());
		$expiredate = BidTimeUtilities::getTimeStamp($add->end_date,0);
		
    	$diff = $expiredate - $time;
    	if ($diff>0){
    		$s=sprintf("%02d",$diff%60); $diff=intval($diff/60);
    		$m=sprintf("%02d",$diff%60); $diff=intval($diff/60);
    		$h=sprintf("%02d",$diff%24); $d=intval($diff/24);
    		if ($d>0) $add->countdown="$d ".$params["word_days"].", $h:$m:$s";
    		else $add->countdown="$h:$m:$s";
    	}else{$add->countdown=$params["word_expired"];}
        	
		
		if ( BidTimeUtilities::getTimeStamp($add->end_date) <= $time ){$add->expired=true;}else $add->expired=false;
	    	$add->start_date_text = date($params["set_date_format"], strtotime($add->start_date) );
	    if ($add->end_date && $add->end_date!='0000-00-00 00:00:00' ) {
			
	    	$dateformat=$params["set_date_format"];
	    	if(bid_opt_enable_hour){$dateformat=$params["set_date_format"]." H:i";}else $dateformat=$params["set_date_format"];
			$add->end_date_text=date($dateformat, strtotime($add->end_date) );
		}
		
	}
	
}

class BidsHTML{
	
	function selectAuctionType( $selected_type )
	{
		$js_atype = "";
		$opts[] = JHTML::_('select.option','',bid_pick_type_of_auction);
		$opts[] = JHTML::_('select.option',AUCTION_TYPE_PUBLIC,bid_public_label);
		if( bid_opt_global_enable_private )
			$opts[] = JHTML::_('select.option',AUCTION_TYPE_PRIVATE,bid_private_label);
		if( bid_opt_global_enable_bin && bid_opt_enable_bin_only ){		
			// function in auction_edit.js ; 1 - displayes only BIN related fields; 0 displayes all fields
			$js_atype = " onchange='changeAuctionType();'";
			$opts[] = JHTML::_('select.option',AUCTION_TYPE_BIN_ONLY,bid_bin_only_label);
		}
		if (count($opts)<=2) $typelist="<span id='bold_text'>".bid_public_label."</span><input type='hidden' name='auction_type' id='auction_type' value='".AUCTION_TYPE_PUBLIC."'>";
		else $typelist=JHTML::_('select.genericlist', $opts, 'auction_type', 'class="inputbox required" '.$js_atype.' alt="auction_type"',  'value', 'text',$selected_type);
		
		return $typelist;
	}

	/**
	 * Generate HTML Select With Countries
	 *
	 * @param varchar $name
	 * @param array $params
	 * @return unknown
	 */
	function selectCountry( $name, $params=array() ){
		
		$database = & JFactory::getDBO();
		
		
		if(isset($params["active_only"]) && $params["active_only"]!="") $active_only = $params["active_only"];
		else $active_only = 1;
			
		if(isset($params["selected"]) && $params["selected"]!="") $filter_country = $params["selected"];
		else $filter_country = null;

		if(isset($params["existing_users"]) && $params["existing_users"]!="") $existing_users = $params["existing_users"];
		else $existing_users = 0;
		
		$active="";
		
		if($active_only){
			$active = " WHERE c.active=1";
		}
		
		
		$filter = "";
		if( $existing_users )
			$filter = " INNER JOIN #__bid_users AS p ON p.country = c.id ";
			
		$countryid = array();
		$sql = "SELECT DISTINCT c.id AS countryid, c.name FROM #__bid_country c {$filter} $active ORDER BY name";
		$database->setQuery($sql);
		
		$countryid[] = JHTML::_('select.option', '0',JText::_("Choose"),'countryid','name');
		$countryid = array_merge( $countryid, $database->loadObjectList() );
		
		return JHTML::_('select.genericlist', $countryid, $name, ' class="inputbox" ', 'countryid', 'name', $filter_country);
		
	}
	
	function selectCategory( $name, $params=array() ){
		
		$cat = new JTheFactoryCategoryObj();
		$cat->show_active_only = true;
		
		$filter_category = null;
		if(isset($params["select"]) && (int)$params["select"]!=0)
			$filter_category = $params["select"];

		return $cattree = $cat->HTMLCatTree($name,$filter_category, $params);
		
	}

	function selectUser( $name, $params=array() ){
		
		$my = & JFactory::getUser();
		$database = &JFactory::getDbo();
		
		
		$where = array();
		
		$filter_user = null;
		if(isset($params["select"]) && (int)$params["select"]!=0){
			$filter_user = $params["select"];
		}

		if(isset($params["filter_admin"]) && (int)$params["filter_admin"]==1){
			$where[]="u.usertype!='Super Administrator' and u.usertype!='Administrator'";
		}
		if(isset($params["filter_enabled"]) && (int)$params["filter_enabled"]==1){
			$where[]="u.block!=1";
		}
			
		$multiple_attr = "";
		if(isset($params["multiple"]) && (int)$params["multiple"]==1){
			$name = $name."[]";
			$multiple_attr = "multiple";
		}

		$query="select distinct u.* from #__users u ";
		if(count($where)>0)
			$query .=" WHERE ".implode("AND", $where);

		$database->setQuery($query);
		$users = $database->loadObjectList();
		
		$useropts=array();
		if(isset($params["select_all"]) && (int)$params["select_all"]==1 && count($users)){
		    $useropts[]=JHTML::_("select.option",0,"Select All");
		}
		
	    for($i=0;$i<count($users);$i++){
		    $useropts[]=JHTML::_("select.option",$users[$i]->id,$users[$i]->username);
	    }
	
	    return JHTML::_("select.genericlist",$useropts,"{$name}",'class="inputbox"  style="width:190px;" '.$multiple_attr,'value', 'text', $filter_user);
	}
	
	function selectCurrency( $name, $params=array() ){
		
		$db = &JFactory::getDBO();
		
		$query = "SELECT id as value, name as text "
		. "\n FROM #__bid_currency"
		. "\n ORDER BY id"
		;
		$opts=null;
		$db->setQuery( $query );
		$opts = $db->loadObjectList();
		
		$selected = null;
		if(isset($params["select"]) && (int)$params["select"]!=0)
			$selected = $params["select"];
			
		return JHTML::_('select.genericlist', $opts, $name, 'class="inputbox" size="1"',  'value', 'text',$selected);
		
	}
	
	function init_captcha(){
		if(bid_opt_enable_captcha && defined("bid_opt_recaptcha_public_key")){
			if(!function_exists('recaptcha_get_html'))
			{
				require(JPATH_COMPONENT_SITE.DS.'helpers'.DS.'recaptcha'.DS.'recaptchalib.php');
			}
			
			$params = null;
			if(defined("bid_opt_recaptcha_theme")){
				$params["theme"] = bid_opt_recaptcha_theme;
			}
			return recaptcha_get_html(bid_opt_recaptcha_public_key, $params);
		}
	}
	
	function verify_captcha(){
		if( !defined("bid_opt_recaptcha_private_key") )
			return true;
			
		if(!function_exists('recaptcha_get_html'))
		{
			require(JPATH_COMPONENT_SITE.DS.'helpers'.DS.'recaptcha'.DS.'recaptchalib.php');
		}
		
		$recaptcha_challenge_field = JRequest::getVar('recaptcha_challenge_field');
		$recaptcha_response_field = JRequest::getVar('recaptcha_response_field');

		$resp = recaptcha_check_answer (bid_opt_recaptcha_private_key, $_SERVER["REMOTE_ADDR"], $recaptcha_challenge_field, $recaptcha_response_field);
		return $resp->is_valid;
	}
	
}
