<?php
/**
 * @package Auctions Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(dirname(__FILE__).DS."pricing_object.php");

class price_featured_bronze extends generic_pricing
{
    var $featured_type='bronze';
    
    function price_featured_bronze(&$db)
	{
		$this->classname='price_featured_bronze';
		$this->classdescription=JText::_("bid_paymentitem_desc_featured_bronze");
		parent::generic_pricing($db);
    }
    
	function ShowPurchaseDialog($d) {
    	
        $my= & JFactory::getUser();
		$smarty = BidsUtilities::SmartyLoaderHelper();
		
        $this->_db->setQuery("select * from #__bid_pricing where enabled=1");
        $rows=$this->_db->LoadObjectList();


		$smarty->assign('object_id',JRequest::getVar("id",null));
        $smarty->assign('pricing',$rows);
        $smarty->assign('selected_type',$this->featured_type);
        $smarty->assign('my',$my);
        $smarty->assign_by_ref('item_object',$this);
	    $smarty->assign('paymenttype','');
		$smarty->assign('return_url',JArrayHelper::getValue($d,'return_url'));
        $smarty->assign('page_title', JText::_("Buy $this->itemname credits") ) ;
        
		$smarty->display('plugins/t_featured_purchase.tpl');
    }
    
    function show_admin_config() {
    	?>
            <form action="index.php" method="post" name="adminForm">
    	<?php
			price_object_AdminHelper::showCommonSettingsTab();
    	?>
			<input type="hidden" name="option" value="com_bids"/>
            <input type="hidden" name="task" value="savepaymentitemsconfig"/>
            <input type="hidden" name="itemname" value="<?php echo $this->itemname;?>"/>
            </form>
    	<?php
    }
    
}

?>