<?php
/**
 * @package Auctions Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );


class generic_pricing
{
    var $classname='override this';
    var $classdescription='Generic Module for pricing';
    var $_db=null;
    var $itemname=null;
    var $price=null;
    var $currency=null;
    var $enabled=null;
    var $ordering=null;
    var $pricetype=null;
    var $params=null;
    var $param_obj=null;

    function generic_pricing(&$db)
    {
        
		JPlugin::loadLanguage( 'bid_pricing' );
		
    	$itemname=substr($this->classname,6);
        $this->_db=$db;
        $this->_db->setQuery("SELECT * FROM #__bid_pricing WHERE itemname='$itemname'");
		
        $tmp = null;
        $tmp = $this->_db->LoadObject();
        
		$this->itemname = $tmp->itemname;
		$this->currency = $tmp->currency;
		$this->enabled = $tmp->enabled;
		$this->price = $tmp->price;
		$this->ordering = $tmp->ordering;
		$this->pricetype = $tmp->pricetype;
		$this->params = ($tmp->params)?$tmp->params:"";
		$this->loadParams($this->params);		
    }
    
    function getPrice($d)
    {
        return $this->price;
    }
    function getCurrency($d)
    {
        return $this->currency;
    }
    function getDescription()
    {
    	return $this->classdescription;
    }
    
    function initiateOrder()
    {
		$my = & JFactory::getUser();
        return md5(microtime())."_".$my->id;
    }
    
    /**
     * 
     * Since 1.4.1
     *
     * @param $log Since 1.4.1 before order_id wich was f actually user_id
     * @param $amount
     */
    function acceptOrder($log,$amount)
    {
    	
        $this->_db->setQuery("select count(*) from #__bid_credits where userid='$log->userid' and credittype='$this->itemname'");
        if ($this->_db->LoadResult()){
            $this->_db->setQuery("update #__bid_credits set amount=amount+$amount where userid='$log->userid' and credittype='$this->itemname'");
        }else{
            $this->_db->setQuery("insert into #__bid_credits set amount=$amount , userid='$log->userid' , credittype='$this->itemname'");
        }
        $this->_db->query();
        
        if($log->object_id)
        	$this->update_object($log);
    }
    
    function cancelOrder($order_id)
    {
        return;
    }
    
    function show_admin_config() {
			price_object_AdminHelper::showCommonSettingsTab();
    }
    
    function save_admin_config()
    {
        $price=JRequest::getVar('price','');
        $currecy=JRequest::getVar('currency','');
        $itemname=JRequest::getVar('itemname','');
        $this->_db->setQuery("update  #__bid_pricing set price='$price',currency='$currecy' where itemname='$itemname'");
        $this->_db->query();
        $this->saveParams($_REQUEST);
    }

    function loadParams($paramtext=null)
    {
    	if ($paramtext===null){
			$this->_db->setQuery("select params from  #__bid_pricing  where itemname='{$this->itemname}'");
        	$paramtext=$this->_db->LoadResult();
    	}
    	$arr=explode("\n",$paramtext);
    	if($arr && $arr[0]!="")
    	for($i=0;$i<count($arr);$i++){
    		$v=explode("=",$arr[$i]);
    		if (in_array($v[0],$this->_param_members)) {
    			$member=$v[0];
    			$this->$member=$v[1];
    		}
    	}
    }
    function saveParams($d=null)
    {
    	$paramtext='';
    	for($i=0;$i<count($this->_param_members);$i++){
    		$member=$this->_param_members[$i];
    		if ($d===null){
    			$value=$this->$member;
    		}else{
    			$value=$d[$member];
    		}
    		$paramtext.=$member.'='.$value."\n";
    	}
		$this->_db->setQuery("update #__bid_pricing set params='{$paramtext}' where itemname='{$this->itemname}'");
    	$this->_db->query();

    }
        
    function checktask($task,$d)
    {
    	// Global Feature Listing CheckTasking
        $my = & JFactory::getUser();
        
        if ($task=='set_featured' && $d['featured']==$this->featured_type){
        	
        	$aid = JArrayHelper::getValue($d,"id");
        	
	        
	        if(isset($_POST['invoice'])){
		        // The Order Number (not order_id !)
		        $invoice =  trim(stripslashes($_POST['invoice']));
		        $payment_status = trim(stripslashes($_POST['payment_status']));
				
				if (!class_exists("JTheFactoryPaymentLog"))
					require_once(dirname(__FILE__).DS."..".DS."payment".DS."payment_log.php");
		        
				$log = new JTheFactoryPaymentLog($this->_db);
				$log->_tbl_key = "invoice";
		
				$log->load($invoice);
				
				// If pending (IPN not runned yet for misc reasons )
				if( ( $payment_status == "Completed" || $payment_status == "Processed" || $payment_status == "In-Progress" || $payment_status == "Pending" ) && $log->status!="ok"){
					FactoryLayer::redirect('index.php?option=com_bids&task=details&id='.$aid,"Payment Succesfully! Waiting for approval!");
					return true;
				}
				
				elseif( $log->status=="ok" ){
					$db = & JFactory::getDBO();
					$ad = new JAuctions($db);
					$ad->load($aid);
					
					if( $ad->featured == str_replace("featured_","",$this->itemname ) )
						FactoryLayer::redirect('index.php?option=com_bids&task=viewbids&id='.$aid,"Payment Succesfully! Set $ad->featured !");
					
				}
				
	        }else{
		        
	        	$credits = $this->getCredits($my->id);
	        	
	            if ( $credits > 0 ){
	            	
	            	$this->update_object($aid);
	                FactoryLayer::redirect('index.php?option=com_bids&task=viewbids&id='.$aid);
					return true;
					
	            }else{
	            	
	            	// TO DO : enhance ItemID
	                $d['return_url']=JURI::root().'index.php?option=com_bids&task=set_featured&featured=featured&id='.$aid;
	                $this->ShowPurchaseDialog($d);
	                return true;
	            }
	        }
	        
            
        }



        if ($task=='buy_featured' && $d['featured']==$this->featured_type){
            $this->ShowPurchaseDialog($d);
            return true;
        }
        return false;
    }

    function ShowPurchaseDialog($d) {
    	
        $my		= & JFactory::getUser();
		$smarty = BidsUtilities::SmartyLoaderHelper();
		
		$smarty->assign('my',$my);
		$smarty->assign_by_ref('item_object',$this);
		$smarty->assign('itemamount',JArrayHelper::getValue($d,'itemamount'));
		$smarty->assign('object_id',JArrayHelper::getValue($d,'id'));
		$smarty->assign('paymenttype','');
		$smarty->assign('return_url',JArrayHelper::getValue($d,'return_url'));
		$smarty->assign('page_title', "Buy $this->itemname credits" ) ;
		$smarty->display('plugins/t_credits_purchase.tpl');
    }
    

    
    function checkReturnStatus(){
    }
    
    /**
     * This is the same for Featuring Listing
     * override function in pricing class for custom handling
     * 
     *
     * @param int/object $order (ad id or log object)
     */
    function update_object($order){
    	// 
    	$my= & JFactory::getUser();
    	$user_id = $my->id;
    	
    	if(is_object($order)){
    		$aid = $order->object_id;
	    	$user_id = $order->userid;
    	}else 
    		$aid = $order;
    	
    	// UPDATE OBJECT	
		$this->_db->setQuery("UPDATE #__bid_auctions SET featured='$this->featured_type' where id='$aid'");
		$this->_db->query();
		
		// CONSUME CREDITS
		$this->_db->setQuery("UPDATE #__bid_credits SET amount=amount-1 WHERE userid='$user_id' and credittype='$this->itemname'");
		$this->_db->query();
		
    }
    
    function consume_credits()
    {
    	// TO DO : single code responsible for credit decrease
    }
    
    function getCredits($user){
		$this->_db->setQuery("SELECT sum(amount) FROM #__bid_credits WHERE userid='$user' AND credittype='$this->itemname'");
		$cur =  $this->_db->LoadResult();
		return (int)$cur;
	}
}

class price_object_AdminHelper{

	function showCommonSettingsTab(){
		?>
	<fieldset>
		<legend><?php echo JText::_("Payment Item")." ".$this->itemname;?></legend>
        <table class="paramlist admintable" width="100%">
        <tr>
            <td class="paramlist key" width="120px"><?php echo JText::_("Payment Item Price");?>: </td>
            <td><input size="5" name="price" class="inputbox" value="<?php echo $this->price;?>"></td>
        </tr>
        <tr>
            <td class="paramlist key" width="120px"><?php echo JText::_("Currency");?>: </td>
            <td><input size="5" name="currency" class="inputbox" value="<?php echo $this->currency;?>"></td>
        </tr>
        </table>
	</fieldset>
		<?php
	}
	function showSpecialUserSettingsTab(){
		
		?>
	<fieldset>
		<legend><?php echo JText::_("Reduced Prices for Payment Item")." ".$this->itemname;?></legend>
        <table class="paramlist admintable" width="100%">
        <tr>
            <td class="paramlist key" width="120px"><?php echo JText::_("Price For Powerseller Users");?>: </td>
            <td><input size="5" name="price_powerseller" class="inputbox" value="<?php echo $this->price_powerseller;?>"></td>
        </tr>
        <tr>
            <td class="paramlist key" width="120px"><?php echo JText::_("Price For Verified Users");?>: </td>
            <td><input size="5" name="price_verified" class="inputbox" value="<?php echo $this->price_verified;?>"></td>
        </tr>
        </table>
	</fieldset>
		<?php
	}
	
}



?>