{if !$is_logged_in}
    <table class="auction_bid_box auction_warning">
        <tr>    
            <td><strong>{$smarty.const.bid_login_to_bid}</strong></td>
        </tr>
    </table>
{elseif !$has_profile}
    <table class="auction_bid_box auction_warning">
        <tr>    
            <td><strong>{$smarty.const.bid_err_more_user_details}</strong></td>
        </tr>
    </table>
{elseif $auction->is_my_auction}
    <table class="auction_bid_box">
        <tr>    
            <td>
                {if $bid_list|@count}
                    {assign var=bid value=$bid_list|@end}
                    {$smarty.const.bid_last_bid}: {printdate date=$bid->modified}, <b>{$bid->username}</b> - {print_price auction=$auction price=$bid->bid_price}
                    <br />&nbsp; <a href="javascript:showMessageBox('auction_bids_history')"><b>{$smarty.const.bid_bids_history}</b></a>
                    <div style="display:none" id="auction_bids_history">
                    {include file="elements/auction_details/t_bid_list.tpl"}
                    </div>
                {else}
                    {$smarty.const.bid_no_user_bids}
                {/if}
            </td>
        </tr>
    </table>
{elseif $auction->close_offer || $auction->expired}
    <table class="auction_bid_box auction_warning">
        <tr>    
            <td align="center">{$smarty.const.bid_auction} {if $auction->expired}{$smarty.const.bid_expired} ({$auction->end_date_text}){else} {$smarty.const.bid_closed} ({printdate date=$auction->closed_date}){/if}</td>
        </tr>
        {if $auction->i_am_winner}
        <tr>
            <td align="center">
                <img src="{$ROOT_HOST}/components/com_bids/images/you_are_winner.jpg" class="hasTip" title="{$smarty.const.bid_alt_you_are_winner}" alt="{$smarty.const.bid_alt_you_are_winner}"/>
                <br /> <strong style="font-size:130%;">{$smarty.const.bid_alt_you_are_winner}</strong>
                <br />{$smarty.const.bid_winning_bid}: {print_price auction=$auction price=$auction->winning_bid}
            </td>
        </tr>
        {elseif $auction->auction_type==AUCTION_TYPE_PUBLIC}
            {$smarty.const.bid_winning_bid}: {print_price auction=$auction price=$auction->winning_bid}
        {/if}
    </table>
{elseif $auction->auction_type==$smarty.const.AUCTION_TYPE_BIN_ONLY}
    <table class="auction_bid_box" width="100%">
        <tr>    
            <td>{$smarty.const.bid_no_bidding_bin_only} </td>
        </tr>
        <tr>
            <td> 
			  <form action="{$ROOT_HOST}index.php" method="post" name="auctionForm_bin" onsubmit="return MakeBinBid(this,{$auction->BIN_price},'{$auction->currency_name}');">
			  <input type="hidden" name="view" value="" />
			  <input type="hidden" name="option" value="com_bids" />
			  <input type="hidden" name="task" value="bin" />
			  <input type="hidden" name="id" value="{$auction->id}" />
			  <input type="hidden" name="Itemid" value="{$Itemid}" />
			  <input type="hidden" name="{$validate}" value="1" />
	  		  <input type="hidden" id="system_bin_quantity" name="bin_quantity" value="1" />  
	  		  <input type="hidden" name="quantity" value="1" />  
                <input type="hidden" id="system_bin_quantity" name="bin_quantity" value="1" />
				{if $auction->quantity>1}
                    <div style="float:left;">
					<span id="spinnerbinBox"></span>&nbsp;{$lists.bin_quantity}&nbsp;x&nbsp;{$auction->BIN_price|string_format:'%.2f'}&nbsp;
                    <span id="quantity_info">&nbsp;=&nbsp;{$auction->BIN_price|string_format:'%.2f'}</span> &nbsp;{$auction->currency_name}
                    &nbsp;
                    </div>
                {/if}
                <div style="float:left;">
                    <input type="button" id="bin_button" class="back_button" value="{$smarty.const.bid_buy_it_now}"	name="bin_button" {$disable_bids} onclick="if({$terms_and_conditions} &&  document.getElementById('agreement').checked) document.auctionForm_bin.submit(); else alert(language['bid_err_terms'])" />
                </div>
               </form> 
            </td>
        </tr>
        {if $terms_and_conditions}
        <tr>    
            <td colspan="3">
                <input type="checkbox" class="inputbox" name="agreement" id="agreement" value="1" {$disable_bids} />
                {$smarty.const.bid_agree}<a href="{$auction->links.terms}" id="auction_category" class="modal">
    			  {$smarty.const.bid_tab_terms_conditions}</a>            
            </td>
        </tr>
        {/if}
    {if $auction->suggestion_tab }
        <tr>
            <td>
                <a href="javascript:showMessageBox('suggest_list');" >
                    {$smarty.const.bid_show_suggestions} ({$suggestions|@count})
                </a>
                <br />
                <a href="javascript:showMessageInline('suggest_box');" >
                {if !$auction->i_am_winner}
                    {$smarty.const.bid_add_suggestions}
                {/if}
                </a>
            </td>
        </tr>
    {/if}        
    </table>
{else}
    <table class="auction_bid_box">
		{if $smarty.const.bid_opt_global_enable_bin && $auction->BIN_price>0}
		<tr>
		 <td colspan="3" align="center">
		  <form action="{$ROOT_HOST}index.php" method="post" name="auctionForm_bin" onsubmit="return MakeBinBid(this,{$auction->BIN_price},'{$auction->currency_name}');">
		  <input type="hidden" name="view" value="" />
		  <input type="hidden" name="option" value="com_bids" />
		  <input type="hidden" name="task" value="bin" />
		  <input type="hidden" name="id" value="{$auction->id}" />
		  <input type="hidden" name="Itemid" value="{$Itemid}" />
		  <input type="hidden" name="{$validate}" value="1" />
  		  <input type="hidden" id="system_bin_quantity" name="bin_quantity" value="1" />  
  		  <input type="hidden" name="quantity" value="1" />  
        <input type="button" id="bin_button" class="auction_button" value="{$smarty.const.bid_buy_it_now} - {$auction->BIN_price} {$auction->currency_name}"	name="bin_button" {$disable_bids} onclick="if({$terms_and_conditions} &&  document.getElementById('agreement').checked) document.auctionForm_bin.submit(); else alert(language['bid_err_terms'])" />
          </form>  
         </td>
		</tr>
        <tr>
            <td colspan="3"><hr /></td>
        </tr>
		{/if}
        {if $auction->auction_type!=AUCTION_TYPE_PRIVATE && $smarty.const.bid_opt_allow_proxy == 1}
		  <form action="{$ROOT_HOST}index.php" method="post" name="auctionForm1" onsubmit="return FormValidate(this);">
		  <input type="hidden" name="view" value="" />
		  <input type="hidden" name="option" value="com_bids" />
		  <input type="hidden" name="task" value="sendbid" />
		  <input type="hidden" name="id" value="{$auction->id}" />
		  <input type="hidden" name="initial_price" value="{$auction->initial_price}" />
		  <input type="hidden" name="bin_price" value="{$auction->BIN_price}" />
		  <input type="hidden" name="mylastbid" value="{$auction->mybid->bid_price}" />
		  <input type="hidden" name="min_increase" value="{$auction->min_increase}" />
		  <input type="hidden" name="Itemid" value="{$Itemid}" />
		  <input type="hidden" name="maxbid" value="{$auction->highest_bid}" />
		  <input type="hidden" name="proxy" value="1" />
		  <input type="hidden" name="{$validate}" value="1" />
        <tr>    
            <td>{$smarty.const.bid_proxy}:</td>
            <td><input name="amount" class="inputbox" type="text" value="" size="3" alt="bid" {$disable_bids}>&nbsp;{$auction->currency_name}&nbsp;</td>
            <td><input type="submit" name="send" value="{$smarty.const.but_send_bid}" class="auction_bid_button" /></td>
        </tr>
		 </form>
        <tr>
            <td colspan="3"><hr /></td>
        </tr>
        {/if}
		  <form action="{$ROOT_HOST}index.php" method="post" name="auctionForm2" onsubmit="return FormValidate(this);">
		  <input type="hidden" name="option" value="com_bids" />
		  <input type="hidden" name="view" value="" />
		  <input type="hidden" name="task" value="sendbid" />
		  <input type="hidden" name="id" value="{$auction->id}" />
		  <input type="hidden" name="initial_price" value="{$auction->initial_price}" />
		  <input type="hidden" name="bin_price" value="{$auction->BIN_price}" />
		  <input type="hidden" name="mylastbid" value="{$auction->mybid->bid_price}" />
		  <input type="hidden" name="min_increase" value="{$auction->min_increase}" />
		  <input type="hidden" name="Itemid" value="{$Itemid}" />
		  <input type="hidden" name="maxbid" value="{$auction->highest_bid}" />
		  <input type="hidden" name="{$validate}" value="1" />
		  <input type="hidden" name="proxy" value="0" />
        <tr>    
            <td>{$smarty.const.bid_exactly}:</td>
            <td><input name="amount" class="inputbox" type="text" value="" size="3" alt="bid" {$disable_bids}>&nbsp;{$auction->currency_name}&nbsp;</td>
            <td><input type="submit" name="send" value="{$smarty.const.but_send_bid}" class="auction_bid_button" /></td>
        </tr>
		 </form>
        {if $terms_and_conditions}
        <tr>    
            <td colspan="3">
                <input type="checkbox" class="inputbox" name="agreement" id="agreement" value="1" {$disable_bids} />
                {$smarty.const.bid_agree}<a href="{$auction->links.terms}" id="auction_category" class="modal">
    			  {$smarty.const.bid_tab_terms_conditions}</a>            
            </td>
        </tr>
        {/if}
    </table>
{/if}
