{* define the cell CSS class *}
{assign var=cellclass value="auction_details_row"}
{assign var=class_featured value=""}


{if $current_row->featured && 	$current_row->featured!='none'}
	{assign var=class_featured value="listing-"|cat:$current_row->featured}
{/if}
	

    <tr class="{$cellclass} {$class_featured}">
{* Thumbnail part *}
		<td id="auction_thumb_list" valign="top">
            <a href="{$current_row->links.auctiondetails}">{$current_row->thumbnail}</a>
        </td>
{* /Thumbnail part *}
		<td valign="top" id="auction_cell" >		
			<table width="100%">
{* Title spans over the rest of the cell*}			
			<tr>
    			<td colspan="3" valign="top">
    				<div id="auction_title">
    					<a href="{$current_row->links.auctiondetails}">{$current_row->title}</a>
    				</div>
    			</td>
			</tr>
{* /Title spans over the rest of the cell*}			
			<tr>
    			<td id="auction_left" valign="top">
    				<div id="auction_description">
    					{$current_row->shortdescription}
    				</div>
                    {if #show_category_link#}
    					<div id="auction_category">
    						{$smarty.const.bid_category}:&nbsp;
    						{if $current_row->catname}
    							<a href="{$current_row->links.filter_cat}">{$current_row->catname}</a>
    						{else}
    							&nbsp;-&nbsp;
    						{/if}
    					</div>
					{/if}
                    {if #show_auctioneer#}
    					<div id="auction_user">
    						{$smarty.const.bid_bid_auctioneer}:&nbsp;<a href="{$current_row->links.otherauctions}" alt="{$smarty.const.bid_more_offers_user}">{$current_row->username}</a>
                            {if #show_auctioneer_rating#}
    						  &nbsp;<a href="{$current_row->links.auctioneer_profile}" alt="{$smarty.const._DETAILS_TITLE}"><span id="rating_user" rating="{$current_row->rating_overall}" ></span></a>
                            {/if}
    					</div>
                    {/if}
					{include file='elements/display_fields.tpl' position='deflisting' this_add=$current_row->id}
										
    				
    			</td>
                <td id="auction_middle">
                        {if #show_current_price#}
                            <div id="auction_price">                    
                            {if $current_row->highest_bid gt 0}
								{print_price auction=$current_row price=$current_row->highest_bid}
                            {elseif $current_row->auction_type!=$smarty.const.AUCTION_TYPE_BIN_ONLY}
								{print_price auction=$current_row price=$current_row->initial_price}
                            {/if}
                            </div>
    					{/if}
                        
                        {if #show_bin_price#}
        					{if $current_row->BIN_price gt 0}
                                <div id="auction_bin">
                                    <span>{$smarty.const.bid_bin_text}:</span>&nbsp;
                					<span id="auction_price_bold">
										{print_price auction=$current_row price=$current_row->BIN_price}
                                    </span>
                                </div>
        					{/if}
    					{/if}
                        {if #show_my_bid#}
    						{if $current_row->mybid}
    							<div id="auction_price_bold">{$smarty.const.bid_mybid}: {print_price auction=$current_row price=$current_row->mybid}</div>
    						{/if}
                        {/if}
                        {if #show_nr_bidders#}
						  <div id="auction_price">{$smarty.const.bid_bidders}: {$current_row->nr_bidders}</div>
                        {/if}
                </td>
    			<td id="auction_right" valign="top">
    				<div id="auction_info_bottom">
						{if $current_row->close_offer}
							<span class='canceled_on'>
							{if $current_row->end_date gt $current_row->closed_date && !$current_row->winning_bid}
								{$smarty.const.bid_canceled_on}
							{else}
								{$smarty.const.bid_closed_on_date}
							{/if}:
							</span>
							{$current_row->closed_date|date_format $smarty.const.bid_opt_date_format}
						{elseif  $current_row->expired}
						   <font class='expired'>{$smarty.const.bid_expired}</font>
						{elseif $smarty.const.bid_opt_enable_countdown}
							 <span class="auction_timer" id="time{$current_row->rownr}">{$current_row->countdown}</span>
						{/if}
                        {if #show_start_date#}
    	    				<div id="auction_date">
    	    					<span>{$smarty.const.bid_start_date} </span>:&nbsp;{$current_row->start_date_text}
    	    				</div>
                        {/if}
                        {if #show_end_date#}
    	    				<div id="auction_date">
    	    					<span>{$smarty.const.bid_end_date}</span>:&nbsp;{$current_row->end_date_text}
    	    				</div>
                        {/if}
			         </div>
    			</td>
			</tr>
        {if #show_auction_toolbar#  || #show_auction_number# || #show_auction_tags#}
			<tr>
				<td colspan="3">
					<div class="auction_bid_toolbar">
                        {if #show_auction_tags#}
                			{if $current_row->links.tags !=""}
                    				<span id="auction_tags">{$smarty.const.bid_tags}:&nbsp;{$current_row->links.tags}</span>
                			{/if}
                        {/if}
                        {if #show_auction_toolbar#}
            			<span id="auction_bid_toolicons">
	        				{if $current_row->add_to_watchlist}
	        					<span id='add_to_watchlist'><a href='{$current_row->links.add_to_watchlist}'>
	        						<img src="{$mosConfig_live_site}/components/com_bids/images/f_watchlist_1.jpg" title="{$smarty.const.bid_add_to_watchlist}" alt="{$smarty.const.bid_add_to_watchlist}"/>
	        					</a></span>
	        				   {elseif $current_row->del_from_watchlist}
	        					<span id='add_to_watchlist'><a href='{$current_row->links.del_from_watchlist}'>
	        						<img src="{$mosConfig_live_site}/components/com_bids/images/f_watchlist_0.jpg" title="{$smarty.const.bid_remove_from_watchlist}" alt="{$smarty.const.bid_remove_from_watchlist}"/>
	        					</a></span>
	        				{/if}
	        				<span id='new_message'><a href='{$current_row->links.messages}'>
	        				{if $current_row->nr_new_messages}
	        					<img src="{$mosConfig_live_site}/components/com_bids/images/f_message_1.png" title="{$smarty.const.bid_newmessages}" alt="{$smarty.const.bid_newmessages}" />
	        				{else}
	        					<img src="{$mosConfig_live_site}/components/com_bids/images/f_message_0.png" title="{$smarty.const.bid_no_new_messages}" alt="{$smarty.const.bid_no_new_messages}" />
	        				{/if}
	        				</a></span>
	        				{if $current_row->is_my_auction!=1 && !$current_row->close_offer}
	        				<a href='{$current_row->links.bids}'><img src="{$mosConfig_live_site}/components/com_bids/images/f_bid.gif" title="{$smarty.const.bid_tab_offer_bidnew}" alt="{$smarty.const.bid_tab_offer_bidnew}" /></a>
	        				{/if}
        				</span>
                        {/if}
                        {if #show_auction_number#}                            
        				    <span id="auction_number">{$smarty.const.bid_auction_number}: {$current_row->auction_nr}</span>
                        {/if}
 					</div> 					
				</td>
			</tr>
         {/if}
			</table>
		</td>
	</tr>
    <tr>
        <td colspan="3"><div class="hr"></div></td>
    </tr>
