<?php

function rating_bar($id,$options=array(),$static='') { 

	$rating_unitwidth=30;
	$units = 5;
	
	if ( !isset($options['total_votes']) || $options['total_votes'] < 1) {
		$count = 0;
	} else {
		$count = $options['total_votes']; //how many votes total
	}
	
	if (!isset($options['total_value']) || $options['total_value'] < 1) {
		$current_rating = 0;
	} else {
		$current_rating=$options['total_value']; //total number of rating added together and stored
	}
	$tense=($count==1) ? "vote" : "votes"; //plural form votes/vote

	$voted=false;

	// now draw the rating bar
	$rating_width = @number_format($current_rating,2)*$rating_unitwidth;


if ($static == 'static') {

		$static_rater = array();
		$static_rater[] .= "\n".'<div class="ratingblock">';
		$static_rater[] .= '<div id="unit_long'.$id.'" title="Currently '.$current_rating .' / '.$count.'">';
		$static_rater[] .= '<ul id="unit_ul'.$id.'" class="unit-rating" style="width:'.$rating_unitwidth*$units.'px;">';
		$static_rater[] .= '<li class="current-rating" style="width:'.$rating_width.'px;">Currently '.$current_rating.'</li>';
		$static_rater[] .= '</ul>';
		$static_rater[] .= '</div>';
		$static_rater[] .= '</div>'."\n\n";

		return join("\n", $static_rater);


} else {

      $rater ='';
      $rater.='<div class="ratingblock">';

      $rater.='<div id="unit_long'.$id.'">';
      $rater.='  <ul id="unit_ul'.$id.'" class="unit-rating" style="width:'.$rating_unitwidth*$units.'px;">';
      $rater.='     <li class="current-rating" style="width:'.$rating_width.'px;">Currently '.$current_rating.'</li>';

      for ($ncount = 1; $ncount <= $units; $ncount++) { // loop from 1 to the number of units
           if(!$voted) { // if the user hasn't yet voted, draw the voting stars
              $rater.='<li><a href="#" onclick="setRate('.$ncount.',this);return false;" title="'.$ncount.' out of '.$units.'" class="r'.$ncount.'-unit rater" rel="nofollow">'.$ncount.'</a></li>';
           }
      }
      $ncount=0; // resets the count
      $rater.='  </ul>';
	  $rater .= '</div>';
	  $rater .= '</div>'."\n\n";
      return $rater;
 }
}
?>