<?php
/**
 * XAJAX INIT
 * 
 * 
 * @author h45h
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

$oldER=error_reporting();
error_reporting(0);
require(dirname(__FILE__).DS.'xajax'.DS.'xajax_core'.DS.'xajaxaio.inc.php');
error_reporting($oldER);

class JTheFactoryXajax{
	
	var $xajax=null;
	var $xajaxMethods=null;
	
	//added the $option parameter for eventuall calls from inside a module or a plugin
	function __construct($component,&$aCallableObjects,&$aFunctionNames ){
		
		global $option;

		$requestURI = JURI::base().'index.php?option=com_'.$component.'&jaxx=1&format=raw';
		$xajax = new xajax($requestURI);

		$xajax->setWrapperPrefix('theFactory_');
		
		$xajaxMethods = array();
		foreach($aCallableObjects as $k=>$cO){
			$xajaxMethods = array_merge($xajaxMethods, $xajax->register(XAJAX_CALLABLE_OBJECT,$aCallableObjects[$k]) );
		}
		foreach($aFunctionNames as $fN){
			$xajaxMethods = array_merge($xajaxMethods, $xajax->register(XAJAX_FUNCTION,$fN));
		}

		foreach($xajaxMethods as $k=>$v){
			$xm =& $xajaxMethods[$k];
			$xm->useSingleQuote();
		}
		
		$jsInHead = JRequest::getVar('jsInHead',1,'get','int');

		$jsURI = JURI::root().'components/com_'.$component.'/thefactory/xajax/xajax/';
		if($jsInHead)
		{
			$js = preg_replace('#((\A\s*<script\s.*?>)|(</script>\s*\Z))#s','',$xajax->getJavascript($jsURI)) ;
			$document =& JFactory::getDocument();
			$document->addScriptDeclaration($js);
		}
		else
		{
			$xajax->printJavascript($jsURI);
		}

		$this->xajax =& $xajax;
		$this->xajaxMethods =& $xajaxMethods;

		foreach($aCallableObjects as $k=>$cO)
		{
			$aCallableObjects[$k]->xajaxMethods = $xajaxMethods;
		}
	}

	function &getXajaxInstance(){
		return $this->xajax;
	}
	function &getXajaxMethods(){
		return $this->xajaxMethods;
	}
}
