<?php
/**
* @package		Auctions Factory
* @license		comercial
* @modified	19/01/2010
*/
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * @package	Auctions Factory
 */
class bidsViewAuction extends JView{
	
	function edit() {
		
		global $Itemid;
		
		$database = &JFactory::getDBO();
		$task = JRequest::getCmd('task');
		$my = & JFactory::getUser();
		$id=(int)JRequest::getVar('id','');
	
	   $category_selected = JRequest::getInt('category_selected', null);
		if (bid_opt_category_page == 1 & !$category_selected && !$id )
		{
			$controller = new BidsController();
			$controller->execute("selectcat");
			$controller->redirect();
			return;
		}
	   // custom fields thing
		Jrequest::setVar("category",$category_selected);
	    
		$row = new JAuctions($database);
		// load the row from the db table
		if ($id){
			$row->load($id);
		   // custom fields thing
			Jrequest::setVar("category",$row->cat);
		}
		
		if (!$row->acl_check($my))
	   {
			JError::raiseWarning( 0,bid_you_have_to_login);
			return;
	   }
	
		if ($task == 'republish')
		{
		  $row->id = null; //republish
		  $row->quantity = $row->nr_items;
		}
	
	    if (!$id)
	    {
	        if (!isset($_SESSION))
	            @session_start();
	        if (isset($_SESSION['auction_temp']))
	        {
	            $row = unserialize($_SESSION['auction_temp']);
	            $row->id = 0;
	        }
	        if (!bid_opt_enable_date)
	        {
	            $mins = array();
	            if (bid_opt_allow_proxy && intval(bid_opt_proxy_default_period) > 0)
	            {
	                $mins[] = bid_opt_proxy_default_period;
	            }
	
	            if (bid_opt_global_enable_bin && intval(bid_opt_bin_default_period) > 0 && $auction->
	                BIN_price > 0)
	            {
	                $mins[] = bid_opt_bin_default_period;
	            }
	
	            if (bid_opt_global_enable_reserve_price && intval(bid_opt_reserve_price_default_period) >
	                0 && $auction->reserve_price > 0)
	            {
	                $mins[] = bid_opt_reserve_price_default_period;
	            }
	            if (intval(bid_opt_default_period) > 0)
	            {
	                $mins[] = bid_opt_default_period;
	            }
	
	            $min = null;
	            if ($mins)
	                $min = min($mins);
	
	            if ($min)
	                $row->end_date = date(bid_opt_date_format, time() + 86400 * $min);
	            else
	                $row->end_date = date(bid_opt_date_format, time() + 86400);
	        }
	    }
	
	    $lists = array();
	    $query = "SELECT id as payment, name" . "\n FROM #__bid_payment" . "\n ORDER BY id";
	
	    if (bid_opt_payment_select_mode == 0)
	    {
	        $database->setQuery($query);
	        $pays = $database->loadObjectList();
	    }
	    else
	    {
	        $pays[] = JHTML::_('select.option','0', bid_types_payment, 'payment', 'name');
	        $database->setQuery($query);
	        $pays = array_merge($pays, $database->loadObjectList());
	    }
	
	    if (bid_opt_payment_select_mode == 0)
	    {
	        $auction_Payments = new JAuctionPayments($database);
	        $auction_Payments->auct = $id;
	        if ($id)
	            $plist = $auction_Payments->getAuctionPayments();
	        else
	        {
	            $plist = $row->payment_options;
	        }
	        $lists['payment'] = JHTML::_('select.genericlist',$pays, 'payment[]','class="inputbox validate-payment" multiple="multiple" alt="payment"', 'payment','name', $plist);
	    }
	    else
	    {
	        $lists['payment'] = JHTML::_('select.genericlist',$pays, 'payment[]','class="inputbox validate-payment" multiple="multiple" alt="payment"', 'payment','name', intval($row->payment));
	    }
	
	    $lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', ($id) ?
	        $row->published : 1, _CMN_YES, _CMN_NO);
	
	    $opts[] = JHTML::_('select.option','0', bid_auction_without_bin);
	    $opts[] = JHTML::_('select.option','1', bid_auction_with_bin);
	    $nbld = "";
	    if ($row->auction_type == AUCTION_TYPE_BIN_ONLY)
	        $nbld = " disabled='disabled' ";
	    $lists['bin'] = JHTML::_('select.genericlist',$opts, 'bin_OPTION', ' id="bin_OPTION" ' . $nbld .' class="inputbox" onchange="changeAuctionType();"', 'value', 'text', ($row->BIN_price > 0 ? 1 : 0));
	
	    $lists['auctiontype'] = BidsHTML::selectAuctionType($row->auction_type);
	
	    $query = "SELECT id as value, name as text " . "\n FROM #__bid_currency" . "\n ORDER BY id";
	    $opts = null;
	    $database->setQuery($query);
	    $opts = $database->loadObjectList();
	    $lists['currency'] = JHTML::_('select.genericlist',$opts, 'currency','class="inputbox required" size="1"', 'value', 'text', $row->currency);
	
	    if (isset($category_selected)) $row->cat = $category_selected;

	    $leaves_only = (defined("bid_opt_leaf_posting_only")&&bid_opt_leaf_posting_only==1)?bid_opt_leaf_posting_only:false;
	        
		$lists['cats'] = BidsHTML::selectCategory("cat",array("select"=>$row->cat, "leaves_enabled"=>$leaves_only, "include_root"=>0,"script"=>"onchange='aiai(this);'"));
		
		
	    if ($id)
	    {
	        $tags_obj = new JAuctionTags($database);
	        $tags = null;
	        $tags = $tags_obj->getAuctionTags($id);
	        if (count($tags))
	            $row->tags = implode(',', $tags);
	    }
	    HTML_Auction::editAuction($row, $option, $lists, $id);
	}
	
    function AuctionDetails(&$auction, &$lists, &$bid_user, &$bid_user_details, &$bids_list, $currency, $messages)
    {

        /* @var $smarty Smarty*/
        /* @var $auction JAuctions */
        /* @var $bid_user mosUser */
        /* @var $max_price int */
        /* @var $bid_list array */
        /* @var $count_bidders int */

        /* @var $currency int */
        global $Itemid, $cb_fieldmap;
        global $mainframe;
        
        $my = &JFactory::getUser();
        $database = &JFactory::getDBO();

        $jdoc = &JFactory::getDocument();

        $auction->_parameters = $auction->ParamsToArray();

		$smarty = BidsUtilities::SmartyLoaderHelper();

        /* Page tagging */
        $tags = new JAuctionTags($database);
        $auction->tags = $tags->getAuctionTags($auction->id);
        $mainframe->setPageTitle($auction->title);
        $mainframe->addMetaTag('description', mosStripslashes(strip_tags($auction->shortdescription)));
        $mainframe->addMetaTag('abstract', mosStripslashes(strip_tags($auction->description)));
        $mainframe->appendMetaTag('keywords', mosStripslashes(strip_tags(implode($auction->tags, ','))));
		$auction->title_sef = JFilterOutput::stringURLSafe($auction->title);
		
		$links_path = JRoute::_('index.php?option=com_bids&taskviewbids&title='.$auction->title_sef.'&id='. $auction->id .'&Itemid='. $Itemid );
		
		$mainframe->appendPathWay( $auction->title,$links_path );

        // gallery
        if (defined("bid_opt_gallery"))
            $gallery_name = "gl_" . bid_opt_gallery;
        else
            $gallery_name = "gl_lytebox";

        $gallery = new $gallery_name($database, AUCTION_PICTURES);
        $gallery->getGalleryForAuction($auction);
        if (count($gallery->imagelist) > 0) {
            $gallery->writeJS();
        }

        JAuctionHelper::renderAuctionTiming($auction);
        JAuctionHelper::getAuctionStatuses($auction);

        if ($my->id) {

            // MY BID
            $mybid = new JBids($database);
            $mybid->LoadBidForUser($auction->id, $my->id);
            
            if (!empty($mybid->bid_price))
                $auction->mybid = $mybid->bid_price;
            else
                $auction->mybid = null;
        }
        

        JAuctionHelper::renderAuctionData($auction);

        if (bid_opt_allowpaypal) {
        	
            /**  ==> Fixed in Auction 1.5.8 **/
            $paypalemail = null;
            
            if (CB_DETECT && bid_opt_profile_mode=="cb") {
            	 $cb_fieldmap = JTheFactoryIntegration::getIntegrationArray("CB");
            	 
                if ($cb_fieldmap['paymentparam']) {
                    $database->setQuery("select " . $cb_fieldmap['paymentparam'] .
                        " from #__comprofiler where user_id='$auction->userid' ");
                    $paypalemail = $database->loadResult();
                } else
                    $paypalemail = null;
            } else {
                $database->setQuery("select paypalemail from #__bid_users where userid='$auction->userid' ");
                $paypalemail = $database->loadResult();
            }
            
            $auction->paypalemail = $paypalemail;
            /**  <== Fixed in Auction 1.5.8 **/
        }

        if ($auction->auction_type != AUCTION_TYPE_PRIVATE && bid_opt_allow_proxy == 1 && !$auction->is_my_auction) {
            $database->setQuery("select max_proxy_price from #__bid_proxy where auction_id='$auction->id' and user_id = '$my->id' ");
            $auction->my_proxy_bid = $database->loadResult();
        }

        $auction->links = HTML_Auction::_CreateLinksArray($auction);
        $auction->thumbnail = $gallery->getThumb(0, 0);
        $auction->gallery = $gallery->getGallery();
        $auction->currency_name = $currency;

        $auction->catname = mosStripslashes($auction->GetCategory());
        $auction->username = $bid_user->username;
        $auction->verified_auctioneer = JBidsACL::_isVerified($auction->userid);

        $auction->description = mosStripslashes($auction->description);
        $auction->shortdescription = mosStripslashes($auction->shortdescription);

        // shipping
        if ( bid_opt_multiple_shipping ) {

			$p = new JAuctionShipZones($database);
			$lists["shipping_zones"] = $p->getPriceList($auction->id);
			
        }

        if( $auction->auction_type!=AUCTION_TYPE_BIN_ONLY) {
        	
	        if ( bid_opt_ilustration_band && bid_opt_range_increment ) {
	
	            $database->setQuery("SELECT MAX(bid_price + 0) FROM #__bids WHERE cancel=0 and id_offer='$auction->id' ");
	            $tmp = $database->LoadResult();
	            //echo $database->_sql;exit;
	            if (!$tmp)
	                $tmp = 0;
	
	            $m=0;
	            $m = max($auction->initial_price, $tmp);
	
	            $inc = new JAuctionBidIncrement($database);
	            $lists["band"] = $inc->getIncrement($m);
	
	            $auction->min_increase = $inc->getIncrementOfValue($m);
	
	            $lists["band_values"] = $inc->getList($m);
	            
	            if ($tmp > 0)
	                $m = $m + $lists["band"]->value;
	
				$lists['start_bid_band']=$m;
	        }
        }
        
        $bidSuggest = new JAuctionBidSuggestions($database);
        $bidSuggest->auctionid = $auction->id;
        $list_suge = null;
        if ($my->id) {
            if (!$auction->is_my_auction)
                $bidSuggest->userid = $my->id;
            $list_suge = $bidSuggest->getSuggestions();
        }

        $positioned1 = JTheFactoryHelper::loadPositionedFields($auction,"t_auctiondetails.tpl", "#__bid_auctions");
        $positioned2 = JTheFactoryHelper::loadPositionedFields($bid_user_details,"t_auctiondetails.tpl", "#__bid_users");
        
        if (!$positioned1)
        	$positioned1 = array();
        if (!$positioned2)
            $positioned2 = array();

        $positionsincredibil = array_merge_recursive($positioned1, $positioned2);
        $smarty->assign('positions', $positionsincredibil);
        /* <- [+] 1.6.7 */

        // TOKENize
        @session_start();
        $token = $_SESSION["auction_token"] = time();

        // used for spoof hardening
        //$smarty->assign('validate', josSpoofValue());

        $smarty->assign('suggestions', $list_suge);
        $smarty->assign('auction', $auction);
        $smarty->assign('auctioneer', $bid_user);
        $smarty->assign('auctioneer_details', $bid_user_details);
        $smarty->assign('bid_list', $bids_list);
        $smarty->assign('message_list', $messages);
        $smarty->assign('lists', $lists);

        /* PLUGINS */
        $database->setQuery("select * from #__bid_pricing where enabled=1 order by ordering");
        $pp = $database->loadObjectList();
        $pricing_plugins = array();
        if ($pp)
            foreach ($pp as $p) {
                $pricing_plugins[$p->itemname] = $p;
            }

        $smarty->assign('pricing_plugins', $pricing_plugins);

        /* PLUGINS */

        $terms = new JAuctionMails($database);
        if ($terms->load('terms_and_conditions'))
            if ($terms->content !== '')
                $smarty->assign('terms_and_conditions', '1');
        if (bid_opt_enable_captcha) {
        	
			$smarty->assign("cs", BidsHTML::init_captcha());
        }
        if (bid_opt_enable_countdown) {
        	
            $jdoc->addScriptDeclaration("var nrcounters=1;");
            
        }
        $smarty->display('t_auctiondetails.tpl');

    }
	
    function search()
    {
		?>
		<script type="text/javascript" src="<?php echo JURI::root(true); ?>/includes/js/calendar/calendar.js"></script>
		<link rel="stylesheet" href="<?php echo JURI::root(true); ?>/media/system/css/calendar-jos.css" type="text/css"  title="green"  media="all" />
		<script type="text/javascript" src="<?php echo JURI::root(true); ?>/includes/js/calendar/lang/calendar-en-GB.js"></script>
		<?php
		$lists = array();
	    global $Itemid, $cb_fieldmap;
	    
	    $database = & JFactory::getDBO();
	    $my = & JFactory::getUser();
	
	    $query = "select distinct u.* from #__users u
				where u.id != '$my->id' and
				u.usertype!='Super Administrator' and u.usertype!='Administrator' and u.block!=1
		";
	    $database->setQuery($query);
	    $users = $database->loadObjectList();
	
	    $query = "select distinct u.* from #__users u
				where 
				u.block!=1
				AND (
				SELECT count( * )
				FROM #__bid_auctions
				WHERE userid = u.id
				) >0
				ORDER BY u.username ASC 
		";
	    $database->setQuery($query);
	    $active_users = $database->loadObjectList();
	    //echo $database->_sql;exit;
	
		$lists['cats'] = BidsHTML::selectCategory("cat");
	
	    $useropts = array();
	    $active_useropts = array();
	    for ($i = 0; $i < count($users); $i++)
	    {
	        $useropts[] = JHTML::_('select.option',$users[$i]->id, $users[$i]->username);
	    }
	    for ($i = 0; $i < count($active_users); $i++)
	    {
	        $active_useropts[] = JHTML::_('select.option',$active_users[$i]->id, $active_users[$i]->
	            username);
	    }
	
	    $useropts = array_merge(array(JHTML::_('select.option','', bid_all)), $useropts);
	    $active_useropts = array_merge(array(JHTML::_('select.option','', bid_all)), $active_useropts);
	
	    $lists['users'] = JHTML::_('select.genericlist',$useropts, 'users[]',
	        'class="inputbox"  style="width:190px;" size="10" multiple', 'value', 'text', '');
	    $lists['active_users'] = JHTML::_('select.genericlist',$active_useropts, 'users[]',
	        'class="inputbox"  style="width:190px;" size="10" multiple', 'value', 'text', '');
	
	    if (!CB_DETECT)
	    {
	        $query = "select distinct country as value,c.name as `text` from #__bid_users as u " .
	            " LEFT JOIN #__bid_country as c ON u.country = c.id ";
	        " WHERE country<>'' and country is not null ";
	        $database->setQuery($query);
	        $country[] = JHTML::_('select.option','', bid_all);
	        $country = array_merge($country, $database->loadObjectList());
	
	        $lists['country'] = JHTML::_('select.genericlist',$country, 'country',
	            'class="inputbox"  style="width:190px;" ', 'value', 'text');
	
	        $query = "select distinct city as value,city as text from #__bid_users " .
	            " where city<>'' and city is not null";
	        $database->setQuery($query);
	        $city[] = JHTML::_('select.option','', bid_all);
	        $city = array_merge($city, $database->loadObjectList());
	        $lists['city'] = JHTML::_('select.genericlist',$city, 'city',
	            'class="inputbox"  style="width:190px;" ', 'value', 'text');
	    }
	    if (CB_DETECT && $cb_fieldmap['country'])
	    {
	        $query = "select distinct " . $cb_fieldmap['country'] . " as value," . $cb_fieldmap['country'] .
	            " as text from #__comprofiler " . " where " . $cb_fieldmap['country'] .
	            "<>'' and " . $cb_fieldmap['country'] . " is not null";
	        $database->setQuery($query);
	        $country[] = JHTML::_('select.option','', bid_all);
	        $country = array_merge($country, $database->loadObjectList());
	        $lists['country'] = JHTML::_('select.genericlist',$country, 'country',
	            'class="inputbox"  style="width:190px;" ', 'value', 'text');
	
	    }
	    if (CB_DETECT && $cb_fieldmap['city'])
	    {
	        $query = "select distinct " . $cb_fieldmap['city'] . " as value," . $cb_fieldmap['city'] .
	            " as text from #__comprofiler " . " where " . $cb_fieldmap['city'] . "<>'' and " .
	            $cb_fieldmap['city'] . " is not null";
	        $database->setQuery($query);
	        $city[] = JHTML::_('select.option','', bid_all);
	        $city = array_merge($city, $database->loadObjectList());
	        $lists['city'] = JHTML::_('select.genericlist',$city, 'city',
	            'class="inputbox"  style="width:190px;" ', 'value', 'text');
	    }

        //require_once(JPATH_ROOT."/components/com_bids/thefactory/FactoryFieldsFront.php");
        $Fi = &FactoryFieldsFront::getInstance();
        $fields = $Fi->getSearchFields(null, null);

		$smarty = BidsUtilities::SmartyLoaderHelper();
        $smarty->assign("profiler", $fields);
        $smarty->assign("lists", $lists);
        $smarty->display("t_search.tpl");
    }
    
    function reportAuction($id, $title, $Itemid)
    {

		$smarty = BidsUtilities::SmartyLoaderHelper();
        $smarty->assign("auction_id", $id);
        $smarty->assign("auction_title", $title);
        $smarty->display("t_report_auction.tpl");

    }
    
	
}
