<?php
/**
* @package		Auction Factory
* @license		comercial
* @modified	29/04/2010
*/
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Auction Factory Component
 *
 * @package		Auction Factory
 */
class bidsViewCategory extends JView
{

	function display(){
		

		$db = & JFactory::getDBO();
		$app	= JFactory::getApplication();
		$curentItemid	= BidsUtilities::getMenuItemId( array("task"=>"listcats") );
		if(!$curentItemid)
			$curentItemid	= BidsUtilities::getMenuItemId( array("view"=>"category","layout"=>"") );
		
		$AdsItemid 	 	= BidsUtilities::getMenuItemId( array("task" => "listauctions") );
		if(!$AdsItemid)
			$AdsItemid	= BidsUtilities::getMenuItemId( array("view"=>"auctions","layout"=>"") );
			
		$filter_cat = (int)JRequest::getVar("cat", 0);
		
		// Get the page/component configuration
		$params = $app->getParams();
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		
		$model		= &$this->getModel("category");
		$items = $model->getCategories();

		$categories = array();


		if( isset($items[$filter_cat]) && count($items[$filter_cat])>0 ){
			foreach ($items[$filter_cat] as $key => $cat ){
				
				$id = $cat->id;
				$rendered = bidsViewCategory::renderCategory($cat, $curentItemid, $AdsItemid);
				$categories[$key] = $rendered;

				if( isset($items[$id]) && count($items[$id])>0  ){
					
					foreach ($items[$id] as $sid => $subcat ){
						if (isset($subcat->id)) {
							$srendered = bidsViewCategory::renderCategory($subcat, $curentItemid, $AdsItemid);
							$categories[$key]->subcategories[] = $srendered;
						}
					}
				}
			}
		}
		
		if($filter_cat){
			
			$c = new JTheFactoryCategoryTable();
			$c->load($filter_cat);
			$q = "
			SELECT a.id
			FROM `#__bid_categories` a
			LEFT JOIN `#__bid_categories` b ON b.id = a.parent LEFT JOIN `#__bid_categories` c ON c.id = b.parent LEFT JOIN `#__bid_categories` d ON d.id = c.parent LEFT JOIN `#__bid_categories` e ON e.id = d.parent LEFT JOIN `#__bid_categories` f ON f.id = e.parent LEFT JOIN `#__bid_categories` g ON g.id = f.parent LEFT JOIN `#__bid_categories` h ON h.id = g.parent LEFT JOIN `#__bid_categories` i ON i.id = h.parent LEFT JOIN `#__bid_categories` j ON j.id = i.parent
			WHERE a.parent =$filter_cat OR b.parent =$filter_cat OR c.parent =$filter_cat OR d.parent =$filter_cat OR e.parent =$filter_cat OR f.parent =$filter_cat OR g.parent =$filter_cat OR h.parent =$filter_cat OR i.parent =$filter_cat OR j.parent =$filter_cat
			";
			$db->setQuery($q);
			$idArray = $db->loadResultArray();
			$c->kids = count($idArray);
			
			$idArray = array_merge(array($filter_cat),$idArray);
			
			$idList = implode(",",$idArray);
			
			if(bid_opt_inner_categories){
				$db->setQuery("SELECT count(*) FROM #__bid_auctions WHERE cat IN ( $idList ) ");
			}else{
				$db->setQuery("SELECT count(*) FROM #__bid_auctions WHERE cat = '{$filter_cat}' ");
			}
			$c->nr_auctions = $db->loadResult();
			$c = bidsViewCategory::renderCategory($c, $curentItemid, $AdsItemid);
			
			
	        $app->setPageTitle($c->catname);
	        if ($c->description) {
		        $app->addMetaTag('description',strip_tags($c->description));
		        $app->addMetaTag('abstract',strip_tags($c->description));
		        $app->appendMetaTag('keywords',strip_tags(implode(explode(" ",$c->description),',')));
	        	
	        }
			$smarty->assign("category_filter", $c);
		}
		
		$smarty->assign("categories", $categories );
		
		if ($params->get('show_page_title', 1)){
			$page_title = $this->escape($params->get('page_title'));
			if($page_title==""){
				$page_title = "Category Page";
			}
			$smarty->assign("page_title" ,  $page_title);
		}
		
		$uri 	  = &JFactory::getURI();
		$uri->delVar("cat");
		
        $smarty->assign("category_home", JRoute::_(JFilterOutput::ampReplace($uri->toString())) );

		JHTML::_("behavior.tooltip");
		$smarty->display( "t_categories.tpl" );
	}
	
	function tree_cats(){
		
		$app	= JFactory::getApplication();
		
		// Get the page/component configuration
		$params = $app->getParams();
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		
		$model	= & $this->getModel("category");
		$items	= & $model->getCategories();
		$cat = (int)JRequest::getVar("cat", 0);
		$categories = bidsViewCategory::renderCategories($items,$cat);
		
		$smarty->assign("categories" ,  $categories);
		
        if($cat){
        	$smarty->assign("category_pathway", $cat);
			//$smarty->assign("category_pathway", JTheFactoryCategoryObj::string_cat_path($cat,'listcats'));
	    }
		
		if ($params->get('show_page_title', 1)){
			$page_title = $this->escape($params->get('page_title'));
			if($page_title==""){
				$page_title = "Category Page";
			}
			$smarty->assign("page_title" ,  $page_title);
		}
		
		JHTML::_("behavior.tooltip");
		$smarty->display( "t_category_tree.tpl" );
		
		$jdoc = &JFactory::getDocument();
		/**
		 * JQuery Loading
		 */
		$j_loaded = false;
		
		foreach ($jdoc->_scripts as $j => $jj)
			if (strstr($j, "jquery.js") !== false){
				$j_loaded = true;
				break;
			}
		
		if( !$j_loaded ){
			$jdoc->addScript('components/com_bids/js/jquery/jquery.js');
			$jdoc->addScript('components/com_bids/js/jquery/jquery.noconflict.js');
		}
		
	}
	
	function catselect(){
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		
		//$items	=& $this->get( 'Categories' );
	    $task = JRequest::getCmd('task');
		$database = & JFactory::getDBO();
		$cat = new JTheFactoryCategoryObj();	
		$cat->show_active_only = true;
		$items = $cat->build_children_tree(0,false);
		
		$id   = (int)JRequest::getVar('id',null);
		
		if($task=="selectcat")
			$task="edit";
		$smarty->assign("task", $task);
		$smarty->assign("categories", $items);
		$smarty->display("t_choose_category.tpl");
	}
	
	function renderCategories($items, $id = 0 ){
		
		$curentItemid	= BidsUtilities::getMenuItemId( array("view"=>"category") );
		$AdsItemid 	 	= BidsUtilities::getMenuItemId( array("view"=>"bids", "task" => "") );
		
		$categories = array();
		
		if( isset($items[$id]) && count($items[$id])>0 ){
			
			foreach ($items[$id] as $key => $cat ){
				
				$rendered = bidsViewCategory::renderTreeCategory($cat, $curentItemid, $AdsItemid );
				$categories[$key] = $rendered;
				
				if( isset($items[$cat->id]) && count($items[$cat->id])>0  ){
					foreach ($items[$cat->id] as $sid => $subcat ){
						if (isset($subcat->id)) {
							$srendered = bidsViewCategory::renderTreeCategory($subcat, $curentItemid, $AdsItemid);
							$categories[$key]->subcategories[$subcat->id] = $srendered;
							$categories[$key]->subcategories[$subcat->id]->subcategories = bidsViewCategory::renderCategories($items,$subcat->id);
						}
					}
				}
			}
		}
		
		return $categories;
	}
	
	function renderCategory( $row, $curentItemid, $AdsItemid ){
		
		$my = &JFactory::getUser();
		$database = &JFactory::getDBO();
		$option = "com_bids";
		$site = JURI::root();
		

        // ===> prepare List of WatchListed Categories in $idslist
        // is this really necessary ?
        $idslist = array();
        if ($my->id) {
            $database->setQuery("SELECT catid FROM #__bid_watchlist_cats WHERE userid=" .$my->id);
            $idslist = $database->loadResultArray();
        }
		// <=== prepare List of WatchListed Categories in $idslist
		
		// add category sef route ; if null process
		$catslug = "";
		if(isset($row->catslug)){
			$separator = PHP_EOL;
			$catslug = str_replace($separator,"/",str_replace("/","-",$row->catslug));
			$catslug = "&amp;catslug=$catslug";
		}
        	
        if (is_array($idslist) && in_array($row->id, $idslist)) {
            // watchlisted
			$row->watchListed_flag = 1;
            $row->link_watchlist = JRoute::_("index.php?option=$option&task=delwatchcat&cat=" .$row->id . "&Itemid=$curentItemid".$catslug);
            
        } else {
        	// not watchlisted
            $row->watchListed_flag = 0;
            $row->link_watchlist = JRoute::_("index.php?option=$option&view=category&task=addwatchcat&cat=" .$row->id . "&Itemid=$curentItemid".$catslug);
        }

        $row->link = JRoute::_("index.php?option=$option&task=listcats&cat=" .$row->id . "&Itemid=$curentItemid".$catslug);
		$row->view = JRoute::_( "index.php?option=$option&task=listauctions&cat=".$row->id . "&Itemid=$AdsItemid".$catslug);
		

        $row->catname = $row->catname;
		$row->descr = "";
        if(isset($row->description))
            $row->descr = $row->description;
            
		return $row;
	            
	}
	
	function renderTreeCategory( $row, $curentItemid, $AdsItemid ){
		
		$my = &JFactory::getUser();
		$database = &JFactory::getDBO();
		$option = "com_bids";
		$site = JURI::root();

        // ===> prepare List of WatchListed Categories in $idslist
        // is this really necessary ?
        $idslist = array();
        if ($my->id) {
            $database->setQuery("SELECT catid FROM #__bid_watchlist_cats WHERE userid=" .$my->id);
            $idslist = $database->loadResultArray();
        }
		// <=== prepare List of WatchListed Categories in $idslist
		
		// add category sef route ; if null process
		$catslug = "";
		if(isset($row->catslug)){
			$separator = PHP_EOL;
			$catslug = str_replace($separator,"/",str_replace("/","-",$row->catslug));
			$catslug = "&amp;catslug=$catslug";
		}
        	
        if (is_array($idslist) && in_array($row->id, $idslist)) {
            // watchlisted
			$row->watchListed_flag = 1;
            $row->link_watchlist = JRoute::_("index.php?option=$option&task=delwatchcat&cat=" .$row->id . "&Itemid=$curentItemid".$catslug);
            
        } else {
        	// not watchlisted
            $row->watchListed_flag = 0;
            $row->link_watchlist = JRoute::_("index.php?option=$option&view=category&task=addwatchcat&cat=" .$row->id . "&Itemid=$curentItemid".$catslug);
        }

        $row->link = JRoute::_("index.php?option=$option&view=category&layout=tree&cat=" .$row->id . "&Itemid=$curentItemid".$catslug);
		$row->view = JRoute::_("index.php?option=$option&view=bids&cat=".$row->id . "&Itemid=$AdsItemid".$catslug);
		

        $row->catname = $row->catname;
		$row->descr = "";
        if(isset($row->description))
            $row->descr = $row->description;
            
		return $row;
	            
	}
}