<?php
/**
 * @package AuctionsFactory
 * @version 1.6.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
    class Bids_Options
    {
        var $_options_array=array(
            'bid_opt_max_picture_size'=>'bid_opt_max_picture_size',
            'date_format'=>'bid_opt_date_format',
            'bid_opt_date_time_format'=>'bid_opt_date_time_format',
            'thumb_resize_width'=>'bid_opt_thumb_width',
            'thumb_resize_height'=>'bid_opt_thumb_height',
            'medium_resize_width'=>'bid_opt_medium_width',
            'medium_resize_height'=>'bid_opt_medium_height',
            'max_nr_months'=>'bid_opt_availability',
            'max_nr_img'=>'bid_opt_maxnr_images',
            'min_increase'=>'bid_opt_min_increase',
            'allow_messages'=>'bid_opt_allow_messages',
            'proxy'=>'bid_opt_allow_proxy',
            'arh'=>'bid_opt_archive',
            'bid_opt_nr_items_per_page'=>'bid_opt_nr_items_per_page',
            'icsv'=>'bid_opt_allow_import',
            'enable_hour'=>'bid_opt_enable_hour',
            'bid_opt_enable_countdown'=>'bid_opt_enable_countdown',
            'language'=>'bid_opt_language',
            'rss_title'=>'bid_opt_RSS_title',
            'rss_description'=>'bid_opt_RSS_description',
            'rss_nritems'=>'bid_opt_RSS_nritems',
            'rss_feedtype'=>'bid_opt_RSS_feedtype',
            'bid_opt_enable_acl'=>'bid_opt_enable_acl',
            'acl_type'=>'bid_opt_acl_type',
            'bidder_group'=>'bid_opt_acl_bidder',
            'seller_group'=>'bid_opt_acl_seller',
            'max_nr_tags'=>'bid_opt_max_nr_tags',
            'allowpaypal'=>'bid_opt_allowpaypal',
            'require_image'=>'bid_opt_require_picture',
            'bid_opt_resize_if_larger'=>'bid_opt_resize_if_larger',
            'allow_multiple_gateways'=>'bid_opt_multiple_payments',
            'bid_opt_gallery'=>'bid_opt_gallery',
            'min_increase_select'=>'bid_opt_min_increase_select',
            'bid_opt_allow_retract'=>'bid_opt_allow_retract',
            'bid_opt_allow_guest_messaging'=>'bid_opt_allow_guest_messaging',
            'bid_opt_enable_captcha'=>'bid_opt_enable_captcha',
            'bid_opt_inner_categories'=>'bid_opt_inner_categories',
            'bid_opt_preferential_cats'=>'bid_opt_preferential_cats',
            'bid_opt_only_payperlist_cats'=>'bid_opt_only_payperlist_cats',
            'bid_opt_paylist_cats'=>'bid_opt_paylist_cats',
            'bid_opt_commission_cats'=>'bid_opt_commission_cats',
            'bid_opt_various_commissions'=>'bid_opt_various_commissions',
            'bid_opt_uddeim'=>'bid_opt_uddeim',
            'bid_opt_auto_extent'=>'bid_opt_auto_extent',
            'bid_opt_auto_extent_limit'=>'bid_opt_auto_extent_limit',
            'bid_opt_auto_extent_limit_type'=>'bid_opt_auto_extent_limit_type',
            'bid_opt_auto_extent_offset'=>'bid_opt_auto_extent_offset',
            'bid_opt_auto_extent_offset_type'=>'bid_opt_auto_extent_offset_type',
            'bid_opt_payment_select_mode'=>'bid_opt_payment_select_mode',
            'bid_opt_multiple_shipping'=>'bid_opt_multiple_shipping',
            'bid_opt_allow_user_settings'=>'bid_opt_allow_user_settings',
            'bid_opt_range_increment'=>'bid_opt_range_increment',
            'bid_opt_ilustration_band'=>'bid_opt_ilustration_band',
            'bid_opt_buyers_premium'=>'bid_opt_buyers_premium',
            'bid_opt_proxy_default_period'=>'bid_opt_proxy_default_period',
            'bid_opt_global_enable_bin'=>'bid_opt_global_enable_bin',
            'bid_opt_bin_default_period'=>'bid_opt_bin_default_period',
            'bid_opt_global_enable_reserve_price'=>'bid_opt_global_enable_reserve_price',
            'bid_opt_reserve_price_default_period'=>'bid_opt_reserve_price_default_period',
            'bid_opt_global_enable_private'=>'bid_opt_global_enable_private',
            'bid_opt_enable_date'=>'bid_opt_enable_date',
            'bid_opt_enable_bin_only'=>'bid_opt_enable_bin_only',
            'bid_opt_show_parameter_tab'=>'bid_opt_show_parameter_tab',
            'bid_opt_default_period'=>'bid_opt_default_period',
            'bin_opt_price_suggestion'=>'bin_opt_price_suggestion',
            'bin_opt_limit_suggestions'=>'bin_opt_limit_suggestions',
            'bid_opt_quantity_enabled'=>'bid_opt_quantity_enabled',
            'bid_opt_category_page'=>'bid_opt_category_page',
            'bid_opt_automatic_auction_select'=>'bid_opt_automatic_auction_select',
			'bid_opt_automatic_auction_default'=>'bid_opt_automatic_auction_default',
			'bid_opt_component_offset'=>'bid_opt_component_offset',
			
			'bid_opt_recaptcha_public_key'=>'bid_opt_recaptcha_public_key',
			'bid_opt_recaptcha_private_key'=>'bid_opt_recaptcha_private_key',
			'bid_opt_mailcaptcha_public_key'=>'bid_opt_mailcaptcha_public_key',
			'bid_opt_mailcaptcha_private_key'=>'bid_opt_mailcaptcha_private_key',
			'bid_opt_enable_antispam_bot'=>'bid_opt_enable_antispam_bot',
			'bid_opt_recaptcha_theme'=>'bid_opt_recaptcha_theme',
			'bid_opt_choose_antispam_bot'=>'bid_opt_choose_antispam_bot',
			'bid_opt_leaf_posting_only'=>'bid_opt_leaf_posting_only',
			'BID_TPL_THEME'=>'BID_TPL_THEME',
			'bid_opt_profile_mode'=>'bid_opt_profile_mode'
			
        );
    	var $_raw_options=array('bid_opt_min_increase','bid_opt_paylist_cats');
		var $_checkboxes=array('bid_opt_resize_if_larger','bid_opt_require_picture','bid_opt_multiple_payments','bid_opt_allowpaypal','bid_opt_min_increase_select', 'bid_opt_enable_countdown', 'bid_opt_leaf_posting_only','bid_opt_inner_categories','bid_opt_category_page');
		var $_db=null;
        function Bids_Options(&$database){
			$this->_db=$database;
        }
        function saveOptions()
        {

        	$out_file = JPATH_COMPONENT_SITE.'/options.php';
        	$f = fopen($out_file,'w');
        	if (!$f) return false;
            fputs($f,"<?php\n");

            foreach ($this->_options_array as $var=>$optstring){
                $defaultval=defined($optstring)?constant($optstring):'';
                if (in_array($optstring,$this->_checkboxes))  $defaultval='0';
                if (in_array($var,$this->_raw_options))
                    $v=JRequest::getVar($var,$defaultval,'default',JREQUEST_ALLOWRAW);
                else
                    $v=JRequest::getVar($var,$defaultval);
                $v=addslashes($v);
                fputs($f,"define('$optstring','$v');\n");

            }
            fputs($f,"\n?>");
           	fclose($f);

        	$term=new JAuctionMails($this->_db);

            $term->load('terms_and_conditions');
        	//$term->content=JRequest::getVar('terms_conditions','','default',JREQUEST_ALLOWRAW);
	    	$term->content=JArrayHelper::getValue($_REQUEST,'terms_conditions','');

        	$term->store();

        	$c=JRequest::getVar('currency',null);
        	$this->SaveArrayInTable('#__bid_currency','name',$c);

        	$p=JRequest::getVar('payment',null);
        	$this->SaveArrayInTable('#__bid_payment','name',$p);

    	    return true;

        }
        
        function SaveArrayInTable($tablename,$fieldname,$values){
        	$valarr=explode('~',$values);
        	if (count($valarr)>0)
        	{
        		$this->_db->setQuery("select * from $tablename");
        		$oldvals=$this->_db->LoadObjectList();

        		$this->_db->setQuery("delete from $tablename");
        		$this->_db->query();

        		foreach ($valarr as $curr){
        			if (!empty($curr)){
        			    $oldid='null';
        			    for ($i=0;$i<count($oldvals);$i++)
        			     if(strtoupper($oldvals[$i]->$fieldname)==strtoupper($curr)) {
        			         $oldid="'".$oldvals[$i]->id."'";
        			         break;
        			     }

        				$this->_db->setQuery("insert into $tablename  set id=$oldid,$fieldname='$curr'");
        				$this->_db->query();

        			}

        		}
        	}else{
        		$this->_db->setQuery("delete from $tablename");
        		$this->_db->query();

        	}

        }
        
	function changeSetting($option,$value){
		
		$out_file = JPATH_COMPONENT_SITE.DS.'options.php';
		$f = fopen($out_file,'w');
		if (!$f) return false;
		
		fputs($f,"<?php\n");
		foreach ($this->_options_array as $var => $optstring){
		if($optstring == $option){
			$v = $value;
		}else {
			$v = constant($optstring);
		}
		fputs($f,"define('$optstring','$v');\n");
		}
		
		fputs($f,"\n?>");
		fclose($f);
		
		return true;
	}
    

    }

function createBackupString($table)
{
    $database = &JFactory::getDBO();
    $database->setQuery("select * from $table");
	$rows = $database->loadObjectList();
	foreach($rows as $row)
    {
        $arr = JArrayHelper::fromObject($row);
        $fieldlist=array_keys($arr);
        $InsertDump = "INSERT INTO $table (".implode($fieldlist,',').") VALUES (";
        foreach($arr as $key => $value)
        {
            $value = addslashes( $value );
            $value = str_replace( "\n", '\r\n', $value );
            $value = str_replace( "\r", '', $value );
            $InsertDump .= "'$value',";
        }
        $file_tmp .= rtrim($InsertDump,',') . ");\n";
    }
    return $file_tmp;
}

    
?>