<?php
/**
 * @package AuctionsFactory
 * @version 2.0.0
 * @author The Factoy
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class HTML_admin_auctions{

	function listUsers($rows,&$page,$search,$lists,$filter_orderid){
		// Initialize variables
		$db		=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$config	=& JFactory::getConfig();
    	
		JHTML::_('behavior.tooltip');
		
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS."tmpl".DS."user".DS."users.php");
    }
    
	function showAuctions( &$rows, &$pageNav, &$lists ) {
		// Initialize variables
		$db		=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$config	=& JFactory::getConfig();
		JHTML::_('behavior.tooltip');
		
		$lists["filter_authorid"] = BidsHTML::selectUser("filter_authorid",array("filter_admin"=>0,"select"=>$filter_authorid,"select_all"=>1));
		

		$closeid[] = JHTML::_('select.option', '0', bid_all_offers);
		$closeid[] = JHTML::_('select.option', '1', bid_opened_offers);
		$closeid[] = JHTML::_('select.option', '2', bid_closed_offer);
		$closeid[] = JHTML::_('select.option', '3', bid_unpublished);
		$closeid[] = JHTML::_('select.option', '4', "Banned by admin");
		$lists['filter_bidtype'] = JHTML::_('select.genericlist', $closeid, 'filter_bidtype', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $lists['filter_bidtype'] );
		
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS."tmpl".DS."auctions".DS."auctions.php");

    }
    
   function editAuction( &$row, &$lists,  $bids, &$pageNav, $user,$adminMessages) {
    	
        $database = &JFactory::getDBO();
		$my = &JFactory::getUser();
        
		$count = count($bids);
		
		$database->setQuery("select max(bid_price+0) from #__bids where id_offer='$row->id'");
		$max_bid=$database->loadResult();
		
		$photos=array();
		if($row->picture){
			$main_pic = new stdClass();
			$main_pic->picture = $row->picture;
			$photos[] = $main_pic;
		}
		
		$database->setQuery("select * from #__bid_pictures where id_offer='$row->id'");
		$extra_photos=$database->loadObjectList();
		
		$photos = array_merge($photos,$extra_photos);
		
		$query = "select m.*,u1.username as fromuser, u2.username as touser  from #__bid_messages m
				left join #__users u1 on u1.id = m.userid1
				left join #__users u2 on u2.id = m.userid2 
				where m.id_offer='$row->id' 
				
		";
		// and (m.userid1 = '$my->id' or m.userid2 = '$my->id') */
		
		$database->setQuery($query);
		$adminMessages = $database->loadObjectList();
		
		$query = "
		SELECT a.*,b.username, bp.max_proxy_price 
		FROM `#__bids` a
		LEFT JOIN `#__users` b on a.userid=b.id 
		LEFT JOIN `#__bid_proxy` bp on a.id_proxy=bp.id and bp.active=1
		WHERE id_offer=$row->id  and userid <> $my->id ";
		$database->setQuery($query, $limitstart,$limit);
		$bids = $database->loadObjectList();
		
		$Fi = & FactoryFieldsFront::getInstance();
		$lists["fields"] = $Fi->getHTMLFields("auctions", $row->id);
		
		$tags = new JAuctionTags($database);
		$lists["tags"] = $tags->getAuctionTags($row->id);
	    
	    JHTML::_( 'behavior.modal' );
	    JHTML::_( 'behavior.tooltip' );
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS."tmpl".DS."auctions".DS."auction.php");
	    
    }
    
	function detailUser(&$user, &$lists, &$ratings, &$pageNav){

		$u=&JTable::getInstance("user");
		$u->load($user->userid);
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS."tmpl".DS."user".DS."user.php");
    }
    
	function showSettings($lists) {
		jimport('joomla.html.pane');
		JHTML::_("behavior.tooltip");
		$tabs = &JPane::getInstance('Tabs');
		?>
		<script type="text/javascript" src="<?php echo JURI::root();?>administrator/components/com_bids/js/bids.js"></script>
		<form action="index.php" method="post" name="adminForm">
			<input type="hidden" name="option" value="com_bids">
			<input type="hidden" name="task" value="savesettings">
			<input type="hidden" name="currency" value="">
			<input type="hidden" name="payment" value="">
			<input type="hidden" name="returnurl" value="<?php echo JURI::root().'/administrator/index.php?option=com_bids&task=settings'; ?>">
			<?php
			$tabList = array(
				array(JText::_("General Settings") , 'miscsettings.php'),
				array(JText::_("Auction Settings"), 'auction.php'),
				array(JText::_("Images"), 'imagesettings.php'),
				array(JText::_("Payment"), 'payment.php'),
				array(JText::_("ACL"), 'acl.php'),
				array(JText::_("Anti Spam"), 'privacy.php'),
				array(bid_tab_terms_conditions, 'terms.php'),
				array(JText::_("Cache Management"), 'cachemanager.php'),
				array(JText::_("System Info"), 'systeminfo.php')
			);
			
			echo $tabs->startPane("configPane");
			foreach ($tabList as $tk => $tabItem){
				echo $tabs->startPanel("<div onclick=\"showProgress($tk);\">{$tabItem[0]}</div>","tab$tk");
				echo '<img id="tab_'.$tk.'" src="'.JURI::root().'administrator/components/com_bids/img/ajax-loader.gif" style="display:none;" border = "0" /><div id="tab_'.$tk.'_content" style="width:100%;">';
				require_once(JPATH_COMPONENT.DS.'tmpl'.DS.'settings'.DS.$tabItem[1]);
				echo "</div>";
				echo $tabs->endPanel();
			}
			echo $tabs->endPane();
			?>
		</form>
		<?php
	}
	
    function listReports($rows,&$pageNav,$lists,$from){
     JHTML::_('behavior.tooltip');

     ?>
     <script language="JavaScript" type="text/javascript">
    	<!--
    	function submitbutton(action){
    	    frm=document.adminForm;
    	    frm.status.value=action;
    	    frm.task.value='change_reported_status';
    		submitform(frm.task.value);

    	}
    	//-->
     </script>

     <table width="100%">
     <form action="index.php" method="post" name="adminForm">
      <tr>
       <td colspan="2">
	    	<table class="adminheading" cellpadding="0" cellspacing="0" border="0">
	    	 <tr>
	    	  <th width="40%"><?php echo bid_reported_auctions; ?></th>
	    	  <td width="60%" align="right"><?php echo $lists['solveid'];?></td>
	    	 </tr>
	    	</table>
       </td>
      </tr>
      <tr>
       <td colspan="2">
    	<table class="adminlist" cellpadding="0" cellspacing="0" border="0">
		<thead>
			<tr>
			<th width="2%" align="center">#</th>
			<th width="2%" align="center">
				<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $rows ); ?>);" />
			</th>
			<th width="10%" class="title" align="center"><?php echo bid_reported_date ?></th>
			<th width="10%" align="center"><?php echo "Reported By"; ?></th>
			<th width="25%" align="center"><?php echo bid_message; ?></th>
			<th width="25%" align="center"><?php echo "Auction";?></th>
			<th width="5%" align="center"><?php echo bid_in_progress ?></th>
			<th width="5%" align="center"><?php echo bid_solved; ?></th>
			<th width="*%" align="center"></th>
			</tr>
		</thead>
    	 <tbody>
         <?php

    	 $k = 0;
    	 for ($i=0, $n=count( $rows ); $i < $n; $i++) {
    		$row = &$rows[$i];
    		$img 	= $row->solved ? 'tick.png' : 'publish_x.png';
    		$img2 	= $row->processing ? 'tick.png' : 'publish_x.png';
    		$task1 	= $row->solved ? 'unsolved' : 'solved';
    		$task2 	= $row->processing ? 'unprocessing' : 'processing';
    		$alt 	= $row->solved ? 'Unsolved' : 'Solved';
    		$alt2 	= $row->processing ? 'Unprocessed' : 'Processed';
    		$message=(strlen($row->message)>30)?substr($row->message,0,30)."..":$row->message;
    		$title=(strlen($row->title)>30)?substr($row->title,0,30)."..":$row->title;

         ?>
    	 <tr class="<?php echo 'row$k'; ?>">
    	  <td align="center">
						<?php echo $pageNav->getRowOffset( $i ); ?>
    	  </td>
    	  <td align="center"><?php echo JHTML::_('grid.checkedout', $row, $i ); ?></td>
    	  <td align="center">
    	  <a href="index.php?option=com_bids&task=editoffer&hidemainmenu=0&id=<?php echo $row->id_offer;?>">
    	       <b><?php echo  date(bid_opt_date_format.
    	       " ".bid_opt_date_time_format,strtotime($row->modified));?></b></a></td>
    	  <td align="center"><?php echo $row->username; ?></td>
    	  <td align="center" title="<?php echo  htmlentities($row->message); ?>" class="hasTip">
    	   <a href="index.php?option=com_bids&task=write_admin_message&id_reported=<?php echo $row->id; ?>">
    	       <?php echo $message;?>
    	   </a>
    	   </td>
    	  <td align="center">
    	   <a href="index.php?option=com_bids&task=editoffer&hidemainmenu=0&id=<?php echo $row->id_offer;?>">
    	       <?php echo $title; ?>
    	   </a>
    	   </td>
    	  <td align="center">
    	   <a href="javascript: void(0);" onclick="return listItemTask('cb<?php echo $i;?>','<?php echo $task2;?>')">
    	  <img src="images/<?php echo $img2;?>" width="12" height="12" border="0" alt="<?php echo $alt2; ?>" /></td>
    	  <td align="center">
    	   <a href="javascript: void(0);" onclick="return listItemTask('cb<?php echo $i;?>','<?php echo $task1;?>')">
    		<img src="images/<?php echo $img;?>" width="12" height="12" border="0" alt="<?php echo $alt; ?>" />
    		</a>
    	  </td>
    	  <td align="center">
    		<a href="index.php?option=com_bids&task=write_admin_message&id_reported=<?php echo $row->id_offer; ?>">
    		<?php echo bid_write_message; ?></a>
    		</td>
    	 </tr>
    	 </tbody>
         <?php
    	 $k = 1 - $k;
    	 }
    	 ?>
    	 <tfoot>
    	 	<tr>
    	 		<td colspan="9">
			    	<?php 
			    	 echo $pageNav->getListFooter();
			    	?>
    	 		</td>
    	 	</tr>
    	 </tfoot>
    	</table>
       </td>
      </tr>
     <input type="hidden" name="option" value="com_bids" />
     <input type="hidden" name="task" value="reported_offers" />
     <input type="hidden" name="status" value="" />
     <input type="hidden" name="boxchecked" value="0" />
     <input type="hidden" name="hidemainmenu" value="0">
    </form>
    </table>
    <?php
    }

    /**
     * @deprecated 
     * 
     * to remove
     *
     * @param unknown_type $auction
     */
    function writeAuctionMessage($auction){

     ?>
     <script language="JavaScript" type="text/javascript">
    	<!--
    	function submitbutton(action){
    		if (document.adminForm.message.value || action==''){
    		    submitform(action);
    			return true;
    		}
    		alert('<?php echo bid_err_message_empty; ?>');

    	}
    	//-->
     </script>

     <form method="POST" action="index.php"  name="adminForm">
      <table width="100%">
       <tr>
    	<td>To: <?php echo $auction->username;?></td>
       </tr>
       <tr>
    	<td>Regarding auction: <?php echo $auction->title;?></td>
       </tr>
       <tr>
    	<td>Id auction: <?php echo $auction->id;?></td>
       </tr>
       <tr>
        <td>
        <textarea name="message" cols="80" rows="10"></textarea>
        </td>
       </tr>
      </table>
    	 <input type="hidden" name="id_auction" value="<?php echo $auction->id;?>">
    	 <input type="hidden" name="option" value="com_bids">
    	 <input type="hidden" name="task" value="send_message_auction">
     </form>
    <?php
    }

    function EmptyAdminForm() {
	 	?>
	 	<form action="index.php" method="post" name="adminForm">
		<input type="hidden" name="option" value="com_bids" />
		<input type="hidden" name="task" value="addItem" />
		<input type="hidden" type="limitstart" value="" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="hidemainmenu" value="0" />
		</form>
	 	<?php
	}

    function userStatistics($users,$totals){

    	?>

		 </script>
    	<link rel="stylesheet" href="<?php echo JURI::root();?>/templates/joomla_admin/css/template_css.css" type="text/css" />
        <link rel="stylesheet" href="<?php echo JURI::root();?>/templates/joomla_admin/css/theme.css" type="text/css" />


   		<table width="100%">
   		 <tr>
   		  <td colspan="2">
   		  	<table class="adminheading" cellpadding="0" cellspacing="0" border="0">
	    	 <tr>
	    	  <th width="40%"><?php echo bid_user_statistics ?></th>
	    	  </tr>
	    	 </table>
   		  </td>
   		 </tr>
   		</table>
		<table width="80%" >
   		<tr>
   		  <td class="stat_users_titles">
   		  	<?php echo bid_user_stat_total_registred;?>&nbsp;<?php echo $totals['r_users'];?>
   		  </td>
		  <td class="stat_users_titles">
		  	<?php echo bid_user_stat_a_auctions;?>&nbsp;<?php echo $totals['a_auctions'];?>
		  </td>
		  <td class="stat_users_titles">
		  	<?php echo bid_user_stat_a_bids;?>&nbsp;<?php echo $totals['a_bids'];?>
		  </td>
   		 </tr>
   		 <tr>
   		  <td class="stat_users_titles">
   		  	<?php echo bid_user_stat_active_registred;?>&nbsp;<?php echo $totals['a_users'];?>
   		  </td>
		  <td class="stat_users_titles">
		  	<?php echo bid_user_stat_c_auctions;?>&nbsp;<?php echo $totals['c_auctions'];?>
		  </td>
		  <td class="stat_users_titles">
		  	<?php echo bid_user_stat_acc_bids;?>&nbsp;<?php echo $totals['ac_bids'];?>
		  </td>
   		 </tr>
   		 </table>
   		 <br>
<?php
 	}

	function auctionsStatistics($userlist,$lists,&$pageNav) {
		$database = &JFactory::getDBO();
		$my = & JFactory::getUser();

?>
		<table width="100%">

	      <tr>
	       <td>
		    	<table class="adminheading"  cellpadding="0" cellspacing="0" border="0">
	         <tr>
	    	  <th><?php echo bid_auction_stats;?></th>
	    	  </tr>
		    	</table>
	       </td>
	      </tr>
			<table class="adminlist" cellpadding="0" cellspacing="0" border="0">
				<thead>
					<tr>
						<th width="42">#</th>
						<th width="69" class="title"><?php echo bid_username; ?></th>
						<th width="69"><?php echo bid_register_date; ?></th>
						<th width="69"><?php echo bid_lastvisit; ?></th>
						<th width="69"><?php echo bid_nr_auctions_placed; ?></th>
						<th width="69"><?php echo bid_nr_bids_placed; ?></th>
						<th width="73"><?php echo bid_nr_auctions_closed; ?></th>
						<th width="80"><?php echo bid_nr_bids_won ?></th>
					</tr>
				</thead>
    	 <?php $k=0;
    	 	for($i=0;$i<count($userlist);$i++){

    	 		$link 	= 'index.php?option=com_bids&task=detailuser&hidemainmenu=0&id='. $userlist[$i]->id;

    	 		$query = "select count(*) from #__bid_auctions where published=1 and close_offer != 1 and close_by_admin != 1 and userid =".$userlist[$i]->id;
    	 		$database->setQuery($query);
    	 		$nr_p_auctions = $database->loadResult();

    	 		$query = "select count(*) from #__bids where accept != 1 and cancel!=1 and userid=".$userlist[$i]->id;
    	 		$database->setQuery($query);
    	 		$nr_p_bids = $database->loadResult();

    	 		$query = "select count(*) from #__bid_auctions where close_offer = 1 and userid=".$userlist[$i]->id;
    	 		$database->setQuery($query);
    	 		$nr_c_auctions = $database->loadResult();

    	 		$query = "select count(*) from #__bids where accept =1 and userid=".$userlist[$i]->id;
    	 		$database->setQuery($query);
    	 		$nr_w_bids = $database->loadResult();
    	 		?>
    	 	<tr class="row<?php echo (int)($i%2);?>">
	    	   <td align="center"><?php //echo $pageNav->rowNumber( $i ); ?></td>
	    	 	<td><a href="<?php echo $link; ?>" title="Details"><?php echo $userlist[$i]->username; ?></a></td>
				<td align="center"><?php echo $userlist[$i]->registerDate;?></td>
	    	 	<td align="center"><?php echo $userlist[$i]->lastvisitDate;?></td>
	    	 	<td align="center"><?php echo $nr_p_auctions;?></td>
	    	 	<td align="center"><?php echo $nr_p_bids;?></td>
	    	 	<td align="center"><?php echo $nr_c_auctions;?></td>
	    	 	<td align="center"><?php echo $nr_w_bids;?></td>
    	 	</tr>
    	 	<?php }?>
			<tr>
				<td colspan="8">
                     <del class="container">
                       <?php echo $pageNav->getListFooter(); ?>
                     </del>
				</td>
			</tr>

	     </table>
<?php
	}

	function bidStatistics($sum_bids,$lists,$errmsg){

	?>
		<table width="100%">

	      <tr>
	       <td>
	    	<table class="adminheading"  cellpadding="0" cellspacing="0" border="0">
	         <tr>
	    	  <th><?php echo bid_bid_stats;?></th>
	    	  <td><?php echo $lists['userid1'];?></td>
	    	  </tr>
	    	</table>
	       </td>
	      </tr>
	      <tr>
	       <td>
	        <?php if($sum_bids!=null && $sum_bids>0){
	        	echo bid_stats_sum_bid." ".$sum_bids;
	        }else{

	        		echo $errmsg;
	        }
	        ?>
	       </td>
	      </tr>




	     </table>
	<?php
	}

	function Statistics($lists,$users,$userlist,&$pageNav,&$totals){
		JHTML::_('behavior.tooltip');

	?>
	<form action="index.php" method="post" name="adminForm">
	<input type="hidden" name="task" value="statistics">
	<input type="hidden" name="option" value="com_bids">

	<?php

		HTML_admin_auctions::userStatistics($users,$totals);

		HTML_admin_auctions::auctionsStatistics($userlist,$lists,$pageNav);

	?>
	</form>
	<?php

	}

	function bulkadmimport($errors){
		$database = & JFactory::getDBO();
		$my = & JFactory::getUser();
?>
		<script language="javascript" type="text/javascript">
			function validateForm(){
				var csv = document.getElementById('csv');

				if(!csv.value){
					alert('<?php echo bid_err_csv_no_file;?>');
					return false;
				}
			}
		</script>
		  <form action="index.php" method="post" name="adminForm" onsubmit="return validateForm();" enctype="multipart/form-data">
		  <input type="hidden" name="option" value="com_bids">
		  <input type="hidden" name="task" value="importcsv">

		  <table width="100%" class="adminlist" cellpadding="0" cellspacing="0" border="0">
		  	<tr>
		  		<td>
		  			<?php echo bid_csv_file, JHTML::tooltip(bid_help_uploadcsv); ?>
		  		</td>
		  		<td>
		  			<input type="file" name="csv" id="csv" size="50">
		  		</td>
		  	</tr>
		  	<tr>
		  		<td>
		  			<?php echo bid_csv_img_arch, JHTML::tooltip(bid_help_uploadimg); ?>
		  		</td>
		  		<td>
		  			<input type="file" name="arch" id="arch" size="50">
		  		</td>
		  	</tr>

		  </table>
		  </form>
		<div align="left">
		<?php
		if(count($errors)>0){
			for ($i=1;$i<=count($errors);$i++){
				if($errors[$i]){
						echo bid_line." ".$errors[$i];
						echo '<br>';

				}
			}
		}

		?>

		</div>

		<?php


	}

	function restoreform($Itemid){
		$database = & JFactory::getDBO();

		?>
		<script language="javascript" type="text/javascript">
			function validateForm(){
				var bkp = document.getElementById('backup');
				var loc=document.getElementById('local_file');
				if(!bkp.value && !loc.value){
					alert('<?php echo bid_err_bkp_no_file;?>');
					return false;
				}
			}
		</script>
		<br>
		  <form action="index.php" method="post" name="adminForm" onsubmit="return validateForm();" enctype="multipart/form-data">
		  <input type="hidden" name="option" value="com_bids">
		  <input type="hidden" name="task" value="restorebackup">
		  <input type="hidden" name="Itemid" value="<?php echo $Itemid;?>">

		  <table width="100%" class="adminlist" cellpadding="0" cellspacing="0" border="0">
		  	<tr>
		  		<td width="300">
		  			<?php echo bid_bkp_file;?>
		  		</td>
		  		<td>
		  			<input type="file" name="backup" id="backup" size="50" />
		  		</td>
		  	</tr>
		  	<tr>
		  		<td>
		  			<?php echo bid_local_file;?>
		  		</td>
		  		<td>
		  			<input type="texst" name="local_file" id="local_file" size="100" value="<?php echo JPATH_ROOT;?>">
		  		</td>
		  	</tr>
		  	
		  	<tr>
		  		<td>
		  			<?php echo bid_bkp_keep;?>
		  		</td>
		  		<td>
		  			<?php echo JHTML::_('select.booleanlist',  'overwrite_imgs', '', 0 );?>
		  		</td>
		  	</tr>

		  </table>
		  </form>
		<?php
	}
	
	function quickiconButton( $link, $image, $text ) {
		?>
		<div style="float:left;">
			<div class="icon">
				<a href="<?php echo $link; ?>">
					<?php
						echo JHTML::_('image.administrator', $image, '/components/com_bids/img/menu/', NULL, NULL, $text );
					?>
					<span><?php echo $text; ?></span>
				</a>
			</div>
		</div>
		<?php
	}

    function showAuctionsManager()
    {
        ?>
        <table width="100%">
        	<tr>
        		<td valign="top" width="240">
			<div id="cpanel">
			<?php
		  $link = 'index.php?option=com_bids&amp;task=comments_administrator';
		  HTML_admin_auctions::quickiconButton( $link, 'add_db.png', "Messages" );
		  
		  $link = 'index.php?option=com_bids&amp;task=reviews_administrator';
		  HTML_admin_auctions::quickiconButton( $link, 'gsettings.png', "Ratings" );
		  
		  echo '<div style="clear:both;"> </div>';
		  
		  $link = 'index.php?option=com_bids&amp;task=exportToXls';
		  HTML_admin_auctions::quickiconButton( $link, 'xlsexport.png', bid_exportToXls );

		  $link = 'index.php?option=com_bids&amp;task=showadmimportform';
		  HTML_admin_auctions::quickiconButton( $link, 'importauctions.png', bid_import_auctions);


		  echo '<div style="clear:both;"> </div>';
		  
		  $link = 'index.php?option=com_bids&amp;task=purgeauctions';
		  HTML_admin_auctions::quickiconButton( $link, 'purgeauctions.png', bid_purge_auctions );
		  
			?>
			</div>
        		</td>
        		<td valign="top" >
			<div id="cpanel">
			<?php
		  $link = 'index.php?option=com_bids&amp;task=bid_stats';
		  HTML_admin_auctions::quickiconButton( $link, 'settings.png', bid_statistics );
		  
		  $link = 'index.php?option=com_bids&amp;task=statistics';
		  HTML_admin_auctions::quickiconButton( $link, 'settings.png', bid_auction_stats );
			
		  echo '<div style="clear:both;"> </div>';
		  
		  $link = 'index.php?option=com_bids&amp;task=backup';
		  HTML_admin_auctions::quickiconButton( $link, 'backupauctions.png', bid_backup_auctions );

		  $link = 'index.php?option=com_bids&amp;task=showrestoreform';
		  HTML_admin_auctions::quickiconButton( $link, 'restoreauctions.png', bid_restore_auctions );
			?>
			</div>
        		</td>
	        	<td valign="top" align="center" width="400">
			    	<table class="adminform">
			    		<tr>
			    		<td style="text-align:center !important;">
						<strong> Check the Documentation and our forum for FAQ's and quick help</strong><br />
						<a href="http://www.thefactory.ro/shop/joomla-components/auction-factory.html"><img src="http://www.thefactory.ro/components/com_virtuemart/shop_image/product/691d18403ccd7476f3035c8252fe0ee2.jpg" /></a>
						<br />
						<a href="http://www.thefactory.ro/support/faq/" target="_blank">http://www.thefactory.ro/support/faq/</a><br>
						<a href="http://www.thefactory.ro/component/option,com_smf/Itemid,40/" target="_blank">http://www.thefactory.ro/component/option,com_smf/Itemid,40/</a><br>
						<br>
						Give us your feedback!<br /> Please <a href="http://extensions.joomla.org/extensions/e-commerce/auction/8772?qh=YToyOntpOjA7czo3OiJhdWN0aW9uIjtpOjE7czo4OiJhdWN0aW9ucyI7fQ%3D%3D" target="_blank">vote for our components and modules on Joomla Extensions</a><br>
			    		</td>
			    		</tr>
					</table>	
	        	</td>
        	</tr>
        </table>
        <?php
    }
    
    function showPaymentManager()
    {
        ?>
    	<div id="cpanel">
		<?php
		  $link = 'index.php?option=com_bids&amp;task=paymentitems';
		  HTML_admin_auctions::quickiconButton( $link, 'paymentitems.png', bid_payment_items );

		  $link = 'index.php?option=com_bids&amp;task=paymentconfig';
		  HTML_admin_auctions::quickiconButton( $link, 'paymentconfig.png', bid_payment_config );

		  $link = 'index.php?option=com_bids&amp;task=payments';
		  HTML_admin_auctions::quickiconButton( $link, 'payments.png', bid_view_payments );
		  ?>
    	</div>
    	<div style="height:100px">&nbsp;</div>
    	<div style="clear:both;"> </div>
        <?php
	}
    
	function showSettingsManager()
	{
        ?>
        <table width="100%">
        <tr>
        	<td width="60%" valign="top">
		    	<div id="cpanel">
				<?php
				  $link = 'index.php?option=com_bids&amp;task=settings';
				  HTML_admin_auctions::quickiconButton( $link, 'settings.png', bid_general_settings );
		
				  $link = 'index.php?option=com_bids&amp;task=mailsettings';
				  HTML_admin_auctions::quickiconButton( $link, 'mailsettings.png', bid_mail_settings );
		
				  $link = 'index.php?option=com_bids&amp;task=field_administrator';
				  HTML_admin_auctions::quickiconButton( $link, 'fieds_manager.png', "Custom fields" );
				  
				  
				  $link = 'index.php?option=com_bids&amp;task=plugins_administrator';
				  HTML_admin_auctions::quickiconButton( $link, 'add_db.png', "Plugins Manager" );
				  
				  
				  ?>
		    	</div>
		    	<br clear="all" />
		    	<div id="cpanel">
				  <?php
				  $link = 'index.php?option=com_bids&amp;task=paymentitems';
				  HTML_admin_auctions::quickiconButton( $link, 'paymentitems.png', bid_payment_items );
		
				  $link = 'index.php?option=com_bids&amp;task=paymentconfig';
				  HTML_admin_auctions::quickiconButton( $link, 'paymentconfig.png', bid_payment_config );
				  
				  $link = 'index.php?option=com_bids&amp;task=shipping_administrator';
				  HTML_admin_auctions::quickiconButton( $link, 'shipping.png', "Shipping" );
				  
				  $link = 'index.php?option=com_bids&amp;task=countries';
				  HTML_admin_auctions::quickiconButton( $link, 'country_manager.png', "Countries" );
				  
				  
				  ?>
		    	</div>
		    	<br clear="all" />
		    	<div id="cpanel">
		    		<?php
					  $link = 'index.php?option=com_bids&amp;task=increment_list';
					  HTML_admin_auctions::quickiconButton( $link, 'min_increase.png', "Min Increase");
					  
					  $link = 'index.php?option=com_bids&amp;task=integration';
					  HTML_admin_auctions::quickiconButton( $link, 'cb_integration.png', "Profile <br /> Integration");
		    		?>
		    	</div>
		    	<br clear="all" />
        	</td>
	        	<td valign="top" align="center" width="400">
		    	<table class="adminform">
		    		<tr>
		    		<td style="text-align:center !important;">
					<strong> Check the Documentation and our forum for FAQ's and quick help</strong><br />
					<a href="http://www.thefactory.ro/shop/joomla-components/auction-factory.html"><img src="http://www.thefactory.ro/components/com_virtuemart/shop_image/product/691d18403ccd7476f3035c8252fe0ee2.jpg" /></a>
					<br />
					<a href="http://www.thefactory.ro/support/faq/" target="_blank">http://www.thefactory.ro/support/faq/</a><br>
					<a href="http://www.thefactory.ro/component/option,com_smf/Itemid,40/" target="_blank">http://www.thefactory.ro/component/option,com_smf/Itemid,40/</a><br>
					<br>
					Give us your feedback!<br /> Please <a href="http://extensions.joomla.org/extensions/e-commerce/auction/8772?qh=YToyOntpOjA7czo3OiJhdWN0aW9uIjtpOjE7czo4OiJhdWN0aW9ucyI7fQ%3D%3D" target="_blank">vote for our components and modules on Joomla Extensions</a><br>
		    		</td>
		    		</tr>
				</table>	
        	</td>
        </tr>
        </table>

        <?php
    }
    function showDashbord(){

    	$database = & JFactory::getDBO();
    	
		$database->setQuery("SELECT p.*,u.username, a.title as object_item 
    	   FROM ".PAYTABLE_PAYLOG." AS p
    	   LEFT JOIN #__users u ON p.userid=u.id 
    	   LEFT JOIN ".PAYTABLE_PAYITEMS_TABLE." as a ON p.object_id = a.id 
    	   $where 
    	   ORDER BY date DESC",0,5);
      $pay_list=$database->loadObjectList();
      
      $database->setQuery("SELECT a.*, u.username FROM #__bid_auctions as a LEFT JOIN #__users as u ON a.userid = u.id ORDER BY a.start_date DESC,id DESC",0,5);
      $auctions = $database->loadObjectList();
      
		$database->setQuery("SELECT a.*, bu.id as filled "
			. " FROM #__users AS a "
			. " LEFT JOIN #__bid_users as bu ON a.id = bu.userid "
			." ORDER BY registerDate DESC ",0,5);
      $users = $database->loadObjectList();
      
    	?>
        <table width="100%">
        <tr>
        	<td width="60%" valign="top">
		    	<div id="cpanel">
				<?php
				  $link = 'index.php?option=com_bids&amp;task=offers';
				  HTML_admin_auctions::quickiconButton( $link, 'settings.png', JText::_("Auctions") );
		
				  $link = 'index.php?option=com_bids&amp;task=payments';
				  HTML_admin_auctions::quickiconButton( $link, 'paymentconfig.png', bid_payment );
		
				  $link = 'index.php?option=com_bids&amp;task=reported_offers';
				  HTML_admin_auctions::quickiconButton( $link, 'settings.png', "Reported Auctions" );
				  
				  $link = 'index.php?option=com_bids&amp;task=statistics';
				  HTML_admin_auctions::quickiconButton( $link, 'add_db.png', "Statistics" );
				  
				  
				  ?>
		    	</div>
		    	<br clear="all" />
	        	<?php
				jimport('joomla.html.pane');
				$pane	= &JPane::getInstance('sliders', array('allowAllClose' => true));
				
	        	?>
				<?php
					echo $pane->startPane("content-pane");
					$title = JText::_( 'Latest auctions' );
					echo $pane->startPanel(  $title , "fields_pane" );
				?>	
				<table class="adminlist">
					<thead>
					<tr>
						<td>#</td>
						<td>Auction</td>
						<td>Date</td>
						<td>By</td>
					</tr>
					</thead>
					<?php 
					if(count($auctions)) { 
					foreach ($auctions as $k => $item ){ ?>
					<tr class="row1">
						<td><?php echo $k+1;?></td>
						<td><?php echo $item->title;?></td>
						<td><?php echo $item->start_date;?></td>
						<td><?php echo $item->username;?></td>
					</tr>
					<?php } ?>
					<?php }else{ ?>
					<tr>
						<td colspan="4">No auctions!</td>
					</tr>
					<?php } ?>
				</table>
				<?php
					echo $pane->endPanel();
					$title = JText::_( 'Latest payments' );
					echo $pane->startPanel( $title, "settings_pane" );
				?>
				<table class="adminlist">
					<thead>
					<tr>
						<td>#</td>
						<td>Payment Pricing</td>
						<td>User</td>
						<td>Date</td>
						<td>Amount</td>
					</tr>
					</thead>
					<?php if(count($pay_list)){ ?>
					<?php foreach ($pay_list as $p => $price){ ?>
					<tr class="row<?php echo (int)($p%2);?>">
						<td><?php echo $p+1;?></td>
						<td><?php echo $price->itemname;?></td>
						<td><?php echo $price->username;?></td>
						<td><?php echo $price->date;?></td>
						<td><?php echo $price->amount." ".$price->currency;?></td>
					</tr>
					<?php } ?>
					<?php }else{ ?>
					<tr>
						<td colspan="5">No payments received!</td>
					</tr>
					<?php } ?>
				</table>
				<?php
					echo $pane->endPanel();
					$title = JText::_( 'Latest registered users' );
					echo $pane->startPanel( $title, "settings_pane" );
				?>
				<table class="adminlist">
					<thead>
						<tr>
							<td>#</td>
							<td>User</td>
							<td>Auctioneer Profile</td>
							<td>Registered</td>
						</tr>
					</thead>
					<?php if ($users){ foreach ($users as $k => $user){ ?>
					<tr class="row<?php echo (int)($k%2);?>">
						<td><?php echo $k+1;?></td>
						<td><?php echo $user->username;?></td>
						<td><?php 
						$filled = (int)((bool)$user->filled);
						if ($filled) {
							echo "Filled";
						}else echo "--";
						?>
						</td>
						<td><?php echo $user->registerDate;?></td>
					</tr>
					<?php } ?>
					<?php }else{ ?>
					<tr>
						<td colspan="4">No users register!</td>
					</tr>
					<?php } ?>
				</table>
			<?php
			echo $pane->endPanel();
			echo $pane->endPane();
			?>
		    	
        	</td>
	        	<td valign="top" align="center" width="400" height="100%">
		    	<table class="adminform" height="100%">
		    		<tr>
		    		<td style="text-align:center !important;" valign="top">
					<strong> Check the Documentation and our forum for FAQ's and quick help</strong><br />
					<a href="http://www.thefactory.ro/shop/joomla-components/auction-factory.html"><img src="http://www.thefactory.ro/components/com_virtuemart/shop_image/product/691d18403ccd7476f3035c8252fe0ee2.jpg" /></a>
					<br />
					<a href="http://www.thefactory.ro/support/faq/" target="_blank">http://www.thefactory.ro/support/faq/</a><br>
					<a href="http://www.thefactory.ro/component/option,com_smf/Itemid,40/" target="_blank">http://www.thefactory.ro/component/option,com_smf/Itemid,40/</a><br>
					<br>
					Give us your feedback!<br /> Please <a href="http://extensions.joomla.org/extensions/e-commerce/auction/8772?qh=YToyOntpOjA7czo3OiJhdWN0aW9uIjtpOjE7czo4OiJhdWN0aW9ucyI7fQ%3D%3D" target="_blank">vote for our components and modules on Joomla Extensions</a><br>
		    		</td>
		    		</tr>
				</table>	
				
        	</td>
        </tr>
        </table>

        <?php
    }
    
    function BidStats(&$rows,&$lists,&$pageNav){
    	?>
    	<form name="adminForm" method="POST">
    		<table>
    			<tr>
    				<td>
					<?php echo $lists['orderid'];?>
					<?php echo $lists['orderdir'];?>
					</td>
   				</tr>
    		</table>
    		<table class="adminform" width="100%">
    			<tr>
    				<th width="60">Auction ID</th>
                    <th>Auction Title</th>
                    <th>Bid Amount</th>
                    <th>Proxy</th>
                    <th>Date</th>
                    <th><?php echo bid_username;?></th>
                    <th><?php echo bid_accepted;?></th>
    			</tr>
				<?php
				foreach($rows as $li => $item){
					?>
					<tr>
						<td align="center"><?php echo $item->id_offer;?></td>
						<td align="center"><a href="index.php?option=com_bids&task=editoffer&id=<?php echo $item->id_offer;?>"><?php echo $item->offer;?></a></td>
						<td align="center"><?php echo $item->bid_price;?></td>
						<td align="center"><?php if($item->proxy) echo "Proxy"; else echo "----";?></td>
						<td align="center"><?php echo $item->modified;?></td>
						<td align="center"><?php echo $item->username;?></td>
						<td align="center"><?php if($item->accepted) echo "Winner"; else echo "----";?></td>
					</tr>
					<?php
				}
				?>
    		</table>
    		<?php echo $pageNav->getListFooter(); ?>
	      <input type="hidden" name="option" value="com_bids" />
	      <input type="hidden" name="task" value="bid_stats" />
		</form>   	
    	<?php
    }
}
?>
