<?php 
/**
 * Payments Controller
 * 
 * 
 * @version 1.2.0 (JTheFactory version)
 * 
 * @package:JTheFactory Framework
 * @subpackage:Payments Management
 * 
**/


class FactoryPaymentsController{
	
	var $_db 	= null;
	
	
	function checkTask( $act )
	{
		$this->_db = &FactoryLayer::getDB();
		
		$method_name = $act;
		
		if ( method_exists($this,$method_name) ){
			require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."payments.toolbar.php");
			$this->$method_name();
			return true;
		}

		return false;
	}
	
	function payments(){
		
		$payment=&JTheFactoryPaymentLib::getInstance();
        $payment->showPaymentLog();
        return true;
		
	}
	
    function new_payment()
    {
		$payment=&JTheFactoryPaymentLib::getInstance();
        $payment->showAddNewPayment();
        return true;
    }
    
	function Save_Payment() {
        
		$payment=&JTheFactoryPaymentLib::getInstance();
        $payment->saveAddNewPayment();
        $japp=&JFactory::getApplication();
        $japp->redirect('index.php?option='.APP_EXTENSION.'&task=payments',JText::_('New Payment saved'));
        return true;
        
	}
	
    function Approve_Payment() {
    	
		$payment=&JTheFactoryPaymentLib::getInstance();
        $payment->approvePayment();
        $japp=&JFactory::getApplication();
        $japp->redirect('index.php?option='.APP_EXTENSION.'&task=payments',JText::_('Payment Approved'));
        return true;
        
	}
	
	function togglePayment()
	{
		$payment=&JTheFactoryPaymentLib::getInstance();
        $payment->enablePaymentGateway();
        $japp=&JFactory::getApplication();
        $japp->redirect('index.php?option='.APP_EXTENSION.'&task=paymentconfig',JText::_('Enable Toggled'));
    	return true;
		
	}
	
	function deletePaylog(){
		$payment=&JTheFactoryPaymentLib::getInstance();
        $payment->deletePaylog();
        $japp=&JFactory::getApplication();
        $japp->redirect('index.php?option='.APP_EXTENSION.'&task=payments',JText::_('Payments Deleted!'));
		
	}
	
}