<?php 
/**
 * Payments Pricing Items Controller
 * 
 * 
 * @version 1.2.0 (JTheFactory version)
 * 
 * @package:JTheFactory Framework
 * @subpackage:Pricing Items Management
 * 
**/


class FactoryPricingsController{
	
	var $_db 	= null;
	
	
	function checkTask( $act )
	{
		$this->_db = &FactoryLayer::getDB();
		
		$method_name = $act;
		
		if ( method_exists($this,$method_name) ){
			require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."pricings.toolbar.php");
			$this->$method_name();
			return true;
		}

		return false;
	}
	
    function PaymentItems()
    {
		$payment=&JTheFactoryPaymentLib::getInstance();
        $payment->showAvailablePaymentItems();
        return true;
    }
    function PaymentItemsConfig()
    {
		$payment=&JTheFactoryPaymentLib::getInstance();
    	$classname = 'price_'.JRequest::getVar('itemname','');

    	$payment->showPaymentItemConfig($classname);
    	return true;

    }
    function SavePaymentItemsConfig()
    {
		$payment=&JTheFactoryPaymentLib::getInstance();
    	$classname = 'price_'.JRequest::getVar('itemname','');

    	$payment->savePaymentItemConfig($classname);
        $japp=&JFactory::getApplication();
        $japp->redirect('index.php?option='.APP_EXTENSION.'&task=paymentitems',JText::_('Settings Saved'));
    	return true;
    }
    function Save_Payment_Item_Order()
    {
		$payment=&JTheFactoryPaymentLib::getInstance();
        $payment->savePaymentItemOrdering();
        $japp=&JFactory::getApplication();
        $japp->redirect('index.php?option='.APP_EXTENSION.'&task=paymentitems',JText::_('Order Saved'));
    	return true;

    }
    function EnablePaymentItem()
    {
		$payment=&JTheFactoryPaymentLib::getInstance();
        $payment->enablePaymentItem();
        $japp=&JFactory::getApplication();
        $japp->redirect('index.php?option='.APP_EXTENSION.'&task=paymentitems',JText::_('Enable Toggled'));
    	return true;

    }
	
}