<?php 
/**
 * Reviews Controller
 * 
 * 
 * @version 1.0.0 (JTheFactory version)
 * 
 * @package:JTheFactory Framework
 * @subpackage:Reviews Management
 * 
**/


class FactoryReviewsController{
	
	var $_db 	= null;
	var $_model = null;
	
	
	function checkTask( &$act )
	{
		$this->_db = &FactoryLayer::getDB();
		if(!$act)
			$act="list_reviews";
			
		$method_name = $act;
		if ( method_exists($this,$method_name) ){
			//require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."reviews.toolbar.php");
			$this->$method_name();
			return true;
		}

		return false;
	}
	
	function del_review(){
		
		$id = FactoryLayer::getRequest($_REQUEST,"id");
		$this->_db->setQuery("DELETE FROM #__bid_rate WHERE id = $id");
		$this->_db->query();
		FactoryLayer::redirect("index.php?option=".F_COMPONENT_NAME."&task=reviews_administrator","Review removed!");
	}
	
	function list_reviews(){
		$app	= JFactory::getApplication();
		$context = "";
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		$limitstart = ( $limit != 0 ? (floor($limitstart / $limit) * $limit) : 0 );

		$this->_db->setQuery("SELECT COUNT(*) FROM #__bid_rate");
		$total = $this->_db->loadResult();
		
		$page = FactoryLayer::initPagination($total, $limitstart, $limit);
		$rows =$this->_model->getList();
		
		require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."reviews_list.php");
		return true;
	}
	
}
