<?php 
/**
 * Shipping Controller
 * 
 * 
 * @version 1.0.0 (JTheFactory version)
 * 
 * @package:JTheFactory Framework
 * @subpackage:Shipping Management
 * 
**/


class FactoryShippingController{
	
	var $_db 	= null;
	var $_model = null;
	
	
	function checkTask( &$act )
	{
		$this->_db = &FactoryLayer::getDB();
		if(!$act)
			$act="list_shipping_zones";
			
		$method_name = $act;
		if ( method_exists($this,$method_name) ){
			require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."shipping.toolbar.php");
			$this->$method_name();
			return true;
		}

		return false;
	}
	
	function del_shipping(){
		
		$id = FactoryLayer::getRequest($_REQUEST,"id");
		
		$shipping_zone = new JAuctionShipZones($database);
		$shipping_zone->delete($id);
		
		FactoryLayer::redirect("index.php?option=".F_COMPONENT_NAME."&task=shipping_administrator","Shipping zone removed!");
	}
	
	function zone_save(){
		
		$db = &JFactory::getDBO();
		$id = FactoryLayer::getRequest($_REQUEST,"id");
		$shipping_zone = new JAuctionShipZones($db);
		$shipping_zone->bind($_POST);
		$shipping_zone->store();
		FactoryLayer::redirect( JURI::root()."administrator/index.php?option=com_bids&task=shipping_administrator", bid_item_saved);
	}
	
	function zone_edit(){
		
		$db = &JFactory::getDBO();
		$id = FactoryLayer::getRequest($_REQUEST,"id");
		$shipping_zone = new JAuctionShipZones($db);
		$shipping_zone->load($id);
		ob_end_clean();
		require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."shipping_zone_edit.php");
		jexit();
		return true;
	}
	
	function list_shipping_zones(){
		
		$app	= JFactory::getApplication();
		$context = APP_EXTENSION."shipping";
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		$limitstart = ( $limit != 0 ? (floor($limitstart / $limit) * $limit) : 0 );

		$this->_db->setQuery("SELECT COUNT(*) FROM #__bid_rate");
		$total = $this->_db->loadResult();
		
		$page = FactoryLayer::initPagination($total, $limitstart, $limit);
		
		$p = new JAuctionShipZones($this->_db);
		$rows = $p->getList();
		JHTML::_("behavior.modal");
		require_once(dirname(__FILE__).DS."..".DS."tmpl".DS."shipping_zones_list.php");
		return true;
	}
	
}
