<?php
/**
 * @package AuctionsFactory
 * @version 2.0.2
 * @copyright www.thefactory.ro
 * @license: commercial
 * @modified:19/11/2010
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

function auctions_filter_this(&$value, $index){
	$value = "'".(int)$value."'";
}



/**
 * 
 * @deprecated 
 * 
 * @use TheFactory Image
 *
*/
function resize_image($picture,$width,$height,$prefix){

    require_once(JPATH_COMPONENT_SITE.DS.'thefactory'.DS.'front.images.php');
	$imgTrans = new JTheFactoryImages();
	return 	$imgTrans->resize_image(AUCTION_PICTURES_PATH.DS.$picture, $width, $height, $prefix);
}

/**
 * 
 * @deprecated 
 * 
 * @use or include TheFactory Image
 *
*/
function resize_to_filesize($file,$outputfile,$maxfilesize)
{
    require_once(JPATH_COMPONENT_SITE.DS.'thefactory'.DS.'front.images.php');
	$imgTrans = new JTheFactoryImages();
	
	return $imgTrans->resize_to_filesize(AUCTION_PICTURES_PATH.DS.$file, $outputfile, $maxfilesize );
	
}

function ImportFromCSV($option,$withids=0)
{
 	global $Itemid,$task;
 	$database = & JFactory::getDBO();
 	$my = & JFactory::getUser();
 	
	jimport('joomla.filesystem.file');
 	
 	require_once( JPATH_ROOT . '/administrator/includes/pcl/pclzip.lib.php' );
	require_once( JPATH_ROOT . '/administrator/includes/pcl/pclerror.lib.php' );
	$tmpdir 		= uniqid( 'images_' );
	$base_Dir 		= JPath::clean( JPATH_ROOT.DS.'media' ).DS;
	$extractdir 	= JPath::clean( $base_Dir . $tmpdir ).DS;
	// ERROR REPORTING
	@error_reporting(E_ALL ^ E_NOTICE); 
	@ini_set("display_errors", 1); 
	@ini_set("display_startup_errors",1);
 
	define('_TMP_DIR',JPATH_ROOT."/media/");
	$msg="&mosmsg=";
	$shipzones = null;
	if(defined('bid_opt_multiple_shipping') && bid_opt_multiple_shipping==1){
		$database->setQuery("SELECT id,name FROM `#__bid_shipment_zones`");
		$shipzones = $database->loadObjectList("name");
	}
	
	$auction = new JAuctions($database);
	$errors=array();
	if($_FILES['csv']['tmp_name']){
		$csv_fname = $_FILES['csv']['name'];
		$ext=substr($csv_fname, strrpos($csv_fname, '.')+1, strlen($csv_fname));
		 if($ext!="csv"){
		 	$msg .= bid_err_csv_ext_not_allowed;
		 }
	    $upload_path = _TMP_DIR.$csv_fname;
		if(!move_uploaded_file($_FILES['csv']['tmp_name'],$upload_path)){
			$msg .= bid_err_csv_import_error;
		}
		@chmod($upload_path,0777);
		if(!file_exists($upload_path)){
			$msg .= bid_err_file_not_there;
		}
		$handle = fopen($upload_path, "r");
		set_time_limit(0);
		$i=1;
		while (($data = fgetcsv($handle, 30000, "\t")) !== FALSE) {
		 //	var_dump($data);echo"<br>";
		 	$params['picture'] = $data[15];
		 	$params['add_picture'] = $data[16];
		 	$params['auto_accept_bin'] = $data[17];
		 	$params['bid_counts'] = $data[18];
		 	$params['max_price'] = $data[19];
		 	if (is_array( $params )) {
				$txt = array();
				foreach ( $params as $k=>$v) {
					$txt[] = "$k=$v";
				}
				$auction->params = implode( "\n", $txt );
			}
            $auction->id = null;
		 	$auction->title = strip_tags($data[1]);
		 	$auction->shortdescription =  strip_tags($data[2]);
		 	$auction->description = preg_replace('/<script[^>]*?>.*?<\/script>/si','',$data[3]); //de testat
		 	$auction->picture = $data[4];
		 	$auction->link_extern = $data[5];
		 	$auction->initial_price =floatval($data[6]);
	 	    if(is_numeric($data[7]))
		 	    $auction->currency = $data[7];
		 	else
		 	    $auction->SetCurrency($data[7]);
		 	$auction->BIN_price = floatval($data[8]);
		 	$auction->auction_type = $data[9];
	 		switch ($auction->auction_type){
	 			case 'public':
					$auction->auction_type = 1;
				break;
				case 'private':
					$auction->auction_type = 2;
				break;
	 		}
		 	$auction->automatic = $data[10];
		 	
			if(bid_opt_payment_select_mode==1)
			 	$auction->SetPaymentMethod($data[11]);
			 	
		 	$auction->shipment_info = $data[12];
		 	$auction->start_date = date("Y-m-d H:i:s",strtotime($data[13]));
		 	$auction->end_date = date("Y-m-d H:i:s",strtotime($data[14]));
		 	$auction->published = $data[20];
		 	$auction->SetCategory($data[21]);
            if ($withids!=0 && intval($data[0])>0)
 			    $auction->userid=$data[0];
		 	else
 			    $auction->userid=$my->id;
			$auction->auction_nr=time().rand(100,999);
			
 			$err = $auction->check();
		 	if(count($err)<=0) {
		 		$auction->store();
				if(bid_opt_payment_select_mode==0){
					
					$payment_list = $data[11];
					if($payment_list!=""){
						$pss = explode(",",$payment_list);
						$pssq = "'".implode( "','" , $pss )."'";
					
						$database->setQuery("SELECT id FROM `#__bid_payment` WHERE name IN ($pssq) ;");
						$pArr = $database->loadObjectList();
						
						$slsl = array();
						foreach ( $pArr as $p ){
							$slsl[] = "(NULL,$auction->id,$p->id)";
						}
						$database->setQuery("DELETE FROM `#__bid_auct_payments` WHERE auct={$auction->id}");
						$database->query();
						$database->setQuery("INSERT INTO `#__bid_auct_payments` VALUES ".implode(",",$slsl));
						$database->query();
					}
					
					
				}
		 		if($_FILES['arch']['tmp_name']){
		 			$upload_arch = $base_Dir.$_FILES['arch']['name'];
		 			if(!move_uploaded_file($_FILES['arch']['tmp_name'],$upload_arch)){
						$msg .= bid_err_csv_import_error;
					}
					@chmod($upload_arch,0777);
					$archivename 	= $upload_arch;
					@mkdir($extractdir);
					$archivename 	= JPath::clean( $archivename );
					$zipfile = new PclZip( $archivename );
					if(!defined("OS_WINDOWS")){
				 		if(substr(PHP_OS, 0, 3) == 'WIN') {
							define("OS_WINDOWS",1);
						} else {
							define("OS_WINDOWS",0);
						}
					}
					//echo $archivename;
					$ret = $zipfile->extract( PCLZIP_OPT_PATH, $extractdir );
					if($ret == 0) {
						die( 'Unrecoverable error '.$zipfile->errorName(true).'"' );
					}
					$arr_pics = array();
					$k=22;
					$j=32;
					// J ia valoarea lui "Shipment"
					if($shipzones != null){
						$sh = array_search("Shipment",$data);
						if($sh!=false)
							$j=$sh;
					}
					
					for($m=$k;$m<$j;$m++){
						if($data[$m])
							$arr_pics[] = $data[$m];
					}

					//insert pics in db<br>
					if($auction->picture){
						if(file_exists($extractdir.$auction->picture)){
							$fname = $auction->picture;
							$ext=JFile::getExt($fname);
							if(!$auction->isAllowedImage($ext)){
					          $msg .= bid_err_not_allowed_ext.': '.$file['name'];
					        }else{
                               if(filesize($extractdir.$auction->picture)>bid_opt_max_picture_size*1024){
                                    $msg.=$auction->picture."- ".bid_err_imagesize_too_big."<br><br>";
                               }else{
            				        $file_name=$auction->id."_".$fname.'.'.$ext;
            						$path= AUCTION_PICTURES_PATH."$file_name";
                                    @unlink($path);
            						if(rename(JPATH_ROOT."/media/".$tmpdir."/".$auction->picture, $path)) {
                				    resize_image($file_name,bid_opt_thumb_width,bid_opt_thumb_height,'resize');
                				    resize_image($file_name,bid_opt_medium_width,bid_opt_medium_height,'middle');
            						$auction->picture=$file_name;
                                    $auction->store();
            					    }else{
            						     $msg.=$auction->picture."- ".bid_err_upload_failed."<br><br>";
            					    }
                               }
					        }
						}
					}
					
				    $nrfiles=0;
					for($m=0;$m<count($arr_pics);$m++){
					    if ($nrfiles>=bid_opt_maxnr_images) continue;
						if(file_exists($extractdir.$arr_pics[$m])) {
                           if(filesize($extractdir.$arr_pics[$m])>bid_opt_max_picture_size*1024){
                                $msg.=$arr_pics[$m]."- ".bid_err_imagesize_too_big."<br><br>";
                                continue;
                           }
							$fname = $arr_pics[$m];
							$ext=JFile::getExt($fname);
					        if(!$auction->isAllowedImage($ext)){
					          $msg .= bid_err_not_allowed_ext.': '.$file['name'];
					          continue;
					        }
					        $file_name=$fname.'.'.$ext;
							$pic=new JAuctionImages($database);
							$pic->id_offer=$auction->id;
							$pic->userid=$my->id;
							$pic->picture=$file_name;
							$pic->modified=date("Y-m-d H:i:s",time());
		          			$pic->store();
							$file_name=$auction->id."_img_$pic->id.$ext";
							$pic->picture=$file_name;
							$pic->store();
							$path= AUCTION_PICTURES_PATH."$file_name";
							if(rename(JPATH_ROOT."/media/".$tmpdir."/".$arr_pics[$m], $path)) {
            				    resize_image($file_name,bid_opt_thumb_width,bid_opt_thumb_height,'resize');
            				    resize_image($file_name,bid_opt_medium_width,bid_opt_medium_height,'middle');
		      				}else{
				    			$msg.=$arr_pics[$m]."- ".bid_err_upload_failed."<br><br>";
					       	}
					       	$nrfiles++;
						}
					}
		 		}//arch pics
		 		
				// m ia valoarea indexului lui "Shipment" + 1
				if($shipzones != null){
					
					$arr_ships = array();
					$m = array_search("Shipment",$data);
					$m = $m+1;
					while($m && $data[$m]){
						if(!$data[$m]){
							break;
						}else{
							$ship_id = false;
							if(isset($shipzones[$data[$m]]))
								$ship_id = $shipzones[$data[$m]]->id;
							if($ship_id!==false){
								$arr_ships[] = "(NULL, {$ship_id} , {$data[$m+1]}, {$auction->id})";
							}
						}
						$m=$m+2;
					}
					
					if( count($arr_ships) ){
						$sql_ships = "INSERT INTO #__bid_shipment_prices VALUES ".implode(",",$arr_ships);
						$database->setQuery($sql_ships);$database->query();
					}
				}
		 	}else
		 		$errors[] ="$i : ".join('<br>',$err);
		 	$i++;
		 }
		if(file_exists($extractdir)){
			 JFolder::delete($extractdir);
		}
		 fclose($handle);
		if(file_exists($base_Dir.$_FILES['csv']['name']))
		 unlink($base_Dir.$_FILES['csv']['name']);
		if(file_exists($base_Dir.$_FILES['csv']['name']))
		 unlink($base_Dir.$_FILES['arch']['name']);

	}
	return $errors;
}

/**
 * @author: psorin
 *
 * @deprecated use TheFactory XLS Export and custom fields.
 */
function createXLS($result){
	$database = &JFactory::getDBO();
	ob_clean ();
	ob_start ();
	set_time_limit ( 0 );
	require_once (JPATH_ROOT.'/components/com_bids/Excel/Writer.php');
	require_once JPATH_ROOT.'/components/com_bids/PEAR.php';
	// Creating a workbook
	$workbook = new Spreadsheet_Excel_Writer();
	$worksheet =& $workbook->addWorksheet('Exported Auctions');
	$BIFF = new Spreadsheet_Excel_Writer_BIFFwriter();
	$format = new Spreadsheet_Excel_Writer_Format($BIFF);
	$format->setBold(1);
	$format->setAlign('center');

	$worksheet->write( 0, 0, "User", $format );
	$worksheet->write( 0, 1, "Title" , $format );
	$worksheet->write( 0, 2, "Short description" );
	$worksheet->write( 0, 3, "Description" );
	$worksheet->write( 0, 4, "Picture" );
	$worksheet->write( 0, 5, "External Link" );
	$worksheet->write( 0, 6, "Initial price" );
	$worksheet->write( 0, 7, "Currency" );
	$worksheet->write( 0, 8, "BIN price" );
	$worksheet->write( 0, 9, "Auction type" );
	$worksheet->write( 0, 10, "Automatic" );
	$worksheet->write( 0, 11, "Payment" );
	$worksheet->write( 0, 12, "Shipment Info" );
	$worksheet->write( 0, 13, "Start date" );
	$worksheet->write( 0, 14, "End date" );
	$worksheet->write( 0, 15, "Param: picture" );
	$worksheet->write( 0, 16, "Param: add_picture" );
	$worksheet->write( 0, 17, "Param: auto_accept_bin" );
	$worksheet->write( 0, 18, "Param: bid_counts" );
	$worksheet->write( 0, 19, "Param: max_price" );
	$worksheet->write( 0, 20, "Published" );
	$worksheet->write( 0, 21, "Category" );
	$worksheet->write( 0, 22, "Highest Bid" );
	for($i = 0; $i< count($result); $i++){
		$worksheet->write( $i+1, 0, $result[$i]->username );
		$worksheet->write( $i+1, 1, $result[$i]->title );
		$worksheet->write( $i+1, 2, $result[$i]->shortdescription );
		$worksheet->write( $i+1, 3, $result[$i]->description );
		$worksheet->write( $i+1, 4, $result[$i]->picture );
		$worksheet->write( $i+1, 5, $result[$i]->link_extern );
		$worksheet->write( $i+1, 6, $result[$i]->initial_price );
		$worksheet->write( $i+1, 7, $result[$i]->currency_name );
		$worksheet->write( $i+1, 8, $result[$i]->BIN_price );
 		switch ($result[$i]->auction_type){
 			case '1':
				$worksheet->write( $i+1, 9, 'public' );
			break;
			case '2':
				$worksheet->write( $i+1, 9, 'private' );
			break;
 		}
		$worksheet->write( $i+1, 10, $result[$i]->automatic );
		$worksheet->write( $i+1, 11, $result[$i]->payment_name );
		$worksheet->write( $i+1, 12, $result[$i]->shipment_info );
		$worksheet->write( $i+1, 13, $result[$i]->start_date );
		$worksheet->write( $i+1, 14, $result[$i]->end_date );
		$params = explode( "\n", $result[$i]->params );
		$tmp = explode( "=", $params[0]); // picture param
		$worksheet->write( $i+1, 15, $tmp[1] );
		$tmp = explode( "=", $params[1]); // add_picture
		$worksheet->write( $i+1, 16, $tmp[1] );
		$tmp = explode( "=", $params[2]); // auto_accept_bin
		$worksheet->write( $i+1, 17, $tmp[1] );
		$tmp = explode( "=", $params[3]); // bid_counts
		$worksheet->write( $i+1, 18, $tmp[1] );
		$tmp = explode( "=", $params[4]); // max_price
		$worksheet->write( $i+1, 19, $tmp[1] );

		$worksheet->write( $i+1, 20, $result[$i]->published );
		$worksheet->write( $i+1, 21, $result[$i]->cat );
		$worksheet->write( $i+1, 22, $result[$i]->highest_bid );

		$worksheet->setColumn(0,0,9);
		$worksheet->setColumn(1,12,25);
	}
	$workbook->close();
	$attachment = ob_get_contents();
	@ob_end_clean();
	return $attachment;
}


?>