<?php
/**
 * @package AuctionsFactory
 * @version 2.0.2
 * @copyright www.thefactory.ro
 * @license: commercial
 * @modified: 19.11.10
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

//================================= BIDS ============================
require_once ($mainframe->getPath('class', $option));
if (defined("bid_opt_gallery")) {
    require_once (JPATH_COMPONENT_SITE . "/gallery/gl_" . bid_opt_gallery . ".php");
} else
    require_once (JPATH_COMPONENT_SITE . "/gallery/gl_lytebox.php");

class HTML_Auction_helper
{

    function bulkimport($Itemid, $option, $errors=null)
    {
        $database = &JFactory::getDBO();

?>
		<script language="javascript" type="text/javascript">
			function validateForm(){
				var csv = document.getElementById('csv');
				if(!csv.value){
					alert('<?php echo bid_err_csv_no_file; ?>');
					return false;
				}
			}
		</script>
		  <form action="<?php echo JURI::root(); ?>/index.php" method="post" name="auctionForm" onsubmit="return validateForm();" enctype="multipart/form-data">
		  <input type="hidden" name="option" value="com_bids">
		  <input type="hidden" name="task" value="importcsv">
		  <input type="hidden" name="Itemid" value="<?php echo $Itemid; ?>">
		  <table width="100%" class="contentpaneopen">
			<tr><th colspan="2"><?php echo bid_auctions_bulk_import; ?></th></tr>
			<tr>
				<td><?php echo bid_csv_file, JHTML::tooltip(bid_help_uploadcsv); ?></td>
				<td><input type="file" name="csv" id="csv"></td>
			</tr>
			<tr>
				<td><?php echo bid_csv_img_arch, JHTML::tooltip(bid_help_uploadimg); ?></td>
				<td><input type="file" name="arch" id="arch"></td>
			</tr>
			<tr>
				<td colspan="2"><input type="submit" name="send" value="<?php echo but_save; ?>" class="back_button" /></td>
			</tr>
		  </table>
		  </form>
		<div align="left">
		<?php
        if (count($errors) > 0) {
            for ($i = 1; $i <= count($errors); $i++) {
                if ($errors[$i]) {
                    echo bid_line . " " . $errors[$i] . '<br>';
                }
            }
        }
?>
		</div>
		<?php
    }
}

class HTML_Auction
{

    function _CreateLinksArray(&$auction)
    {
        global $Itemid, $task;
        
        $ItemIdList = new stdClass();
        

        // List Auctions, Auction Details
        $tmp_id = BidsUtilities::getMenuItemId(array("task"=>"listauctions"),1);
        if( !$tmp_id )
	        $tmp_id = BidsUtilities::getMenuItemId(array("view"=>"auctions", "layout"=>""));
        if( !$tmp_id )
        	$tmp_id = $Itemid;
        	
        $ItemIdList->listauctions = $tmp_id;
        
        // New Auctions
        $tmp_id = BidsUtilities::getMenuItemId(array("task"=>"newauction"),1);
        if( !$tmp_id )
	        $tmp_id = BidsUtilities::getMenuItemId(array("view"=>"auction", "layout"=>"form"));
        if( !$tmp_id )
				$tmp_id = $Itemid;
        $ItemIdList->newauction = $tmp_id;

        $links = array();

        $links['otherauctions'] = JRoute::_('index.php?option=com_bids&amp;task=listauctions&amp;userid=' .$auction->userid . '&amp;Itemid=' . $ItemIdList->listauctions);
        $links['auctiondetails'] =  JRoute::_('index.php?option=com_bids&task=viewbids&id=' .$auction->id . '&Itemid=' . $ItemIdList->listauctions);
        $links['bids'] =  JRoute::_('index.php?option=com_bids&task=viewbids&id=' . $auction->id . '&Itemid=' . $ItemIdList->listauctions) . '#bid';
        $links['bid_list'] =  JRoute::_('index.php?option=com_bids&task=viewbids&id=' .$auction->id . '&Itemid=' . $ItemIdList->listauctions) . '#bid_list';
        $links['edit'] =  JRoute::_('index.php?option=com_bids&amp;view=auction&amp;task=editauction&amp;id=' .$auction->id . '&amp;Itemid=' . $ItemIdList->listauctions);
        $links['cancel'] =  JRoute::_('index.php?option=com_bids&amp;task=cancelauction&amp;id=' .$auction->id . '&amp;Itemid=' . $Itemid);
        $links['publish'] =  JRoute::_('index.php?option=com_bids&amp;task=publish&amp;Itemid=' .$Itemid . '&amp;id=' . $auction->id);
        $links['filter_cat'] =  JRoute::_("index.php?option=com_bids&task=listauctions&cat=$auction->cat&Itemid={$ItemIdList->listauctions}");
        $links['republish'] =  JRoute::_('index.php?option=com_bids&amp;task=republish&amp;Itemid=' .$Itemid . '&amp;id=' . $auction->id);
        $links['messages'] =  JRoute::_('index.php?option=com_bids&amp;task=viewbids&amp;Itemid=' .$ItemIdList->listauctions . '&amp;id=' . $auction->id) . '#messages';
        $links['rate_auction'] =  JRoute::_('index.php?option=com_bids&amp;task=viewbids&amp;Itemid=' .$ItemIdList->listauctions . '&amp;id=' . $auction->id) . '#bid_list';
        $links['add_to_watchlist'] =  JRoute::_('index.php?option=com_bids&amp;task=watchlist&amp;Itemid=' .$Itemid . '&amp;id=' . $auction->id);
        $links['del_from_watchlist'] =  JRoute::_('index.php?option=com_bids&amp;task=delwatch&amp;Itemid=' .$Itemid . '&amp;id=' . $auction->id);
        $links['pagelinks'] =  JRoute::_('index.php?option=com_bids&amp;task=' . $task .'&amp;Itemid=' . $ItemIdList->listauctions);
        $links['auctioneer_profile'] =  JRoute::_('index.php?option=com_bids&amp;task=ViewDetails&amp;id=' .$auction->userid . '&amp;Itemid=' . $Itemid);
        $links['auctioneer_ratings'] =  JRoute::_('index.php?option=com_bids&amp;view=user&amp;task=userratings&amp;userid=' .$auction->userid . '&amp;Itemid=' . $Itemid);

        $links['report'] =  JRoute::_('index.php?option=com_bids&amp;task=report_auction&amp;id=' .$auction->id . '&amp;Itemid=' . $Itemid);
        $links['bin'] =  JRoute::_('index.php?option=com_bids&amp;task=bin&amp;id=' . $auction->id . '&amp;Itemid=' . $ItemIdList->listauctions);

        $links['new_auction'] =  JRoute::_('index.php?option=com_bids&amp;task=newauction&amp;Itemid=' .$ItemIdList->newauction);
        $links['bulkimport'] =  JRoute::_('index.php?option=com_bids&amp;task=bulkimport&amp;Itemid=' .$Itemid);
        $links['terms'] =  JRoute::_('index.php?option=com_bids&task=terms_and_conditions');

        $links['tags'] = '';
        if (isset($auction->tags) && count($auction->tags) > 0)
            for ($i = 0; $i < count($auction->tags); $i++) {
                if ($auction->tags[$i]) {
                    $href =  JRoute::_('index.php?option=com_bids&amp;task=tags&amp;Itemid=' . $Itemid .
                        '&amp;tag=' . $auction->tags[$i]);
                    $links['tags'] .= "<span id='auction_tag'><a href='$href'>" . trim($auction->
                        tags[$i]) . "</a>" . (($i + 1 < count($auction->tags)) ? "," : "") . "</span>";
                }
            }

        return $links;
    }

    function editAuction(&$auction, $option, $lists, $id = null)
    {
		/*@var $auction JAuctions */
		global $Itemid, $mainframe;
		
		$database = &JFactory::getDBO();
		$task = & JRequest::getCmd("task");
		$my = & JFactory::getUser();


		$auction->_parameters = $auction->ParamsToArray();
		$mainframe->loadEditor = true;

		$editor =& JFactory::getEditor();
		echo $editor->initialise();
        
     if (defined("bid_opt_gallery"))
         $gallery_name = "gl_" . bid_opt_gallery;
     else
         $gallery_name = "gl_lytebox";
		$gallery = new $gallery_name($database, AUCTION_PICTURES);
		$gallery->getGalleryForAuction($auction);

		$doc = &JFactory::getDocument();
		$doc->addScript(JURI::root(true) . "/includes/js/calendar/calendar.js");
		$doc->addScript(JURI::root(true) ."/includes/js/calendar/lang/calendar-en-GB.js");
		$doc->addStyleSheet(JURI::root(true) . "/media/system/css/calendar-jos.css");
		  
		JFilterOutput::objectHTMLSafe($auction, ENT_QUOTES);
		$smarty = BidsUtilities::SmartyLoaderHelper();

		$gallery = new $gallery_name($database, AUCTION_PICTURES);
		if ($task == 'republish') {
		   $old_auction = new JAuctions($database);
		   $old_auction->load($id);
		   $gallery->getGalleryForAuction($old_auction);
		} else
		   $gallery->getGalleryForAuction($auction);
		
		$auction->imagelist = array();
		if (count($gallery->imagelist) >= 1) {
            for ($i = 0; $i < count($gallery->imagelist); $i++) {
                $obj = new stdClass();
                if ($auction->picture != 0) {
                    if (isset($gallery->imagelist_ids[$i + 1])) {
                        $obj->thumbnail = $gallery->getThumb($i + 1, 0);
                        $obj->id = $gallery->imagelist_ids[$i + 1];
                    } else {
                        $obj->id = null;
                    }
                } else {
                    $obj->thumbnail = $gallery->getThumb($i, 0);
                    $obj->id = $gallery->imagelist_ids[$i];
                }
                if ($obj->id)
                    $auction->imagelist[] = $obj;
            }
        }

        $auction->is_my_auction = 1;
        $auction->expired = false;
        if ($auction->start_date && $auction->start_date != '0000-00-00 00:00:00') {
            $auction->start_date_text = date(bid_opt_date_format, strtotime($auction->
                start_date));
        }
        if ($auction->end_date && $auction->end_date != '0000-00-00 00:00:00') {
            if (bid_opt_enable_hour) {
                $dateformat = bid_opt_date_format . " H:i";
                $auction->end_hour = date("H", strtotime($auction->end_date));
                $auction->end_minutes = date("i", strtotime($auction->end_date));
            } else
                $dateformat = bid_opt_date_format;
            $auction->end_date_text = date($dateformat, strtotime($auction->end_date));
        }
        $auction->links = HTML_Auction::_CreateLinksArray($auction);
        $auction->gallery = $gallery->getGallery();
        $auction->thumbnail = $gallery->getThumb(0, 0);

        /* ==> Fixed in Auction Factory 1.5.8 */
        if ($auction->currency) {
            $database->setQuery("select name from #__bid_currency where id='$auction->currency'");
            $auction->currency_name = $database->loadResult();
        }
        if ($auction->payment && !is_array($auction->payment)) {

            $database->setQuery("select name from #__bid_payment where id=$auction->payment");
            $auction->payment_name = $database->loadResult();
        }
        /* <== Fixed in Auction Factory 1.5.8 */

        $auction->username = $my->username;
        $auction->description = mosStripslashes($auction->description);
        $auction->shortdescription = mosStripslashes($auction->shortdescription);
        if ($auction->min_increase == "")
            $auction->min_increase = bid_opt_min_increase;

        // shipping
        if (bid_opt_multiple_shipping) {

            $p = new JAuctionShipZones($database);
            if ($id) {
                $lists["U_shipping_zones"] = $p->getPriceList($id);
            }

            $lists["shipping_zones"] = $p->getList();
        }

        $AuctionParameters = $auction->ParamsToArray();
        if (!$id && bid_opt_allow_user_settings) {
            $p = new JAuctionUserDefaults($database);
            $p->userid = $my->id;
            $lists["user_settings"] = $p->getUserSettings();
            if ($lists["user_settings"])
                foreach ($lists["user_settings"] as $setk => $setting) {
                    $sname = $setting->name;
                    if (isset($AuctionParameters[$sname]))
                        $AuctionParameters[$sname] = $setting->value;
                    else
                        $auction->$sname = $setting->value;

                }

            // bull stuff
            if (isset($auction->end_minute))
                $auction->end_minutes = $auction->end_minute;

            // settting processing
            if ($auction->payment_options) {
                $query = " SELECT id as payment, name " . "\n FROM #__bid_payment " . "\n ORDER BY id ";

                if (bid_opt_payment_select_mode == 0) {
                    $database->setQuery($query);
                    $pays = $database->loadObjectList();
                } else {
                    $pays[] = JHTML::_('select.option','0', bid_types_payment, 'payment', 'name');
                    $database->setQuery($query);
                    $pays = array_merge($pays, $database->loadObjectList());
                }
                $database->setQuery("SELECT id as payment, name FROM #__bid_payment WHERE id IN ({$auction->payment_options})");
                $plist = $database->loadObjectList();

                $lists['payment'] = JHTML::_('select.genericlist',$pays, 'payment[]',
                    'class="inputbox" multiple="multiple" alt="payment"', 'payment', 'name', $plist);
            }

            if ($auction->auction_type) {
                $lists['auctiontype'] = BidsHTML::selectAuctionType($auction->auction_type);
            }

            if ($auction->currency) {

                $query = "SELECT id as value, name as text " . "\n FROM #__bid_currency" . "\n ORDER BY id";
                $opts = null;
                $database->setQuery($query);
                $opts = $database->loadObjectList();
                $lists['currency'] = JHTML::_('select.genericlist',$opts, 'currency',
                    'class="inputbox" size="1"', 'value', 'text', $auction->currency);

            }

            if (bid_opt_multiple_shipping) {
                if (count($lists["shipping_zones"]))
                    for ($oi = 0; $oi < count($lists["shipping_zones"]); $oi++) {
                        $itm = $lists["shipping_zones"][$oi];
                        if (isset($lists["user_settings"]["shipping_$itm->id"])) {
                            $plm = new stdclass();

                            $plm->price = $lists["user_settings"]["shipping_$itm->id"]->value;
                            $plm->name = $itm->name;
                            $plm->id = $itm->id;
                            $lists["U_shipping_zones"][] = $plm;
                        }
                    }
            }

            //echo "<pre>";var_dump($lists["shipping_zones"]);exit;

        }

        $lists["exist_suggests"] = 0;
        if ($auction->id) {

            $bidSuggest = new JAuctionBidSuggestions($database);
            $bidSuggest->auctionid = $auction->id;
            $suggests = $bidSuggest->getSuggestions();
            $lists["exist_suggests"] = 0;
            if (count($suggests) > 0)
                $lists["exist_suggests"] = 1;

        }

        // 1.6.9 op: if no bids yet , editing can still be done
        $auction->testIfBidder($my->id);
        if (!$auction->has_placed_bids && !$lists["exist_suggests"]) {
            $smarty->assign('task', "new");
        }

        /**
         * CUSTOM Fields
        */
		$Fi = & FactoryFieldsFront::getInstance();
		$fields = $Fi->getHTMLFields("auctions", $auction->id);
		
		if( count($fields)>0 ){
			$vcf = array();
			foreach ($fields as $fi){
				if($fi["compulsory"]==1 || $fi["validate_type"]!=""){
					$vcf[] = "'".$fi["field_id"]."'";
				}
			}
			$lists["validate_custom_fields"] = " new Array(".implode(",",$vcf).")";
			$lists["validate_custom_fields_count"] = count($vcf);
		}else {
			$lists["validate_custom_fields"] = " new Array()";
			$lists["validate_custom_fields_count"] = "0";
		}
		
		// Custom Fields Per Category
		$allowed_fields = array();
		$database->setQuery("SELECT cid,GROUP_CONCAT(a.db_name) as a_fields FROM #__bid_fields_categories LEFT JOIN #__bid_fields as a ON fid=a.id GROUP BY cid ");
		$category_fields = $database->loadObjectList("cid");
		
		$jdoc = & JFactory::getDocument();
		
		$jscat = "var CategoriesFields = new Array();\r\n";
		$c=0;
		foreach ($category_fields as $k => $cat){
			$jscat .= "CategoriesFields[$k] = '$cat->a_fields';\r\n";
			$c++;
		}
		$jdoc->addScriptDeclaration($jscat);
		
		$jscat = "var AllFields = new Array();\r\n";
		$c=0;
		foreach ($fields as $k => $f){
			$fid = $f['row_id'];
		
			$jscat .= "AllFields[$c] = '{$fid}';\r\n";
			$c++;
		}
		$jdoc->addScriptDeclaration($jscat);
		
		$smarty->assign("category_fields", $category_fields);
		
		// Custom Fields Per Category
		$smarty->assign("profiler", $fields );

        $smarty->assign('old_id', $id);
        $smarty->assign('lists', $lists);
        $smarty->assign('auction', $auction);
        $smarty->assign('parameters', $AuctionParameters);

        // TOKENize
        @session_start();
        $token = $_SESSION["auction_token"] = time();

        $smarty->display('t_editauction.tpl');

    }

    function makeFilterArray($filters)
    {
    	$database = & JFactory::getDBO();
        $searchstrings = array();
        if (isset($filters['keyword']) && $filters['keyword']) {
            $searchstrings[search_keyword_text] = $filters['keyword'];
        }

        if (isset($filters['userid']) && $filters['userid']) {
            $database->setQuery("select username from #__users where id in (" . (int)$filters['userid'] .") and block=0");
			$results = $database->loadResultArray();
			if (is_array($results)) {
				$usernames = join(',', $results);
				$searchstrings[search_usernames_text] = $usernames;
            }
        }
        if (isset($filters['users']) && $filters['users'] && is_array($filters['users'])  && !empty($filters["users"][0]) ) {
			//array_walk($filters["users"], function(&$value, $index){$value = "'".(int)$value."'";});
			array_walk($filters["users"], "auctions_filter_this");
        	$users = implode(",",$filters['users']);
        	
            $database->setQuery("select GROUP_CONCAT(username) as username from #__users where id in (" . $users .") and block=0 GROUP BY id");
			$results = $database->loadResultArray();
			
			if (is_array($results)) {
				$usernames = join(',', $results);
				$searchstrings[search_usernames_text] = $usernames;
            }
        }
        
        if (isset($filters['cat']) && $filters['cat']) {
            $database->setQuery("select id,catname from #__bid_categories where id='" . (int)$filters['cat'] ."'");
            $catname = $database->loadAssoc();
            $searchstrings[bid_category] = $catname["catname"];
        }
        if (isset($filters['sdate']) && $filters['sdate']) {
            if (date('Y', strtotime($filters['sdate'])) > '1970') {
                $searchstrings[bid_start_date] = date(bid_opt_date_format, strtotime($filters['sdate']));
            }
        }
        if (isset($filters['bdate']) && $filters['bdate']) {
            if (date('Y', strtotime($filters['bdate'])) > '1970') {
                $searchstrings[bid_end_date] = date(bid_opt_date_format, strtotime($filters['bdate']));
            }
        }
        if (isset($filters['tag']) && $filters['tag']) {
            $searchstrings[bid_tags] = $filters['tag'];
        }
        if (isset($filters['auction_nr']) && $filters['auction_nr']) {
            $searchstrings[bid_auction_number] = $filters['auction_nr'];
        }
        if (isset($filters['inarch']) && $filters['inarch']) {
            if ($filters['inarch'] == 1)
                $searchstrings[bid_filter_archive] = bid_yes;
            else
                $searchstrings[bid_filter_watchlist] = bid_yes;
        }
        if (isset($filters['filter_rated']) && $filters['filter_rated']) {
            $searchstrings[bid_filter_rated] = bid_unrated;
        }
        if (isset($filters['country']) && $filters['country']) {
            if (CB_DETECT)
                $searchstrings[bid_country] = $filters['country'];
            else {
                $database->setQuery("select name from #__bid_country where id='" . $filters['country'] .
                    "'");
                $searchstrings[bid_country] = $database->loadResult();
            }
        }
        if (isset($filters['city']) && $filters['city']) {
            $searchstrings[bid_city] = $filters['city'];
        }
        return $searchstrings;
    }
    
}
?>