<?php
/**
 * @package AuctionsFactory
 * @version 1.7.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }



require_once( JPATH_ROOT. '/includes/pageNavigation.php' );
define(ITEMS_PER_PAGE, '5');
class getmyratingsTab extends cbTabHandler {

	function getmyratingsTab() {
		$this->cbTabHandler();
	}

	function getDisplayTab($tab,$user,$ui){
		global $Itemid;
		$database = & JFactory::getDBO();
		$my  = &JFactory::getUser();

		if(!file_exists(JPATH_ROOT."/components/com_bids/bids.php")){
			  return "<div>You must First install <a href='http://www.thefactory.ro/shop/joomla-components/auction-factory.html'> Auction Factory </a></div>";
		}
		require_once(JPATH_ROOT."/components/com_bids/options.php");


        if (file_exists(JPATH_ROOT.'/components/com_bids/lang/'.bid_opt_language))
            require_once(JPATH_ROOT.'/components/com_bids/lang/'.bid_opt_language);
        else
            require_once(JPATH_ROOT.'/components/com_bids/lang/default.php');


		$params = $this->params;


// total ratings
   		$query = "select count(*) from #__bid_rate r
			  left join #__users us on r.voter = us.id
			  left join #__bid_auctions a on r.auction_id = a.id
		      where r.user_rated = '$user->user_id' ";
		$database->setQuery($query);
		$total= $database->loadResult();
		
		$limitstart=0;
		$pagingParams = $this->_getPaging( array(), array( "myrates_" ) );
		if (isset($pagingParams["myrates_limitstart"])) {
			$limitstart=$pagingParams["myrates_limitstart"];
		}
   		

// my ratings
   		$query = "select r.*,us.username,a.title from #__bid_rate r
			  left join #__users us on r.voter = us.id
			  left join #__bid_auctions a on r.auction_id = a.id
		      where r.user_rated = '$user->user_id' ";
		$database->setQuery($query,$limitstart, ITEMS_PER_PAGE);
		
		$pagingParams["limitstart"] = $limitstart;
		$pagingParams["limit"] = ITEMS_PER_PAGE;
		$myratings = $database->loadObjectList();
		
// all ratings
		$query = "select sum(rating) from #__bid_rate r
			  left join #__users us on r.voter = us.id
			  left join #__bid_auctions a on r.auction_id = a.id
		      where r.user_rated = '$user->user_id' ";
		$database->setQuery($query);
		$all_ratings= $database->loadResult();

// seller ratings
		$query = "select avg(rating) from #__bid_rate r
			  left join #__users us on r.voter = us.id
			  left join #__bid_auctions a on r.auction_id = a.id
		      where r.user_rated = '$user->user_id' and rate_type='auctioneer' ";
		$database->setQuery($query);
		$seller_ratings= intval($database->loadResult());

// buyer ratings
		$query = "select avg(rating) from #__bid_rate r
			  left join #__users us on r.voter = us.id
			  left join #__bid_auctions a on r.auction_id = a.id
		      where r.user_rated = '$user->user_id' and rate_type!='auctioneer' ";
		$database->setQuery($query);

		$buyer_ratings= intval($database->loadResult());

		$rating=($total>0)?intval($all_ratings/$total):0;

        
		$return = "<style type='text/css'>
						#auction_star{height:12px;margin:0px;padding:0px;}
					</style>";
		
		
		
        $return .="<span class='auction_my_rating'>".bid_overall_rating.": <span id='rating_user' rating='".$rating."'></span>&nbsp;($rating/10)</span><br>";
        $return .="<span class='auction_my_rating'>".bid_rating_auctioneer.": <span id='rating_user' rating='".$seller_ratings."'></span>&nbsp;($seller_ratings/10)</span><br>";
        $return .="<span class='auction_my_rating'>".bid_rating_bidder.": <span id='rating_user' rating='".$buyer_ratings."'></span>&nbsp;($buyer_ratings/10)</span>";
		$return .='<form name="topForm'.$tab->tabid.'" action="index.php" method="post">';
		$return .="<table width='100%'>";
		$return .="<input type='hidden' name='option' value='com_comprofiler' />";
		$return .="<input type='hidden' name='task' value='userProfile' />";
		$return .="<input type='hidden' name='user' value='".$user->user_id."' />";
		$return .="<input type='hidden' name='tab' value='".$tab->tabid."' />";
		$return .="<input type='hidden' name='act' value='' />";


		if($myratings) {
			$return	.= '<tr>';
 			$return .='<td colspan=3><hr></td>';
			$return .= '</tr>';
			$k=0;
			
			foreach ($myratings as $mr){
			 	$link_view_details = sefRelToAbs("index.php?option=com_bids&task=ViewDetails&id=$mr->voter&Itemid=$Itemid");
			 	$link_view_bids = sefRelToAbs("index.php?option=com_bids&task=viewbids&id=$mr->auction_id&Itemid=$Itemid");
			 	if ($mr->rate_type=='auctioneer'){$utype=bid_buyer;}else{$utype=bid_seller;}

    			 $return .="<tr class='myrating".($k)."'>";
    			 $return .="<td colspan=3>";
    			 $return .="<a href='".$link_view_bids."'>$mr->title</a>";
    			 $return .="</td>";
    			 $return .= "</tr>";
    			 $return .='<tr class="myrating'.$k.'">';
    			 $return .='<td>';
				 $return .= "<a href='".$link_view_details."'>$mr->username </a>(".$utype.") - " .date(bid_opt_date_format,strtotime($mr->modified));
				 $return .= "</td>";
    			 $return .="<td width='20%' colspan=2 nowrap>";
		         $return .="<span id='rating_user' rating='".$mr->rating."'></span>";
    			 $return .="</td>";
    			 $return .="</tr>";
    			 $return .="<tr class='myrating".($k)."'>";
    			 $return .="<td colspan='3' style='border-bottom:1px solid black'>";
    			 $return .= $mr->message;
    			 $return .= "</td>";
    			 $return .= "</tr>";
    			 $k=1-$k;

			 }
		} else {

			$return .=	"".bid_no_items."";

		}

		$pageslinks = "index.php?option=com_comprofiler&task=userProfile&user=$user->user_id&tab=$tab->tabid";

		$return .= "<tr height='20px'>";
		$return .= "<td colspan='3' align='center'>";
		$return .= "</td>";
		$return .= "</tr>";

		$return .= "<tr>";
		$return .= "<td colspan='2' align='center'>";
		$return .= $this->_writePaging($pagingParams,"myrates_", ITEMS_PER_PAGE, $total);
		$return .= "</td>";
		$return .= "</tr>";

		$return .= "</table>";
		$return .= "</form>";
		
		$rating_js = '
			var JS_ROOT_HOST=\''.JURI::root().'/\';
			var alreadyrunflag=0
			if (document.addEventListener)
			{
				document.addEventListener("DOMContentLoaded", function(){
					alreadyrunflag=2; 
					FillRatings();
					}, false)
			}
			else if (document.all && !window.opera){
				document.write(\'<script type="text/javascript" id="contentloadtag" defer="defer" src="javascript:void(0)"><\/script>\')
			
				var contentloadtag=document.getElementById("contentloadtag")
				alreadyrunflag=1
				contentloadtag.onreadystatechange=function(){
					if (this.readyState=="complete"){
						alreadyrunflag=2
						FillRatings();
					}
				}
			}
			window.onload=function(){
				if (!alreadyrunflag && alreadyrunflag!=2) 
					setTimeout("if (!alreadyrunflag && alreadyrunflag!=2) {FillRatings();}", 0)
			}
		';
        if(class_exists("JFactory")){
        	$jdoc= &JFactory::getDocument();
        	$jdoc->addScript(JURI::root()."/components/com_bids/js/ratings.js");
        	$jdoc->addScriptDeclaration($rating_js);
        }else{
			$return.='<script type="text/javascript" src="'.JURI::root().'/components/com_bids/js/ratings.js"></script>';
			$return .= "
					<script type='text/javascript'>
					$rating_js
					</script>
			";
			
        }


		return $return;


	}

}


?>