<?php

/* cron script */
define( '_JEXEC', 1 );
//Change the password in the next line
define('AUCTIONS_CRON_PASSWORD','pass');

define( 'DS', DIRECTORY_SEPARATOR );
define('JPATH_BASE', str_replace("components".DS."com_bids","",dirname(__FILE__)));
require_once( '../../includes/defines.php' );
require_once ( '../../includes/framework.php' );
$mosConfig_live_site = JPATH_SITE;
$mainframe =& JFactory::getApplication('site');

$mainframe->initialise();

JPluginHelper::importPlugin('system');

JDEBUG ? $_PROFILER->mark('afterInitialise') : null;
$mainframe->triggerEvent('onAfterInitialise');

$database = & JFactory::getDBO();
if(!defined("JPATH_COMPONENT_SITE"))
	define("JPATH_COMPONENT_SITE",JPATH_ROOT.DS."components".DS."com_bids".DS);
define("AUCTION_COMPONENT_PATH",JPATH_COMPONENT_SITE);


if (!defined("JPATH_COMPONENT_ADMINISTRATOR")) {
	define("JPATH_COMPONENT_ADMINISTRATOR",JPATH_ADMINISTRATOR.DS."components".DS."com_bids");
}


require_once(JPATH_ROOT.DS.'components'.DS.'com_bids'.DS.'thefactory'.DS.'application.php');
$Tapp=&JTheFactoryApp::getInstance();

require_once( 'bids.class.php' );
require_once( 'options.php' );
require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_bids'.DS.'thefactory'.DS.'payments'.DS.'payments.lib.php');
require_once( JPATH_SITE.DS.'components'.DS.'com_bids'.DS.'thefactory'.DS.'front.payment.php' );
require_once( 'helpers/helper.php' );

if(! isset($_SESSION)){
	session_name( md5( $mosConfig_live_site ) );
	session_start();
}
@set_time_limit(0);
@ignore_user_abort(true);

if(php_sapi_name()=='cli')
{
    $argv=$_SERVER['argv'];
    $argc=$_SERVER['argc'];
    if ($argc > 0)
    {
      for ($i=1;$i < $argc;$i++)
      {
        parse_str($argv[$i],$tmp);
        $_REQUEST = array_merge($_REQUEST, $tmp);
      }
    }
}


$pass = JRequest::getVar('pass','');
$daily= JRequest::getVar('daily','');
if ( $pass !== AUCTIONS_CRON_PASSWORD ){
	
	die ("AUTH ERROR");
	
}

$database = & JFactory::getDBO();
// -------------- EXPIRED AUCTIONS  ----------- //
	$now = BidTimeUtilities::getNow();
	//$nowMysql = date("Y-m-d H:i",$now);
	$nowMysql = gmdate("Y-m-d H:i:s" ,$now);
	
// reminder for due to expire suggestions
$database->setQuery(" SELECT a.* FROM #__bid_suggest as a
    				  LEFT JOIN #__bid_auctions b ON a.auctionid = b.id  
					  WHERE '$nowMysql' > DATE_ADD( a.modified, INTERVAL 24 HOUR) AND a.status=2
					  AND '$nowMysql' < b.end_date and b.close_offer != 1 and b.published = 1 and b.close_by_admin!=1 
					  GROUP BY auctionid");

$curs = $database->loadObjectList();
if(count($curs)>0){
	$row = new JAuctions( $database );
	foreach($curs as $k=>$val){
		$row->load($val->auctionid);
		$query = "select u.* from #__users u
				  where u.id in ( $row->userid )";
		$database->setQuery($query);
		$mails = $database->loadObjectList();
		$row->SendMails($mails,'suggest_reminder'); //Notyfy Sellers abour pending suggestions
	}
}

// reject expired suggestions
$database->setQuery(" SELECT a.* FROM #__bid_suggest as a 
    				  LEFT JOIN #__bid_auctions b ON a.auctionid = b.id  
					  WHERE '$nowMysql' > DATE_ADD( a.modified, INTERVAL 48 HOUR) AND a.status=2  
					  ");
$curs = $database->loadObjectList();

if(count($curs)>0){
	$row = new JAuctions( $database );
	$sug = new JAuctionBidSuggestions( $database );
	foreach($curs as $k=>$val){
		$row->load($val->auctionid);
		$sug->load($val->id);
		$sug->status=0;
		$sug->store();// reject the sug
		
		$query = "select u.* from #__users u
				  where u.id in ( $sug->userid )";
		$database->setQuery($query);
		$mails = $database->loadObjectList();
		$row->SendMails($mails,'suggest_rejected'); //Notyfy Bidders abour rejected suggestion
	}
}



	$query = "SELECT a.* from #__bid_auctions a
			  where '$nowMysql' > a.end_date and a.close_offer != 1 and a.published = 1 and a.close_by_admin!=1";
	$database->setQuery($query);
	$rows = $database->loadObjectList();
	
	if(count($rows)>0){
		$row = new JAuctions( $database );
		foreach ($rows as $r){
    		// Close expired auctions
    		$row->load( $r->id );
    		// !!!! DEV ONLY decomment the next two lines!!
    		$row->close_offer=1;
    		$row->closed_date=date("Y-m-d H:i:s",time());

    		if ($row->ancStore()){
       			//Notify users;
        		$query = "select distinct a.userid from #__bids a where a.id_offer=$row->id";
        		$database->setQuery($query);
        		$ids = $database->loadResultArray();
                $id_string=implode(',',$ids);
                //get all bidders
                if (count($ids)>0){
        			$query = "select u.* from #__users u
        					  where u.id in ( $id_string )";
        			$database->setQuery($query);
        			$mails = $database->loadObjectList();
        			$row->SendMails($mails,'bid_closed'); //Notyfy Bidders abour closed Auction

        			//delete bidders from watchlist, to avoid double notification
        			$query = "delete from #__bid_watchlist where auctionid='$r->id' and userid in ($id_string)";
        			$database->setQuery($query);
        			$database->query();

                }

        		//Notify  Watchlist, Clean Watchlist
        		$query = "select a.userid from #__bid_watchlist a where a.auctionid=$r->id";
        		$database->setQuery($query);
        		$ids = $database->loadResultArray();
                $id_string=implode(',',$ids);

                if (count($ids)>0){
        			$query = "select u.* from #__users u
        					  where u.id in ($id_string)";
        			$database->setQuery($query);
        			$mails = $database->loadObjectList();
        			$row->SendMails($mails,'bid_watchlist_closed'); //Notify Watchlist
                }
        	    $query = "delete from #__bid_watchlist a where a.auctionid=$r->id";
        		$database->setQuery($query);
        		$database->query();
        		//Choose a winner

        		if($row->automatic){
    					$row->ChooseWinner();//automatic choose winner
    			}else{
    				$usr=new JTableUser($database);
    				$usr->load($row->userid);
    				$row->SendMails(array($usr),'bid_choose_winner');// Notify owner to choose winner
    			}
    		}
    		
	   }
	}
	
// END EXPIRED AUCTION

// BEGIN DAILY TASKS --> notifications , watchlist
    if ($daily){
		$now = BidTimeUtilities::getNow();
		$nowMysql = date("Y-m-d H:i",$now);
        //Notify upcoming expirations
    	$query = "SELECT a.* from #__bid_auctions a
    		 	  where '$nowMysql'>=DATE_ADD(end_date,INTERVAL -1 DAY) and a.close_offer != 1 and published = 1 and a.close_by_admin!=1";
    	$database->setQuery($query);
    	$rows = $database->loadObjectList();

    	$auction = new JAuctions($database);
    	$usr=new JTableUser($database);

    	if (count($rows))
        	foreach ($rows as $row){
                	$auction->load($row->id);
        			$usr->load($row->userid);
        			$auction->SendMails(array($usr),'bid_your_will_expire'); // Notify Owner that his auction will soon expire

        			$query = "SELECT u.* from #__users u
        					left join #__bid_watchlist w on u.id = w.userid
        					where w.auctionid = $row->id";

        			$database->setQuery($query);
        			$watchlist_mails = $database->loadObjectList();
        			$auction->SendMails($watchlist_mails,'bid_watchlist_will_expire'); //Notify Users in watchlist that an auction will expire
        	}

    	//Close all auctions without a parent user (deleted users?)
    	$query = "update #__bid_auctions a left join #__users b on a.userid=b.id set close_by_admin = 1,closed_date=now() where b.id is null";
    	$database->setQuery($query);
    	$database->query();
        //delete Very old auctions (past Archived time)
    	$interval =  intval(bid_opt_archive);
    	if ($interval>0){
        	$query = "SELECT id 
        				FROM #__bid_auctions
        				WHERE '$nowMysql' > DATE_ADD( closed_date, INTERVAL $interval
        				MONTH )
        				AND (close_offer =1
        				or  close_by_admin=1)";
            $database->setQuery($query);
        	$idx = $database->loadResultArray(); //select auctions that have to be purged

            $row = new JAuctions( $database );
            if (count($idx))
        		foreach ($idx as $id){
        		    $row->delete($id);
        		}
    	}
    }
//plugin tasks
    /*@var $payment BidsPayment*/
    $payment=&JTheFactoryPaymentController::getInstance();
    $payment->processCron($daily);



?>