<?php
/**
 * @package Factory
 * @version 1.7.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

include_once(JPATH_ROOT . DS . "components". DS ."com_bids" . DS . "gallery" . DS . "gallery.php");

class gl_simple_carousel extends auct_gallery{
	
	var $_pathToJS;
	var $_pathToImages;

	function gl_simple_carousel(&$db,$pathToImages)
	{
		$this->_db=$db;
		$this->_pathToJS = JURI::root() . "/components/com_bids/gallery/simple_carousel/";
		$this->_pathToImages = $pathToImages."/";
	}
	
	function getJS()
	{
      $jdoc = & JFactory::getDocument();
      
      $width = intval(bid_opt_medium_width);
      $height = intval(bid_opt_medium_height);
		
      $box_width = $width+20;
      $box_height = $height+20;
      
      $gal_width = $width + 100;
      
      $gal_width_half = (int)($box_height/2) - 30;
      
		$css = "
			#id_waid{
				display:none; 
				margin-top:30px;
				margin-left:{$gal_width_half}px;
				margin-bottom:30px;
			}
			.gallery_wrap{
				width:{$gal_width}px !important;
				height:{$box_width}px !important;
			}
			
			.gallery_left{
				float:left;
				cursor:pointer;
			}
			
			.gallery_right{
				float:left;
				cursor:pointer;
			}
			
			#gallery_preview{
				border:1px solid #000;
				float:left;
				width:{$box_width}px;
				background:#FFF;
			}
			
			#preview_pic{
				margin:10px;
				max-width:{$width}px;
				max-height:{$height}px;
				width:{$width}px;
			}
		";
		
		$jdoc->addStyleDeclaration($css);
		$js = "
			var gl_index = 0;
			var gl_images = new Array();
			var gl_path_to_js = '".$this->_pathToJS."';
		";
		$jdoc->addScriptDeclaration($js);
		$jdoc->addScript($this->_pathToJS."/js/gl_js.js");
		}
	function writeJS(){
		$this->getJS();
		JHTML::_('behavior.modal');
	}
	
	function getThumb($thumbnr=0,$overlib=1,$medium=0)
	{
		$img = "";
		if($this->imagelist[$thumbnr]){
		   $img_small=$this->_pathToImages.'/resize_'.$this->imagelist[$thumbnr];
   	   $img_full=$this->_pathToImages.$this->imagelist[$thumbnr];
   	   $img_middle=$this->_pathToImages.'/middle_'.$this->imagelist[$thumbnr];
	      $img_small_html="<img src='$img_small' border=0>";
	      $img_middle_html="<img src='$img_middle' border=0>";
	      $img_full_html="<img src='$img_full' border=0>";
		   if ($overlib){{
				JHTML::_("behavior.tooltip",".hasTip");
				$img = "$img_middle_html";
				echo '<style type="text/css">.tool-tip{max-width:100% !important;}</style>';
				$img='<img src="'.$img_small.'" border="0" class="editlinktip hasTip" title="'.$img.'" >';
		   }

		   }else{
    	       $img='<a href="'.$img_full.'" class="modal">';
		       $img.='<img src="'.$img_small.'" border="0" />';
		       $img.='</a>';
		   }
		}else{
 	       if ($medium)
	           $width= intval(bid_opt_medium_width);
	       else
	           $width= intval(bid_opt_thumb_width);
           $img.='<img src="'.$this->_pathToImages.'/no_image.png" border="0" width="'.$width.'"/>';

		}
        return $img;
	}
	
	function writeThumb($thumbnr=0,$overlib=1,$medium=0)
	{
		//JHTMLBehavior::mootools();
	    echo $this->getThumb($thumbnr,$overlib,$medium);
	}
	
	function getGallery()
	{
		
		$img = "";
        $width= intval(bid_opt_medium_width);
	    if (count($this->imagelist)>0){

	        if($this->imagelist[0]){
		        $main_img = $this->imagelist[0];
	        }
		
			  $img.='<div class="gallery_wrap">';
	        
	        $img.='
				      <a class="gallery_left" onclick="gl_left()" onmouseover="gl_hover(\'left\')" onmouseout="gl_out(\'left\')" ><img id="left_bar" src="'.$this->_pathToJS.'left.png" alt="left" /></a>
	        			<div id="gallery_preview">
							<img id="id_waid" src="'.$this->_pathToJS.'ajax-loader.gif" alt="wait" />
							<a id="preview_modal" class="modal" href="'.$this->_pathToImages.$main_img.'"><img id="preview_pic" src="'.$this->_pathToImages.'middle_'.$main_img.'" alt="thumb" /></a>
						</div>
						<a class="gallery_right" onclick="gl_right()" onmouseover="gl_hover(\'right\')" onmouseout="gl_out(\'right\')" ><img id="right_bar" src="'.$this->_pathToJS.'right.png" alt="right" /></a>';
	        
			        $img.= '<script type="text/javascript">';
			        for($i=0;$i<count($this->imagelist);$i++){
			            if ($this->imagelist[$i]=='') continue;
			            
			            $img.= 'gl_images["'.$i.'"]='."'".$this->_pathToImages.'middle_'.$this->imagelist[$i]."';";
				            	 
			        }
			        $img .='</script>';
           $img.='</div>';
           
	    } else {
	        $img='<img src="'.$this->_pathToImages.'no_image.png" border="0" alt="No image" >';
	    }
	    
	    return $img;
	}
	
	function writeGallery(){
	    echo $this->getGallery();

	}

}

?>