<?php
/**
 * @package AuctionsFactory
 * @version 1.5.7
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

include_once(JPATH_ROOT   ."/components/com_bids/gallery/gallery.php");
class gl_yui extends auct_gallery{
	var $_pathToJS;
	var $_pathToImages;

	function gl_yui(&$db,$pathToImages)
	{
		$this->_db=$db;
		$this->_pathToJS=JURI::root()."/components/com_bids/gallery/yui_js";
		$this->_pathToImages=$pathToImages;
	}
	function getJS()
	{
        $width= intval(bid_opt_medium_width);
        $height= intval(bid_opt_medium_height);
		$code="
		<link rel=\"stylesheet\" type=\"text/css\" href=\"http://yui.yahooapis.com/2.6.0/build/fonts/fonts.css\">
		<link type=\"text/css\" rel=\"stylesheet\" href=\"$this->_pathToJS/yui_skin.css\">
		<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.6.0/build/yahoo-dom-event/yahoo-dom-event.js\"></script>
		<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.6.0/build/element/element-beta-min.js\"></script>
		<script type=\"text/javascript\" src=\"http://yui.yahooapis.com/2.6.0/build/carousel/carousel-beta-min.js\"></script>
		";
		return $code;
	}
	function writeJS()
	{
		echo $this->getJS();
	}

	function getThumb($thumbnr=0,$overlib=1)
	{
		
		if(isset($this->imagelist[$thumbnr]) && $this->imagelist[$thumbnr]!=""){
		   if ($overlib){
    	       $img_middle="<img src=\"".$this->_pathToImages.'/middle_'.$this->imagelist[$thumbnr]."\" border=0>";
		       $img='<img src="'.$this->_pathToImages.'/resize_'.$this->imagelist[$thumbnr].'" border="0" />';
		   }else{
    	       $img_full=$this->_pathToImages.'/'.$this->imagelist[$thumbnr];
    	       $img='<a href="'.$img_full.'" class="thickbox">';
		       $img.='<img src="'.$this->_pathToImages.'/resize_'.$this->imagelist[$thumbnr].'" border="0" />';
		       $img.='</a>';
		   }
		} else {
			$img='<img src="'.$this->_pathToImages.'/no_image.png" border="0">';
		}
        return $img;
	}
	
	function writeThumb($thumbnr=0,$overlib=1)
	{
	    echo $this->getThumb($thumbnr,$overlib);
	}

	function getGallery()
	{
		JHTML::_('behavior.modal');
		
        $width= intval(bid_opt_medium_width);
        if (count($this->imagelist)==1)
        	return $this->popImage("modal");
        
	    if (count($this->imagelist)>0){
	    	$nr=0;
	        for($i=0;$i<count($this->imagelist);$i++){
	        	if ($this->imagelist[$i]=='') continue;
	        	$nr++;
	        }
	        
	        $img .="
	        <script>
	    	(function () {
		        var carousel;
		                
		        YAHOO.util.Event.onDOMReady(function (ev) {
		            var carousel    = new YAHOO.widget.Carousel(\"container\", {
		                         isCircular: true, numVisible: 1
		                });
		            carousel.render(); // get ready for rendering the widget
		            carousel.show();   // display the widget
		        });
		    })();
		    </script>
			";

	        $img.='
			<div class="yui-skin-sam">	        
	        <div id="container">
			<ol id="carousel">
			';
			
	        for($i=0;$i<count($this->imagelist);$i++){
	            if ($this->imagelist[$i]=='') continue;
	            
            	$css_class = "modal";
	            $img.='
				<li>
					<a href="'.$this->_pathToImages.'/'.$this->imagelist[$i].'" class="'.$css_class.'" ><img src="'.$this->_pathToImages.'/middle_'.$this->imagelist[$i].'" width="'.$width.'"></a>
				</li>';
	        }
            $img.='
				</ol>
			</div>
			</div>
	        ';

	    }else
	    {
	        $img='<img src="'.$this->_pathToImages.'/no_image.png" border="0">';
	    }
		return $img;
	}
	function writeGallery(){
	    echo $this->getGallery();

	}
}



?>