<?php
/**
 * @modified 29.04.10
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.application.component.helper');

/**
 * @package		Auction Factory
 * @since 2.0
 */
class bidsModelCategory extends JModel
{
	var $_name='category';
	
	
	function getCategories(){
		
		
		$curentItemid	= BidsUtilities::getMenuItemId( array("view"=>"category") );
		$AdsItemid 	 	= BidsUtilities::getMenuItemId( array("view"=>"bids", "task" => "") );
		
		$database = &JFactory::getDbo();
		
        $cat = (int)JRequest::getVar("cat", 0);
        
    	$CO = new JTheFactoryCategoryObj();
    	$cTree = $CO->build_child($cat,true);
    	$treeDEPTH = 2;
        
    	$cat_filter = "";
        
    	foreach ($cTree as $key => $tc){
    		if(isset($tc["id"])){
				$cat_ids[] = "'".$tc["id"]."'";
	    		if($tc["depth"]>$treeDEPTH)
		    		$treeDEPTH=$tc["depth"];
    		}
    		
    	}
    	
        if($cat!=0){
	        
        	if( count($cat_ids) > 0 ){
        		$cat_filter_sql = implode(",", $cat_ids);
		        $cat_filter = " AND ( c.id IN ($cat_filter_sql) )" ;
        	}
        }
    	
		/**
		 * Max Category Depth 
		 * to prevent mysql bug @link: http://bugs.mysql.com/bug.php?id=20017
		 */
		$Category_Tree_Depth = $treeDEPTH;
		
		$sql_category_left_join_aux = array();
		$category_join_filter_aux =array();
		$category_selected_cat_filter = array();
				
		for ($t = 0; $t < $Category_Tree_Depth; $t++){
			
			$table_alias = "catjoin".$t;
			if($t>0){
				$table_join_alias = "catjoin".($t-1);
			}else{
				$table_join_alias = "c";
			}
			
			$category_join_filter_aux[] =  " a.cat = `$table_alias`.id ";
			$sql_category_left_join_aux[] = " LEFT JOIN `#__bid_categories` AS `{$table_alias}` ON `{$table_alias}`.parent = `{$table_join_alias}`.id \r\n";
		}
			
		if(count($sql_category_left_join_aux))
			$sql_category_left_join = implode("\r\n",$sql_category_left_join_aux);
		else 
			$sql_category_left_join = "";
			
		if(bid_opt_inner_categories){
			if(count($category_join_filter_aux))
				$category_join = " ( a.cat = c.id OR  \r\n".implode("OR \r\n ",$category_join_filter_aux).")";
			else	
	        	$category_join = " a.cat = c.id ";
        }else{
        	$category_join = " a.cat = c.id ";
        }
		
		$database->setQuery(" 
		SELECT c . * , COUNT( DISTINCT a.id ) as nr_a   
		\r\n".
		" FROM #__bid_categories AS c  \r\n".
		$sql_category_left_join.
	    " LEFT JOIN `#__bid_auctions` AS a ON ".
	    " ( 
			$category_join
	     AND a.close_offer=0 AND a.start_date<=now() AND a.published=1 
	    )
	    WHERE c.status=1 $cat_filter
	    \r\n".
		" GROUP BY c.id  order by c.id,c.ordering,catname asc
		");
		//echo nl2br($database->_sql);exit;
		$dbrows = $database->loadObjectList();
		
		
		$cats = array();
		if($dbrows)
		foreach ($dbrows as $k =>$rw){
			$cats[$rw->parent][] = $rw;
		}
		
		return $cats;
	}
	

    // CATEGORIES WATCHLIST (favoriteS)
    function addWatch($id)
    {
        $database = &JFactory::getDBO();
        $user = &JFactory::getUser();
        if ($user->id && $id != "") {
            $database->setQuery("INSERT INTO #__bid_watchlist SET userid = '" . (int)$user->id .
                "',catid='" . (int)$id . "'");
            $database->query();
        }
        return true;
    }

    function delWatch($id)
    {
        $database = &JFactory::getDBO();
        $user = &JFactory::getUser();
        if ($user->id && $id != "") {
            $database->setQuery("DELETE FROM #__bid_watchlist WHERE userid = '" . (int)$user->id .
                "' AND catid='" . (int)$id . "'");
            $database->query();
        }
        return true;
    }
    
}