<?php 
$lang = & JFactory::getLanguage();
$lang->load( 'com_bids' );

JHTML::stylesheet("mod_bids.css","modules/mod_bids/tmpl/");
JHTML::stylesheet("jquery.countdown.css","modules/mod_bids/assets/");
JHTML::script("countdown.js","modules/mod_bids/assets/");

JHTML::_('behavior.tooltip');

$jdoc  = &JFactory::getDocument();
$js = "
	window.addEvent('domready', function() {
		if ((typeof moduleSetTimeLeft =='function')) 
			moduleSetTimeLeft('modulebidstime{$mid}_',3);
	});
";
$jdoc->addScriptDeclaration( $js );
global  $Itemid;
$AdsItemid 	 	= BidsUtilities::getMenuItemId( array("task" => "listauctions") , 1 );
if(!$AdsItemid)
	$AdsItemid	= BidsUtilities::getMenuItemId( array("view"=>"auctions","layout"=>"") );
if(!$AdsItemid)
	$AdsItemid	= $Itemid;

?>
<table width="100%" class="mod_bids_table_vertical" cellpadding=0 cellspacing="0">
	<thead>
		<tr>
		  <?php if ($display_image) { ?>
		      <th>&nbsp;</th>
		  <?php } ?>
			<th><?php echo JText::_("Title");?></th>
		  <?php if ($display_counter) { ?>
			<th><?php echo JText::_("Time Left");?></th>
		  <?php } ?>
			<th><?php echo JText::_("Highest Bid");?></th>
		</tr>
	</thead>
	<?php
	
	for($i=0;$i<count($rows);$i++){

		$overlib_str = JText::_("By")." ".$rows[$i]->by_user."<br />";

		if($rows[$i]->auction_type == 1){
			$overlib_str .= JText::_("Start Bid").": ".$rows[$i]->initial_price." ".$rows[$i]->name;
		}

		if( $i%2 == 0 ){
			$alt_class="row_1";
		}else {
			$alt_class="row_2";
		}

 		$link_to_auction = JRoute::_("index.php?option=com_bids&amp;task=viewbids&amp;id=".$rows[$i]->id."&amp;Itemid=".$AdsItemid);
 		
 		if ($display_image) {
 			
			if (file_exists(AUCTION_PICTURES_PATH.$rows[$i]->picture)&& $rows[$i]->picture){
				$image = AUCTION_PICTURES."/".$rows[$i]->picture;
			}else{
				$image = AUCTION_PICTURES."/no_image.png";
			}
			
 		}
 		if ($display_counter)
	 		modBidsHelper::renderAuctionTiming($rows[$i]);
 		
 		?>

	<tr class="<?php echo $alt_class;?>" onmouseover="this.className='<?php echo $alt_class;?>_hover'" onmouseout="this.className='<?php echo $alt_class;?>'">
	  <?php if ($display_image) { ?>
	      <td nowrap width="<?php echo $image_width+30;?>" height="<?php echo $image_height+10;?>" align="center">
		      <?php echo $i+1;?>. 
		      <img src="<?php echo $image;?>" border="0" width="<?php echo $image_width;?>" height="<?php echo $image_height;?>" >
	      </td>
	  <?php } ?>
 		 <td>
 		 	<?php if (!$display_image) echo $i+1,'. ';?><a href="<?php echo $link_to_auction;?>" title="<?php echo $overlib_str;?>" class="hasTip"><?php echo $rows[$i]->title;?></a>
 		 </td>
 		 <?php if ($display_counter) { ?>
 		 <td>
			<span id="modulebidstime<?php echo $mid;?>_<?php echo $i+1;?>"><?php echo $rows[$i]->countdown;?></span>
 		 </td>
 		 <?php 
 		 }
 		 ?>
 		 <td>
 		 	<?php
 		 	if( $rows[$i]->auction_type != AUCTION_TYPE_PRIVATE ){
 		 		$database->setQuery("SELECT MAX(bid_price+0) FROM `#__bids` WHERE id_offer='".$rows[$i]->id."' ");
 		 		$result = $database->loadResult();
 		 		if(!$result){
 		 			$max_bid=JText::_("No bids");
 		 		}else {
 		 			$max_bid = number_format($result,2)." ".$rows[$i]->name;
 		 		}
 		 	}else {
 		 		$max_bid = JText::_("Private");
 		 	}
 		 	echo $max_bid;
 		 	?>
 		 </td>
 		</tr>
 		<?php
	}?>
</table>
