<?php
/**
 * @package Auctions Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
 * @modified: 10.02.10
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
require_once(dirname(__FILE__).DS."pricing_object.php");

class price_bid extends generic_pricing {

    function price_bid(&$db) {
        $this->classname='price_bid';
        $this->classdescription='Module for buying Auction pay per bid';
        parent::generic_pricing($db);
    }

    function checktask($task,$d) {
        global $Itemid;
        
        $my = &JFactory::getUser();
		$credits = $this->getCredits($my->id);

        if ($task=='sendbid'){
            
            if ($credits>0){
            	
                 $this->_db->setQuery("update #__bid_credits set amount=amount-1 where userid='$my->id' and credittype='$this->itemname'");
                 $this->_db->query();
                 return false;
                 
            }else{
            	
                $this->ShowPurchaseDialog($d);
                return true;
                
            }
        }

        if ($task=='buy_bidding' ){
            $this->ShowPurchaseDialog($d);
            return true;
        }
        
        return false;
    }

    function show_admin_config() {
    	?>
            <form action="index.php" method="post" name="adminForm">
    	<?php
			price_object_AdminHelper::showCommonSettingsTab();
    	?>
			<input type="hidden" name="option" value="com_bids"/>
            <input type="hidden" name="task" value="savepaymentitemsconfig"/>
            <input type="hidden" name="itemname" value="<?php echo $this->itemname;?>"/>
            </form>
    	<?php
    
    }
    
    function update_object($order){
    	
    }
    
	function processTemplate($task,$d, &$smarty){
		global $Itemid;
		$my = & JFactory::getUser();
		if($smarty){			
			if($task=="viewbids" ){
				if($my->id){
					$credits = $this->getCredits($my->id);
					$smarty->_tpl_vars["Plugins_msg"]["bid"]->bid_info = "A bid costs a credit of $this->price $this->currency You have $credits bid credits!";
				}

			}
		}
    }

}

?>