<?php
/**
 * 
 * @modified:19/01/10
**/
	require_once( JPATH_ROOT.DS.'components'.DS.'com_bids'.DS.'helpers'.DS.'helper.php' );
	require_once( JPATH_ROOT.DS.'components'.DS.'com_bids'.DS.'helpers'.DS.'route.php' );
	
	function bidsBuildRoute(&$query){

		$database = &JFactory::getDBO();

		$segments = array();
    	if(isset($query['task'])){
    		
    		if( isset($query['task']) && $query['task'] =="viewbids") {
				if(!empty($query['id'])){
					$q 	 = "SELECT a.title FROM #__bid_auctions AS a WHERE id='".$query['id']."'"; $database->setQuery($q);
					$rec = $database->loadObject();
					$segments[]="viewbids"; 
					$segments[]=$query['id'];
					
					$segments[]=JFilterOutput::stringURLSafe($rec->title).".html";
						
					unset($query['id']);
					unset($query['task']);
				}
    		}
    		
    		
    		if( isset($query['task']) &&  $query['task'] =="listcats") {
				
				$segments[]="listcats.html";
				unset($query['task']);
			}
    		if( isset($query['task']) &&  $query['task'] =="search") {
				
				$segments[]="search.html";
				unset($query['task']);
			}
    		if( isset($query['task']) &&  $query['task'] =="tags") {
				
				$segments[]="tags";
				unset($query['task']);
				if(!empty($query['tag'])){
					$segments[]=$query['tag'];
					unset($query['tag']);
				}
			}
			
    		if( isset($query['task']) &&  $query['task'] =="listauctions") {
				
				$segments[]="listauctions";
				unset($query['task']);
				
				if(isset($query['cat'])){
					
					// dev
					unset($query['catslug']);
					
					if(isset($query['catslug']) && $query['catslug']!=''){
						$segments[]=$query['catslug'];
						unset($query['catslug']);
						
					}
					else
						$segments[]=BidsHelperRoute::getSEFCatString($query['cat']);
						
					unset($query['cat']);
				}
				if(!empty($query['userid'])){
					$q="SELECT username FROM #__users WHERE id='".$query['userid']."'"; $database->setQuery($q);
					$rec = $database->loadObject();
					if ($rec){
    					$segments[]='user/'.$query['userid'].'/'.TMPsefbids_helper::str_clean($rec->username);
    					unset($query['userid']);
					}
				}
				
    		}
    	}

		return $segments;
	}

	function bidsParseRoute($segments){


		$vars = array();

		switch($segments[0]){
			case 'viewbids':
				$vars['task'] = 'viewbids';
				$v=explode('/',$segments[1]);
				$vars['id']=$v[0];
			break;
			case 'listcats.html':
				$vars['task'] = 'listcats';
				$v=explode('/',$segments[1]);
			break;
			case 'search.html':
				$vars['task'] = 'search';
				$v=explode('/',$segments[1]);
			break;
			case 'tags':
				$vars['task'] = 'tags';
				$vars['tag']=$segments[1];
			break;
			case 'listauctions':
				$vars['task'] = 'listauctions';

				$categories = $segments;
				unset($categories[0]);
				
				if($segments[1]=="user") {
					$vars['userid']=$segments[2];
				}else{
					$qu = count($categories);
					if($qu>0){
						if($qu==1){
							$pcat = isset($categories[1])?$categories[1]:null;
							$pscat = null;
							$pcat = preg_replace('/:/', '-', $pcat, 1);
						}else{
							$pcat = isset($categories[$qu-1])?$categories[$qu-1]:null;
							$pscat = isset($categories[$qu])?$categories[$qu]:null;
							
							$pcat = preg_replace('/:/', '-', $pcat, 1);
							$pscat = preg_replace('/:/', '-', $pscat, 1);
						}
						
						$vars['cat']=BidsHelperRoute::getSEFCat($pcat, $pscat);
					}
				}
			break;
		}
		/**
		 * @added:25/09/09 
		 **/
		$vars["Itemid"] = AuctionGetMenuItem($vars["task"]);
		return $vars;

	}
	
	/**
	 * @added:25/09/09 
	 **/
	function AuctionGetMenuItem($task_name){

		$database = &JFactory::getDBO();
		$database->setQuery("SELECT id FROM #__menu WHERE link LIKE '%task=$task_name%'OR link LIKE '%task=listauctions%' ORDER BY id DESC LIMIT 0 , 1 ");
		return $database->loadResult();

	}
	

class TMPsefbids_helper {
    function GetTaskMap()
    {
        $task_map=array(
            "viewbids"=>"auction",
            "ViewDetails"=>"auctioneer"

        );
        return $task_map;
    }
    function Task2Map($task){
        $map=TMPsefbids_helper::GetTaskMap();

        if (isset($map[$task]))
            return $map[$task];
        else
            return $task;
    }
    function Map2Task($url_part){
        $map=array_flip(TMPsefbids_helper::GetTaskMap());
        if (isset($map[$url_part]))
            return $map[$url_part];
        else
            return $url_part;
    }

	function str_clean( $string ) {
		$aToReplace = array(" ","/","&","?","?","?","!","$","%","@","?","#","(",")","+","*",":",";","'","\"");
		$aReplacements = array("-","-","and","");

		$str_buff = str_replace($aToReplace,$aReplacements,strtolower($string)	);
		return $str_buff;
	}

	function getCatString(&$id){
		
		/*
		TO DO: load just once categories in static var
		static $Bids_category_static_list;
		if(!$Bids_category_static_list){
			
			
			global $database;
			$database->setQuery("SELECT * FROM #__bid_categories");
			$Bids_category_static_list = $database->loadObjectList("id");
		}
		*/
		
		$database = &JFactory::getDBO();
		$database->setQuery("select * from #__bid_categories where id='$id'");
		$res='';
		do{
			$row=$database->loadAssoc();
			if ($row) $res=$row['catname'].'/'.$res;
			$parent_id=$row['parent'];
			$database->setQuery("select * from #__bid_categories where id='$parent_id'");
			
		}while($parent_id>0);
		
		return $res;
	}

	function getCat(&$cat,&$subcat){
		$database = &JFactory::getDBO();
		if (!$cat) return false;
		$database->setQuery("select id from #__bid_categories where hash like '".md5(strtolower(TMPsefbids_helper::str_clean($cat)))."'");
		$id = $database->loadResult();
		

		if ($subcat){
    		$database->setQuery("select id from #__bid_categories where hash like '".md5(strtolower(TMPsefbids_helper::str_clean($subcat)))."' and parent='$id'");
		    $id = $database->loadResult();

		}
		return $id;
	}

	function getTitleBid(&$id){
		$database = &JFactory::getDBO();
		$database->setQuery("select title from #__bid_auctions where id=$id");
		$result = $database->loadResult();
		$result = TMPsefbids_helper::str_clean($result);
		return $result;
	}

	function getUsername(&$id){
		$database = &JFactory::getDBO();
		$database->setQuery("select a.username from #__users a where a.id = $id ");
		$result = $database->loadResult();
		$result = TMPsefbids_helper::str_clean($result);
		return $result;
	}

    function getAuctionNr($url_array)
    {
        $ret="";
        if (in_array("auction_nr",$url_array)){
            $i=array_search("auction_nr",$url_array);
            TMPsefbids_helper::setVar("auction_nr",$url_array[$i+1]);
            $ret.="&auction_nr=".$url_array[$i+1];
        }
        return $ret;

    }
	function getVal (&$string, $varname, $default) {

	     $string = str_replace("&amp;","&",$string);    // replace "&amp;" with "&" for explore routine...
	     $vars = explode("&", $string);

	     $temp = array();
	     $i=0;

	     foreach ($vars as $var) {
	        $temp = explode("=", $var);

	        if ($temp[0] == $varname) {  // Found the variable
	         	break;
	        }
	        $i++;
	     }
	     if ($temp[0] != $varname) { // Not found => Set Default values
	        $temp[0] = $varname;
	        $temp[1] = $default;
	     }

     return $temp[1];
	}

	function  setVar($varname,$value) {

	 global $_GET, $_REQUEST,$_POST;       // Mandatory : Need to access to gobal Link (Request) and Posted (GET) Mambo data


     $_POST[$varname] = $value;
     $_GET[$varname] = $value;
     $_REQUEST[$varname] = $value;
     $v = "&" .$varname. "=$value";

     return $v;
  	}

}
?>