{include file="../configs/config_template.tpl"}
{set_css}
{init_behavior type='modal'}
{init_behavior type='tooltip'}
{include file='snippets/t_javascript_language.tpl'}

{include file='elements/myuserdetails/t_myuserdetails_js.tpl'}

{include file='snippets/t_modal_js.tpl'}
{import_js_file url="`$ROOT_HOST`/components/com_bids/js/ratings.js"}

{if $has_profile}
	<div class="auction_header">{$smarty.const.bid_account_info}</div>
	<table width="100%">
	<tr>
	    <td width="50%" valign="top">
	        <table width="100%" class="auction_caption_box">
	        <tr >
	            <th>
	                {$smarty.const.bid_user_profile}
	            </th>
	        </tr>
	        <tr>
	            <td>
	                {include file='snippets/t_display_userprofile.tpl'}
	            </td>
	        </tr>
	        <tr>
	            <td>
	                <a href="javascript:showMessageBox('auction_edit_profile');">
	        			<img src="{$ROOT_HOST}/components/com_bids/images/edit_user_detail.jpg" width="24" title="{$smarty.const.bid_edit_user_details}" alt="{$smarty.const.bid_edit_user_details}"/>
	        		</a>    
	            
	            </td>
	        </tr>
	        </table>
	    </td>
	    <td width="50%" valign="top" >
	    {if $has_profile}
	        <table width="100%" class="auction_caption_box">
	        <tr>
	            <th>
	                {$smarty.const.bid_recent_ratings}
	            </th>
	        </tr>
	        <tr>
	            <td>
	                {include file='elements/myuserdetails/t_myratingstable.tpl' ratings=$lists.ratings}
	            </td>
	        </tr> 
	        <tr>
	            <td><a href="{$ROOT_HOST}index.php?option=com_bids&task=myratings&userid={$user->userid}&Itemid={$Itemid}">{$smarty.const.bid_view_all_ratings}</a></td>
	        </tr>
	        </table>
		{/if}
	    </td>
	</tr>
	{if $has_profile}{* has profile *}
	<tr>
	    <td colspan="2" width="50%" valign="top">
	
	    {if $lists.packages|@count}
			<table width="100%" class="auction_caption_box">
			<tr>
			    <th>
			    	{txt}Packages{/txt}
			    </th>
			</tr>
			<tr>
			    <td valign="top">
					<table width="100%">
					<tr>
					{foreach from=$lists.packages item=pac key=key}
						<td align="center" valign="top">
							<table>
								<tr>
									<td align="center"><strong>{$pac->name}</strong></td>
								</tr>
								<tr>
									<td align="center">{$pac->price} {$pac->currency}</td>
								</tr>
								<tr>
									<td height="100" align="center">
										<a href="index.php?option=com_bids&task=buy_packages&package={$pac->name}"><img src="{$pac->image}" width="100" border="0" /></a>
									</td>
								</tr>
								<tr>
									<td align="center"><a class="bids_packages_link" href="index.php?option=com_bids&task=buy_packages&package={$pac->name}" >Buy!</a></td>
								</tr>
							</table>
						</td>
					{/foreach}
					</tr>
					</table>
			    </td>
			</tr>
			</table>
		{/if}
	        <table width="100%" class="auction_caption_box">
	        <tr>
	            <th>
	                {$smarty.const.bid_payment_credits}
	            </th>
	        </tr>
	        <tr>
	            <td>
	            {include file='elements/myuserdetails/t_mycreditstable.tpl' credits=$lists.credits}
	            </td>
	        </tr>
	        </table>
	    </td>
	</tr>
	{if $smarty.const.bid_opt_allow_user_settings}
	<tr>
	    <td colspan="2">
	        <table width="100%" class="auction_caption_box">
	        <tr>
	            <th>
	                {$smarty.const.bid_default_settings}
	            </th>
	        </tr>
	        <tr>
	            <td>
	                <div id="auctionedit_pane">
	                    {include file='elements/myuserdetails/t_edit_defaultsettings.tpl'}
	                </div>
	            </td>
	        </tr>
	        </table>
	    </td>
	</tr>
	{/if}
	<tr>
	    <td colspan="2">
	        <table width="100%" class="auction_caption_box">
	        <tr>
	            <th>
		            {$smarty.const.bid_messages_received}
	            </th>
	        </tr>
	        <tr>
	            <td>
	                <div id="auctionedit_pane">
						{include file='elements/myuserdetails/t_message_inbox.tpl'}
					</div>
	            </td>
	        </tr>
	        </table>
	    </td>
	</tr>
	{/if} {* has profile *}
	</table>
	
	
	<div style="display:none" id="auction_edit_profile">
	    {include file='elements/myuserdetails/t_editprofile_form.tpl'}
	</div>

{else}
    {include file='elements/myuserdetails/t_editprofile_form.tpl'}
{/if}