<?php

if (!defined('SMARTY_DIR'))
    define('SMARTY_DIR', JPATH_COMPONENT_SITE .DS. 'smarty'.DS.'libs'.DS);

require_once (SMARTY_DIR . 'Smarty.class.php');

class JTheFactorySmarty extends Smarty
{
	/**
	 * @todo factorize smarty themes
	 */
	function display($tpl_name){
		$task = JRequest::getCmd('task');
		$database = & JFactory::getDBO();
		/*@var $payment JTheFactoryPaymentController*/
		$payment=&JTheFactoryPaymentController::getInstance($database,$_REQUEST);		
		$payment->processTemplate($task, $_REQUEST,$this);
		
		if(file_exists($this->template_dir.$tpl_name))
			parent::display($tpl_name);
		else 	
			parent::display(JPATH_COMPONENT_SITE.'/templates/default/'.$tpl_name);
	}
	
	function _smarty_include($params){
		
		$tpl_inc = $params['smarty_include_tpl_file'];
		if(!file_exists($this->template_dir.$tpl_inc))
			$tpl_inc = JPATH_COMPONENT_SITE.'/templates/default/'.$params['smarty_include_tpl_file'];
		
		$params['smarty_include_tpl_file'] = $tpl_inc;
		parent::_smarty_include($params);
	}
	
}

?>